'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.getUrl = exports.redirectIfMobile = exports.redirectIfDesktop = undefined;

var _uaParserJs = require('ua-parser-js');

var _uaParserJs2 = _interopRequireDefault(_uaParserJs);

var _isbot = require('isbot');

var _isbot2 = _interopRequireDefault(_isbot);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var redirectIfDesktop = exports.redirectIfDesktop = function redirectIfDesktop(req, res, next) {
	// const bot = isBot(req.headers['user-agent']);

	// if(bot){
	// 	req.isBot = true;
	// 	return next();
	// }

	/** 
  * banner ad injection
  */
	if (req.query.burl) {
		return next();
	}

	if (req.query.clearCache) {
		return next();
	}

	var userAgent = (0, _uaParserJs2.default)(req.headers['user-agent']);

	if (userAgent.device.type !== "mobile") {

		var host = req.get('host');

		return res.redirect(getUrl(req).replace(host + '/m', host));
	}

	next();
};

var redirectIfMobile = exports.redirectIfMobile = function redirectIfMobile(req, res, next) {
	// const bot = isBot(req.headers['user-agent']);

	// if(bot){
	// 	req.isBot = true;
	// 	return next();
	// }

	var userAgent = (0, _uaParserJs2.default)(req.headers['user-agent']);

	if (userAgent.device.type === "mobile") {

		var host = req.get('host');

		return res.redirect(getUrl(req).replace(host, host + '/m'));
	}

	next();
};

var getUrl = exports.getUrl = function getUrl(req) {
	return req.protocol + '://' + req.get('host') + req.originalUrl;
};