'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// const redis = require('redis');
var Redis = require('ioredis');
var q = require('q');

var RedisCache = exports.RedisCache = function () {
	function RedisCache(_ref) {
		var host = _ref.host,
		    port = _ref.port,
		    password = _ref.password,
		    masterName = _ref.masterName;

		_classCallCheck(this, RedisCache);

		this.host = host;
		this.port = port;
		this.password = password;
		this.masterName = masterName;

		this.connect();
	}

	_createClass(RedisCache, [{
		key: 'connect',
		value: function connect() {
			var _this = this;

			if (this.host.length === 1) {

				this.redisCache = new Redis({
					port: this.port, // Redis port
					host: this.host[0], // Redis host
					password: this.password,
					retryStrategy: function retryStrategy(times) {

						var delay = Math.min(times * 1000, 20000);
						console.log(delay);
						return delay;
					}
				});
			} else {
				// Redis
				this.redisCache = new Redis({
					sentinels: this.host.map(function (h, i) {
						return {
							port: _this.port[i],
							host: h
						};
					}),
					name: this.masterName,
					password: this.password,
					retryStrategy: function retryStrategy(times) {
						var delay = Math.min(times * 50, 2000);
						console.log(delay);
						return delay;
					}
				});

				// Redis.Cluster(

				// 	this.host.map(
				// 		( h, i ) => ({
				// 			port: this.port[i],
				// 			host: h
				// 		})
				// 	),

				// 	{
				// 		clusterRetryStrategy: ( times ) => {
				// 			var delay = Math.min(100 + times * 2, 2000);
				// 			return delay;
				// 		},
				// 		redisOptions: {
				// 			password: this.password
				// 		}
				// 	}

				// );
			}

			// this.redisCache = redis.createClient({
			// 	host: this.host,
			// 	port: this.port,
			// 	retry_strategy: function (options) {
			// 		if (options.error && options.error.code === 'ECONNREFUSED') {
			// 				// End reconnecting on a specific error and flush all commands with
			// 				// a individual error
			// 				return new Error('The server refused the connection');
			// 		}
			// 		if (options.total_retry_time > 1000 * 60 * 60) {
			// 				// End reconnecting after a specific timeout and flush all commands
			// 				// with a individual error
			// 				return new Error('Retry time exhausted');
			// 		}
			// 		if (options.attempt > 100) {
			// 				// End reconnecting with built in error
			// 				return undefined;
			// 		}
			// 		// reconnect after
			// 		return Math.min(options.attempt * 100, 3000);
			// 	}

			// });
		}
	}, {
		key: 'del',
		value: function del(key) {
			var promise = q.defer();

			if (this.redisCache.status === 'reconnecting') {
				promise.reject({
					msg: 'Redis not connected'
				});
				return promise.promise;
			}

			this.redisCache.del(key, function (err, data) {
				if (err) {
					promise.reject(err);
					return promise.promise;
				}

				promise.resolve(data);
			});

			return promise.promise;
		}
	}, {
		key: 'keys',
		value: function keys(pattern) {

			var promise = q.defer();

			if (this.redisCache.status === 'reconnecting') {
				promise.reject({
					msg: 'Redis not connected'
				});
				return promise.promise;
			}

			// redisCache.exist( key, )
			this.redisCache.keys(pattern, function (err, data) {
				if (err) {
					promise.reject(err);
					return promise.promise;
				}

				promise.resolve(data);
			});

			// this.redisCache.exist( key, ( err, data ) => {
			// 	if(err){
			// 		promise.reject(err);
			// 		return promise.promise;
			// 	}

			// 	promise.resolve( data );
			// });

			return promise.promise;
		}
	}, {
		key: 'exist',
		value: function exist(key) {

			var promise = q.defer();

			if (this.redisCache.status === 'reconnecting') {
				promise.reject({
					msg: 'Redis not connected'
				});
				return promise.promise;
			}

			// redisCache.exist( key, )
			this.redisCache.exists(key, function (err, data) {
				if (err) {
					promise.reject(err);
					return promise.promise;
				}

				promise.resolve(data);
			});

			// this.redisCache.exist( key, ( err, data ) => {
			// 	if(err){
			// 		promise.reject(err);
			// 		return promise.promise;
			// 	}

			// 	promise.resolve( data );
			// });

			return promise.promise;
		}
	}, {
		key: 'get',
		value: function get(key) {

			var promise = q.defer();

			if (this.redisCache.status === 'reconnecting') {
				promise.reject({
					msg: 'Redis not connected'
				});
				return promise.promise;
			}

			this.redisCache.get(key, function (err, data) {
				if (err) {
					promise.reject(err);
					return promise.promise;
				}

				promise.resolve(data);
			});

			return promise.promise;
		}

		// hset( key, value ){

		// 	let promise = q.defer();

		// 	this.redisCache.hset( key, objKey, value, (err, reply) => {
		// 		if(err){
		// 			promise.reject(err);
		// 			return promise.promise;
		// 		}

		// 		promise.resolve( reply );
		// 	});

		// 	return promise.promise;

		// }

	}, {
		key: 'set',
		value: function set(key, value) {
			var ex = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;


			var promise = q.defer();

			if (this.redisCache.status === 'reconnecting') {
				promise.reject({
					msg: 'Redis not connected'
				});
				return promise.promise;
			}

			if (ex) {

				this.redisCache.set(key, value, 'EX', ex, function (err, reply) {
					if (err) {
						promise.reject(err);
						return promise.promise;
					}

					promise.resolve(reply);
				});
			} else {
				this.redisCache.set(key, value, function (err, reply) {
					if (err) {
						promise.reject(err);
						return promise.promise;
					}

					promise.resolve(reply);
				});
			}

			return promise.promise;
		}
	}, {
		key: 'setObj',
		value: function setObj(key, value) {

			var promise = q.defer();

			// value
			if (this.redisCache.status === 'reconnecting') {
				promise.reject({
					msg: 'Redis not connected'
				});
				return promise.promise;
			}

			this.redisCache.hmset(key, value, function (err, reply) {
				if (err) {
					promise.reject(err);
					return promise.promise;
				}

				promise.resolve(reply);
			});

			return promise.promise;
		}
	}, {
		key: 'getObj',
		value: function getObj(key) {

			var promise = q.defer();

			if (this.redisCache.status === 'reconnecting') {
				promise.reject({
					msg: 'Redis not connected'
				});
				return promise.promise;
			}

			this.redisCache.hgetall(key, function (err, reply) {
				if (err) {
					promise.reject(err);
					return promise.promise;
				}

				if (Object.keys(reply).length === 0) {
					promise.resolve(null);
					return promise.promise;
				}

				promise.resolve(reply);
			});

			return promise.promise;
		}
	}]);

	return RedisCache;
}();