import { 
	getBrandPageInfo, 
	getProductDetailsPageInfo, 
	getSubCategoryInfo, 
	getSearchPageInfo,
	getStorePageInfo
} from './seo';

import { validate } from './validate';
// import { searchResults, brandResults, categoryResults } from './mock';

import searchResults from './mock.search.json';
import safetySearchResults from './mock.safety.json';
import toyogoSearchResults from './mock.searchToyogo.json';
import categoryResults from './mock.category.json';
import brandResults from './mock.brand.json';
import emptyResults from './mock.empty.json';
import mockProduct from './mock.product.json';
import storeResults from './mock.store.json';

import { RedisCache } from './redis';

let redisCache;

// it("Redis can connect, get obj and return falsey", function() {
// 	// expect(true).toBeFalsy();
// 	expect.assertions(1);

// 	let redisCache = new RedisCache({
// 		host: ['localhost'],
// 		port: 6379
// 	})

// 	redisCache.getObj('obj:falseyBitch')
// 		.then( data => expect(data).toBeFalsy() )

// 		// 	{
// 		// 	console.log(data && 1 === 1);
// 		// 	expect(true).toBeFalsy()
// 		// })

// });

// test('Redis can connect, get obj and return falsey', async  () => {

// 	expect.assertions(1);
	
// 	let redisCache = new RedisCache({
// 		host: ['localhost'],
// 		port: 6379
// 	})

// 	return redisCache.getObj('obj:falseyBitch')
// 		.then( data => expect(data).toBeFalsy());
// })

// test('Redis can connect, get and set', async () => {

// 	let redisCache = new RedisCache({
// 		host: ['localhost'],
// 		port: 6379
// 	})

// 	return redisCache.set('redis-test-jasper', 'hello world')
// 		.then( () => redisCache.get('redis-test-jasper'))
// 		.then( data => expect(data).toBe('hello world'))
// })

// test('Redis can connect, set expiry and get falsy', async () => {

// 	let redisCache = new RedisCache({
// 		host: ['localhost'],
// 		port: 6379
// 	})

// 	return redisCache.set('redis-test-jasper-ex', 'hello world', 1)
// 		.then( () => {
// 			return new Promise( ( resolve, reject ) => {
// 				setTimeout(
// 					() => {

// 						redisCache.get('redis-test-jasper-ex')
// 							// .then( data => {
// 							// 	console.log(data);
// 							// 	return expect(data).toBe('hello world')
// 							// })
// 							.then( data => resolve(data) )
// 							.catch( err => reject(err) )
							
// 					}, 3000
// 				)
// 			})
// 		})
// 		.then( data => {
// 			return expect(data).toBeFalsy()
// 		})
		
// })

// test('Redis can connect, set expiry and get value', async () => {

// 	let redisCache = new RedisCache({
// 		host: ['localhost'],
// 		port: 6379
// 	})

// 	return redisCache.set('redis-test-jasper-ex', 'hello world', 5)
// 		.then( () => {
// 			return new Promise( ( resolve, reject ) => {
// 				setTimeout(
// 					() => {

// 						redisCache.get('redis-test-jasper-ex')
// 							// .then( data => {
// 							// 	console.log(data);
// 							// 	return expect(data).toBe('hello world')
// 							// })
// 							.then( data => resolve(data) )
// 							.catch( err => reject(err) )
							
// 					}, 3000
// 				)
// 			})
// 		})
// 		.then( data => {
// 			return expect(data).toBe('hello world')
// 		})
		
// })

// test('Redis can connect, get and set obj', async () => {

// 	let redisCache = new RedisCache({
// 		host: ['localhost'],
// 		port: 6379
// 	})

// 	return redisCache.setObj('obj:test', { msg: 'hello world' })
// 		.then( () => redisCache.getObj('obj:test'))
// 		.then( data => expect(data.msg).toBe('hello world'))
// })

// test('Redis can connect to a cluster, get and set obj', async () => {

// 	let redisCache = new RedisCache({
// 		host: ["10.148.0.11", "10.148.0.13", "10.148.0.12"],
// 		port: ['6379', '6379', '6379']
// 	})

// 	return redisCache.setObj('obj:test', { msg: 'hello world' })
// 		.then( () => redisCache.getObj('obj:test'))
// 		.then( data => expect(data.msg).toBe('hello world'))
// })

test('Search page info is correct', () => {

	const inputs = {
		productList: searchResults.products, 
		searchParam: 'a',
		size: searchResults.size
	};

	let {
		title,
		description,
		searchParam,
		image,
		aggregatePriceJSON
	} = getSearchPageInfo( inputs );
	
	console.log(aggregatePriceJSON);

	expect(title).toBe("Find A In Singapore - Eezee");
	expect(description).toBe("Compare prices from different suppliers, wholesalers and distributors for A on Eezee.")
	expect(searchParam).toBe("a")
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/20140730114812KXWPANWWL3ZTC_full.jpg")
	expect(aggregatePriceJSON).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"Anchors & Rivets","image":["https://storage.googleapis.com/eezee-product-images/20140730114812KXWPANWWL3ZTC_full.jpg","https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg","https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg"],"offers":{"@type":"AggregateOffer","lowPrice":0.59,"highPrice":1300,"priceCurrency":"SGD","offerCount":8142},"brand":{"@type":"Thing","name":"HIT TOOLS"}}`);

  
});

test('Search page 2 info is correct', () => {

	const inputs = {
		productList: searchResults.products, 
		searchParam: 'a',
		size: searchResults.size,
		page: 2
	};

	let {
		title,
		description,
		searchParam,
		image,
		aggregatePriceJSON
	} = getSearchPageInfo( inputs );
	
	console.log(aggregatePriceJSON);

	expect(title).toBe("Find A In Singapore - Eezee - Page 2");
	expect(description).toBe("Page 2 - Compare prices from different suppliers, wholesalers and distributors for A on Eezee.")
	expect(searchParam).toBe("a")
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/20140730114812KXWPANWWL3ZTC_full.jpg")
	expect(aggregatePriceJSON).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"Anchors & Rivets","image":["https://storage.googleapis.com/eezee-product-images/20140730114812KXWPANWWL3ZTC_full.jpg","https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg","https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg"],"offers":{"@type":"AggregateOffer","lowPrice":0.59,"highPrice":1300,"priceCurrency":"SGD","offerCount":8142},"brand":{"@type":"Thing","name":"HIT TOOLS"}}`);

  
});

test('Search "safety" page info is correct', () => {

	const inputs = {
		productList: safetySearchResults.products, 
		searchParam: 'safety',
		size: safetySearchResults.size
	};

	let {
		title,
		description,
		searchParam,
		image,
		aggregatePriceJSON
	} = getSearchPageInfo( inputs );

	// Safety search results on Eezee Singapore
	expect(title).toBe("Find Safety In Singapore - Eezee");
	expect(description).toBe("Compare prices from different suppliers, wholesalers and distributors for Safety on Eezee.")
	expect(searchParam).toBe("safety")
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/20131227150417AWXS0Z0LWLL9A_full.jpg")
	expect(aggregatePriceJSON).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"Body & Fall Protection","image":["https://storage.googleapis.com/eezee-product-images/20131227150417AWXS0Z0LWLL9A_full.jpg","https://storage.googleapis.com/eezee-product-images/20131227150421DWJ4AQ6P0HXHZ_full.jpg","https://storage.googleapis.com/eezee-product-images/20131227150425HAJX9RANLTUU9_full.jpg","https://storage.googleapis.com/eezee-product-images/201312271504293PVVJCKDESOKK_full.jpg","https://storage.googleapis.com/eezee-product-images/x47x2vn.jpeg","https://storage.googleapis.com/eezee-product-images/rbi3jap.png","https://storage.googleapis.com/eezee-product-images/20141210174413DEXBJ1XWZAOF8_full.jpg","https://storage.googleapis.com/eezee-product-images/20141210174417XXDVZX6HA5C9G_full.jpg"],"offers":{"@type":"AggregateOffer","lowPrice":0.65,"highPrice":644,"priceCurrency":"SGD","offerCount":3749},"brand":{"@type":"Thing","name":"NO BRAND"}}`);

});

// test('Search "toyogo" page info is correct', () => {

// 	const inputs = {
// 		productList: toyogoSearchResults.products, 
// 		searchParam: 'toyogo',
// 		size: toyogoSearchResults.size
// 	};

// 	let {
// 		title,
// 		description,
// 		searchParam,
// 		image,
// 		aggregatePriceJSON
// 	} = getSearchPageInfo( inputs );

// 		console.log(title)
// 		console.log(description)
// 		console.log(searchParam)
// 		console.log(image)
// 		console.log(aggregatePriceJSON)

// 	// Safety search results on Eezee Singapore
// 	expect(title).toBe("Toyogo search results on Eezee Singapore");
// 	expect(description).toBe("Find and compare prices for Safety on Eezee.")
// 	expect(searchParam).toBe("safety")
// 	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/20131227150417AWXS0Z0LWLL9A_full.jpg")
// 	expect(aggregatePriceJSON).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"Body &amp; Fall Protection","image":["https://storage.googleapis.com/eezee-product-images/20131227150417AWXS0Z0LWLL9A_full.jpg","https://storage.googleapis.com/eezee-product-images/20131227150421DWJ4AQ6P0HXHZ_full.jpg","https://storage.googleapis.com/eezee-product-images/20131227150425HAJX9RANLTUU9_full.jpg","https://storage.googleapis.com/eezee-product-images/201312271504293PVVJCKDESOKK_full.jpg","https://storage.googleapis.com/eezee-product-images/x47x2vn.jpeg","https://storage.googleapis.com/eezee-product-images/rbi3jap.png","https://storage.googleapis.com/eezee-product-images/20141210174413DEXBJ1XWZAOF8_full.jpg","https://storage.googleapis.com/eezee-product-images/20141210174417XXDVZX6HA5C9G_full.jpg"],"offers":{"@type":"AggregateOffer","lowPrice":0.65,"highPrice":644,"priceCurrency":"SGD","offerCount":3749},"brand":{"@type":"Thing","name":"NO BRAND"}}`);

  
// });

test('Search "acc safe", empty page info is correct', () => {

	const inputs = {
		productList: emptyResults.products, 
		searchParam: 'acc safe',
		size: emptyResults.size
	};

	let {
		title,
		description,
		searchParam,
		image,
		aggregatePriceJSON
	} = getSearchPageInfo( inputs );

	// Safety search results on Eezee Singapore
	expect(title).toBe("Find Acc Safe In Singapore - Eezee");
	expect(description).toBe("Compare prices from different suppliers, wholesalers and distributors for Acc Safe on Eezee.")
	expect(searchParam).toBe("acc safe")
	expect(image).toBe("https://eezee.sg/static/eezee-product.svg")
	expect(aggregatePriceJSON).toBe(``);

  
});

test('Category page info is correct', () => {

	const inputs = {
		productList: categoryResults.products, 
		size: categoryResults.size
	};

	let {
		title,
		description,
		searchParam,
		image,
		aggregatePriceJSON
	} = getSubCategoryInfo( inputs );

	expect(title).toBe(`Find【Cordless Drills, Impact Drivers & Wrenches】in Singapore - Best Price on Eezee`);
	expect(description).toBe(`Source and compare Cordless Drills, Impact Drivers & Wrenches directly from authorised distributors on Eezee.【Bulk Discount】【Wholesale Price】`);
	expect(searchParam).toBe(`Cordless Drills, Impact Drivers & Wrenches`);
	expect(image).toBe(`https://storage.googleapis.com/eezee-product-images/201511031408597GPLBC5ASWEJE_full.jpg`);
	expect(aggregatePriceJSON).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"Cordless Drills, Impact Drivers & Wrenches","image":["https://storage.googleapis.com/eezee-product-images/201511031408597GPLBC5ASWEJE_full.jpg","https://storage.googleapis.com/eezee-product-images/20130603174555ZJQKB4FMA4CJD_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123231OMG6X6OVRWL10_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123230O7J4SX3OEHDGF_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123232SLX076H1GYXEH_full.jpg","https://storage.googleapis.com/eezee-product-images/20130603190247E4E7K02ODMWSV_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123656C2IN7ZZXC6GFV_full.jpg","https://storage.googleapis.com/eezee-product-images/20170207131217OFP8J4MSOWUQR_full.jpg","https://storage.googleapis.com/eezee-product-images/20170207131218EPJL3XEUNSX1T_full.jpg"],"offers":{"@type":"AggregateOffer","lowPrice":49.85,"highPrice":909.5,"priceCurrency":"SGD","offerCount":399},"brand":{"@type":"Thing","name":"DAWER POWER TOOLS"}}`);
});

test('Category page 2 info is correct', () => {

	const inputs = {
		productList: categoryResults.products, 
		size: categoryResults.size,
		page: 2
	};

	let {
		title,
		description,
		searchParam,
		image,
		aggregatePriceJSON
	} = getSubCategoryInfo( inputs );

	expect(title).toBe(`Find【Cordless Drills, Impact Drivers & Wrenches】in Singapore - Best Price on Eezee - Page 2`);
	expect(description).toBe(`Page 2 - Source and compare Cordless Drills, Impact Drivers & Wrenches directly from authorised distributors on Eezee.【Bulk Discount】【Wholesale Price】`);
	expect(searchParam).toBe(`Cordless Drills, Impact Drivers & Wrenches`);
	expect(image).toBe(`https://storage.googleapis.com/eezee-product-images/201511031408597GPLBC5ASWEJE_full.jpg`);
	expect(aggregatePriceJSON).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"Cordless Drills, Impact Drivers & Wrenches","image":["https://storage.googleapis.com/eezee-product-images/201511031408597GPLBC5ASWEJE_full.jpg","https://storage.googleapis.com/eezee-product-images/20130603174555ZJQKB4FMA4CJD_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123231OMG6X6OVRWL10_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123230O7J4SX3OEHDGF_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123232SLX076H1GYXEH_full.jpg","https://storage.googleapis.com/eezee-product-images/20130603190247E4E7K02ODMWSV_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123656C2IN7ZZXC6GFV_full.jpg","https://storage.googleapis.com/eezee-product-images/20170207131217OFP8J4MSOWUQR_full.jpg","https://storage.googleapis.com/eezee-product-images/20170207131218EPJL3XEUNSX1T_full.jpg"],"offers":{"@type":"AggregateOffer","lowPrice":49.85,"highPrice":909.5,"priceCurrency":"SGD","offerCount":399},"brand":{"@type":"Thing","name":"DAWER POWER TOOLS"}}`);
});

test('Brand page info is correct', () => {

	const inputs = {
		productList: brandResults.products, 
		size: brandResults.size
	};

	let {
		title,
		description,
		searchParam,
		image,
		aggregatePriceJSON
	} = getBrandPageInfo( inputs );

	expect(title).toBe(`Toyogo Singapore - Best Price`);
	expect(description).toBe(`Source and compare Toyogo products directly from Toyogo on Eezee Singapore.【Bulk Discount】【Wholesale Price】`);
	expect(searchParam).toBe(`Toyogo`);
	expect(image).toBe(`https://storage.googleapis.com/eezee-product-images/20151029200331W9BI33HXOYEZR_full.jpg`);
	expect(aggregatePriceJSON).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"Storage Boxes & Shelving","image":["https://storage.googleapis.com/eezee-product-images/20151029200331W9BI33HXOYEZR_full.jpg","https://storage.googleapis.com/eezee-product-images/201510292021166CPG8RJIETM4H_full.jpg","https://storage.googleapis.com/eezee-product-images/2017052211051215V4HHXSPKZAA_full.jpg"],"offers":{"@type":"AggregateOffer","lowPrice":3.42,"highPrice":115,"priceCurrency":"SGD","offerCount":24},"brand":{"@type":"Thing","name":"TOYOGO"}}`);

});

test('Brand page 2 info is correct', () => {

	const inputs = {
		productList: brandResults.products, 
		size: brandResults.size,
		page: 2
	};

	let {
		title,
		description,
		searchParam,
		image,
		aggregatePriceJSON
	} = getBrandPageInfo( inputs );

	expect(title).toBe(`Toyogo Singapore Page 2 - Best Price`);
	expect(description).toBe(`Page 2 - Source and compare Toyogo products directly from Toyogo on Eezee Singapore.【Bulk Discount】【Wholesale Price】`);
	expect(searchParam).toBe(`Toyogo`);
	expect(image).toBe(`https://storage.googleapis.com/eezee-product-images/20151029200331W9BI33HXOYEZR_full.jpg`);
	expect(aggregatePriceJSON).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"Storage Boxes & Shelving","image":["https://storage.googleapis.com/eezee-product-images/20151029200331W9BI33HXOYEZR_full.jpg","https://storage.googleapis.com/eezee-product-images/201510292021166CPG8RJIETM4H_full.jpg","https://storage.googleapis.com/eezee-product-images/2017052211051215V4HHXSPKZAA_full.jpg"],"offers":{"@type":"AggregateOffer","lowPrice":3.42,"highPrice":115,"priceCurrency":"SGD","offerCount":24},"brand":{"@type":"Thing","name":"TOYOGO"}}`);

});

test('Brand Page still shows proper seo when no products are returned', () => {

	const inputs = {
		productList: [], 
		size: 0,
		searchParam: 'boxco'
	};

	let {
		title,
		image,
		searchParam,
		description,
		aggregatePriceJSON
	} = getBrandPageInfo( inputs );

	expect(title).toBe("Boxco Singapore - Best Price");
	expect(description).toBe("Source and compare Boxco products directly from Boxco on Eezee Singapore.【Bulk Discount】【Wholesale Price】");
	expect(searchParam).toBe(`Boxco`);	
	expect(image).toBe("https://eezee.sg/static/eezee-product.svg");
	expect(aggregatePriceJSON).toBe(``);

})

test('Product Page Info does not include model number if length > 15', () => {

	const inputs = mockProduct[0];

	let {
		title,
		image,
		description,
		productSchema
	} = getProductDetailsPageInfo( inputs );

	expect(title).toBe("ORING AS568 AS457 ID 354.97 X CS 6.99 Silicone 70 Shore Singapore - Eezee");
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/tjewl6d.jpeg");
	expect(description).toBe("Up to 26% Off - Buy ORING AS568 AS457 ID 354.97 X CS 6.99 Silicone 70 Shore directly from authorised distributors, suppliers and wholesalers on Eezee Singapore.");
	expect(productSchema).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"ORING AS568 AS457 ID 354.97 X CS 6.99 Silicone 70 Shore","image":["https://storage.googleapis.com/eezee-product-images/tjewl6d.jpeg","https://storage.googleapis.com/eezee-product-images/6646v7l.jpeg"],"mpn":"ORING AS568 AS457 ID 354.97 X CS 6.99Silicone 70 Shore","brand":{"@type":"Thing","name":"Eriks"},"offers":{"@type":"Offer","priceCurrency":"SGD","price":26,"itemCondition":"https://schema.org/NewCondition","availability":"http://schema.org/InStock"}}`);
	
});

test('Product Page Info should include model number if length < 15 and not in product title', () => {

	const inputs = mockProduct[1];

	let {
		title,
		image,
		description,
		productSchema,
		breadCrumbSchema
	} = getProductDetailsPageInfo( inputs );

	// console.log( JSON.stringify(breadCrumbSchema) );

	expect(title).toBe("CLABER RAIN SENSOR Singapore - Eezee");
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/20160622133420NTDBSYUKP9MSA_full.jpg");
	expect(description).toBe("Buy CLABER RAIN SENSOR 90915 directly from authorised distributors, suppliers and wholesalers on Eezee Singapore.");
	expect(productSchema).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"CLABER RAIN SENSOR","image":["https://storage.googleapis.com/eezee-product-images/20160622133420NTDBSYUKP9MSA_full.jpg","https://storage.googleapis.com/eezee-product-images/201606221334541ZUISXEFJJDZ4_full.jpg","https://storage.googleapis.com/eezee-product-images/20160622133454HBW7E4DG0V5O7_full.jpg","https://storage.googleapis.com/eezee-product-images/20160622133454TSRQKQUACUXG0_full.jpg"],"mpn":"90915","brand":{"@type":"Thing","name":"CLABER"},"offers":{"@type":"Offer","priceCurrency":"SGD","price":79.9,"itemCondition":"https://schema.org/NewCondition","availability":"http://schema.org/InStock"}}`);
	
});

test('Store Page Info should render properly', () => {
	// getStorePageInfo();

	const inputs = {
		searchParam: "0563306553",
		productList: storeResults.products, 
		size: storeResults.size, 
		page: false, 
		categoryNiche: storeResults.categoryNiche,
		companyName: storeResults.c
	}

	let {
		title,
		image,
		searchParam,
		description,
		aggregatePriceJSON
	} = getStorePageInfo( inputs );

	expect(title).toBe("Eezee Store 0563306553 | Tiger Hand Tools");
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg");
	expect(description).toBe("Tiger Hand Tools stocks reputable brands for Mechanical Tools, Fastening Tools & Air Tools in Singapore. Shop with us now!");
	expect(aggregatePriceJSON).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"Packaging & Shipping Supplies","image":["https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg","https://storage.googleapis.com/eezee-product-images/O24EoqiMcC10foNWdsXNdN.jpg","https://storage.googleapis.com/eezee-product-images/BG3VrUBIpfnK5WgDp3H3H~.jpg","https://storage.googleapis.com/eezee-product-images/lxwEUb0GhyOk~ZoYWPNYw3.png","https://storage.googleapis.com/eezee-product-images/vSLLCG8yvrzrbMJaqX7B2D.png","https://storage.googleapis.com/eezee-product-images/BG3VrUBIpfnK5WgDp3H3H~.jpg","https://storage.googleapis.com/eezee-product-images/lxwEUb0GhyOk~ZoYWPNYw3.png","https://storage.googleapis.com/eezee-product-images/vSLLCG8yvrzrbMJaqX7B2D.png"],"offers":{"@type":"AggregateOffer","lowPrice":4.8,"highPrice":115,"priceCurrency":"SGD","offerCount":746},"brand":{"@type":"Thing","name":"TOYOGO"}}`);

})

test('Store Page 2 Info should render properly', () => {
	// getStorePageInfo();

	const inputs = {
		searchParam: "0563306553",
		productList: storeResults.products, 
		size: storeResults.size, 
		page: 2, 
		categoryNiche: storeResults.categoryNiche,
		companyName: storeResults.c
	}

	let {
		title,
		image,
		searchParam,
		description,
		aggregatePriceJSON
	} = getStorePageInfo( inputs );

	expect(title).toBe("Eezee Store 0563306553 | Tiger Hand Tools - Page 2");
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg");
	expect(description).toBe("Page 2 - Tiger Hand Tools stocks reputable brands for Mechanical Tools, Fastening Tools & Air Tools in Singapore. Shop with us now!");
	expect(aggregatePriceJSON).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"Packaging & Shipping Supplies","image":["https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg","https://storage.googleapis.com/eezee-product-images/O24EoqiMcC10foNWdsXNdN.jpg","https://storage.googleapis.com/eezee-product-images/BG3VrUBIpfnK5WgDp3H3H~.jpg","https://storage.googleapis.com/eezee-product-images/lxwEUb0GhyOk~ZoYWPNYw3.png","https://storage.googleapis.com/eezee-product-images/vSLLCG8yvrzrbMJaqX7B2D.png","https://storage.googleapis.com/eezee-product-images/BG3VrUBIpfnK5WgDp3H3H~.jpg","https://storage.googleapis.com/eezee-product-images/lxwEUb0GhyOk~ZoYWPNYw3.png","https://storage.googleapis.com/eezee-product-images/vSLLCG8yvrzrbMJaqX7B2D.png"],"offers":{"@type":"AggregateOffer","lowPrice":4.8,"highPrice":115,"priceCurrency":"SGD","offerCount":746},"brand":{"@type":"Thing","name":"TOYOGO"}}`);

})

// test('Validator works as expected', () => {

// 	const schema = {
// 		name: {
// 			conditions: [
// 				{ 
// 					required: true,
// 					msg: 'Name is required lei...'
// 				}
// 			]
// 		},

// 		hp: {
// 			conditions: [
// 				{
// 					required: true,
// 					msg: 'HP is required!'
// 				},

// 				{ 
// 					field: 'hp',
// 					comparator: 'length',
// 					length:{
// 						condition: '$gte',
// 						value: 9
// 					},
// 					msg: 'HP NEED TO BE GTE 9 LA'
// 				}
// 			]
// 		}
// 	}

// 	const obj = {
// 		name:'',
// 		hp:'92718779'
// 	};

// 	const errors = validate({ obj, schema });

// 	console.log(errors);
	
// 	expect( errors.name ).toBe('Name is required lei...');
// 	expect( errors.hp ).toBe('HP NEED TO BE GTE 9 LA');
	
// })