export const validate = ({ obj, schema }) => {

	let _errors = {};
	let schemaKeys = Object.keys(schema);

	const handleComparator = ({ 
		condition,
		obj,
		key,
		successFlag
	}) => {

		condition = condition || {};

		condition.comparator = condition.comparator || "";

		try{

			switch( condition.comparator ) {

				case 'if':
				case 'equal':
					if(obj[condition.field] !== condition.value){
						successFlag = false;
					}

					break;

				case 'length':
					switch(condition.length.condition){

						case '$gte':
							if(obj[condition.field].length < condition.length.value){
								successFlag = false
							}
							break;

						case '$gt':
							if(obj[condition.field].length <= condition.length.value){
								successFlag = false
							}
							break;

						case '$lte':
							if(obj[condition.field].length > condition.length.value){
								successFlag = false
							}
							break;

						case '$lt':
							if(obj[condition.field].length >= condition.length.value){
								successFlag = false
							}
							break;

					}

					break;
			}

		} catch (e){
			console.log(e);
		}

		return successFlag;
	}

	schemaKeys.map(
		_errorKeys => {

			schema[_errorKeys].conditions.map(
				
				// for each condition
				condition => {

					// if required
					if( condition.required){

						if(!obj[_errorKeys]){
							_errors[_errorKeys] = condition.msg
						}

						return;
					}

					// if comparator success
					// console.log({ _errorKeys,condition, handleComparator: handleComparator(condition)})
					let skipFlag = true;

					skipFlag = !handleComparator({
						condition,
						key: _errorKeys,
						obj: obj,
						successFlag: skipFlag
					});

					console.log({condition, skipFlag});

					if( skipFlag ){
						return;
					}

					if( !skipFlag && !condition.$and){
						console.log({condition});
						_errors[_errorKeys] = condition.msg;
						return;
					}

					if( condition.$and ){

						let successFlag = true;

						condition.$and.map(
							andCondition => {

								// handle comparator
								successFlag = handleComparator({
									condition: andCondition,
									key: _errorKeys,
									obj: obj,
									successFlag: successFlag
								});

								
								// if( andCondition.comparator === 'length' ){

								// 	try{
								// 		switch(andCondition.length.condition){

								// 			case '$gte':
								// 				if(obj[_errorKeys].length < andCondition.length.value){
								// 					successFlag = false
								// 				}
								// 				break;

								// 			case '$gt':
								// 				if(obj[_errorKeys].length <= andCondition.length.value){
								// 					successFlag = false
								// 				}
								// 				break;

								// 			case '$lte':
								// 				if(obj[_errorKeys].length > andCondition.length.value){
								// 					successFlag = false
								// 				}
								// 				break;

								// 			case '$lt':
								// 				if(obj[_errorKeys].length >= andCondition.length.value){
								// 					successFlag = false
								// 				}
								// 				break;

								// 		}
								// 	} catch( e ){
								// 		console.log(e);
								// 	}

								// }

								// if( andCondition.comparator === 'equal' ){
								// 	if(obj[andCondition.field] !== andCondition.value){
								// 		successFlag = false;
								// 	}
								// }

							}
						)

						if(!successFlag){
							_errors[_errorKeys] = condition.msg;
						}

					}
				}
			)

			// if(schema[_errorKeys].required && !obj[_errorKeys]){
			// 	_errors[_errorKeys] = ''
			// }

		}
	)

	return _errors;
}