'use strict';

var _seo = require('./seo');

var _validate = require('./validate');

var _redis = require('./redis');

// import { searchResults, brandResults, categoryResults } from './mock';

var searchResults = {
	size: 8142,
	products: [{
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140730114812KXWPANWWL3ZTC_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140730114812KXWPANWWL3ZTC_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 0.59,
			po: 'S$0.59'
		},
		includes: [],
		model: 'AB405',
		variants: [{
			name: 'Model',
			_id: '59f6ffb5324e463245cb9b3f',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AB405',
				_id: '59f6ffb5324e463245cb9b4a',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AB409',
				_id: '59f6ffb5324e463245cb9b49',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AB416',
				_id: '59f6ffb5324e463245cb9b48',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AB423',
				_id: '59f6ffb5324e463245cb9b47',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AB438',
				_id: '59f6ffb5324e463245cb9b46',
				order: 4
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AB514',
				_id: '59f6ffb5324e463245cb9b45',
				order: 5
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AB527',
				_id: '59f6ffb5324e463245cb9b44',
				order: 6
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AB545',
				_id: '59f6ffb5324e463245cb9b43',
				order: 7
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AB614',
				_id: '59f6ffb5324e463245cb9b42',
				order: 8
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AB627',
				_id: '59f6ffb5324e463245cb9b41',
				order: 9
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AB645',
				_id: '59f6ffb5324e463245cb9b40',
				order: 10
			}]
		}, {
			name: 'Package',
			_id: '59f6ffb5324e463245cb9b3e',
			_set: []
		}],
		categories: {
			sub: 'Anchors & Rivets',
			mainKebabCase: 'fasteners',
			subKebabCase: 'anchors-rivets',
			main: 'Fasteners'
		},
		title: 'HIT STEEL BOARD ANCHOR',
		uniqTitle: 'hit-steel-board-anchor',
		bulkDiscount: [],
		sku: 'b38541c358',
		brand: {
			lowerCaseName: 'hit tools',
			kebabName: 'hit-tools',
			name: 'HIT TOOLS',
			_id: '59b24e3eb38a0b0ad30a3ab6'
		},
		dateUpdated: '2017-11-21T12:17:44.273000',
		_id: '59b90311196632786ed89bee'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '5khs8ue.jpeg',
			expire: '2017-10-04T15:28:34.538Z',
			__v: 0,
			_id: '59d5956e189444587ddb09de',
			url: 'https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg',
			fileType: 'image'
		}],
		supplierId: '59ccaff835cc384838b44e60',
		includes: [],
		variants: [{
			name: 'Ampere',
			_id: '59f6ffcd324e463245cbb19a',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC110V',
				_id: '59f6ffcd324e463245cbb19f',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC220V',
				_id: '59f6ffcd324e463245cbb19e',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC240V',
				_id: '59f6ffcd324e463245cbb19d',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC380V',
				_id: '59f6ffcd324e463245cbb19c',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC440V',
				_id: '59f6ffcd324e463245cbb19b',
				order: 4
			}]
		}],
		title: 'Terasaki Contactor 3P, 65A 50/60Hz',
		uniqTitle: 'terasaki-contactor-3-p-65-a-50-60-hz',
		bulkDiscount: [{
			quantity: 100,
			discount: 10,
			_id: '59f6ffcd324e463245cbb1a0'
		}],
		dateUpdated: '2017-11-21T12:17:44.571000',
		price: {
			ps: 'S$0.00',
			original: 136,
			po: 'S$136.00'
		},
		model: 'TC-65A',
		categories: {
			sub: 'Contactors',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'contactors',
			main: 'Electrical Components'
		},
		sku: 'f14f802cbf',
		brand: {
			lowerCaseName: 'terasaki',
			kebabName: 'terasaki',
			name: 'TERASAKI',
			_id: '59c899ba65b9111a584936a9'
		},
		_id: '59dc459bbaaac3444823b46e'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '5khs8ue.jpeg',
			expire: '2017-10-04T15:28:34.538Z',
			__v: 0,
			_id: '59d5956e189444587ddb09de',
			url: 'https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg',
			fileType: 'image'
		}],
		supplierId: '59ccaff835cc384838b44e60',
		includes: [],
		variants: [{
			name: 'Ampere',
			_id: '59f6ffcd324e463245cbb133',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC110V',
				_id: '59f6ffcd324e463245cbb138',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC220V',
				_id: '59f6ffcd324e463245cbb137',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC240V',
				_id: '59f6ffcd324e463245cbb136',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC380V',
				_id: '59f6ffcd324e463245cbb135',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC440V',
				_id: '59f6ffcd324e463245cbb134',
				order: 4
			}]
		}],
		title: 'Terasaki Contactor 3P, 18B 50/60Hz',
		uniqTitle: 'terasaki-contactor-3-p-18-b-50-60-hz',
		bulkDiscount: [{
			quantity: 100,
			discount: 10,
			_id: '59f6ffcd324e463245cbb139'
		}],
		dateUpdated: '2017-11-21T12:17:44.568000',
		price: {
			ps: 'S$0.00',
			original: 33,
			po: 'S$33.00'
		},
		model: 'TC-18B',
		categories: {
			sub: 'Contactors',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'contactors',
			main: 'Electrical Components'
		},
		sku: 'ed636b028c',
		brand: {
			lowerCaseName: 'terasaki',
			kebabName: 'terasaki',
			name: 'TERASAKI',
			_id: '59c899ba65b9111a584936a9'
		},
		_id: '59d5a477189444587ddb0ba4'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '5khs8ue.jpeg',
			expire: '2017-10-04T15:28:34.538Z',
			__v: 0,
			_id: '59d5956e189444587ddb09de',
			url: 'https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg',
			fileType: 'image'
		}],
		supplierId: '59ccaff835cc384838b44e60',
		includes: [],
		variants: [{
			name: 'Ampere',
			_id: '59f6ffcd324e463245cbb193',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC110V',
				_id: '59f6ffcd324e463245cbb198',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC220V',
				_id: '59f6ffcd324e463245cbb197',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC240V',
				_id: '59f6ffcd324e463245cbb196',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC380V',
				_id: '59f6ffcd324e463245cbb195',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC440V',
				_id: '59f6ffcd324e463245cbb194',
				order: 4
			}]
		}],
		title: 'Terasaki Contactor 3P, 50A 50/60Hz',
		uniqTitle: 'terasaki-contactor-3-p-50-a-50-60-hz',
		bulkDiscount: [{
			quantity: 100,
			discount: 10,
			_id: '59f6ffcd324e463245cbb199'
		}],
		dateUpdated: '2017-11-21T12:17:44.571000',
		price: {
			ps: 'S$0.00',
			original: 107.8,
			po: 'S$107.80'
		},
		model: 'TC-50A',
		categories: {
			sub: 'Contactors',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'contactors',
			main: 'Electrical Components'
		},
		sku: '89b20c10b2',
		brand: {
			lowerCaseName: 'terasaki',
			kebabName: 'terasaki',
			name: 'TERASAKI',
			_id: '59c899ba65b9111a584936a9'
		},
		_id: '59dc4492baaac3444823b0e5'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'k0lwll6.jpeg',
			expire: '2017-09-30T19:12:39.936Z',
			__v: 0,
			_id: '59d1df688ba7b94b9dca668c',
			url: 'https://storage.googleapis.com/eezee-product-images/k0lwll6.jpeg',
			fileType: 'image'
		}],
		supplierId: '59ccaff835cc384838b44e60',
		includes: [],
		variants: [{
			name: 'Ampere',
			_id: '59f6ffcc324e463245cbb124',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC110V',
				_id: '59f6ffcc324e463245cbb12a',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC220V',
				_id: '59f6ffcc324e463245cbb129',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC240V',
				_id: '59f6ffcc324e463245cbb128',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC380V',
				_id: '59f6ffcc324e463245cbb127',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC415V',
				_id: '59f6ffcc324e463245cbb126',
				order: 4
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC440V',
				_id: '59f6ffcc324e463245cbb125',
				order: 5
			}]
		}],
		title: 'Terasaki Contactor, 3P 9B 50/60Hz',
		bulkDiscount: [{
			quantity: 100,
			discount: 10,
			_id: '59f6ffcc324e463245cbb12b'
		}],
		uniqTitle: 'terasaki-contactor-3-p-9-b-50-60-hz',
		dateUpdated: '2017-11-21T12:17:44.566000',
		price: {
			ps: 'S$0.00',
			original: 21,
			po: 'S$21.00'
		},
		model: 'TC-9B',
		categories: {
			sub: 'Contactors',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'contactors',
			main: 'Electrical Components'
		},
		oldSku: 'f1ba40ed02',
		sku: 'e2c2507fbe',
		brand: {
			lowerCaseName: 'terasaki',
			kebabName: 'terasaki',
			name: 'TERASAKI',
			_id: '59c899ba65b9111a584936a9'
		},
		_id: '59d1e0118ba7b94b9dca668d'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201501201509438OCOTJ7IT9N0I_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201501201509438OCOTJ7IT9N0I_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201610041411337HCSSS0R6IYDA_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201610041411337HCSSS0R6IYDA_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 2.2,
			po: 'S$2.20'
		},
		includes: [],
		model: 'A01',
		variants: [{
			name: 'Colour',
			_id: '59f6ffb3324e463245cb9817',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A01 Gross Black',
				_id: '59f6ffb3324e463245cb982a',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A02 Matt Black',
				_id: '59f6ffb3324e463245cb9829',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A03 Tangerine',
				_id: '59f6ffb3324e463245cb9828',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A04 Fire Red',
				_id: '59f6ffb3324e463245cb9827',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A06 Burnt Orange',
				_id: '59f6ffb3324e463245cb9826',
				order: 4
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A07 Yellow',
				_id: '59f6ffb3324e463245cb9825',
				order: 5
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A09 Royal Blue',
				_id: '59f6ffb3324e463245cb9824',
				order: 6
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A10 Gray Primer',
				_id: '59f6ffb3324e463245cb9823',
				order: 7
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A13 Light Green',
				_id: '59f6ffb3324e463245cb9822',
				order: 8
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A14 Irish Green',
				_id: '59f6ffb3324e463245cb9821',
				order: 9
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A16 Medium Yellow',
				_id: '59f6ffb3324e463245cb9820',
				order: 10
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A19 Sky Blue',
				_id: '59f6ffb3324e463245cb981f',
				order: 11
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A21 Gloss White',
				_id: '59f6ffb3324e463245cb981e',
				order: 12
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A24 Matt White',
				_id: '59f6ffb3324e463245cb981d',
				order: 13
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A25 Aluminium',
				_id: '59f6ffb3324e463245cb981c',
				order: 14
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A26 Pink',
				_id: '59f6ffb3324e463245cb981b',
				order: 15
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A27 Light Gray',
				_id: '59f6ffb3324e463245cb981a',
				order: 16
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A32 Clear',
				_id: '59f6ffb3324e463245cb9819',
				order: 17
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'A41 Brown Tobacco',
				_id: '59f6ffb3324e463245cb9818',
				order: 18
			}]
		}, {
			name: 'Package',
			_id: '59f6ffb3324e463245cb9816',
			_set: []
		}],
		categories: {
			sub: 'Spray Paints',
			mainKebabCase: 'paints',
			subKebabCase: 'spray-paints',
			main: 'Paints'
		},
		title: 'OREX SPRAY PAINT 400ML',
		uniqTitle: 'orex-spray-paint-400-ml',
		bulkDiscount: [],
		sku: '0a98413c9c',
		brand: {
			lowerCaseName: 'orex',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'xffW75pRyf1P9bUYeRnLz7.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a43579acdf0b936572d34fb',
				url: 'https://storage.googleapis.com/eezee-brand-images/xffW75pRyf1P9bUYeRnLz7.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'orex',
			name: 'OREX',
			_id: '59b24e3eb38a0b0ad30a3a28'
		},
		dateUpdated: '2017-11-21T12:17:44.260000',
		_id: '59b90311196632786ed899fb'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '5khs8ue.jpeg',
			expire: '2017-10-04T15:28:34.538Z',
			__v: 0,
			_id: '59d5956e189444587ddb09de',
			url: 'https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg',
			fileType: 'image'
		}],
		supplierId: '59ccaff835cc384838b44e60',
		includes: [],
		variants: [{
			name: 'Ampere',
			_id: '59f6ffcd324e463245cbb13b',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC110V',
				_id: '59f6ffcd324e463245cbb140',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC220V',
				_id: '59f6ffcd324e463245cbb13f',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC240V',
				_id: '59f6ffcd324e463245cbb13e',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC380V',
				_id: '59f6ffcd324e463245cbb13d',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC440V',
				_id: '59f6ffcd324e463245cbb13c',
				order: 4
			}]
		}],
		title: 'Terasaki Contactor 3P, 22B 50/60Hz',
		uniqTitle: 'terasaki-contactor-3-p-22-b-50-60-hz',
		bulkDiscount: [{
			quantity: 100,
			discount: 10,
			_id: '59f6ffcd324e463245cbb141'
		}],
		dateUpdated: '2017-11-21T12:17:44.568000',
		price: {
			ps: 'S$0.00',
			original: 39.8,
			po: 'S$39.80'
		},
		model: 'TC-22B',
		categories: {
			sub: 'Contactors',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'contactors',
			main: 'Electrical Components'
		},
		sku: '464a8027a8',
		brand: {
			lowerCaseName: 'terasaki',
			kebabName: 'terasaki',
			name: 'TERASAKI',
			_id: '59c899ba65b9111a584936a9'
		},
		_id: '59d5a580189444587ddb0d95'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '5khs8ue.jpeg',
			expire: '2017-10-04T15:28:34.538Z',
			__v: 0,
			_id: '59d5956e189444587ddb09de',
			url: 'https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg',
			fileType: 'image'
		}],
		supplierId: '59ccaff835cc384838b44e60',
		includes: [],
		variants: [{
			name: 'Ampere',
			_id: '59f6ffcd324e463245cbb18c',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC110V',
				_id: '59f6ffcd324e463245cbb191',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC220V',
				_id: '59f6ffcd324e463245cbb190',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC240V',
				_id: '59f6ffcd324e463245cbb18f',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC380V',
				_id: '59f6ffcd324e463245cbb18e',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC440V',
				_id: '59f6ffcd324e463245cbb18d',
				order: 4
			}]
		}],
		title: 'Terasaki Contactor 3P, 32A 50/60Hz',
		uniqTitle: 'terasaki-contactor-3-p-32-a-50-60-hz',
		bulkDiscount: [{
			quantity: 100,
			discount: 10,
			_id: '59f6ffcd324e463245cbb192'
		}],
		dateUpdated: '2017-11-21T12:17:44.571000',
		price: {
			ps: 'S$0.00',
			original: 63.2,
			po: 'S$63.20'
		},
		model: 'TC-32A',
		categories: {
			sub: 'Contactors',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'contactors',
			main: 'Electrical Components'
		},
		sku: 'e0044a8651',
		brand: {
			lowerCaseName: 'terasaki',
			kebabName: 'terasaki',
			name: 'TERASAKI',
			_id: '59c899ba65b9111a584936a9'
		},
		_id: '59dc43edbaaac3444823af90'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '5khs8ue.jpeg',
			expire: '2017-10-04T15:28:34.538Z',
			__v: 0,
			_id: '59d5956e189444587ddb09de',
			url: 'https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg',
			fileType: 'image'
		}],
		supplierId: '59ccaff835cc384838b44e60',
		includes: [],
		variants: [{
			name: 'Ampere',
			_id: '59f6ffcd324e463245cbb1b2',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC110V',
				_id: '59f6ffcd324e463245cbb1b7',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC220V',
				_id: '59f6ffcd324e463245cbb1b6',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC240V',
				_id: '59f6ffcd324e463245cbb1b5',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC380V',
				_id: '59f6ffcd324e463245cbb1b4',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC440V',
				_id: '59f6ffcd324e463245cbb1b3',
				order: 4
			}]
		}],
		title: 'Terasaki Contactor 3P, 65A 50/60Hz',
		uniqTitle: 'terasaki-contactor-3-p-65-a-50-60-hz',
		bulkDiscount: [{
			quantity: 100,
			discount: 10,
			_id: '59f6ffcd324e463245cbb1b8'
		}],
		dateUpdated: '2017-11-21T12:17:44.572000',
		price: {
			ps: 'S$0.00',
			original: 136,
			po: 'S$136.00'
		},
		model: 'TC-65A',
		categories: {
			sub: 'Contactors',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'contactors',
			main: 'Electrical Components'
		},
		sku: '1bea4d0705',
		brand: {
			lowerCaseName: 'terasaki',
			kebabName: 'terasaki',
			name: 'TERASAKI',
			_id: '59c899ba65b9111a584936a9'
		},
		_id: '59dc5ea7e921c74d0963bc89'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'hFmngwsHdAC4LPRFTyTD6Q.JPG',
			__v: 0,
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5721df37f8836a18c59c81',
			url: 'https://storage.googleapis.com/eezee-product-images/hFmngwsHdAC4LPRFTyTD6Q.JPG',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'ARdFOSKe4ZMJ8qe_Q7bHTy.JPG',
			__v: 0,
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a57220237f8836a18c59f05',
			url: 'https://storage.googleapis.com/eezee-product-images/ARdFOSKe4ZMJ8qe_Q7bHTy.JPG',
			fileType: 'image'
		}],
		supplierId: '5a02cd0665b34a6f49530232',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'Capacity',
			_id: '5a57220a37f8836a18c59f0e',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '45L',
				_id: '5a57220a37f8836a18c59f10',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 10,
					po: 'S$10.00'
				},
				name: '60L',
				_id: '5a57220a37f8836a18c59f0f',
				order: 1
			}]
		}, {
			name: 'A4 Size Recycling Label',
			_id: '5a57220a37f8836a18c59f08',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 6,
					po: 'S$6.00'
				},
				name: 'Yellow - CANS',
				_id: '5a57220a37f8836a18c59f0d',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 6,
					po: 'S$6.00'
				},
				name: 'Blue - PAPER',
				_id: '5a57220a37f8836a18c59f0c',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 6,
					po: 'S$6.00'
				},
				name: 'Green - PLASTIC',
				_id: '5a57220a37f8836a18c59f0b',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 6,
					po: 'S$6.00'
				},
				name: 'Red - GLASS',
				_id: '5a57220a37f8836a18c59f0a',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 6,
					po: 'S$6.00'
				},
				name: 'White - GENERAL WASTE',
				_id: '5a57220a37f8836a18c59f09',
				order: 4
			}]
		}],
		title: 'SELF CLOSING METAL BIN C/W RECYCLING STICKER',
		bulkDiscount: [],
		uniqTitle: 'self-closing-metal-bin-c-w-recycling-sticker',
		dateUpdated: '2018-01-11T08:36:26.078000',
		price: {
			ps: 'S$0.00',
			original: 70,
			po: 'S$70.00'
		},
		model: 'AZ902R1/ AZ901R1',
		categories: {
			sub: 'Trash & Recycling',
			mainKebabCase: 'cleaning-products',
			subKebabCase: 'trash-recycling',
			main: 'Cleaning Products'
		},
		sku: '7c6adc6656',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		_id: '59b90312196632786ed8acfd'
	}, {
		buyPrice: 9.5,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'lvyyipk.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dde513d9df997a8c7ffdf8',
			url: 'https://storage.googleapis.com/eezee-product-images/lvyyipk.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'AccSafe AZ011T Twist Auto Lock Karabiner Openning 18mm',
		bulkDiscount: [],
		uniqTitle: 'accsafe-az-011-t-twist-auto-lock-karabiner-openning-18-mm',
		dateUpdated: '2017-11-21T12:17:44.577000',
		price: {
			ps: 'S$0.00',
			original: 12.4,
			po: 'S$12.40'
		},
		model: 'AccSafe AZ011T ',
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		sku: 'ef869b9dc0',
		oldSku: 'f46f6c5c62',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59dde528d9df997a8c7ffdfa'
	}, {
		buyPrice: 131,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '2xm07p5.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dde029d9df997a8c7ffc0d',
			url: 'https://storage.googleapis.com/eezee-product-images/2xm07p5.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'EA',
			_id: '59f6ffcd324e463245cbb238',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '10M',
				_id: '59f6ffcd324e463245cbb23a',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 10.3,
					po: 'S$10.30'
				},
				name: '20M',
				_id: '59f6ffcd324e463245cbb239',
				order: 1
			}]
		}],
		title: 'AccSafe AE320 Horizontal Adjustable Webbing 10m with Bag AX050 ',
		bulkDiscount: [],
		uniqTitle: 'accsafe-ae-320-horizontal-adjustable-webbing-10-m-with-bag-ax-050',
		dateUpdated: '2017-11-21T12:17:44.577000',
		price: {
			ps: 'S$0.00',
			original: 150.7,
			po: 'S$150.70'
		},
		model: 'AccSafe AE320 Horizontal Adjustable Webbing 10m',
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		sku: 'd02aab54c9',
		oldSku: 'f46f6c5c62',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59dde562d9df997a8c7ffe0d'
	}, {
		buyPrice: 7.5,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'hwjomtw.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dde024d9df997a8c7ffbfd',
			url: 'https://storage.googleapis.com/eezee-product-images/hwjomtw.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'AccSafe AZ011 Screw Lock Openning 18MM Carabiner ',
		bulkDiscount: [],
		uniqTitle: 'accsafe-az-011-screw-lock-openning-18-mm-carabiner',
		dateUpdated: '2017-11-21T12:17:44.577000',
		price: {
			ps: 'S$0.00',
			original: 9.8,
			po: 'S$9.80'
		},
		model: 'AccSafe AZ011 ',
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		sku: '236a6b4e86',
		oldSku: 'f46f6c5c62',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59dde4f2d9df997a8c7ffde5'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '5khs8ue.jpeg',
			expire: '2017-10-04T15:28:34.538Z',
			__v: 0,
			_id: '59d5956e189444587ddb09de',
			url: 'https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg',
			fileType: 'image'
		}],
		supplierId: '59ccaff835cc384838b44e60',
		includes: [],
		variants: [{
			name: 'Ampere',
			_id: '59f6ffcd324e463245cbb12c',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC110V',
				_id: '59f6ffcd324e463245cbb130',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC220V',
				_id: '59f6ffcd324e463245cbb12f',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC240V',
				_id: '59f6ffcd324e463245cbb12e',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AC440V',
				_id: '59f6ffcd324e463245cbb12d',
				order: 3
			}]
		}],
		title: 'Terasaki Contactor 3P, 75A 50/60Hz',
		bulkDiscount: [{
			quantity: 100,
			discount: 10,
			_id: '59f6ffcd324e463245cbb131'
		}],
		uniqTitle: 'terasaki-contactor-3-p-75-a-50-60-hz',
		dateUpdated: '2017-11-21T12:17:44.568000',
		price: {
			ps: 'S$0.00',
			original: 156,
			po: 'S$156.00'
		},
		model: 'TC-75A',
		categories: {
			sub: 'Contactors',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'contactors',
			main: 'Electrical Components'
		},
		oldSku: '6ee8199954',
		sku: '31dbfac977',
		brand: {
			lowerCaseName: 'terasaki',
			kebabName: 'terasaki',
			name: 'TERASAKI',
			_id: '59c899ba65b9111a584936a9'
		},
		_id: '59d59674189444587ddb09ef'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150210112338TK63KTBXD8EV7_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150210112338TK63KTBXD8EV7_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 367.44,
			po: 'S$367.44'
		},
		includes: [],
		model: 'AH870S',
		variants: [{
			name: 'Model',
			_id: '59f6ffb7324e463245cb9fe5',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 65.91,
					po: 'S$65.91'
				},
				name: 'AH1040S',
				_id: '59f6ffb7324e463245cb9fe8',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 167.56,
					po: 'S$167.56'
				},
				name: 'AH1240S',
				_id: '59f6ffb7324e463245cb9fe7',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'AH870S',
				_id: '59f6ffb7324e463245cb9fe6',
				order: 2
			}]
		}],
		categories: {
			sub: 'Construction Tools',
			mainKebabCase: 'construction-products',
			subKebabCase: 'construction-tools',
			main: 'Construction Products'
		},
		title: 'ISHII TILE CUTTER AH870S / AH1040S / AH1240S',
		uniqTitle: 'ishii-tile-cutter-ah-870-s-ah-1040-s-ah-1240-s',
		bulkDiscount: [],
		sku: '1da86f264b',
		brand: {
			lowerCaseName: 'ishii tools',
			kebabName: 'ishii-tools',
			name: 'ISHII TOOLS',
			_id: '59b24e3eb38a0b0ad30a3b08'
		},
		dateUpdated: '2017-11-21T12:17:44.287000',
		_id: '59b90311196632786ed89e04'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'c52mw18.png',
			expire: '2017-10-27T10:41:08.204Z',
			__v: 0,
			_id: '59f41309f257f031ebf3fa9f',
			url: 'https://storage.googleapis.com/eezee-product-images/c52mw18.png',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'AccSafe Webbing Sling with Sewn Rubber Band 45mm x 1m included Screw Karabiner AZ011',
		uniqTitle: 'accsafe-webbing-sling-with-sewn-rubber-band-45-mm-x-1-m-included-screw-karabiner-az-011',
		bulkDiscount: [],
		dateUpdated: '2017-11-21T12:17:44.585000',
		price: {
			ps: 'S$0.00',
			original: 32.2,
			po: 'S$32.20'
		},
		model: 'AccSafe Webbing Sling AZ700',
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		sku: '89a220f814',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59f4138ff257f031ebf3fabb'
	}, {
		buyPrice: 140,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'gmal7o5.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dda09ed9df997a8c7fe27f',
			url: 'https://storage.googleapis.com/eezee-product-images/gmal7o5.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'AccSafe Foldable 2 Pole Stretcher Orange c/w Carrying Bag',
		bulkDiscount: [],
		uniqTitle: 'accsafe-foldable-2-pole-stretcher-orange-c-w-carrying-bag',
		dateUpdated: '2017-11-21T12:17:44.576000',
		price: {
			ps: 'S$0.00',
			original: 161,
			po: 'S$161.00'
		},
		model: 'AS Folding aluminum pole stretcher',
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		sku: '639762ee47',
		oldSku: 'f46f6c5c62',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59dda0dbd9df997a8c7fe297'
	}, {
		buyPrice: 95,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '0s6puko.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59ddde8bd9df997a8c7ffb71',
			url: 'https://storage.googleapis.com/eezee-product-images/0s6puko.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'AccSafe AH210 Rolex Self-Retracting Fall Arrester Webbing 2.25M c/w Carabiner',
		bulkDiscount: [],
		uniqTitle: 'accsafe-ah-210-rolex-self-retracting-fall-arrester-webbing-2-25-m-c-w-carabiner',
		dateUpdated: '2017-11-21T12:17:44.577000',
		price: {
			ps: 'S$0.00',
			original: 109.3,
			po: 'S$109.30'
		},
		model: 'AccSafe AH210 Rolex',
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		sku: '1bfb51e929',
		oldSku: 'f46f6c5c62',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59dde454d9df997a8c7ffda1'
	}, {
		buyPrice: 8,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'pq28kcs.png',
			expire: '2017-10-26T15:34:17.283Z',
			__v: 0,
			_id: '59f2ab2f7aea4707f1dcc2a7',
			url: 'https://storage.googleapis.com/eezee-product-images/pq28kcs.png',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Set',
			_id: '59f6ffce324e463245cbb3b5',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'M 10 x 110',
				_id: '59f6ffce324e463245cbb3b6',
				order: 0
			}]
		}],
		title: 'AccSafe AT181 SS316 Permanent Anchor Point Set with Stub M10x110',
		bulkDiscount: [],
		uniqTitle: 'accsafe-at-181-ss-316-permanent-anchor-point-set-with-stub-m-10-x-110',
		dateUpdated: '2017-11-21T12:17:44.585000',
		price: {
			ps: 'S$0.00',
			original: 10.4,
			po: 'S$10.40'
		},
		model: 'AccSafe AT181 SS316',
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		sku: '3bdb988f93',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59f4114ef257f031ebf3f9d0'
	}, {
		buyPrice: 107,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'k1iiuju.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59ddbbdfd9df997a8c7feb90',
			url: 'https://storage.googleapis.com/eezee-product-images/k1iiuju.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'AccSafe P11 Safety Harness with Front, Back Anchorage Point + AccSafe BW200LB122 Energy Absorber Double Lanyard with Scaffold Hook AZ022 & Auto Lock Carabiner AZ011T',
		bulkDiscount: [],
		uniqTitle: 'accsafe-p-11-safety-harness-with-front-back-anchorage-point-accsafe-bw-200-lb-122-energy-absorber-double-lanyard-with-scaffold-hook-az-022-auto-lock-carabiner-az-011-t',
		dateUpdated: '2017-11-21T12:17:44.577000',
		price: {
			ps: 'S$0.00',
			original: 123.1,
			po: 'S$123.10'
		},
		model: 'P11 Safety Harness with Front, Back Anchorage Point + AccSafe BW200LB122 Energy Absorber Double Lanyard with Scaffold Hook AZ022 & Auto Lock Carabiner AZ011T',
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		sku: 'bb4a527057',
		oldSku: 'f46f6c5c62',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59ddbe0cd9df997a8c7fec21'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'q6XcjWiYgsQ3wG~cma3FO8.jpg',
			expire: '2017-11-22T06:35:22.658Z',
			__v: 0,
			_id: '5a1675d3918693670dce7f45',
			url: 'https://storage.googleapis.com/eezee-product-images/q6XcjWiYgsQ3wG~cma3FO8.jpg',
			fileType: 'image'
		}],
		supplierId: '59ea27e1e7b62563f4032cea',
		includes: [],
		duplicate: false,
		variants: [],
		title: 'Lutron Bench Power Analyzer DW-6090A',
		bulkDiscount: [],
		uniqTitle: 'lutron-bench-power-analyzer-dw-6090-a',
		dateUpdated: '2017-11-23T08:10:46.309000',
		price: {
			ps: 'S$0.00',
			original: 540,
			po: 'S$540.00'
		},
		model: 'DW-6090A',
		categories: {
			sub: 'Power Meters',
			mainKebabCase: 'test-measure',
			subKebabCase: 'power-meters',
			main: 'Test & Measure'
		},
		sku: 'f29750ac78',
		brand: {
			lowerCaseName: 'lutron',
			kebabName: 'lutron',
			name: 'Lutron',
			_id: '59f8171262af544889dcd5da'
		},
		_id: '5a167659918693670dce7fe0'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '04028wy.jpeg',
			expire: '2017-10-10T05:46:53.096Z',
			__v: 0,
			_id: '59dc57f2e921c74d0963b9c3',
			url: 'https://storage.googleapis.com/eezee-product-images/04028wy.jpeg',
			fileType: 'image'
		}],
		supplierId: '59dc47cabaaac3444823b624',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'White',
			_id: '5a6009e741cb88759890c8d8',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 6,
					po: 'S$6.00'
				},
				name: '125ml Tube',
				_id: '5a6009e741cb88759890c8da',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '290ml Cartridge ',
				_id: '5a6009e741cb88759890c8d9',
				order: 1
			}]
		}],
		title: 'Quiadsa Ms-Aqua Sealant Adhesive',
		bulkDiscount: [{
			quantity: 167,
			discount: 10,
			_id: '5a6009e741cb88759890c8db'
		}],
		uniqTitle: 'quiadsa-ms-aqua-sealant-adhesive',
		dateUpdated: '2018-01-18T02:43:51.174000',
		price: {
			ps: 'S$0.00',
			original: 18,
			po: 'S$18.00'
		},
		model: 'Quiadsa Ms-Aqua Sealant Adhesive',
		categories: {
			sub: 'Sealants',
			mainKebabCase: 'chemical-products',
			subKebabCase: 'sealants',
			main: 'Chemical Products'
		},
		oldSku: '45451d6d28',
		sku: '2b562e36c7',
		brand: {
			lowerCaseName: 'quiadsa',
			kebabName: 'quiadsa',
			name: 'Quiadsa',
			_id: '59dc416cbaaac3444823ad76'
		},
		_id: '59dc5919e921c74d0963ba09'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20131113101258LAPH1NMX4RTEX_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20131113101258LAPH1NMX4RTEX_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 20,
			po: 'S$20.00'
		},
		includes: [],
		model: 'ASSMS',
		variants: [],
		categories: {
			sub: 'Office Equipment',
			mainKebabCase: 'stationery-office-equipment',
			subKebabCase: 'office-equipment',
			main: 'Stationery & Office Equipment'
		},
		title: 'MEASURING SCALE 5KG/1G',
		uniqTitle: 'measuring-scale-5-kg-1-g',
		bulkDiscount: [],
		sku: 'df2a46df88',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.155000',
		_id: '59b90310196632786ed891ef'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20131210144502SDCPXJAQO9UWU_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20131210144502SDCPXJAQO9UWU_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 136.96,
			po: 'S$136.96'
		},
		includes: [],
		model: 'ABC2404',
		variants: [],
		categories: {
			sub: 'Connected Homes & Electrics',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'connected-homes-electrics',
			main: 'Electrical Components'
		},
		title: 'LEAD ACID AUTOMATIC BTY CHARGER ABC2404  24V 4A',
		uniqTitle: 'lead-acid-automatic-bty-charger-abc-2404-24-v-4-a',
		bulkDiscount: [],
		sku: '1491a75700',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.166000',
		_id: '59b90310196632786ed892a6'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140710134336ONQFMX4M42AC5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140710134336ONQFMX4M42AC5_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 3.8,
			po: 'S$3.80'
		},
		includes: [],
		model: 'APS700',
		variants: [],
		categories: {
			sub: 'Gardening Tools',
			mainKebabCase: 'outdoor-gardening',
			subKebabCase: 'gardening-tools',
			main: 'Outdoor & Gardening'
		},
		title: 'TRIMMER SHEAR 170MM ---- A-PS700',
		uniqTitle: 'trimmer-shear-170-mm-a-ps-700',
		bulkDiscount: [],
		sku: '2c90de1b36',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.237000',
		_id: '59b90311196632786ed897fd'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201509071558030IDWVVLM9SASM_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201509071558030IDWVVLM9SASM_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 642,
			po: 'S$642.00'
		},
		includes: [],
		model: 'AN800',
		variants: [],
		categories: {
			sub: 'Air Tools',
			mainKebabCase: 'air-equipment',
			subKebabCase: 'air-tools',
			main: 'Air Equipment'
		},
		title: 'SUNCITY AIR NUT RIVETER AN800',
		uniqTitle: 'suncity-air-nut-riveter-an-800',
		bulkDiscount: [],
		sku: 'ff7ffbbccb',
		brand: {
			lowerCaseName: 'sun city',
			kebabName: 'sun-city',
			name: 'SUN CITY',
			_id: '59b24e3eb38a0b0ad30a3b07'
		},
		dateUpdated: '2017-11-21T12:17:44.339000',
		_id: '59b90311196632786ed8a200'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130315155501VLEWL0VUMV6JC_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130315155501VLEWL0VUMV6JC_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 16.65,
			po: 'S$16.65'
		},
		includes: [],
		model: 'ASG28',
		variants: [],
		categories: {
			sub: 'Fillers, Putty & Waterproofing',
			mainKebabCase: 'chemical-products',
			subKebabCase: 'fillers-putty-waterproofing',
			main: 'Chemical Products'
		},
		title: 'ASG JOINT COMPOUND -28KGS/PAIL',
		uniqTitle: 'asg-joint-compound-28-kgs-pail',
		bulkDiscount: [],
		sku: 'df1d734ce8',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.216000',
		_id: '59b90311196632786ed8967b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140729083902TFO1U3ZG0OXNP_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140729083902TFO1U3ZG0OXNP_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 17.7,
			po: 'S$17.70'
		},
		includes: [],
		model: 'AB1',
		variants: [],
		categories: {
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools',
			main: 'Hand Tools'
		},
		title: 'BEARING PULLER AB-1 19MM-35MM',
		uniqTitle: 'bearing-puller-ab-1-19-mm-35-mm',
		bulkDiscount: [],
		sku: 'a248f0b123',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.271000',
		_id: '59b90311196632786ed89bab'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141118124409SO4KL3N2WLG57_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141118124409SO4KL3N2WLG57_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 0.64,
			po: 'S$0.64'
		},
		includes: [],
		model: 'AB409O',
		variants: [{
			name: 'Package',
			_id: '59f6ffb5324e463245cb9b4f',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 30.93,
					po: 'S$30.93'
				},
				name: 'Box of 50',
				_id: '59f6ffb5324e463245cb9b50',
				order: 0
			}]
		}],
		categories: {
			sub: 'Anchors & Rivets',
			mainKebabCase: 'fasteners',
			subKebabCase: 'anchors-rivets',
			main: 'Fasteners'
		},
		title: 'HIT STEEL BOARD ANCHOR HOOK AB409O',
		uniqTitle: 'hit-steel-board-anchor-hook-ab-409-o',
		bulkDiscount: [],
		sku: 'd2b020a16e',
		brand: {
			lowerCaseName: 'hit tools',
			kebabName: 'hit-tools',
			name: 'HIT TOOLS',
			_id: '59b24e3eb38a0b0ad30a3ab6'
		},
		dateUpdated: '2017-11-21T12:17:44.273000',
		_id: '59b90311196632786ed89bf1'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150413170458NZMBXHADMVX1Y_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150413170458NZMBXHADMVX1Y_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 2.7,
			po: 'S$2.70'
		},
		includes: [],
		model: 'A620',
		variants: [],
		categories: {
			sub: 'Door Hardware & Locks',
			mainKebabCase: 'locks-iron-mongery',
			subKebabCase: 'door-hardware-locks',
			main: 'Locks & Iron Mongery'
		},
		title: 'ADL CHAIN DOOR GUARD-A620',
		uniqTitle: 'adl-chain-door-guard-a-620',
		bulkDiscount: [],
		sku: '141e52b404',
		brand: {
			lowerCaseName: 'adl',
			kebabName: 'adl',
			name: 'ADL',
			_id: '59b24e3eb38a0b0ad30a3a54'
		},
		dateUpdated: '2017-11-21T12:17:44.302000',
		_id: '59b90311196632786ed89f5e'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20161221172052WGSMUGITDPKYO_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161221172052WGSMUGITDPKYO_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20161221172100J9LYLMGCTUAEF_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161221172100J9LYLMGCTUAEF_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 29.9,
			po: 'S$29.90'
		},
		includes: [],
		model: 'AC326',
		variants: [],
		categories: {
			sub: 'Car Care Products',
			mainKebabCase: 'cleaning-products',
			subKebabCase: 'car-care-products',
			main: 'Cleaning Products'
		},
		title: 'RUST OLEUM KRUD KUTTER 3-IN-1 AUTOMOTIVE SPRAY CLEAN-UP AC326 32OZ',
		uniqTitle: 'rust-oleum-krud-kutter-3-in-1-automotive-spray-clean-up-ac-326-32-oz',
		bulkDiscount: [],
		sku: 'cf30dd743d',
		brand: {
			lowerCaseName: 'rust oleum',
			kebabName: 'rust-oleum',
			name: 'RUST OLEUM',
			_id: '59b24e3eb38a0b0ad30a3b62'
		},
		dateUpdated: '2017-11-21T12:17:44.483000',
		_id: '59b90312196632786ed8ac9e'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160525124512LJ7UNGJCF4X4S_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160525124512LJ7UNGJCF4X4S_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 70.62,
			po: 'S$70.62'
		},
		includes: [],
		model: 'AWS68',
		variants: [],
		categories: {
			sub: 'Lubricants & Oils',
			mainKebabCase: 'chemical-products',
			subKebabCase: 'lubricants-oils',
			main: 'Chemical Products'
		},
		title: 'CASTROL HYDRAULIC OIL HYSPIN AWS 68 (18 L)',
		uniqTitle: 'castrol-hydraulic-oil-hyspin-aws-68-18-l',
		bulkDiscount: [],
		sku: 'd7ee33aef2',
		dateUpdated: '2017-11-21T12:17:44.421000',
		_id: '59b90312196632786ed8a800'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170613164711R7DKYEER6Y3TY_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170613164711R7DKYEER6Y3TY_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612105326ZGQK3R3WA1VYG_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612105326ZGQK3R3WA1VYG_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612105330VHHGMMVCUPEJM_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612105330VHHGMMVCUPEJM_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612105334OHGB6EBYEMVSN_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612105334OHGB6EBYEMVSN_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 727.6,
			po: 'S$727.60'
		},
		includes: [],
		model: 'AR0173',
		variants: [],
		categories: {
			sub: 'Rehab, Home Care & Medical Equipment',
			mainKebabCase: 'medical-healthcare-supplies',
			subKebabCase: 'rehab-home-care-medical-equipment',
			main: 'Medical & Healthcare Supplies'
		},
		title: 'ASSURE ALUMINIUM DAEF RECLINING WHEEL CHAIR 18" AR0173',
		uniqTitle: 'assure-aluminium-daef-reclining-wheel-chair-18-ar-0173',
		bulkDiscount: [],
		sku: 'e08f3ac974',
		brand: {
			lowerCaseName: 'assure',
			kebabName: 'assure',
			name: 'ASSURE',
			_id: '59b24e3eb38a0b0ad30a3a88'
		},
		dateUpdated: '2017-11-21T12:17:44.533000',
		_id: '59b90312196632786ed8afcf'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170613164255Q9HCC0TDNJPFQ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170613164255Q9HCC0TDNJPFQ_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612112713CFJNNKC4CGVFA_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612112713CFJNNKC4CGVFA_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 288.9,
			po: 'S$288.90'
		},
		includes: [],
		model: 'AR0194',
		variants: [],
		categories: {
			sub: 'Rehab, Home Care & Medical Equipment',
			mainKebabCase: 'medical-healthcare-supplies',
			subKebabCase: 'rehab-home-care-medical-equipment',
			main: 'Medical & Healthcare Supplies'
		},
		title: 'ASSURE SUPER LT WT SEMI STD TRANSPORT CHAIR 18" WITH 8" REAR WHEEL AR0194',
		uniqTitle: 'assure-super-lt-wt-semi-std-transport-chair-18-with-8-rear-wheel-ar-0194',
		bulkDiscount: [],
		sku: 'f9c5be0a84',
		brand: {
			lowerCaseName: 'assure',
			kebabName: 'assure',
			name: 'ASSURE',
			_id: '59b24e3eb38a0b0ad30a3a88'
		},
		dateUpdated: '2017-11-21T12:17:44.533000',
		_id: '59b90312196632786ed8afd1'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170613164116QUXA5FW0QSNFB_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170613164116QUXA5FW0QSNFB_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612112754KYHFXN3AGRP7B_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612112754KYHFXN3AGRP7B_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612112757D7H2QCVT7HCHH_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612112757D7H2QCVT7HCHH_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612112801MGSKEEBXSUB34_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612112801MGSKEEBXSUB34_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201706121128075THPTZB2HUKFR_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201706121128075THPTZB2HUKFR_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612112813VX1GM7FLEHMPI_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612112813VX1GM7FLEHMPI_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612112820LJZFSZCT1RVTN_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612112820LJZFSZCT1RVTN_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612112825YYZQW3ZZG6KDC_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612112825YYZQW3ZZG6KDC_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 353.1,
			po: 'S$353.10'
		},
		includes: [],
		model: 'AR0195',
		variants: [],
		categories: {
			sub: 'Rehab, Home Care & Medical Equipment',
			mainKebabCase: 'medical-healthcare-supplies',
			subKebabCase: 'rehab-home-care-medical-equipment',
			main: 'Medical & Healthcare Supplies'
		},
		title: 'ASSURE SUPER LT WT DAF TRANSPORT CHAIR 18" WITH 12" REAR WHEEL AR0195',
		uniqTitle: 'assure-super-lt-wt-daf-transport-chair-18-with-12-rear-wheel-ar-0195',
		bulkDiscount: [],
		sku: 'a3bbb27dda',
		brand: {
			lowerCaseName: 'assure',
			kebabName: 'assure',
			name: 'ASSURE',
			_id: '59b24e3eb38a0b0ad30a3a88'
		},
		dateUpdated: '2017-11-21T12:17:44.533000',
		_id: '59b90312196632786ed8afd2'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170613163937IDCO6RYAJCG1K_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170613163937IDCO6RYAJCG1K_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612113540FY4TTQLRBULVV_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612113540FY4TTQLRBULVV_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612113544XUHF33WBFTA55_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612113544XUHF33WBFTA55_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612113548DKG0DXJJRLOQA_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612113548DKG0DXJJRLOQA_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612113556CEO9OIS2KLJ5E_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612113556CEO9OIS2KLJ5E_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170612113603CSAOEOOPPS19L_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612113603CSAOEOOPPS19L_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 251.45,
			po: 'S$251.45'
		},
		includes: [],
		model: 'AR0190',
		variants: [],
		categories: {
			sub: 'Rehab, Home Care & Medical Equipment',
			mainKebabCase: 'medical-healthcare-supplies',
			subKebabCase: 'rehab-home-care-medical-equipment',
			main: 'Medical & Healthcare Supplies'
		},
		title: 'ASSURE ALUMINIUM TRANSIT CHAIR WITH FLIP AF & DB HANDLE 14.5" AR0190',
		uniqTitle: 'assure-aluminium-transit-chair-with-flip-af-db-handle-14-5-ar-0190',
		bulkDiscount: [],
		sku: 'dcee423ec0',
		brand: {
			lowerCaseName: 'assure',
			kebabName: 'assure',
			name: 'ASSURE',
			_id: '59b24e3eb38a0b0ad30a3a88'
		},
		dateUpdated: '2017-11-21T12:17:44.533000',
		_id: '59b90312196632786ed8afd3'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170612122505LRCPCBKRR1BTP_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612122505LRCPCBKRR1BTP_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 123.05,
			po: 'S$123.05'
		},
		includes: [],
		model: 'AR0248',
		variants: [],
		categories: {
			sub: 'Rehab, Home Care & Medical Equipment',
			mainKebabCase: 'medical-healthcare-supplies',
			subKebabCase: 'rehab-home-care-medical-equipment',
			main: 'Medical & Healthcare Supplies'
		},
		title: 'ASSURE ALUMINIUM ADJ.SHOWER SEAT WITH EVA FOAM & BACKSET AR0248',
		uniqTitle: 'assure-aluminium-adj-shower-seat-with-eva-foam-backset-ar-0248',
		bulkDiscount: [],
		sku: 'bb2473384f',
		brand: {
			lowerCaseName: 'assure',
			kebabName: 'assure',
			name: 'ASSURE',
			_id: '59b24e3eb38a0b0ad30a3a88'
		},
		dateUpdated: '2017-11-21T12:17:44.533000',
		_id: '59b90312196632786ed8afd9'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '2017061316250308RO1QIPYS0IR_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2017061316250308RO1QIPYS0IR_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 786.45,
			po: 'S$786.45'
		},
		includes: [],
		model: 'AR0558',
		variants: [],
		categories: {
			sub: 'Rehab, Home Care & Medical Equipment',
			mainKebabCase: 'medical-healthcare-supplies',
			subKebabCase: 'rehab-home-care-medical-equipment',
			main: 'Medical & Healthcare Supplies'
		},
		title: 'ASSURE 3 POSITION GERIATRIC CHAIR WITH DROP ARMREST,100/120/125\xB0 AR0558',
		uniqTitle: 'assure-3-position-geriatric-chair-with-drop-armrest-100-120-125-ar-0558',
		bulkDiscount: [],
		sku: '04cad4cb38',
		brand: {
			lowerCaseName: 'assure',
			kebabName: 'assure',
			name: 'ASSURE',
			_id: '59b24e3eb38a0b0ad30a3a88'
		},
		dateUpdated: '2017-11-21T12:17:44.533000',
		_id: '59b90312196632786ed8afe1'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170612155048DKAOD5EZPYWME_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170612155048DKAOD5EZPYWME_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 10.7,
			po: 'S$10.70'
		},
		includes: [],
		model: 'AR0730',
		variants: [],
		categories: {
			sub: 'Medical Disposables',
			mainKebabCase: 'medical-healthcare-supplies',
			subKebabCase: 'medical-disposables',
			main: 'Medical & Healthcare Supplies'
		},
		title: 'ASSURE COLD & HOT PACK 27CMX14CM AR0730',
		uniqTitle: 'assure-cold-hot-pack-27-cmx-14-cm-ar-0730',
		bulkDiscount: [],
		sku: 'c51426aa8a',
		brand: {
			lowerCaseName: 'assure',
			kebabName: 'assure',
			name: 'ASSURE',
			_id: '59b24e3eb38a0b0ad30a3a88'
		},
		dateUpdated: '2017-11-21T12:17:44.535000',
		_id: '59b90312196632786ed8afe4'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170905100929TE7F33WVYVDE7_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170905100929TE7F33WVYVDE7_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 630.01,
			po: 'S$630.01'
		},
		includes: [],
		model: 'AG890R',
		variants: [],
		categories: {
			sub: 'Air Tools',
			mainKebabCase: 'air-equipment',
			subKebabCase: 'air-tools',
			main: 'Air Equipment'
		},
		title: 'MAJESTA AIR ANGLE GRINDER 7" HEAVY DUTY AG-890R',
		uniqTitle: 'majesta-air-angle-grinder-7-heavy-duty-ag-890-r',
		bulkDiscount: [],
		sku: '26bf4c95c9',
		dateUpdated: '2017-11-21T12:17:44.557000',
		_id: '59b90312196632786ed8b159'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170905101213DGNFVYCR3MRBO_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170905101213DGNFVYCR3MRBO_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 1300,
			po: 'S$1,300.00'
		},
		includes: [],
		model: 'AG629L',
		variants: [],
		categories: {
			sub: 'Air Tools',
			mainKebabCase: 'air-equipment',
			subKebabCase: 'air-tools',
			main: 'Air Equipment'
		},
		title: 'MAJESTA AIR ANGLE GRINDER 9" HEAVY DUTY AG-629L',
		uniqTitle: 'majesta-air-angle-grinder-9-heavy-duty-ag-629-l',
		bulkDiscount: [],
		sku: 'd4a5a5e346',
		dateUpdated: '2017-11-21T12:17:44.558000',
		_id: '59b90312196632786ed8b15a'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '2016062017135302KKZD3UOXDFI_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2016062017135302KKZD3UOXDFI_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160620171356RXR8NWLZMG5RQ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160620171356RXR8NWLZMG5RQ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 3,
			po: 'S$3.00'
		},
		includes: [],
		model: 'AD117',
		variants: [],
		categories: {
			sub: 'Adhesives & Glues',
			mainKebabCase: 'chemical-products',
			subKebabCase: 'adhesives-glues',
			main: 'Chemical Products'
		},
		title: '3M SCOTCH GENERAL PURPOSE SUPER GLUE LIQUD 7OZ (2PPP) - AD117',
		uniqTitle: '3-m-scotch-general-purpose-super-glue-liqud-7-oz-2-ppp-ad-117',
		bulkDiscount: [],
		sku: '864afbcf21',
		brand: {
			lowerCaseName: '3m',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'XGfw9FuhgQqHnuYNmgfDr~.jpg',
				expire: '2017-12-20T12:56:42.106000',
				__v: 0,
				_id: '5a3b21b1f5ad5a4e7cc92d35',
				url: 'https://storage.googleapis.com/eezee-brand-images/XGfw9FuhgQqHnuYNmgfDr~.jpg',
				fileType: 'image'
			},
			featured: true,
			kebabName: '3-m',
			name: '3M',
			_id: '59b24e3eb38a0b0ad30a39f1'
		},
		dateUpdated: '2017-11-21T12:17:44.433000',
		_id: '59b90312196632786ed8a8cf'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'bjDcMiR98FJKRBVcdQzzZ0.jpg',
			expire: '2017-12-26T05:19:32.898Z',
			__v: 0,
			_id: '5a430a824d28407c4dd66552',
			url: 'https://storage.googleapis.com/eezee-product-images/bjDcMiR98FJKRBVcdQzzZ0.jpg',
			fileType: 'image'
		}],
		supplierId: '59f03ce3f0e6051110ae2e06',
		price: {
			ps: 'S$0.00',
			original: 10.5,
			po: 'S$10.50'
		},
		includes: [],
		model: 'Azfoam',
		variants: [],
		categories: {
			sub: 'Fillers, Putty & Waterproofing',
			mainKebabCase: 'chemical-products',
			subKebabCase: 'fillers-putty-waterproofing',
			main: 'Chemical Products'
		},
		title: 'Expanding Foam 750ml',
		uniqTitle: 'expanding-foam-750-ml',
		bulkDiscount: [],
		sku: 'eb9f6a4c11',
		brand: {
			lowerCaseName: 'azfast',
			kebabName: 'azfast',
			name: 'Azfast',
			_id: '59f04431f0e6051110ae3342'
		},
		_id: '5a43130b4d28407c4dd67bae'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201603091438319UTET0OAZZARY_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201603091438319UTET0OAZZARY_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 187.25,
			po: 'S$187.25'
		},
		includes: [],
		model: 'AL1860CV',
		variants: [],
		categories: {
			sub: 'Batteries & Chargers',
			mainKebabCase: 'power-tools-accessories',
			subKebabCase: 'batteries-chargers',
			main: 'Power Tools - Accessories'
		},
		title: 'BOSCH STARTER KIT 2.0AH/14.4V (AL1860CV)',
		uniqTitle: 'bosch-starter-kit-2-0-ah-14-4-v-al-1860-cv',
		bulkDiscount: [],
		sku: '8129a79c6d',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		dateUpdated: '2017-11-21T12:17:44.406000',
		_id: '59b90311196632786ed8a6c3'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130828172858C7EUTDDJWPDQC_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130828172858C7EUTDDJWPDQC_full.jpg',
			fileType: 'image'
		}],
		supplierId: '5a1fba59735a7d0cbca41451',
		includes: ['Hose', 'Nozzle with dust pick up brush', 'Water pick up brush', 'Crevice tool with bristle brush', 'Extension wand X 2', 'Filter', 'Mesh'],
		duplicate: false,
		variants: [],
		title: 'AEG 20L VACUUM CLEANER, 1200W, AP20',
		bulkDiscount: [],
		uniqTitle: 'aeg-20-l-vacuum-cleaner-1200-w-ap-20',
		dateUpdated: '2017-12-02T09:07:48.528000',
		price: {
			ps: 'S$0.00',
			original: 160.5,
			po: 'S$160.50'
		},
		model: 'AP20',
		categories: {
			sub: 'Vacuums & Floor Care',
			mainKebabCase: 'cleaning-products',
			subKebabCase: 'vacuums-floor-care',
			main: 'Cleaning Products'
		},
		sku: 'c307e9fbbc',
		brand: {
			lowerCaseName: 'aeg',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '_fceFZujLWYnG0RblL8tFM.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a421de64d28407c4dd48d24',
				url: 'https://storage.googleapis.com/eezee-brand-images/_fceFZujLWYnG0RblL8tFM.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'aeg',
			name: 'AEG',
			_id: '59b24e3eb38a0b0ad30a39de'
		},
		_id: '59b90310196632786ed88f3d'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20161014121614IKHNKUYZLD5HS_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161014121614IKHNKUYZLD5HS_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20161014121650AFQV2PCJM2S8Y_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161014121650AFQV2PCJM2S8Y_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20161014121652WYLOJNZPGOWYE_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161014121652WYLOJNZPGOWYE_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20161014121655SXXIFBA0QJ5FG_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161014121655SXXIFBA0QJ5FG_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 99.95,
			po: 'S$99.95'
		},
		includes: [],
		model: 'ALTA7200',
		variants: [],
		categories: {
			sub: 'Garden Watering System',
			mainKebabCase: 'outdoor-gardening',
			subKebabCase: 'garden-watering-system',
			main: 'Outdoor & Gardening'
		},
		title: 'DIMARTINO PRESSURE SPRAYER ALTA 15000 FPM BLUE',
		uniqTitle: 'dimartino-pressure-sprayer-alta-15000-fpm-blue',
		bulkDiscount: [],
		sku: '7137155bea',
		brand: {
			lowerCaseName: 'dimartino',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'j1rqZMAkMjwrYgxsqBoZif.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a433619cdf0b93657281310',
				url: 'https://storage.googleapis.com/eezee-brand-images/j1rqZMAkMjwrYgxsqBoZif.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'dimartino',
			name: 'DIMARTINO',
			_id: '59b24e3eb38a0b0ad30a39f4'
		},
		dateUpdated: '2017-11-21T12:17:44.068000',
		_id: '59b90310196632786ed88c6a'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20161014122756SX9ELW7XORSK7_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161014122756SX9ELW7XORSK7_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 99.85,
			po: 'S$99.85'
		},
		includes: [],
		model: 'ALTA12000',
		variants: [],
		categories: {
			sub: 'Garden Watering System',
			mainKebabCase: 'outdoor-gardening',
			subKebabCase: 'garden-watering-system',
			main: 'Outdoor & Gardening'
		},
		title: 'DIMARTINO KNACKSPACK SPRAYER HERMETIC NYPLEN PISTON VITON, ALTA 12000,FPM,',
		uniqTitle: 'dimartino-knackspack-sprayer-hermetic-nyplen-piston-viton-alta-12000-fpm',
		bulkDiscount: [],
		sku: '61dfe5444a',
		brand: {
			lowerCaseName: 'dimartino',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'j1rqZMAkMjwrYgxsqBoZif.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a433619cdf0b93657281310',
				url: 'https://storage.googleapis.com/eezee-brand-images/j1rqZMAkMjwrYgxsqBoZif.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'dimartino',
			name: 'DIMARTINO',
			_id: '59b24e3eb38a0b0ad30a39f4'
		},
		dateUpdated: '2017-11-21T12:17:44.277000',
		_id: '59b90311196632786ed89c8f'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20131128115005WT25I6P1ZPI3S_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20131128115005WT25I6P1ZPI3S_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 5.9,
			po: 'S$5.90'
		},
		includes: [],
		model: 'AG',
		variants: [],
		categories: {
			sub: 'Adhesives & Glues',
			mainKebabCase: 'chemical-products',
			subKebabCase: 'adhesives-glues',
			main: 'Chemical Products'
		},
		title: 'AMAZING GOOP ALL PURPOSE 29.5ML',
		uniqTitle: 'amazing-goop-all-purpose-29-5-ml',
		bulkDiscount: [],
		sku: 'c9d23fe671',
		brand: {
			lowerCaseName: 'amazing goop',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'Cwyt1Pw_Zo5q1gXMRVqQPW.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a4356d6cdf0b936572d31b5',
				url: 'https://storage.googleapis.com/eezee-brand-images/Cwyt1Pw_Zo5q1gXMRVqQPW.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'amazing-goop',
			name: 'AMAZING GOOP',
			_id: '59b24e3eb38a0b0ad30a3a25'
		},
		dateUpdated: '2017-11-21T12:17:44.131000',
		_id: '59b90310196632786ed890a3'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151105175622UWYSJFR5C7ZG6_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151105175622UWYSJFR5C7ZG6_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 11.3,
			po: 'S$11.30'
		},
		includes: [],
		model: 'AAA',
		variants: [{
			name: 'Litre',
			_id: '59f6ffac324e463245cb91c6',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 30.7,
					po: 'S$30.70'
				},
				name: '16L',
				_id: '59f6ffac324e463245cb91c8',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '3.5L',
				_id: '59f6ffac324e463245cb91c7',
				order: 1
			}]
		}],
		categories: {
			sub: 'Paint Thinners, Solvents & Cleaners',
			mainKebabCase: 'paints',
			subKebabCase: 'paint-thinners-solvents-cleaners',
			main: 'Paints'
		},
		title: 'TIGER THINNER AAA',
		uniqTitle: 'tiger-thinner-aaa',
		bulkDiscount: [],
		sku: 'ea886c3b32',
		brand: {
			lowerCaseName: 'tiger brand paint',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'elWIEnBGxjEjjD2_qZx1kY.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a43565dcdf0b936572d2dcc',
				url: 'https://storage.googleapis.com/eezee-brand-images/elWIEnBGxjEjjD2_qZx1kY.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'tiger-brand-paint',
			name: 'TIGER BRAND PAINT',
			_id: '59b24e3eb38a0b0ad30a3a23'
		},
		dateUpdated: '2017-11-21T12:17:44.195000',
		_id: '59b90311196632786ed894e6'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141015213046ZYM1W7QE5IZOZ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141015213046ZYM1W7QE5IZOZ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 8.6,
			po: 'S$8.60'
		},
		includes: [],
		model: 'AP203',
		variants: [{
			name: 'Capacity',
			_id: '59f6ffb3324e463245cb98a4',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '1 L',
				_id: '59f6ffb3324e463245cb98a9',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 60.95,
					po: 'S$60.95'
				},
				name: '16 L',
				_id: '59f6ffb3324e463245cb98a8',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 79.14,
					po: 'S$79.14'
				},
				name: '20L',
				_id: '59f6ffb3324e463245cb98a7',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 11.3,
					po: 'S$11.30'
				},
				name: '3.5 L',
				_id: '59f6ffb3324e463245cb98a6',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 19.9,
					po: 'S$19.90'
				},
				name: '5 L',
				_id: '59f6ffb3324e463245cb98a5',
				order: 4
			}]
		}],
		categories: {
			sub: 'Interior Paints',
			mainKebabCase: 'paints',
			subKebabCase: 'interior-paints',
			main: 'Paints'
		},
		title: 'TIGER ALUMINIUM PAINT',
		uniqTitle: 'tiger-aluminium-paint',
		bulkDiscount: [],
		sku: '416bf49196',
		brand: {
			lowerCaseName: 'tiger brand paint',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'elWIEnBGxjEjjD2_qZx1kY.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a43565dcdf0b936572d2dcc',
				url: 'https://storage.googleapis.com/eezee-brand-images/elWIEnBGxjEjjD2_qZx1kY.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'tiger-brand-paint',
			name: 'TIGER BRAND PAINT',
			_id: '59b24e3eb38a0b0ad30a3a23'
		},
		dateUpdated: '2017-11-21T12:17:44.262000',
		_id: '59b90311196632786ed89a43'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140107095154YMOAFB3OCX2W7_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140107095154YMOAFB3OCX2W7_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 3,
			po: 'S$3.00'
		},
		includes: [],
		model: 'A23',
		variants: [],
		categories: {
			sub: 'Household Sundries',
			mainKebabCase: 'household-products',
			subKebabCase: 'household-sundries',
			main: 'Household Products'
		},
		title: 'ENERGIZER ALKALINE BATTERY 12V (A23)',
		uniqTitle: 'energizer-alkaline-battery-12-v-a-23',
		bulkDiscount: [],
		sku: '03c97e1ce9',
		brand: {
			lowerCaseName: 'energizer battery',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'CDow7ove3q7sCuCNSrZ8Q_.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a436e1acdf0b936573566db',
				url: 'https://storage.googleapis.com/eezee-brand-images/CDow7ove3q7sCuCNSrZ8Q_.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'energizer-battery',
			name: 'ENERGIZER BATTERY',
			_id: '59b24e3eb38a0b0ad30a3a42'
		},
		dateUpdated: '2017-11-21T12:17:44.177000',
		_id: '59b90311196632786ed8936b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141107130918H5MYIBKGLCQAQ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141107130918H5MYIBKGLCQAQ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 13.4,
			po: 'S$13.40'
		},
		includes: [],
		model: 'AC8',
		variants: [],
		categories: {
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools',
			main: 'Electrical Components'
		},
		title: 'OPT WIRE ROPE CUTTER AC8 - CUTTER RANGE:DIA 4MM',
		uniqTitle: 'opt-wire-rope-cutter-ac-8-cutter-range-dia-4-mm',
		bulkDiscount: [],
		sku: 'b714351d06',
		brand: {
			lowerCaseName: 'opt electricians tools',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'k6s1Dyi_Oim4XGZgBp~YlG.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a43723ecdf0b936573583cb',
				url: 'https://storage.googleapis.com/eezee-brand-images/k6s1Dyi_Oim4XGZgBp~YlG.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'opt-electricians-tools',
			name: 'OPT ELECTRICIANS TOOLS',
			_id: '59b24e3eb38a0b0ad30a3a50'
		},
		dateUpdated: '2017-11-21T12:17:44.269000',
		_id: '59b90311196632786ed89b47'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'yK8JiEnfBvN2El54YHJUCO.png',
			__v: 0,
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5880c837f8836a18cbed1c',
			url: 'https://storage.googleapis.com/eezee-product-images/yK8JiEnfBvN2El54YHJUCO.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '2jmRgKxcS6nv5f1pvT2XoZ.png',
			__v: 0,
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5880cc37f8836a18cbed1d',
			url: 'https://storage.googleapis.com/eezee-product-images/2jmRgKxcS6nv5f1pvT2XoZ.png',
			fileType: 'image'
		}],
		supplierId: '5a41c6cbe0f45a72d56dae5c',
		includes: [],
		duplicate: false,
		variants: [],
		title: 'Zeca/Italy - Las Vegas Art.339 (Rechargeable LED Lamp)',
		bulkDiscount: [],
		uniqTitle: 'zeca-italy-las-vegas-art-339-rechargeable-led-lamp',
		dateUpdated: '2018-01-12T09:37:43.726000',
		price: {
			ps: 'S$0.00',
			original: 177,
			po: 'S$177.00'
		},
		model: 'Art.KB339',
		categories: {
			sub: 'Flashlights & Lighting',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'flashlights-lighting',
			main: 'Electrical Components'
		},
		sku: '6941ce8a02',
		brand: {
			lowerCaseName: 'zeca',
			kebabName: 'zeca',
			name: 'ZECA',
			_id: '5a2e9a7d1f57bf1c11fdd79f'
		},
		_id: '5a587f5037f8836a18cbe7d0'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140708131248EXO3URCBOWF5K_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140708131248EXO3URCBOWF5K_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20151014161649CEQKZJWDUWWTM_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151014161649CEQKZJWDUWWTM_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 25.7,
			po: 'S$25.70'
		},
		includes: [],
		model: 'AT519',
		variants: [],
		categories: {
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools',
			main: 'Hand Tools'
		},
		title: 'APEXON 4-IN-1 HD METAL STAPLE GUN AT519',
		uniqTitle: 'apexon-4-in-1-hd-metal-staple-gun-at-519',
		bulkDiscount: [],
		sku: '61a5bacc75',
		brand: {
			lowerCaseName: 'apexon',
			kebabName: 'apexon',
			name: 'APEXON',
			_id: '59b24e3eb38a0b0ad30a3abc'
		},
		dateUpdated: '2017-11-21T12:17:44.233000',
		_id: '59b90311196632786ed89785'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201408061457418S5YLLQNDALKJ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201408061457418S5YLLQNDALKJ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 3.8,
			po: 'S$3.80'
		},
		includes: [],
		model: 'APEX',
		variants: [{
			name: 'Loading',
			_id: '59f6ffb0324e463245cb9598',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '08kg',
				_id: '59f6ffb0324e463245cb959c',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 1.05,
					po: 'S$1.05'
				},
				name: '12kg',
				_id: '59f6ffb0324e463245cb959b',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 1.55,
					po: 'S$1.55'
				},
				name: '15kg',
				_id: '59f6ffb0324e463245cb959a',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 2.75,
					po: 'S$2.75'
				},
				name: '20kg',
				_id: '59f6ffb0324e463245cb9599',
				order: 3
			}]
		}],
		categories: {
			sub: 'Door Hardware & Locks',
			mainKebabCase: 'locks-iron-mongery',
			subKebabCase: 'door-hardware-locks',
			main: 'Locks & Iron Mongery'
		},
		title: 'APEX GAS SPRING',
		uniqTitle: 'apex-gas-spring',
		bulkDiscount: [],
		sku: '777b1ca009',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.238000',
		_id: '59b90311196632786ed89806'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160504160338EMYQNRBDSIQW6_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160504160338EMYQNRBDSIQW6_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201605041606474LN0WQHPH3XEK_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201605041606474LN0WQHPH3XEK_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160504161812BYMUFQJYFXTWT_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160504161812BYMUFQJYFXTWT_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 374.5,
			po: 'S$374.50'
		},
		includes: [],
		model: 'ARC250GA',
		variants: [],
		categories: {
			sub: 'Welders',
			mainKebabCase: 'welding-equipment-products',
			subKebabCase: 'welders',
			main: 'Welding Equipment & Products'
		},
		title: 'CYC IGBT INVERTER WELDER ARC250GA',
		uniqTitle: 'cyc-igbt-inverter-welder-arc-250-ga',
		bulkDiscount: [],
		sku: '65de391e6b',
		brand: {
			lowerCaseName: 'cyc',
			kebabName: 'cyc',
			name: 'CYC',
			_id: '59b24e3eb38a0b0ad30a3a96'
		},
		dateUpdated: '2017-11-21T12:17:44.247000',
		_id: '59b90311196632786ed898b0'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140723110956OUH8K4UYOVESY_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140723110956OUH8K4UYOVESY_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 11.25,
			po: 'S$11.25'
		},
		includes: [],
		model: 'A650',
		variants: [],
		categories: {
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools',
			main: 'Hand Tools'
		},
		title: 'GIKEN CUTTER A-650',
		uniqTitle: 'giken-cutter-a-650',
		bulkDiscount: [],
		sku: '7f9651e0a0',
		brand: {
			lowerCaseName: 'giken',
			kebabName: 'giken',
			name: 'GIKEN',
			_id: '59b24e3eb38a0b0ad30a3ab5'
		},
		dateUpdated: '2017-11-21T12:17:44.256000',
		_id: '59b90311196632786ed8996a'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140729084139SZJCX6VL0B4GY_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140729084139SZJCX6VL0B4GY_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 69.55,
			po: 'S$69.55'
		},
		includes: [],
		model: 'AB3',
		variants: [],
		categories: {
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools',
			main: 'Hand Tools'
		},
		title: 'BEARING PULLER AB-3  35MM-80MM',
		uniqTitle: 'bearing-puller-ab-3-35-mm-80-mm',
		bulkDiscount: [],
		sku: '0034cccac4',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.271000',
		_id: '59b90311196632786ed89bad'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160531161511ZOUX8816IJL4W_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160531161511ZOUX8816IJL4W_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 481.5,
			po: 'S$481.50'
		},
		includes: [],
		model: 'AN300',
		variants: [],
		categories: {
			sub: 'Electrical Measuring Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrical-measuring-tools',
			main: 'Electrical Components'
		},
		title: 'EXTECH AN300 ANEMOMETER',
		uniqTitle: 'extech-an-300-anemometer',
		bulkDiscount: [],
		sku: '0038092301',
		brand: {
			lowerCaseName: 'extech instruments',
			kebabName: 'extech-instruments',
			name: 'EXTECH INSTRUMENTS',
			_id: '59b24e3eb38a0b0ad30a3b0b'
		},
		dateUpdated: '2017-11-21T12:17:44.425000',
		_id: '59b90312196632786ed8a836'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160403213200NUUR1YE6TE4H5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160403213200NUUR1YE6TE4H5_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 197.95,
			po: 'S$197.95'
		},
		includes: [],
		model: 'AERO21',
		variants: [],
		categories: {
			sub: 'Vacuums & Floor Care',
			mainKebabCase: 'cleaning-products',
			subKebabCase: 'vacuums-floor-care',
			main: 'Cleaning Products'
		},
		title: 'NILFISK ALTO VACUUM CLEANER, 1250W, AERO21-01 WET/DRY',
		uniqTitle: 'nilfisk-alto-vacuum-cleaner-1250-w-aero-21-01-wet-dry',
		bulkDiscount: [],
		sku: '06f0b754f4',
		brand: {
			lowerCaseName: 'nilfisk',
			kebabName: 'nilfisk',
			name: 'NILFISK',
			_id: '59b24e3eb38a0b0ad30a3aba'
		},
		dateUpdated: '2017-11-21T12:17:44.410000',
		_id: '59b90312196632786ed8a734'
	}]
};
var safetySearchResults = {
	size: 3749,
	products: [{
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20131227150417AWXS0Z0LWLL9A_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20131227150417AWXS0Z0LWLL9A_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20131227150421DWJ4AQ6P0HXHZ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20131227150421DWJ4AQ6P0HXHZ_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20131227150425HAJX9RANLTUU9_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20131227150425HAJX9RANLTUU9_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201312271504293PVVJCKDESOKK_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201312271504293PVVJCKDESOKK_full.jpg',
			fileType: 'image'
		}],
		includes: [],
		variants: [{
			name: 'Colour',
			_id: '5a17d42039e4f75041b0292d',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Green',
				_id: '5a17d42039e4f75041b0292f',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Orange',
				_id: '5a17d42039e4f75041b0292e',
				order: 1
			}]
		}],
		duplicate: false,
		title: 'SAFETY VEST X STRIP REFLECTIVE',
		uniqTitle: 'safety-vest-x-strip-reflective',
		bulkDiscount: [],
		dateUpdated: '2017-11-24T08:11:12.277000',
		price: {
			ps: 'S$0.00',
			original: 2.35,
			po: 'S$2.35'
		},
		model: 'Safety Vest',
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		sku: 'e23c36af34',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		_id: '59b90311196632786ed8933a'
	}, {
		buyPrice: 3.8,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'x47x2vn.jpeg',
			expire: '2017-10-23T04:07:30.007Z',
			__v: 0,
			_id: '59edabd5ef904a07fd5229a1',
			url: 'https://storage.googleapis.com/eezee-product-images/x47x2vn.jpeg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'rbi3jap.png',
			expire: '2017-10-23T04:07:30.007Z',
			__v: 0,
			_id: '59edabdbef904a07fd5229a2',
			url: 'https://storage.googleapis.com/eezee-product-images/rbi3jap.png',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Printing at Back ',
			_id: '59f6ffce324e463245cbb2d5',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Rigger signal Green',
				_id: '59f6ffce324e463245cbb2f5',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Rigger signal Red',
				_id: '59f6ffce324e463245cbb2f4',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Rigger signalman Green',
				_id: '59f6ffce324e463245cbb2f3',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Rigger signalman Red',
				_id: '59f6ffce324e463245cbb2f2',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Rigger Green',
				_id: '59f6ffce324e463245cbb2f1',
				order: 4
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Rigger Red',
				_id: '59f6ffce324e463245cbb2f0',
				order: 5
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Riggerman Green',
				_id: '59f6ffce324e463245cbb2ef',
				order: 6
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Riggerman Red',
				_id: '59f6ffce324e463245cbb2ee',
				order: 7
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Safety advisor Green',
				_id: '59f6ffce324e463245cbb2ed',
				order: 8
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Safety supervisor Green',
				_id: '59f6ffce324e463245cbb2ec',
				order: 9
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Safety worker Green',
				_id: '59f6ffce324e463245cbb2eb',
				order: 10
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Safety Erector Green',
				_id: '59f6ffce324e463245cbb2ea',
				order: 11
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Signalman Green',
				_id: '59f6ffce324e463245cbb2e9',
				order: 12
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Signalman Red ',
				_id: '59f6ffce324e463245cbb2e8',
				order: 13
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Station manager Orange',
				_id: '59f6ffce324e463245cbb2e7',
				order: 14
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Traffic controller Green',
				_id: '59f6ffce324e463245cbb2e6',
				order: 15
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Traffic controller Red',
				_id: '59f6ffce324e463245cbb2e5',
				order: 16
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Visitor Green',
				_id: '59f6ffce324e463245cbb2e4',
				order: 17
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Gammon Green',
				_id: '59f6ffce324e463245cbb2e3',
				order: 18
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Gammon Red',
				_id: '59f6ffce324e463245cbb2e2',
				order: 19
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Gammon c/w pocket Green ',
				_id: '59f6ffce324e463245cbb2e1',
				order: 20
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'WSHC Orange',
				_id: '59f6ffce324e463245cbb2e0',
				order: 21
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'WSHO Orange',
				_id: '59f6ffce324e463245cbb2df',
				order: 22
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Safety vest Blue',
				_id: '59f6ffce324e463245cbb2de',
				order: 23
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Advisor Green ',
				_id: '59f6ffce324e463245cbb2dd',
				order: 24
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Assistant station manager Green',
				_id: '59f6ffce324e463245cbb2dc',
				order: 25
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Banksman Green',
				_id: '59f6ffce324e463245cbb2db',
				order: 26
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Banksman Red',
				_id: '59f6ffce324e463245cbb2da',
				order: 27
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Fire warden Red ',
				_id: '59f6ffce324e463245cbb2d9',
				order: 28
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Fire watchman Red',
				_id: '59f6ffce324e463245cbb2d8',
				order: 29
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Fire watchman Green',
				_id: '59f6ffce324e463245cbb2d7',
				order: 30
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Lifting supervisor Green',
				_id: '59f6ffce324e463245cbb2d6',
				order: 31
			}]
		}],
		title: 'AccSafe Safety Vest Red or Lime Green Mesh with Reflective Strip & Printing',
		bulkDiscount: [],
		uniqTitle: 'accsafe-safety-vest-red-or-lime-green-mesh-with-reflective-strip-printing',
		dateUpdated: '2017-11-21T12:17:44.583000',
		price: {
			ps: 'S$0.00',
			original: 5,
			po: 'S$5.00'
		},
		model: 'AccSafe Safety Vest ',
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		sku: '1be7e4b275',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59edae98ef904a07fd522a19'
	}, {
		buyPrice: 11,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141210174413DEXBJ1XWZAOF8_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141210174413DEXBJ1XWZAOF8_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20141210174417XXDVZX6HA5C9G_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141210174417XXDVZX6HA5C9G_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'AccSafe SAFETY VEST LONG SLEEVE HIGH VISIBILITY',
		bulkDiscount: [],
		uniqTitle: 'accsafe-safety-vest-long-sleeve-high-visibility',
		dateUpdated: '2017-11-21T12:17:44.276000',
		price: {
			ps: 'S$0.00',
			original: 12.7,
			po: 'S$12.70'
		},
		model: 'Safety Vest Long Sleeve',
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		sku: 'f606a95ad2',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59b90311196632786ed89c7a'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'wpw1q9a.png',
			expire: '2017-10-25T06:16:42.860Z',
			__v: 0,
			_id: '59f06812d96a67110a1efb97',
			url: 'https://storage.googleapis.com/eezee-product-images/wpw1q9a.png',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'AccSafe TM-9 Safety Tripod With Chain & Webbing ',
		uniqTitle: 'accsafe-tm-9-safety-tripod-with-chain-webbing',
		bulkDiscount: [],
		dateUpdated: '2017-11-21T12:17:44.584000',
		price: {
			ps: 'S$0.00',
			original: 644,
			po: 'S$644.00'
		},
		model: 'AccSafe TM-9 Safety Tripod',
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		sku: 'caf2c1d4b5',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59f068c0f0e6051110ae4539'
	}, {
		buyPrice: 2,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'o71ip99.jpeg',
			__v: 0,
			expire: '2017-10-23T04:07:30.007Z',
			_id: '59eda793f8cd5108075a5317',
			url: 'https://storage.googleapis.com/eezee-product-images/o71ip99.jpeg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '2d24k82.jpeg',
			__v: 0,
			expire: '2017-10-23T04:07:30.007Z',
			_id: '59eda798f8cd5108075a5321',
			url: 'https://storage.googleapis.com/eezee-product-images/2d24k82.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Color',
			_id: '59f6ffcd324e463245cbb216',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Red',
				_id: '59f6ffcd324e463245cbb218',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Lime Green',
				_id: '59f6ffcd324e463245cbb217',
				order: 1
			}]
		}],
		title: 'AccSafe Safety Vest Red or Lime Green  Mesh with Reflective Strip',
		bulkDiscount: [],
		uniqTitle: 'accsafe-safety-vest-red-or-lime-green-mesh-with-reflective-strip',
		dateUpdated: '2017-11-21T12:17:44.576000',
		price: {
			ps: 'S$0.00',
			original: 2.6,
			po: 'S$2.60'
		},
		model: 'AccSafe Safety Vest ',
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		sku: '06f87451e4',
		oldSku: 'f46f6c5c62',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59dd94d3d9df997a8c7fd80d'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'eluqy0a.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dd8578d9df997a8c7fd1ca',
			url: 'https://storage.googleapis.com/eezee-product-images/eluqy0a.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'AccSafe Safety Bump Cap HDPE Plastic White ',
		bulkDiscount: [],
		uniqTitle: 'accsafe-safety-bump-cap-hdpe-plastic-white',
		dateUpdated: '2017-11-21T12:17:44.575000',
		price: {
			ps: 'S$0.00',
			original: 7.2,
			po: 'S$7.20'
		},
		model: 'Safety Bump Cap HDPE Plastic White ',
		categories: {
			sub: 'Head & Face Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'head-face-protection',
			main: 'Safety Products'
		},
		oldSku: 'f46f6c5c62',
		sku: '2af8e7929e',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59dd8d1fd9df997a8c7fd47a'
	}, {
		buyPrice: 74.5,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'c37c4sx.jpeg',
			expire: '2017-10-08T02:42:33.058Z',
			__v: 0,
			_id: '59db03f1660a27394142f56d',
			url: 'https://storage.googleapis.com/eezee-product-images/c37c4sx.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffcd324e463245cbb16a',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'S (UK 1.5-5.5)',
				_id: '59f6ffcd324e463245cbb16c',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'M (UK 6-9)',
				_id: '59f6ffcd324e463245cbb16b',
				order: 1
			}]
		}],
		title: 'Visitor Safety Toe-cap For  Shoe ',
		bulkDiscount: [],
		uniqTitle: 'visitor-safety-toe-cap-for-shoe',
		dateUpdated: '2017-11-21T12:17:44.570000',
		price: {
			ps: 'S$0.00',
			original: 85.7,
			po: 'S$85.70'
		},
		model: 'Visitor Safety Toe-cap for shoe',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '78ac870376',
		oldSku: '8af67fc7a1',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59db047b660a27394142f57a'
	}, {
		buyPrice: 2.5,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'l8xh1cu.jpeg',
			__v: 0,
			expire: '2017-10-18T09:27:17.174Z',
			_id: '59e72138fe49210c062fc154',
			url: 'https://storage.googleapis.com/eezee-product-images/l8xh1cu.jpeg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'vjrr5bm.jpeg',
			__v: 0,
			expire: '2017-10-18T09:27:17.160Z',
			_id: '59e721302629600c07297236',
			url: 'https://storage.googleapis.com/eezee-product-images/vjrr5bm.jpeg',
			fileType: 'image'
		}],
		supplierId: '59e63499eb94df0602fa8887',
		includes: [],
		variants: [],
		title: 'Green Safety Vest with Security Wording',
		bulkDiscount: [],
		uniqTitle: 'green-safety-vest-with-security-wording',
		dateUpdated: '2017-11-21T12:17:44.580000',
		price: {
			ps: 'S$0.00',
			original: 3.25,
			po: 'S$3.25'
		},
		model: 'Green Safety Vest with Security Wording',
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		sku: 'bc53dcbcc6',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		_id: '59e71fe02629600c072971f9'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '85no6m5.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dd84f1d9df997a8c7fd19e',
			url: 'https://storage.googleapis.com/eezee-product-images/85no6m5.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'AccSafe ChemGard Safety Chemical Splash Goggle Clear Anti Fog Lens (100pcs/ctn) ',
		bulkDiscount: [],
		uniqTitle: 'accsafe-chemgard-safety-chemical-splash-goggle-clear-anti-fog-lens-100-pcs-ctn',
		dateUpdated: '2017-11-21T12:17:44.575000',
		price: {
			ps: 'S$0.00',
			original: 3.3,
			po: 'S$3.30'
		},
		model: 'ChemGard Safety Chemical Splash Goggle Clear Anti Fog Lens',
		categories: {
			sub: 'Head & Face Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'head-face-protection',
			main: 'Safety Products'
		},
		oldSku: 'f46f6c5c62',
		sku: '104dfb3400',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59dd8bd8d9df997a8c7fd3a2'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'op67gnf.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dd8511d9df997a8c7fd1ad',
			url: 'https://storage.googleapis.com/eezee-product-images/op67gnf.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: '3M 1623AF Safety Goggle Clear PC Lens Anti-Fog',
		bulkDiscount: [],
		uniqTitle: '3-m-1623-af-safety-goggle-clear-pc-lens-anti-fog',
		dateUpdated: '2017-11-21T12:17:44.575000',
		price: {
			ps: 'S$0.00',
			original: 13.3,
			po: 'S$13.30'
		},
		model: '3M 1623AF Safety Goggle Clear PC Lens Anti-Fog',
		categories: {
			sub: 'Head & Face Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'head-face-protection',
			main: 'Safety Products'
		},
		oldSku: 'f46f6c5c62',
		sku: '9e74b8a6fa',
		brand: {
			lowerCaseName: '3m',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'XGfw9FuhgQqHnuYNmgfDr~.jpg',
				expire: '2017-12-20T12:56:42.106000',
				__v: 0,
				_id: '5a3b21b1f5ad5a4e7cc92d35',
				url: 'https://storage.googleapis.com/eezee-brand-images/XGfw9FuhgQqHnuYNmgfDr~.jpg',
				fileType: 'image'
			},
			featured: true,
			kebabName: '3-m',
			name: '3M',
			_id: '59b24e3eb38a0b0ad30a39f1'
		},
		_id: '59dd8bffd9df997a8c7fd3b2'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'ttqqau2.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dd8482d9df997a8c7fd18d',
			url: 'https://storage.googleapis.com/eezee-product-images/ttqqau2.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Color',
			_id: '59f6ffcd324e463245cbb1f5',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Clear',
				_id: '59f6ffcd324e463245cbb1f7',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Grey',
				_id: '59f6ffcd324e463245cbb1f6',
				order: 1
			}]
		}],
		title: 'AccSafe Nova Safety Spectacle Clear or Grey Frame, Clear HC Lens, Anti Scratch, UV Protection (12pcs/box, 300pcs/ctn) ',
		bulkDiscount: [],
		uniqTitle: 'accsafe-nova-safety-spectacle-clear-or-grey-frame-clear-hc-lens-anti-scratch-uv-protection-12-pcs-box-300-pcs-ctn',
		dateUpdated: '2017-11-21T12:17:44.575000',
		price: {
			ps: 'S$0.00',
			original: 2.2,
			po: 'S$2.20'
		},
		model: 'Nova Safety Spectacle Clear or Grey Frame, Clear HC Lens, Anti Scratch, UV Protection',
		categories: {
			sub: 'Head & Face Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'head-face-protection',
			main: 'Safety Products'
		},
		oldSku: 'f46f6c5c62',
		sku: 'b35d7a8195',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59dd8b8bd9df997a8c7fd379'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'xg70uee.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dd84d7d9df997a8c7fd19c',
			url: 'https://storage.googleapis.com/eezee-product-images/xg70uee.jpeg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'nh881xc.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dd84dbd9df997a8c7fd19d',
			url: 'https://storage.googleapis.com/eezee-product-images/nh881xc.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Color',
			_id: '59f6ffcd324e463245cbb1fb',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Clear',
				_id: '59f6ffcd324e463245cbb1fd',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Grey',
				_id: '59f6ffcd324e463245cbb1fc',
				order: 1
			}]
		}],
		title: 'AccSafe Dover Safety Overspec Clear or Gery Frame, Clear HC Lens, Anti Scratch, UV Protection (12pcs/box)',
		bulkDiscount: [],
		uniqTitle: 'accsafe-dover-safety-overspec-clear-or-gery-frame-clear-hc-lens-anti-scratch-uv-protection-12-pcs-box',
		dateUpdated: '2017-11-21T12:17:44.575000',
		price: {
			ps: 'S$0.00',
			original: 3,
			po: 'S$3.00'
		},
		model: 'Dover Safety Overspec Clear or Gery Frame, Clear HC Lens, Anti Scratch, UV Protection',
		categories: {
			sub: 'Head & Face Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'head-face-protection',
			main: 'Safety Products'
		},
		oldSku: 'f46f6c5c62',
		sku: '36841a0d55',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59dd8bbad9df997a8c7fd38c'
	}, {
		buyPrice: 76,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'pnpwi8v.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59ddc72bd9df997a8c7ff407',
			url: 'https://storage.googleapis.com/eezee-product-images/pnpwi8v.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'AccSafe P60 Safety Harness with Front, Back Anchorage and Work Position Belt',
		bulkDiscount: [],
		uniqTitle: 'accsafe-p-60-safety-harness-with-front-back-anchorage-and-work-position-belt',
		dateUpdated: '2017-11-21T12:17:44.577000',
		price: {
			ps: 'S$0.00',
			original: 87.4,
			po: 'S$87.40'
		},
		model: 'P60 Safety Harness with Front, Back Anchorage and Work Position Belt',
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		sku: 'ffb94d604f',
		oldSku: 'f46f6c5c62',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59ddc733d9df997a8c7ff409'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'r4rrj64.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dd845dd9df997a8c7fd174',
			url: 'https://storage.googleapis.com/eezee-product-images/r4rrj64.jpeg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'a6ano6j.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dd8479d9df997a8c7fd175',
			url: 'https://storage.googleapis.com/eezee-product-images/a6ano6j.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Color',
			_id: '59f6ffcd324e463245cbb1f8',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Clear',
				_id: '59f6ffcd324e463245cbb1fa',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Grey',
				_id: '59f6ffcd324e463245cbb1f9',
				order: 1
			}]
		}],
		title: 'AccSafe Pioneer Safety Spectacle Clear or Grey Frame, Clear HC Lens, Anti Scratch, UV Protection (12pcs/box) ',
		bulkDiscount: [],
		uniqTitle: 'accsafe-pioneer-safety-spectacle-clear-or-grey-frame-clear-hc-lens-anti-scratch-uv-protection-12-pcs-box',
		dateUpdated: '2017-11-21T12:17:44.575000',
		price: {
			ps: 'S$0.00',
			original: 2.6,
			po: 'S$2.60'
		},
		model: 'Pioneer Safety Spectacle Clear or Grey Frame, Clear HC Lens, Anti Scratch, UV Protection',
		categories: {
			sub: 'Head & Face Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'head-face-protection',
			main: 'Safety Products'
		},
		oldSku: 'f46f6c5c62',
		sku: 'c952c39cc1',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59dd8ba3d9df997a8c7fd384'
	}, {
		buyPrice: 150,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '5o80rxr.png',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59ddc72ed9df997a8c7ff408',
			url: 'https://storage.googleapis.com/eezee-product-images/5o80rxr.png',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffcd324e463245cbb22a',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'M',
				_id: '59f6ffcd324e463245cbb22d',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'L',
				_id: '59f6ffcd324e463245cbb22c',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Xl',
				_id: '59f6ffcd324e463245cbb22b',
				order: 2
			}]
		}],
		title: 'AccSafe P90 M-XL Safety Harness with Front, Back Anchorage Point, Attaching Point for Sitting and Work Positioning Belt, 140KG ',
		bulkDiscount: [],
		uniqTitle: 'accsafe-p-90-m-xl-safety-harness-with-front-back-anchorage-point-attaching-point-for-sitting-and-work-positioning-belt-140-kg',
		dateUpdated: '2017-11-21T12:17:44.577000',
		price: {
			ps: 'S$0.00',
			original: 172.5,
			po: 'S$172.50'
		},
		model: 'P90 M-XL Safety Harness with Front, Back Anchorage Point, Attaching Point for Sitting and Work Positioning Belt, 140KG ',
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		sku: '4638abe042',
		oldSku: 'f46f6c5c62',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59ddc784d9df997a8c7ff430'
	}, {
		buyPrice: 9.2,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'ly3qv70.png',
			__v: 0,
			expire: '2017-10-20T12:39:13.994Z',
			_id: '59ea2e60e7b62563f4032fab',
			url: 'https://storage.googleapis.com/eezee-product-images/ly3qv70.png',
			fileType: 'image'
		}],
		supplierId: '59ea2c29e7b62563f4032eb4',
		includes: [],
		variants: [],
		title: 'UNIVET Safety Googles Clear lens  619.02.01.00',
		bulkDiscount: [],
		uniqTitle: 'univet-safety-googles-clear-lens-619-02-01-00',
		dateUpdated: '2017-11-21T12:17:44.581000',
		price: {
			ps: 'S$0.00',
			original: 10.6,
			po: 'S$10.60'
		},
		model: '619.02.01.00',
		categories: {
			sub: 'Head & Face Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'head-face-protection',
			main: 'Safety Products'
		},
		sku: '3f0cdca532',
		brand: {
			lowerCaseName: 'univet',
			kebabName: 'univet',
			name: 'UNIVET',
			_id: '59ea2de4e7b62563f4032faa'
		},
		_id: '59ea2da5e7b62563f4032fa7'
	}, {
		buyPrice: 107,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'k1iiuju.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59ddbbdfd9df997a8c7feb90',
			url: 'https://storage.googleapis.com/eezee-product-images/k1iiuju.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'AccSafe P11 Safety Harness with Front, Back Anchorage Point + AccSafe BW200LB122 Energy Absorber Double Lanyard with Scaffold Hook AZ022 & Auto Lock Carabiner AZ011T',
		bulkDiscount: [],
		uniqTitle: 'accsafe-p-11-safety-harness-with-front-back-anchorage-point-accsafe-bw-200-lb-122-energy-absorber-double-lanyard-with-scaffold-hook-az-022-auto-lock-carabiner-az-011-t',
		dateUpdated: '2017-11-21T12:17:44.577000',
		price: {
			ps: 'S$0.00',
			original: 123.1,
			po: 'S$123.10'
		},
		model: 'P11 Safety Harness with Front, Back Anchorage Point + AccSafe BW200LB122 Energy Absorber Double Lanyard with Scaffold Hook AZ022 & Auto Lock Carabiner AZ011T',
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		sku: 'bb4a527057',
		oldSku: 'f46f6c5c62',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59ddbe0cd9df997a8c7fec21'
	}, {
		buyPrice: 14.5,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '1euegin.jpeg',
			expire: '2017-10-08T02:42:33.058Z',
			__v: 0,
			_id: '59db00cb660a27394142f377',
			url: 'https://storage.googleapis.com/eezee-product-images/1euegin.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffcd324e463245cbb15a',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-6',
				_id: '59f6ffcd324e463245cbb160',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-7',
				_id: '59f6ffcd324e463245cbb15f',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-8',
				_id: '59f6ffcd324e463245cbb15e',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-9',
				_id: '59f6ffcd324e463245cbb15d',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-10',
				_id: '59f6ffcd324e463245cbb15c',
				order: 4
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-11',
				_id: '59f6ffcd324e463245cbb15b',
				order: 5
			}]
		}],
		title: 'SAFETY JOGGER SAFETY SHOE  HERCULES',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-safety-shoe-hercules',
		dateUpdated: '2017-11-21T12:17:44.570000',
		price: {
			ps: 'S$0.00',
			original: 16.7,
			po: 'S$16.70'
		},
		model: 'HERCULES-S5',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '167f634608',
		oldSku: '8af67fc7a1',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59db00d7660a27394142f378'
	}, {
		buyPrice: 43,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160108162454VPP2JEI6S49MN_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160108162454VPP2JEI6S49MN_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201601051603478PYUFAND8SHSB_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201601051603478PYUFAND8SHSB_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160122155546QPI58UGL684KE_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160122155546QPI58UGL684KE_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffc0324e463245cba9ab',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-06',
				_id: '59f6ffc0324e463245cba9b0',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-07 ',
				_id: '59f6ffc0324e463245cba9af',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-08',
				_id: '59f6ffc0324e463245cba9ae',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-09',
				_id: '59f6ffc0324e463245cba9ad',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-10',
				_id: '59f6ffc0324e463245cba9ac',
				order: 4
			}]
		}],
		title: 'SAFETY JOGGER SAFETY SHOE DAKAR [S3]',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-safety-shoe-dakar-s-3',
		dateUpdated: '2017-11-21T12:17:44.399000',
		price: {
			ps: 'S$0.00',
			original: 49.5,
			po: 'S$49.50'
		},
		model: 'DAKAR S3',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '467ea3e028',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59b90311196632786ed8a635'
	}, {
		buyPrice: 59,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150408140134WYCIG9BE451PG_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150408140134WYCIG9BE451PG_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20140311161104VB3FVMBSV1YJW_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140311161104VB3FVMBSV1YJW_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20151117220208IYFYFNXTMEK8A_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151117220208IYFYFNXTMEK8A_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffaa324e463245cb8d51',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-06 ',
				_id: '59f6ffaa324e463245cb8d56',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-07',
				_id: '59f6ffaa324e463245cb8d55',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-8',
				_id: '59f6ffaa324e463245cb8d54',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-9',
				_id: '59f6ffaa324e463245cb8d53',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-10',
				_id: '59f6ffaa324e463245cb8d52',
				order: 4
			}]
		}],
		title: 'SAFETY JOGGER SAFETY SHOE LAUDA ',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-safety-shoe-lauda',
		dateUpdated: '2017-11-21T12:17:44.158000',
		price: {
			ps: 'S$0.00',
			original: 67.9,
			po: 'S$67.90'
		},
		model: 'LAUDA-S3',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: 'e25308d406',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59b90310196632786ed89242'
	}, {
		buyPrice: 18,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'ldrqkvm.jpeg',
			expire: '2017-10-08T02:42:33.058Z',
			__v: 0,
			_id: '59db0104660a27394142f38f',
			url: 'https://storage.googleapis.com/eezee-product-images/ldrqkvm.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffcd324e463245cbb161',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '7',
				_id: '59f6ffcd324e463245cbb165',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '8',
				_id: '59f6ffcd324e463245cbb164',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '9',
				_id: '59f6ffcd324e463245cbb163',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '10',
				_id: '59f6ffcd324e463245cbb162',
				order: 3
			}]
		}],
		title: ' SAFETY JOGGER SAFETY SHOE POSEIDON',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-safety-shoe-poseidon',
		dateUpdated: '2017-11-21T12:17:44.570000',
		price: {
			ps: 'S$0.00',
			original: 20.7,
			po: 'S$20.70'
		},
		model: 'Poseidon [S-4]',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '64fedbe036',
		oldSku: '8af67fc7a1',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59db015e660a27394142f394'
	}, {
		buyPrice: 42,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150408134359VO8EJNT0GKFKP_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150408134359VO8EJNT0GKFKP_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20140310151436KYOMTY4MRJSD5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140310151436KYOMTY4MRJSD5_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20151117220156YCD8TTWE35BUM_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151117220156YCD8TTWE35BUM_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffa3324e463245cb859a',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-05.5 EU-39',
				_id: '59f6ffa3324e463245cb85a1',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-06 EU-40',
				_id: '59f6ffa3324e463245cb85a0',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-07 EU-41',
				_id: '59f6ffa3324e463245cb859f',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-08 EU-42',
				_id: '59f6ffa3324e463245cb859e',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-09 EU-43',
				_id: '59f6ffa3324e463245cb859d',
				order: 4
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-10 EU-44',
				_id: '59f6ffa3324e463245cb859c',
				order: 5
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-10.5 EU-45',
				_id: '59f6ffa3324e463245cb859b',
				order: 6
			}]
		}],
		title: 'SAFETY JOGGER SAFETY SHOE JUMPER ',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-safety-shoe-jumper',
		dateUpdated: '2017-11-21T12:17:44.060000',
		price: {
			ps: 'S$0.00',
			original: 48.5,
			po: 'S$48.50'
		},
		model: 'JUMPER-S3',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '68c89722ab',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59b90310196632786ed88bfa'
	}, {
		buyPrice: 110,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150408141748F5BLQLINFNWAB_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150408141748F5BLQLINFNWAB_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20130819182715F1PJI1LYPAKSE_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130819182715F1PJI1LYPAKSE_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20151117220417LWZYDMD25ZSON_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151117220417LWZYDMD25ZSON_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffa3324e463245cb85aa',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-06 ',
				_id: '59f6ffa3324e463245cb85af',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-07',
				_id: '59f6ffa3324e463245cb85ae',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-08',
				_id: '59f6ffa3324e463245cb85ad',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-09',
				_id: '59f6ffa3324e463245cb85ac',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-10',
				_id: '59f6ffa3324e463245cb85ab',
				order: 4
			}]
		}],
		title: 'SAFETY JOGGER  SAFETY SHOE ULTIMA',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-safety-shoe-ultima',
		dateUpdated: '2017-11-21T12:17:44.060000',
		price: {
			ps: 'S$0.00',
			original: 126.5,
			po: 'S$126.50'
		},
		model: 'ULTIMA-S3',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: 'c2f1bb494d',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59b90310196632786ed88bff'
	}, {
		buyPrice: 30,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150518142510W23LL0YDZMDL1_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150518142510W23LL0YDZMDL1_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201511172159037SN3PZKFPSNUD_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201511172159037SN3PZKFPSNUD_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffba324e463245cba330',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-06 ',
				_id: '59f6ffba324e463245cba335',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-07 ',
				_id: '59f6ffba324e463245cba334',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-08',
				_id: '59f6ffba324e463245cba333',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-09 ',
				_id: '59f6ffba324e463245cba332',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-10',
				_id: '59f6ffba324e463245cba331',
				order: 4
			}]
		}],
		title: 'SAFETY JOGGER SAFETY SHOE BESTRUN S3',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-safety-shoe-bestrun-s-3',
		dateUpdated: '2017-11-21T12:17:44.316000',
		price: {
			ps: 'S$0.00',
			original: 34.5,
			po: 'S$34.50'
		},
		model: 'BESTRUN S3',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: 'bd4305e718',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59b90311196632786ed8a074'
	}, {
		buyPrice: 38,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '70k2ute.png',
			expire: '2017-10-08T02:42:33.058Z',
			__v: 0,
			_id: '59daff5a660a27394142f214',
			url: 'https://storage.googleapis.com/eezee-product-images/70k2ute.png',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffcd324e463245cbb154',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-6',
				_id: '59f6ffcd324e463245cbb159',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-7',
				_id: '59f6ffcd324e463245cbb158',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-8',
				_id: '59f6ffcd324e463245cbb157',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-9',
				_id: '59f6ffcd324e463245cbb156',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-10',
				_id: '59f6ffcd324e463245cbb155',
				order: 4
			}]
		}],
		title: 'Safety Jogger Safety Shoe Bestfit ',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-safety-shoe-bestfit',
		dateUpdated: '2017-11-21T12:17:44.570000',
		price: {
			ps: 'S$0.00',
			original: 43.7,
			po: 'S$43.70'
		},
		model: 'Bestfit',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '477872b295',
		oldSku: '8af67fc7a1',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59daffc7660a27394142f21d'
	}, {
		buyPrice: 43,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '54qhr9c.jpeg',
			expire: '2017-10-08T02:42:33.058Z',
			__v: 0,
			_id: '59daff0a660a27394142f10e',
			url: 'https://storage.googleapis.com/eezee-product-images/54qhr9c.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffcd324e463245cbb14e',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '6',
				_id: '59f6ffcd324e463245cbb153',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '7',
				_id: '59f6ffcd324e463245cbb152',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '8',
				_id: '59f6ffcd324e463245cbb151',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '9',
				_id: '59f6ffcd324e463245cbb150',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '10',
				_id: '59f6ffcd324e463245cbb14f',
				order: 4
			}]
		}],
		title: 'Safety Jogger Safety Shoe Bestboot S3 ',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-safety-shoe-bestboot-s-3',
		dateUpdated: '2017-11-21T12:17:44.570000',
		price: {
			ps: 'S$0.00',
			original: 49.5,
			po: 'S$49.50'
		},
		model: 'Bestboot 2 [S3]',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '87a7bc3afe',
		oldSku: '8af67fc7a1',
		brand: {
			lowerCaseName: 'accsafe',
			kebabName: 'accsafe',
			name: 'ACCSAFE',
			_id: '59c27528a29a683e5671841b'
		},
		_id: '59daff0d660a27394142f10f'
	}, {
		buyPrice: 50,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150408135614FW7AKAGKTEWR0_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150408135614FW7AKAGKTEWR0_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20151117220219BOBXHJU638MEY_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151117220219BOBXHJU638MEY_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffb8324e463245cba10e',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-06',
				_id: '59f6ffb8324e463245cba113',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-07',
				_id: '59f6ffb8324e463245cba112',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-08',
				_id: '59f6ffb8324e463245cba111',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-09',
				_id: '59f6ffb8324e463245cba110',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-10',
				_id: '59f6ffb8324e463245cba10f',
				order: 4
			}]
		}],
		title: 'SAFETY JOGGER  EXECUTIVE SAFETY SHOE-MANAGER ',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-executive-safety-shoe-manager',
		dateUpdated: '2017-11-21T12:17:44.292000',
		price: {
			ps: 'S$0.00',
			original: 57.5,
			po: 'S$57.50'
		},
		model: 'MANAGER-S3',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '5c25169aab',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59b90311196632786ed89ecb'
	}, {
		buyPrice: 53,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140310151719ZQIWPG8FQ780L_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140310151719ZQIWPG8FQ780L_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20151117220019ZG1SJTTNWNBQE_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151117220019ZG1SJTTNWNBQE_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffa3324e463245cb858e',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-3.5',
				_id: '59f6ffa3324e463245cb8593',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-4.5',
				_id: '59f6ffa3324e463245cb8592',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-5',
				_id: '59f6ffa3324e463245cb8591',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-6',
				_id: '59f6ffa3324e463245cb8590',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-6.5',
				_id: '59f6ffa3324e463245cb858f',
				order: 4
			}]
		}],
		title: 'SAFETY JOGGER SAFETY SHOE LADY CERES S3',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-safety-shoe-lady-ceres-s-3',
		dateUpdated: '2017-11-21T12:17:44.060000',
		price: {
			ps: 'S$0.00',
			original: 61,
			po: 'S$61.00'
		},
		model: 'CERES S3',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: 'cfd694d55f',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59b90310196632786ed88bf4'
	}, {
		buyPrice: 35,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201504081231429JLUBGUYYCPSU_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201504081231429JLUBGUYYCPSU_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201403101245492JLOSWMHAWW3X_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201403101245492JLOSWMHAWW3X_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20151117220514VFERRT7OIR154_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151117220514VFERRT7OIR154_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffac324e463245cb90fc',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-06',
				_id: '59f6ffac324e463245cb9101',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-07',
				_id: '59f6ffac324e463245cb9100',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-08',
				_id: '59f6ffac324e463245cb90ff',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-09',
				_id: '59f6ffac324e463245cb90fe',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-10',
				_id: '59f6ffac324e463245cb90fd',
				order: 4
			}]
		}],
		title: 'SAFETY JOGGER SAFETY SHOE X0600 ',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-safety-shoe-x-0600',
		dateUpdated: '2017-11-21T12:17:44.193000',
		price: {
			ps: 'S$0.00',
			original: 40.5,
			po: 'S$40.50'
		},
		model: 'X0600-S3',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: 'd87145624f',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59b90311196632786ed89496'
	}, {
		buyPrice: 2.5,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140310113213SUTPPVORLMWP0_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140310113213SUTPPVORLMWP0_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20150408112617UGH6DOAD9WXUA_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150408112617UGH6DOAD9WXUA_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'SAFETY JOGGER SJ SOCK',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-sj-sock',
		dateUpdated: '2017-11-21T12:17:44.191000',
		price: {
			ps: 'S$0.00',
			original: 3.3,
			po: 'S$3.30'
		},
		model: 'SJ SOCK',
		categories: {
			sub: 'Lifestyle Apparels',
			mainKebabCase: 'household-products',
			subKebabCase: 'lifestyle-apparels',
			main: 'Household Products'
		},
		sku: 'aa044cfbbf',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59b90311196632786ed89493'
	}, {
		buyPrice: 39,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '2015040812404918IWJC7AH3STO_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2015040812404918IWJC7AH3STO_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20140310151240M2W8AZZMMUR75_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140310151240M2W8AZZMMUR75_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20151117220049O0SOOCZJLYJDI_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151117220049O0SOOCZJLYJDI_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffa3324e463245cb8594',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-06 ',
				_id: '59f6ffa3324e463245cb8599',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-07',
				_id: '59f6ffa3324e463245cb8598',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-08',
				_id: '59f6ffa3324e463245cb8597',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-09 ',
				_id: '59f6ffa3324e463245cb8596',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-10',
				_id: '59f6ffa3324e463245cb8595',
				order: 4
			}]
		}],
		title: 'SAFETY JOGGER SAFETY SHOE EOS [S3 ESD]',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-safety-shoe-eos-s-3-esd',
		dateUpdated: '2017-11-21T12:17:44.060000',
		price: {
			ps: 'S$0.00',
			original: 44.9,
			po: 'S$44.90'
		},
		model: 'EOS-S3',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '3d8c0b2bcd',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59b90310196632786ed88bf6'
	}, {
		buyPrice: 55,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150408135358Z4MAQDSHZF1OO_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150408135358Z4MAQDSHZF1OO_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20151117220143ITWQTBWCNIJLB_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151117220143ITWQTBWCNIJLB_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'Size',
			_id: '5a530901806c690331bdc6ac',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-3.5',
				_id: '5a530901806c690331bdc6b4',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-4',
				_id: '5a530901806c690331bdc6b3',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-4.5',
				_id: '5a530901806c690331bdc6b2',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-5',
				_id: '5a530901806c690331bdc6b1',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-5.5',
				_id: '5a530901806c690331bdc6b0',
				order: 4
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-6',
				_id: '5a530901806c690331bdc6af',
				order: 5
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-6.5',
				_id: '5a530901806c690331bdc6ae',
				order: 6
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-7',
				_id: '5a530901806c690331bdc6ad',
				order: 7
			}]
		}],
		title: 'SAFETY JOGGER LADY SAFETY SHOE ISIS [S3]',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-lady-safety-shoe-isis-s-3',
		dateUpdated: '2018-01-08T06:00:33.863000',
		price: {
			ps: 'S$0.00',
			original: 63.3,
			po: 'S$63.30'
		},
		model: 'ISIS-04',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '4f5111c8fd',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59b90310196632786ed88dd8'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170318110031RR68TVNFNDNLT_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170318110031RR68TVNFNDNLT_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170406090624EXEE184LKPWUL_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170406090624EXEE184LKPWUL_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 81.95,
			po: 'S$81.95'
		},
		includes: [],
		model: 'WORKERPLUS07',
		variants: [{
			name: 'Size',
			_id: '59f6ffc8324e463245cbad8a',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-07 EU-40',
				_id: '59f6ffc8324e463245cbad8f',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-08 EU-42',
				_id: '59f6ffc8324e463245cbad8e',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-09 EU-43',
				_id: '59f6ffc8324e463245cbad8d',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-10 EU-44',
				_id: '59f6ffc8324e463245cbad8c',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-11 EU-46',
				_id: '59f6ffc8324e463245cbad8b',
				order: 4
			}]
		}],
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		title: 'SAFETY JOGGER SHOE WORKERPLUS',
		uniqTitle: 'safety-jogger-shoe-workerplus',
		bulkDiscount: [],
		sku: 'f47b1c8294',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		dateUpdated: '2017-11-21T12:17:44.502000',
		_id: '59b90312196632786ed8adc7'
	}, {
		buyPrice: 15,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'xV_yUw1qG56Rh4elXFu061.JPG',
			expire: '2017-11-15T04:05:37.548Z',
			__v: 0,
			_id: '5a0c0ff056abb27e23bde841',
			url: 'https://storage.googleapis.com/eezee-product-images/xV_yUw1qG56Rh4elXFu061.JPG',
			fileType: 'image'
		}],
		supplierId: '59e7ab3e2629600c0729b21a',
		includes: [],
		duplicate: false,
		variants: [],
		title: 'Panda Safety Vest PD295',
		bulkDiscount: [],
		uniqTitle: 'panda-safety-vest-pd-295',
		dateUpdated: '2017-11-21T12:17:44.613000',
		price: {
			ps: 'S$0.00',
			original: 17.3,
			po: 'S$17.30'
		},
		model: 'PD295',
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		sku: 'd4bebb8473',
		brand: {
			lowerCaseName: 'panda',
			kebabName: 'panda',
			name: 'Panda',
			_id: '5a0c0fc656abb27e23bde818'
		},
		_id: '5a0c101956abb27e23bde842'
	}, {
		buyPrice: 18,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'rlrtard.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dd8597d9df997a8c7fd1cb',
			url: 'https://storage.googleapis.com/eezee-product-images/rlrtard.jpeg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'ypp1hx7.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dd859ad9df997a8c7fd1cc',
			url: 'https://storage.googleapis.com/eezee-product-images/ypp1hx7.jpeg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'cowl2rh.jpeg',
			expire: '2017-10-10T11:22:18.229Z',
			__v: 0,
			_id: '59dd859dd9df997a8c7fd1cd',
			url: 'https://storage.googleapis.com/eezee-product-images/cowl2rh.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [{
			name: 'Color',
			_id: '59f6ffcd324e463245cbb208',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'White',
				_id: '59f6ffcd324e463245cbb20a',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Yellow',
				_id: '59f6ffcd324e463245cbb209',
				order: 1
			}]
		}],
		title: 'MSA V-Gard Safety Helmet White or Yellow Colour c/w Fas-Trac Ratchet Suspension and Nylon Chin Strap (PSB) (PSB Approved)',
		bulkDiscount: [],
		uniqTitle: 'msa-v-gard-safety-helmet-white-or-yellow-colour-c-w-fas-trac-ratchet-suspension-and-nylon-chin-strap-psb-psb-approved',
		dateUpdated: '2017-11-21T12:17:44.575000',
		price: {
			ps: 'S$0.00',
			original: 20.7,
			po: 'S$20.70'
		},
		model: ' V-Gard Safety Helmet White or Yellow Colour c/w Fas-Trac Ratchet Suspension and Nylon Chin Strap (PSB) (PSB Approved)',
		categories: {
			sub: 'Head & Face Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'head-face-protection',
			main: 'Safety Products'
		},
		sku: 'ebaf66e1b9',
		oldSku: 'f46f6c5c62',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		_id: '59dd8d4bd9df997a8c7fd49c'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'qlzKKhvYo1D8Mjsg7zxmNc.jpg',
			expire: '2018-01-11T05:53:14.713Z',
			__v: 0,
			_id: '5a59ccc237f8836a18cf6d7b',
			url: 'https://storage.googleapis.com/eezee-product-images/qlzKKhvYo1D8Mjsg7zxmNc.jpg',
			fileType: 'image'
		}],
		supplierId: '59c212d10302410b73a5b6c5',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'Size',
			_id: '5a59ce7b37f8836a18cf72b4',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '700mm',
				_id: '5a59ce7b37f8836a18cf72b6',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 25.3,
					po: 'S$25.30'
				},
				name: '1000mm',
				_id: '5a59ce7b37f8836a18cf72b5',
				order: 1
			}]
		}],
		title: 'Nipon Unbreakable PVC Safety Cone',
		bulkDiscount: [],
		uniqTitle: 'nipon-unbreakable-pvc-safety-cone',
		dateUpdated: '2018-01-13T09:16:43.183000',
		price: {
			ps: 'S$0.00',
			original: 18.4,
			po: 'S$18.40'
		},
		model: '700UB 1000UB',
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		sku: 'dcd40bb7cb',
		brand: {
			lowerCaseName: 'aa',
			kebabName: 'aa',
			name: 'AA',
			_id: '5a59cbf437f8836a18cf6ab2'
		},
		_id: '5a59cd9637f8836a18cf6fbb'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141209164313VOEJVEJWR6VTV_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141209164313VOEJVEJWR6VTV_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20141209164319VGUBDSJRZFTCB_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141209164319VGUBDSJRZFTCB_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 15.55,
			po: 'S$15.55'
		},
		includes: [],
		model: '',
		variants: [],
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		title: 'ROAD SAFETY LIGHT',
		uniqTitle: 'road-safety-light',
		bulkDiscount: [],
		sku: '98bc75ba69',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.276000',
		_id: '59b90311196632786ed89c6c'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140404155517SDD2AGVT8T8BD_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140404155517SDD2AGVT8T8BD_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 3.21,
			po: 'S$3.21'
		},
		includes: [],
		model: '',
		variants: [],
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		title: 'SAFETY CONE 9" (PLASTIC)',
		uniqTitle: 'safety-cone-9-plastic',
		bulkDiscount: [],
		sku: 'c6eaf955df',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.124000',
		_id: '59b90310196632786ed89021'
	}, {
		buyPrice: 2.5,
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'wm7udb4.jpeg',
			expire: '2017-10-08T02:42:33.058Z',
			__v: 0,
			_id: '59db017d660a27394142f3a9',
			url: 'https://storage.googleapis.com/eezee-product-images/wm7udb4.jpeg',
			fileType: 'image'
		}],
		supplierId: '59d5dec6189444587ddb1feb',
		includes: [],
		variants: [],
		title: 'Premium Sock Safety Jogger',
		bulkDiscount: [],
		uniqTitle: 'premium-sock-safety-jogger',
		dateUpdated: '2017-11-21T12:17:44.570000',
		price: {
			ps: 'S$0.00',
			original: 3.3,
			po: 'S$3.30'
		},
		model: 'Premium Sock',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '79c14d297e',
		oldSku: '8af67fc7a1',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '59db01c3660a27394142f3ae'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140530114250LOMHFKLBMOKTP_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140530114250LOMHFKLBMOKTP_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 0.65,
			po: 'S$0.65'
		},
		includes: [],
		model: '',
		variants: [{
			name: 'Package',
			_id: '59f6ffab324e463245cb8e13',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 4.7,
					po: 'S$4.70'
				},
				name: 'Pack of 10',
				_id: '59f6ffab324e463245cb8e16',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 9.35,
					po: 'S$9.35'
				},
				name: 'Pack of 20',
				_id: '59f6ffab324e463245cb8e15',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Single Piece',
				_id: '59f6ffab324e463245cb8e14',
				order: 2
			}]
		}],
		categories: {
			sub: 'Head & Face Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'head-face-protection',
			main: 'Safety Products'
		},
		title: 'SAFETY HELMET CHIN STRAP',
		uniqTitle: 'safety-helmet-chin-strap',
		bulkDiscount: [],
		sku: '234352b94e',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.171000',
		_id: '59b90310196632786ed892d4'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201511181639115YMELRO2YMKMY_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201511181639115YMELRO2YMKMY_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20151118164111CXEJXSCK7DZFM_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151118164111CXEJXSCK7DZFM_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 14.46,
			po: 'S$14.46'
		},
		includes: [],
		model: '20',
		variants: [{
			name: 'Size',
			_id: '59f6ffb6324e463245cb9d46',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '20"',
				_id: '59f6ffb6324e463245cb9d48',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 11.22,
					po: 'S$11.22'
				},
				name: '38"',
				_id: '59f6ffb6324e463245cb9d47',
				order: 1
			}]
		}],
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		title: 'SAFETY WHIPLASH ARRESTOR',
		uniqTitle: 'safety-whiplash-arrestor',
		bulkDiscount: [],
		sku: 'f25008164b',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.279000',
		_id: '59b90311196632786ed89cfa'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140404121221BUBUVLPLYFJDC_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140404121221BUBUVLPLYFJDC_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 18.75,
			po: 'S$18.75'
		},
		includes: [],
		model: '',
		variants: [],
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		title: 'SAFETY CONE-18" (RUBBERIZED)',
		uniqTitle: 'safety-cone-18-rubberized',
		bulkDiscount: [],
		sku: '3761ab112d',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.194000',
		_id: '59b90311196632786ed894ba'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140530122833XHQB7HWWT6AZG_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140530122833XHQB7HWWT6AZG_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 4.28,
			po: 'S$4.28'
		},
		includes: [],
		model: '',
		variants: [],
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		title: 'SAFETY CLIPPER FOR HAND GLOVES',
		uniqTitle: 'safety-clipper-for-hand-gloves',
		bulkDiscount: [],
		sku: '53fb396aa4',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.224000',
		_id: '59b90311196632786ed896ea'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140612111152GNGKQRGZVWMRW_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140612111152GNGKQRGZVWMRW_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 19.8,
			po: 'S$19.80'
		},
		includes: [],
		model: 'RDM1601BN',
		variants: [{
			name: 'Inner Diameter',
			_id: '59f6ffaf324e463245cb9436',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '55mm',
				_id: '59f6ffaf324e463245cb943a',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '60mm',
				_id: '59f6ffaf324e463245cb9439',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 9.64,
					po: 'S$9.64'
				},
				name: '65mm',
				_id: '59f6ffaf324e463245cb9438',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 9.64,
					po: 'S$9.64'
				},
				name: '75mm',
				_id: '59f6ffaf324e463245cb9437',
				order: 3
			}]
		}],
		categories: {
			sub: 'Drilling & Fastening Acc',
			mainKebabCase: 'power-tools-accessories',
			subKebabCase: 'drilling-fastening-acc',
			main: 'Power Tools - Accessories'
		},
		title: 'D&D SAFETY CHUCK GUARD',
		uniqTitle: 'd-d-safety-chuck-guard',
		bulkDiscount: [],
		sku: 'cc473ea801',
		brand: {
			lowerCaseName: 'd&d tools',
			kebabName: 'd-d-tools',
			name: 'D&D TOOLS',
			_id: '59b24e3eb38a0b0ad30a39ff'
		},
		dateUpdated: '2017-11-21T12:17:44.225000',
		_id: '59b90311196632786ed8970b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141216150834VQKV1YKEEVNYK_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141216150834VQKV1YKEEVNYK_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 3.8,
			po: 'S$3.80'
		},
		includes: [],
		model: '',
		variants: [],
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		title: 'SAFETY VEST VELCRO GREEN REFLECTIVE',
		uniqTitle: 'safety-vest-velcro-green-reflective',
		bulkDiscount: [],
		sku: '2dffe5fbd0',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.278000',
		_id: '59b90311196632786ed89cab'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '2015040811360808KNBYJSW8JZR_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2015040811360808KNBYJSW8JZR_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20140310101113KHVUMCUHSCUZB_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140310101113KHVUMCUHSCUZB_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20151117215948KGO04CK0SU7AL_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151117215948KGO04CK0SU7AL_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 19.75,
			po: 'S$19.75'
		},
		includes: [],
		model: 'BLW05',
		variants: [{
			name: 'Size',
			_id: '59f6ffac324e463245cb90ec',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-05 EU-38',
				_id: '59f6ffac324e463245cb90f2',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-06 EU-39',
				_id: '59f6ffac324e463245cb90f1',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-07 EU-40',
				_id: '59f6ffac324e463245cb90f0',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-08 EU-42',
				_id: '59f6ffac324e463245cb90ef',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-09 EU-43',
				_id: '59f6ffac324e463245cb90ee',
				order: 4
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-11 EU-46',
				_id: '59f6ffac324e463245cb90ed',
				order: 5
			}]
		}],
		categories: {
			sub: 'Lifestyle Apparels',
			mainKebabCase: 'household-products',
			subKebabCase: 'lifestyle-apparels',
			main: 'Household Products'
		},
		title: 'SAFETY JOGGER SHOE BESTLIGHT WHITE',
		uniqTitle: 'safety-jogger-shoe-bestlight-white',
		bulkDiscount: [],
		sku: '523c3ff34f',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		dateUpdated: '2017-11-21T12:17:44.191000',
		_id: '59b90311196632786ed89491'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130527102658AZ47BKVUH6FTU_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130527102658AZ47BKVUH6FTU_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 1.1,
			po: 'S$1.10'
		},
		includes: [],
		model: 'NA',
		variants: [],
		categories: {
			sub: 'Head & Face Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'head-face-protection',
			main: 'Safety Products'
		},
		title: 'SAFETY GOGGLE WITH STRAP',
		uniqTitle: 'safety-goggle-with-strap',
		bulkDiscount: [],
		sku: '2b4f58087f',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.234000',
		_id: '59b90311196632786ed8979e'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140912151503TMEFWCA1B9FKJ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140912151503TMEFWCA1B9FKJ_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20140912153958LHQSKR879SKDX_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140912153958LHQSKR879SKDX_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 0.76,
			po: 'S$0.76'
		},
		includes: [],
		model: '',
		variants: [{
			name: 'Type',
			_id: '59f6ffac324e463245cb9145',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'With Hole',
				_id: '59f6ffac324e463245cb9147',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: -0.01,
					po: 'S$-0.01'
				},
				name: 'Without Hole',
				_id: '59f6ffac324e463245cb9146',
				order: 1
			}]
		}],
		categories: {
			sub: 'Household Sundries',
			mainKebabCase: 'household-products',
			subKebabCase: 'household-sundries',
			main: 'Household Products'
		},
		title: 'SAFETY PLUG KEY -3PPP',
		uniqTitle: 'safety-plug-key-3-ppp',
		bulkDiscount: [],
		sku: '9370014ee5',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.194000',
		_id: '59b90311196632786ed894b2'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150203101105OX7LZGUCDWS4K_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150203101105OX7LZGUCDWS4K_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'kva856n.jpeg',
			__v: 0,
			expire: '2017-10-21T11:01:15.943Z',
			_id: '59ed4b8d1c420a45562c7669',
			url: 'https://storage.googleapis.com/eezee-product-images/kva856n.jpeg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'nbd88t3.jpeg',
			__v: 0,
			expire: '2017-10-21T11:01:15.882Z',
			_id: '59ed4b92e769aa455af4655d',
			url: 'https://storage.googleapis.com/eezee-product-images/nbd88t3.jpeg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '7gt5asj.jpeg',
			__v: 0,
			expire: '2017-10-21T11:01:15.943Z',
			_id: '59ed4b961c420a45562c766a',
			url: 'https://storage.googleapis.com/eezee-product-images/7gt5asj.jpeg',
			fileType: 'image'
		}],
		supplierId: '59e40bac4fc38517c13ff564',
		includes: [],
		variants: [{
			name: 'Size',
			_id: '59f6ffb7324e463245cb9e17',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-06 EU-39/40',
				_id: '59f6ffb7324e463245cb9e1c',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-07 EU-41',
				_id: '59f6ffb7324e463245cb9e1b',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-09 EU-43',
				_id: '59f6ffb7324e463245cb9e1a',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-10 EU-44/45',
				_id: '59f6ffb7324e463245cb9e19',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-8 EU-42',
				_id: '59f6ffb7324e463245cb9e18',
				order: 4
			}]
		}],
		title: 'KINGS SAFETY SHOE KWS803',
		uniqTitle: 'kings-safety-shoe-kws-803',
		bulkDiscount: [],
		dateUpdated: '2017-11-21T12:17:44.284000',
		price: {
			ps: 'S$0.00',
			original: 62.52,
			po: 'S$62.52'
		},
		model: 'KWS803',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: 'cae2aeec66',
		brand: {
			lowerCaseName: 'kings',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'vs4BlaKkzgkyziDt9JqE3y.jpg',
				expire: '2017-12-20T12:56:42.106000',
				__v: 0,
				_id: '5a3b227df5ad5a4e7cc92edc',
				url: 'https://storage.googleapis.com/eezee-brand-images/vs4BlaKkzgkyziDt9JqE3y.jpg',
				fileType: 'image'
			},
			featured: true,
			kebabName: 'kings',
			name: 'KINGS',
			_id: '59e878950b0d27128901bc34'
		},
		_id: '59b90311196632786ed89daf'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140404152052WRBUAW71CHFXF_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140404152052WRBUAW71CHFXF_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170201203641MFAJ3OMKWH57T_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170201203641MFAJ3OMKWH57T_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 25.68,
			po: 'S$25.68'
		},
		includes: [],
		model: '410RED',
		variants: [],
		categories: {
			sub: 'Padlocks & Lockout Devices',
			mainKebabCase: 'locks-iron-mongery',
			subKebabCase: 'padlocks-lockout-devices',
			main: 'Locks & Iron Mongery'
		},
		title: 'MASTERLOCK SAFETY LOCKOUT PADLOCK - 410RED',
		uniqTitle: 'masterlock-safety-lockout-padlock-410-red',
		bulkDiscount: [],
		sku: '699b07571f',
		brand: {
			lowerCaseName: 'master lock',
			kebabName: 'master-lock',
			name: 'MASTER LOCK',
			_id: '59b24e3eb38a0b0ad30a3ab2'
		},
		dateUpdated: '2017-11-21T12:17:44.398000',
		_id: '59b90311196632786ed8a634'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170724095138ZRRFGZZRI1Q1U_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170724095138ZRRFGZZRI1Q1U_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170724102327Y4AIDRMNYFCHT_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170724102327Y4AIDRMNYFCHT_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 15,
			po: 'S$15.00'
		},
		includes: [],
		model: '031.181.001.001',
		variants: [],
		categories: {
			sub: 'Body & Fall Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'body-fall-protection',
			main: 'Safety Products'
		},
		title: 'PONSA SAFETY FALL STOP TRAUMA',
		uniqTitle: 'ponsa-safety-fall-stop-trauma',
		bulkDiscount: [],
		sku: '7c46f803fc',
		brand: {
			lowerCaseName: 'ponsa',
			kebabName: 'ponsa',
			name: 'PONSA',
			_id: '59b24e3eb38a0b0ad30a3b9b'
		},
		dateUpdated: '2017-11-21T12:17:44.519000',
		_id: '59b90312196632786ed8aec9'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160223145217AMYOR5IW4DZ70_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160223145217AMYOR5IW4DZ70_full.jpg',
			fileType: 'image'
		}],
		supplierId: '5a1d19f63ce29442a26763ae',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'Size',
			_id: '5a223531735a7d0cbcaa4cbb',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'EU 40 -UK 6',
				_id: '5a223531735a7d0cbcaa4cc0',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'EU 41 -UK 7',
				_id: '5a223531735a7d0cbcaa4cbf',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'EU 42 -UK 8',
				_id: '5a223531735a7d0cbcaa4cbe',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'EU 43 -UK 9',
				_id: '5a223531735a7d0cbcaa4cbd',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'EU 44 -UK 10',
				_id: '5a223531735a7d0cbcaa4cbc',
				order: 4
			}]
		}],
		title: 'D&D SAFETY SHOE 8868',
		bulkDiscount: [],
		uniqTitle: 'd-d-safety-shoe-8868',
		dateUpdated: '2017-12-02T05:08:01.262000',
		price: {
			ps: 'S$0.00',
			original: 75,
			po: 'S$75.00'
		},
		model: '8868',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '76d01fbe7b',
		brand: {
			lowerCaseName: 'd&d safety shoes',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'qUvRiAJ5uBaB3R0hiybdxp.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a435ed8cdf0b936572f020c',
				url: 'https://storage.googleapis.com/eezee-brand-images/qUvRiAJ5uBaB3R0hiybdxp.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'd-d-safety-shoes',
			name: 'D&D SAFETY SHOES',
			_id: '59b24e3eb38a0b0ad30a3a3f'
		},
		_id: '59b90310196632786ed8914c'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '76ununy.jpeg',
			expire: '2017-10-30T08:41:28.939Z',
			__v: 0,
			_id: '59f6e2839518e2289998c124',
			url: 'https://storage.googleapis.com/eezee-product-images/76ununy.jpeg',
			fileType: 'image'
		}],
		supplierId: '59c261ffd6cfd23e4425a049',
		includes: [],
		variants: [],
		title: 'Safety Jogger Shoe  X 0500',
		bulkDiscount: [],
		uniqTitle: 'safety-jogger-shoe-x-0500',
		dateUpdated: '2017-11-21T12:17:44.594000',
		price: {
			ps: 'S$0.00',
			original: 48,
			po: 'S$48.00'
		},
		model: 'X 0500 ',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: 'a2658bbebf',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		_id: '5a069de865b34a6f4956b658'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130513164210F8YCLGZ8CXLQL_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130513164210F8YCLGZ8CXLQL_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 10.7,
			po: 'S$10.70'
		},
		includes: [],
		model: '',
		variants: [{
			name: 'Size',
			_id: '59f6ffb2324e463245cb9748',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '06',
				_id: '59f6ffb2324e463245cb974d',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '07',
				_id: '59f6ffb2324e463245cb974c',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '08',
				_id: '59f6ffb2324e463245cb974b',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '09',
				_id: '59f6ffb2324e463245cb974a',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: '10',
				_id: '59f6ffb2324e463245cb9749',
				order: 4
			}]
		}],
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		title: 'PVC SAFETY BOOT WITH TOE CAP & MIDSOLE',
		uniqTitle: 'pvc-safety-boot-with-toe-cap-midsole',
		bulkDiscount: [],
		sku: '87bfd32690',
		brand: {
			lowerCaseName: 'no brand',
			kebabName: 'no-brand',
			name: 'NO BRAND',
			_id: '59b24e3eb38a0b0ad30a39f6'
		},
		dateUpdated: '2017-11-21T12:17:44.256000',
		_id: '59b90311196632786ed8995c'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160711165329QKVVAICGJ3D0U_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160711165329QKVVAICGJ3D0U_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201610241537235N1TIAWVFW5VL_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201610241537235N1TIAWVFW5VL_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 38.52,
			po: 'S$38.52'
		},
		includes: [],
		model: '',
		variants: [{
			name: 'Size',
			_id: '59f6ffc4324e463245cbaad4',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-07 EU-39/40',
				_id: '59f6ffc4324e463245cbaad9',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-08 EU-41',
				_id: '59f6ffc4324e463245cbaad8',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-09 EU-42',
				_id: '59f6ffc4324e463245cbaad7',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-10 EU-43',
				_id: '59f6ffc4324e463245cbaad6',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-11 EU-44/45',
				_id: '59f6ffc4324e463245cbaad5',
				order: 4
			}]
		}],
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		title: 'KRUSHERS SAFETY SHOE UTAH [S1 EH]',
		uniqTitle: 'krushers-safety-shoe-utah-s-1-eh',
		bulkDiscount: [],
		sku: '9466afb0fb',
		brand: {
			lowerCaseName: 'krushers safety shoes',
			kebabName: 'krushers-safety-shoes',
			name: 'KRUSHERS SAFETY SHOES',
			_id: '59b24e3eb38a0b0ad30a3b47'
		},
		dateUpdated: '2017-11-21T12:17:44.442000',
		_id: '59b90312196632786ed8a9a6'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160702103014FKWFY0K6HUHXL_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160702103014FKWFY0K6HUHXL_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160702103102XOXGKYDU7FXBZ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160702103102XOXGKYDU7FXBZ_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20161013150020YZMVFOFBYU9IU_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161013150020YZMVFOFBYU9IU_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 45,
			po: 'S$45.00'
		},
		includes: [],
		model: 'DESERT06',
		variants: [{
			name: 'Size',
			_id: '59f6ffc6324e463245cbabf5',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-06 EU-39',
				_id: '59f6ffc6324e463245cbabf7',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-07 EU-40',
				_id: '59f6ffc6324e463245cbabf6',
				order: 1
			}]
		}],
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		title: 'SAFETY JOGGER SHOE DESERT [S1-P]',
		uniqTitle: 'safety-jogger-shoe-desert-s-1-p',
		bulkDiscount: [],
		sku: 'c3cc92ab49',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		dateUpdated: '2017-11-21T12:17:44.468000',
		_id: '59b90312196632786ed8aba7'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160711160253CYJCNJLBRUFAJ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160711160253CYJCNJLBRUFAJ_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201610241538423Y5DOK9ZI1QJN_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201610241538423Y5DOK9ZI1QJN_full.jpg',
			fileType: 'image'
		}],
		includes: [],
		variants: [{
			name: 'Size',
			_id: '5a5ed57d37f8836a18e00cf8',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-06 EU-38',
				_id: '5a5ed57d37f8836a18e00cfe',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-07 EU-39/40',
				_id: '5a5ed57d37f8836a18e00cfd',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-08 EU-41',
				_id: '5a5ed57d37f8836a18e00cfc',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-09 EU-42',
				_id: '5a5ed57d37f8836a18e00cfb',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-10 EU-43',
				_id: '5a5ed57d37f8836a18e00cfa',
				order: 4
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'US-11 EU-44/45',
				_id: '5a5ed57d37f8836a18e00cf9',
				order: 5
			}]
		}],
		duplicate: false,
		title: 'KRUSHERS SAFETY SHOE TULSA [S1 EH]',
		uniqTitle: 'krushers-safety-shoe-tulsa-s-1-eh',
		bulkDiscount: [],
		dateUpdated: '2018-01-17T04:47:57.983000',
		price: {
			ps: 'S$0.00',
			original: 52.5,
			po: 'S$52.50'
		},
		model: 'TULSA',
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		sku: '4f9375b5c4',
		brand: {
			lowerCaseName: 'krushers safety shoes',
			kebabName: 'krushers-safety-shoes',
			name: 'KRUSHERS SAFETY SHOES',
			_id: '59b24e3eb38a0b0ad30a3b47'
		},
		_id: '59b90311196632786ed8a248'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141028125034NVUVXYGBFJAMR_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141028125034NVUVXYGBFJAMR_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 5.89,
			po: 'S$5.89'
		},
		includes: [],
		model: 'SRS/8YLW',
		variants: [{
			name: 'Colour',
			_id: '59f6ffb3324e463245cb98d2',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Red',
				_id: '59f6ffb3324e463245cb98d5',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0.57,
					po: 'S$0.57'
				},
				name: 'White',
				_id: '59f6ffb3324e463245cb98d4',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Yellow',
				_id: '59f6ffb3324e463245cb98d3',
				order: 2
			}]
		}],
		categories: {
			sub: 'Workplace Safety',
			mainKebabCase: 'safety-products',
			subKebabCase: 'workplace-safety',
			main: 'Safety Products'
		},
		title: '3M SAFETY REFLECTIVE STICKER -8PPP',
		uniqTitle: '3-m-safety-reflective-sticker-8-ppp',
		bulkDiscount: [],
		sku: '5d273982ed',
		brand: {
			lowerCaseName: '3m',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'XGfw9FuhgQqHnuYNmgfDr~.jpg',
				expire: '2017-12-20T12:56:42.106000',
				__v: 0,
				_id: '5a3b21b1f5ad5a4e7cc92d35',
				url: 'https://storage.googleapis.com/eezee-brand-images/XGfw9FuhgQqHnuYNmgfDr~.jpg',
				fileType: 'image'
			},
			featured: true,
			kebabName: '3-m',
			name: '3M',
			_id: '59b24e3eb38a0b0ad30a39f1'
		},
		dateUpdated: '2017-11-21T12:17:44.263000',
		_id: '59b90311196632786ed89a77'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201502051453007JRXED6W1FAC5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201502051453007JRXED6W1FAC5_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20151117220449XH0MZZ6ZABMON_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151117220449XH0MZZ6ZABMON_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 82.4,
			po: 'S$82.40'
		},
		includes: [],
		model: 'VALLIS07',
		variants: [{
			name: 'Size',
			_id: '59f6ffba324e463245cba349',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-09 EU-43',
				_id: '59f6ffba324e463245cba34c',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-10 EU-44',
				_id: '59f6ffba324e463245cba34b',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'UK-11 EU-46',
				_id: '59f6ffba324e463245cba34a',
				order: 2
			}]
		}],
		categories: {
			sub: 'Safety Shoes',
			mainKebabCase: 'safety-products',
			subKebabCase: 'safety-shoes',
			main: 'Safety Products'
		},
		title: 'SAFETY JOGGER SHOE VALLIS [S3]',
		uniqTitle: 'safety-jogger-shoe-vallis-s-3',
		bulkDiscount: [],
		sku: '9900ec69c3',
		brand: {
			lowerCaseName: 'safety jogger',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '5H1Bduc4ZzrBb52sBUK0iR.png',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a573ab237f8836a18c6ee90',
				url: 'https://storage.googleapis.com/eezee-brand-images/5H1Bduc4ZzrBb52sBUK0iR.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'safety-jogger',
			name: 'SAFETY JOGGER',
			_id: '59b24e3eb38a0b0ad30a39e8'
		},
		dateUpdated: '2017-11-21T12:17:44.317000',
		_id: '59b90311196632786ed8a089'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201401131246577H7BCG2SASRZ2_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201401131246577H7BCG2SASRZ2_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20140113124706CAATKQZYIDMWO_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140113124706CAATKQZYIDMWO_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '2014011312471211SYV1MQ7ZDJS_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2014011312471211SYV1MQ7ZDJS_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201401131247236RNKEJ8FSW1XP_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201401131247236RNKEJ8FSW1XP_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 3,
			po: 'S$3.00'
		},
		includes: [],
		model: '',
		variants: [{
			name: 'Colour',
			_id: '59f6ffa6324e463245cb8996',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0.85,
					po: 'S$0.85'
				},
				name: 'Blue',
				_id: '59f6ffa6324e463245cb899e',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0.85,
					po: 'S$0.85'
				},
				name: 'Brown',
				_id: '59f6ffa6324e463245cb899d',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0.85,
					po: 'S$0.85'
				},
				name: 'Green',
				_id: '59f6ffa6324e463245cb899c',
				order: 2
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0.85,
					po: 'S$0.85'
				},
				name: 'Grey',
				_id: '59f6ffa6324e463245cb899b',
				order: 3
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0.85,
					po: 'S$0.85'
				},
				name: 'Orange',
				_id: '59f6ffa6324e463245cb899a',
				order: 4
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0.85,
					po: 'S$0.85'
				},
				name: 'Red',
				_id: '59f6ffa6324e463245cb8999',
				order: 5
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'White',
				_id: '59f6ffa6324e463245cb8998',
				order: 6
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Yellow',
				_id: '59f6ffa6324e463245cb8997',
				order: 7
			}]
		}],
		categories: {
			sub: 'Head & Face Protection',
			mainKebabCase: 'safety-products',
			subKebabCase: 'head-face-protection',
			main: 'Safety Products'
		},
		title: 'DANCEL SAFETY HELMET [EN397]',
		uniqTitle: 'dancel-safety-helmet-en-397',
		bulkDiscount: [],
		sku: '36737b6b13',
		brand: {
			lowerCaseName: 'dancel',
			featured: false,
			kebabName: 'dancel',
			name: 'DANCEL',
			_id: '59b24e3eb38a0b0ad30a3a02'
		},
		dateUpdated: '2017-11-21T12:17:44.106000',
		_id: '59b90310196632786ed88ef0'
	}]
};
var toyogoSearchResults = {
	size: 24,
	products: [{
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151029200331W9BI33HXOYEZR_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151029200331W9BI33HXOYEZR_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 11.77,
			po: 'S$11.77'
		},
		includes: [],
		model: 'ID3902',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO CRATE ID3902',
		uniqTitle: 'toyogo-crate-id-3902',
		bulkDiscount: [],
		sku: '97ead77f20',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a442'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201510292021166CPG8RJIETM4H_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201510292021166CPG8RJIETM4H_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 8.03,
			po: 'S$8.03'
		},
		includes: [],
		model: '2181',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX 2181',
		uniqTitle: 'toyogo-storage-box-2181',
		bulkDiscount: [],
		sku: 'b66bd7b136',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a446'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151029205551NEVT4ZDBKJ2S1_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151029205551NEVT4ZDBKJ2S1_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 19.26,
			po: 'S$19.26'
		},
		includes: [],
		model: '4218-4',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO TRAY 4218-4',
		uniqTitle: 'toyogo-tray-4218-4',
		bulkDiscount: [],
		sku: 'f64f58f3a6',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a44b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160526224432GJ6FOZ5NFU9V4_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160526224432GJ6FOZ5NFU9V4_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 3.42,
			po: 'S$3.42'
		},
		includes: [],
		model: '4313',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO PLASTIC BASKET 4313',
		uniqTitle: 'toyogo-plastic-basket-4313',
		bulkDiscount: [],
		sku: 'edc6e76dec',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.422000',
		_id: '59b90312196632786ed8a80b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '2017052211051215V4HHXSPKZAA_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2017052211051215V4HHXSPKZAA_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 9.1,
			po: 'S$9.10'
		},
		includes: [],
		model: '9703',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9703',
		uniqTitle: 'toyogo-storage-box-with-cover-9703',
		bulkDiscount: [],
		sku: '624f9956a3',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.522000',
		_id: '59b90312196632786ed8af07'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'g9iJ~~aXADOzOk5hBgILvs.png',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14fde0d0e0fa3ebd9715c3',
			url: 'https://storage.googleapis.com/eezee-product-images/g9iJ~~aXADOzOk5hBgILvs.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'PkyHZOVARaOE5Gm_TCM8ij.png',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14fde5d0e0fa3ebd9715c4',
			url: 'https://storage.googleapis.com/eezee-product-images/PkyHZOVARaOE5Gm_TCM8ij.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'nXYoMwIJHkZ~nCLZe7_O8D.png',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14fdead0e0fa3ebd9715c5',
			url: 'https://storage.googleapis.com/eezee-product-images/nXYoMwIJHkZ~nCLZe7_O8D.png',
			fileType: 'image'
		}],
		supplierId: '59c261ffd6cfd23e4425a049',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'Colour',
			_id: '5a1502a0d0e0fa3ebd971cba',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Grey',
				_id: '5a1502a0d0e0fa3ebd971cbd',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Blue',
				_id: '5a1502a0d0e0fa3ebd971cbc',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Green',
				_id: '5a1502a0d0e0fa3ebd971cbb',
				order: 2
			}]
		}],
		title: 'TOYOGO SECURITY CRATE CONTAINER 4631',
		bulkDiscount: [],
		uniqTitle: 'toyogo-security-crate-container-4631',
		dateUpdated: '2017-11-22T04:52:48.249000',
		price: {
			ps: 'S$0.00',
			original: 49.05,
			po: 'S$49.05'
		},
		model: '4631',
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		sku: '87ec8b4305',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		_id: '5a14fd6fd0e0fa3ebd971515'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151029200748NMDNXX2APVZQ5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151029200748NMDNXX2APVZQ5_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 19.26,
			po: 'S$19.26'
		},
		includes: [],
		model: 'ID4713',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO INDUSTRIAL CRATE ID4713',
		uniqTitle: 'toyogo-industrial-crate-id-4713',
		bulkDiscount: [],
		sku: '018397fcba',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a443'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'PdxEi1BtfMTFLajLiIOjHY.png',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14e33ad0e0fa3ebd96eb8b',
			url: 'https://storage.googleapis.com/eezee-product-images/PdxEi1BtfMTFLajLiIOjHY.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'HfMcf3IfTEDvI~6t~EZvM7.png',
			expire: '2017-11-21T10:03:48.977Z',
			__v: 0,
			_id: '5a14f62bd0e0fa3ebd970a77',
			url: 'https://storage.googleapis.com/eezee-product-images/HfMcf3IfTEDvI~6t~EZvM7.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '0RzUX7r_yWPUgofk96iDsu.jpg',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14fa3fd0e0fa3ebd97104f',
			url: 'https://storage.googleapis.com/eezee-product-images/0RzUX7r_yWPUgofk96iDsu.jpg',
			fileType: 'image'
		}],
		supplierId: '59c261ffd6cfd23e4425a049',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'Colour',
			_id: '5a14feb1d0e0fa3ebd971752',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Grey',
				_id: '5a14feb1d0e0fa3ebd971754',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Blue',
				_id: '5a14feb1d0e0fa3ebd971753',
				order: 1
			}]
		}],
		title: 'TOYOGO SECURITY CRATE CONTAINER 4629',
		bulkDiscount: [],
		uniqTitle: 'toyogo-security-crate-container-4629',
		dateUpdated: '2017-11-22T04:36:01.424000',
		price: {
			ps: 'S$0.00',
			original: 33.1,
			po: 'S$33.10'
		},
		model: '4629',
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		sku: 'bbfdccb579',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		_id: '5a14ed22d0e0fa3ebd96fbfd'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'FVAH18~dN5cIf8~v6br4DL.png',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14f7a6d0e0fa3ebd970d08',
			url: 'https://storage.googleapis.com/eezee-product-images/FVAH18~dN5cIf8~v6br4DL.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'J~K~w6lF9O~t1YLvnw~I1H.png',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14f8a5d0e0fa3ebd970e58',
			url: 'https://storage.googleapis.com/eezee-product-images/J~K~w6lF9O~t1YLvnw~I1H.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'cpePhXiTJ1hdZ71owFEMCr.jpg',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14f9e6d0e0fa3ebd970fa2',
			url: 'https://storage.googleapis.com/eezee-product-images/cpePhXiTJ1hdZ71owFEMCr.jpg',
			fileType: 'image'
		}],
		supplierId: '59c261ffd6cfd23e4425a049',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'Colour',
			_id: '5a14fe97d0e0fa3ebd9716dd',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Grey',
				_id: '5a14fe97d0e0fa3ebd9716df',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Blue',
				_id: '5a14fe97d0e0fa3ebd9716de',
				order: 1
			}]
		}],
		title: 'TOYOGO SECURITY CRATE CONTAINER 4630',
		bulkDiscount: [],
		uniqTitle: 'toyogo-security-crate-container-4630',
		dateUpdated: '2017-11-22T04:35:35.063000',
		price: {
			ps: 'S$0.00',
			original: 42.9,
			po: 'S$42.90'
		},
		model: '4630',
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		sku: '394d12f070',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		_id: '5a14f6ead0e0fa3ebd970bfb'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201409191215342XDXM8TJ9NPA5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201409191215342XDXM8TJ9NPA5_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201409191215577ENR7JQCEJVXW_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201409191215577ENR7JQCEJVXW_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 24.93,
			po: 'S$24.93'
		},
		includes: [],
		model: '9709',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO FANCY CLIPS BOX-9709',
		uniqTitle: 'toyogo-fancy-clips-box-9709',
		bulkDiscount: [],
		sku: '161cfdea71',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a44a'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151007131054SJXP5QROZL7AV_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151007131054SJXP5QROZL7AV_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 37.45,
			po: 'S$37.45'
		},
		includes: [],
		model: '9809',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9809',
		uniqTitle: 'toyogo-storage-box-with-cover-9809',
		bulkDiscount: [],
		sku: 'c102fb9c38',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.255000',
		_id: '59b90311196632786ed8994d'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '2015082510142228O65ELJCCC3P_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2015082510142228O65ELJCCC3P_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 9.63,
			po: 'S$9.63'
		},
		includes: [],
		model: '9507',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9507',
		uniqTitle: 'toyogo-storage-box-with-cover-9507',
		bulkDiscount: [],
		sku: 'a4768f842c',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a445'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141029115825TTZFIC10CNBRK_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141029115825TTZFIC10CNBRK_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 16.59,
			po: 'S$16.59'
		},
		includes: [],
		model: '9906',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9906',
		uniqTitle: 'toyogo-storage-box-with-cover-9906',
		bulkDiscount: [],
		sku: 'f30123aaa2',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a448'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141117085848L8JXJONH09DJ5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141117085848L8JXJONH09DJ5_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 8.56,
			po: 'S$8.56'
		},
		includes: [],
		model: '9506',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9506',
		uniqTitle: 'toyogo-storage-box-with-cover-9506',
		bulkDiscount: [],
		sku: '6a2145d113',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.255000',
		_id: '59b90311196632786ed8994e'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140326124408WMZLJQNJFJVQV_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140326124408WMZLJQNJFJVQV_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20140326124413OHU5KQUHPGWOS_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140326124413OHU5KQUHPGWOS_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 19.26,
			po: 'S$19.26'
		},
		includes: [],
		model: '9508',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9508',
		uniqTitle: 'toyogo-storage-box-with-cover-9508',
		bulkDiscount: [],
		sku: '3d1e403647',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.196000',
		_id: '59b90311196632786ed894fb'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140210153708EBNIAOD5JK3XL_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140210153708EBNIAOD5JK3XL_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 44.94,
			po: 'S$44.94'
		},
		includes: [],
		model: '9810',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9810',
		uniqTitle: 'toyogo-storage-box-with-cover-9810',
		bulkDiscount: [],
		sku: 'a166a0760c',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a444'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151029203957YJFJ2UNOBWIC7_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151029203957YJFJ2UNOBWIC7_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 35.31,
			po: 'S$35.31'
		},
		includes: [],
		model: '9808',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9808',
		uniqTitle: 'toyogo-storage-box-with-cover-9808',
		bulkDiscount: [],
		sku: 'ddd09d77dd',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a449'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'PPTtfzJE9xtKKOe2XBMHKU.jpg',
			expire: '2017-11-22T06:35:22.658Z',
			__v: 0,
			_id: '5a156d78918693670dc274ee',
			url: 'https://storage.googleapis.com/eezee-product-images/PPTtfzJE9xtKKOe2XBMHKU.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'UhJ0MIm9CjaOc1uS5HqkRW.jpg',
			expire: '2017-11-22T06:35:22.658Z',
			__v: 0,
			_id: '5a154f21918693670dc24a28',
			url: 'https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'zfNdxdzB~UO~aZ5sQ4TCnU.jpg',
			expire: '2017-11-22T06:35:22.658Z',
			__v: 0,
			_id: '5a156ea8918693670dc2764c',
			url: 'https://storage.googleapis.com/eezee-product-images/zfNdxdzB~UO~aZ5sQ4TCnU.jpg',
			fileType: 'image'
		}],
		supplierId: '59c261ffd6cfd23e4425a049',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'Colour',
			_id: '5a3c6498f5ad5a4e7ccd1e82',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Blue',
				_id: '5a3c6498f5ad5a4e7ccd1e84',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Black',
				_id: '5a3c6498f5ad5a4e7ccd1e83',
				order: 1
			}]
		}],
		title: 'TOYOGO INDUSTRIAL PALLET P-1114G',
		bulkDiscount: [],
		uniqTitle: 'toyogo-industrial-pallet-p-1114-g',
		dateUpdated: '2017-12-22T01:49:12.949000',
		price: {
			ps: 'S$0.00',
			original: 103.5,
			po: 'S$103.50'
		},
		model: 'P-1114G',
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		sku: 'f6070e246a',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		_id: '5a156c4c918693670dc27302'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140326115621HEIOS8N4NZ22B_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140326115621HEIOS8N4NZ22B_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20140326115629A97MVPRMC3FSJ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140326115629A97MVPRMC3FSJ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 16.05,
			po: 'S$16.05'
		},
		includes: [],
		model: '1090',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-1090',
		uniqTitle: 'toyogo-storage-box-with-cover-1090',
		bulkDiscount: [],
		sku: 'ae9117116a',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.196000',
		_id: '59b90311196632786ed894fa'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151029210131UJCB4JKPVOBWI_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151029210131UJCB4JKPVOBWI_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 7.49,
			po: 'S$7.49'
		},
		includes: [],
		model: '9904',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9904',
		uniqTitle: 'toyogo-storage-box-with-cover-9904',
		bulkDiscount: [],
		sku: 'e720ce0490',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a44c'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'UhJ0MIm9CjaOc1uS5HqkRW.jpg',
			expire: '2017-11-22T06:35:22.658Z',
			__v: 0,
			_id: '5a154f21918693670dc24a28',
			url: 'https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'O24EoqiMcC10foNWdsXNdN.jpg',
			expire: '2017-11-22T06:35:22.658Z',
			__v: 0,
			_id: '5a15501e918693670dc24b88',
			url: 'https://storage.googleapis.com/eezee-product-images/O24EoqiMcC10foNWdsXNdN.jpg',
			fileType: 'image'
		}],
		supplierId: '59c261ffd6cfd23e4425a049',
		includes: [],
		duplicate: false,
		variants: [],
		title: 'TOYOGO HEAVY DUTY PALLET P-1411H',
		bulkDiscount: [],
		uniqTitle: 'toyogo-heavy-duty-pallet-p-1411-h',
		dateUpdated: '2017-11-26T09:50:23.146000',
		price: {
			ps: 'S$0.00',
			original: 115,
			po: 'S$115.00'
		},
		model: 'P-1411H',
		categories: {
			sub: 'Packaging & Shipping Supplies',
			mainKebabCase: 'industrial-consumable-goods',
			subKebabCase: 'packaging-shipping-supplies',
			main: 'Industrial Consumable Goods'
		},
		sku: '00e66e3885',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		_id: '5a1553ef918693670dc25007'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201408071740032PUWZWGK4BUWD_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201408071740032PUWZWGK4BUWD_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 16.05,
			po: 'S$16.05'
		},
		includes: [],
		model: '1070',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-1070',
		uniqTitle: 'toyogo-storage-box-with-cover-1070',
		bulkDiscount: [],
		sku: '0f0c406c2a',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.240000',
		_id: '59b90311196632786ed89825'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151029202815IFNQN1W6F7H1S_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151029202815IFNQN1W6F7H1S_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 25.68,
			po: 'S$25.68'
		},
		includes: [],
		model: '9807',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9807',
		uniqTitle: 'toyogo-storage-box-with-cover-9807',
		bulkDiscount: [],
		sku: 'a5f65c8e8b',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a447'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201510292105543RIEBF6MAGSBF_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201510292105543RIEBF6MAGSBF_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 21.4,
			po: 'S$21.40'
		},
		includes: [],
		model: '407-4',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO 4 TIER COLLEGE A4 DRAWER 407-4',
		uniqTitle: 'toyogo-4-tier-college-a-4-drawer-407-4',
		bulkDiscount: [],
		sku: 'b4d3cb1afd',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a44d'
	}]
};
var categoryResults = {
	size: 399,
	products: [{
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201511031408597GPLBC5ASWEJE_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201511031408597GPLBC5ASWEJE_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 321,
			po: 'S$321.00'
		},
		includes: [],
		model: 'DC240S',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'DAWER DC240S BRUSHLESS 20V LI-ON ROTARY HAMMER 26MM',
		uniqTitle: 'dawer-dc-240-s-brushless-20-v-li-on-rotary-hammer-26-mm',
		bulkDiscount: [],
		sku: '13838c94cb',
		brand: {
			lowerCaseName: 'dawer power tools',
			kebabName: 'dawer-power-tools',
			name: 'DAWER POWER TOOLS',
			_id: '59b24e3eb38a0b0ad30a3b6d'
		},
		dateUpdated: '2017-11-21T12:17:44.390000',
		_id: '59b90311196632786ed8a58d'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130603174555ZJQKB4FMA4CJD_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130603174555ZJQKB4FMA4CJD_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170110123231OMG6X6OVRWL10_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170110123231OMG6X6OVRWL10_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170110123230O7J4SX3OEHDGF_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170110123230O7J4SX3OEHDGF_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170110123232SLX076H1GYXEH_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170110123232SLX076H1GYXEH_full.jpg',
			fileType: 'image'
		}],
		includes: [],
		variants: [],
		duplicate: false,
		title: 'BOSCH 18V LI-ION IMPACT DRIVER, GDR18V-LI',
		uniqTitle: 'bosch-18-v-li-ion-impact-driver-gdr-18-v-li',
		bulkDiscount: [],
		dateUpdated: '2017-11-29T12:10:41.446000',
		price: {
			ps: 'S$0.00',
			original: 545.7,
			po: 'S$545.70'
		},
		model: 'GDR18V-LI',
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		sku: 'e014a00599',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		_id: '59b90310196632786ed88b6b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130603190247E4E7K02ODMWSV_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130603190247E4E7K02ODMWSV_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170110123656C2IN7ZZXC6GFV_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170110123656C2IN7ZZXC6GFV_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170207131217OFP8J4MSOWUQR_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170207131217OFP8J4MSOWUQR_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170207131218EPJL3XEUNSX1T_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170207131218EPJL3XEUNSX1T_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 284.62,
			po: 'S$284.62'
		},
		includes: [],
		model: 'GSB18-2 LI',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'BOSCH 18V LI-ION IMPACT DRILL, GSB18-2 LI',
		uniqTitle: 'bosch-18-v-li-ion-impact-drill-gsb-18-2-li',
		bulkDiscount: [],
		sku: '180c7fd4c9',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		dateUpdated: '2017-11-21T12:17:44.051000',
		_id: '59b90310196632786ed88b87'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130603190843UXVCRN4C5A36I_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130603190843UXVCRN4C5A36I_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170110122426IOTBC5AVCYZKD_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170110122426IOTBC5AVCYZKD_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170110122426GEZMOQUPPXSFY_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170110122426GEZMOQUPPXSFY_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170110122426L14PPRY5P9ELL_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170110122426L14PPRY5P9ELL_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170110122427S07OYMNQRSBZQ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170110122427S07OYMNQRSBZQ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 94.16,
			po: 'S$94.16'
		},
		includes: [],
		model: 'GSR3.6 PRO DRIV',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'BOSCH 3.6V LI-ION SCREWDRIVER, GSR3.6 PRODRIVE',
		uniqTitle: 'bosch-3-6-v-li-ion-screwdriver-gsr-3-6-prodrive',
		bulkDiscount: [],
		sku: 'a9ade85960',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		dateUpdated: '2017-11-21T12:17:44.051000',
		_id: '59b90310196632786ed88b91'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141031213839ZGCPFQGWQSK2D_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141031213839ZGCPFQGWQSK2D_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201701091752170HMYVHJINVAYO_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201701091752170HMYVHJINVAYO_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170109175416GYL21WYL82QFC_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170109175416GYL21WYL82QFC_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201701091754183NHGIUSGKILW5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201701091754183NHGIUSGKILW5_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170109175420VGNKXGOUFWJVS_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170109175420VGNKXGOUFWJVS_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170109175422TBIV66XXRRTTV_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170109175422TBIV66XXRRTTV_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 631.3,
			po: 'S$631.30'
		},
		includes: [],
		model: 'GBH18V-EC',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'BOSCH 18MM 18V LI-ION BRUSHLESS ROTARY HAMMER, GBH18V-EC',
		uniqTitle: 'bosch-18-mm-18-v-li-ion-brushless-rotary-hammer-gbh-18-v-ec',
		bulkDiscount: [],
		sku: 'b41344c2b9',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		dateUpdated: '2017-11-21T12:17:44.265000',
		_id: '59b90311196632786ed89ad3'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160222155701STDTSC7AO5U6O_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160222155701STDTSC7AO5U6O_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 144.45,
			po: 'S$144.45'
		},
		includes: [],
		model: 'GSB1080-2-LI',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'BOSCH 10.8V LI-ION IMPACT DRIVER DRILL, GSB1080-2-LI',
		uniqTitle: 'bosch-10-8-v-li-ion-impact-driver-drill-gsb-1080-2-li',
		bulkDiscount: [],
		sku: '8b1648097a',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		dateUpdated: '2017-11-21T12:17:44.403000',
		_id: '59b90311196632786ed8a699'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170113120339LCS9EI8I02KPM_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170113120339LCS9EI8I02KPM_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 141.24,
			po: 'S$141.24'
		},
		includes: [],
		model: 'GSB120-LI',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'BOSCH 12V LI-ION IMPACT DRILL GSB120-LI',
		uniqTitle: 'bosch-12-v-li-ion-impact-drill-gsb-120-li',
		bulkDiscount: [],
		sku: '72a5cf417f',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		dateUpdated: '2017-11-21T12:17:44.485000',
		_id: '59b90312196632786ed8accb'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130606145315VBI33IRAGIMJA_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130606145315VBI33IRAGIMJA_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201403241515159OASG9QSI6JJA_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201403241515159OASG9QSI6JJA_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 206.21,
			po: 'S$206.21'
		},
		includes: ['Quick-action keyless chuck', '1 Pozidriv bit, size 2/ 50 mm', 'Li-power rechargeable battery pack (10.8 V/1.5 Ah)', 'Charger LC 40', 'Tool bag'],
		model: 'POWERMAXX',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'METABO 10.8V LI-ION POWERMAXX DRILL, BS PRO',
		uniqTitle: 'metabo-10-8-v-li-ion-powermaxx-drill-bs-pro',
		bulkDiscount: [],
		sku: '871c44d871',
		brand: {
			lowerCaseName: 'metabo',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '0gTkD11zsCBRnlOqay3CNP.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a4323cecdf0b9365722cea5',
				url: 'https://storage.googleapis.com/eezee-brand-images/0gTkD11zsCBRnlOqay3CNP.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'metabo',
			name: 'METABO',
			_id: '59b24e3eb38a0b0ad30a39e6'
		},
		dateUpdated: '2017-11-21T12:17:44.059000',
		_id: '59b90310196632786ed88bd2'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130311155144HC4JK9MVMUFVB_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130311155144HC4JK9MVMUFVB_full.jpg',
			fileType: 'image'
		}],
		supplierId: '5a1fba59735a7d0cbca41451',
		includes: ['2 X Batteries', 'Charger', 'Kitbox'],
		duplicate: false,
		variants: [],
		title: 'AEG 12V LI-ION 2-SPEED ULTRA COMPACT DRIVER DRILL, BS12C2LI',
		bulkDiscount: [],
		uniqTitle: 'aeg-12-v-li-ion-2-speed-ultra-compact-driver-drill-bs-12-c-2-li',
		dateUpdated: '2017-12-02T05:45:17.102000',
		price: {
			ps: 'S$0.00',
			original: 192.6,
			po: 'S$192.60'
		},
		model: 'BS12CSCLI',
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		sku: '246896fdd6',
		brand: {
			lowerCaseName: 'aeg',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '_fceFZujLWYnG0RblL8tFM.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a421de64d28407c4dd48d24',
				url: 'https://storage.googleapis.com/eezee-brand-images/_fceFZujLWYnG0RblL8tFM.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'aeg',
			name: 'AEG',
			_id: '59b24e3eb38a0b0ad30a39de'
		},
		_id: '59b90310196632786ed88b2b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150214131922T47GSUQYIFQYP_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150214131922T47GSUQYIFQYP_full.jpg',
			fileType: 'image'
		}],
		supplierId: '5a1fba59735a7d0cbca41451',
		includes: [],
		duplicate: false,
		variants: [],
		title: 'AEG 12V ULTRA COMPACT IMPACT DRIVER, BSS12CLI-152C',
		bulkDiscount: [],
		uniqTitle: 'aeg-12-v-ultra-compact-impact-driver-bss-12-cli-152-c',
		dateUpdated: '2017-12-02T09:27:32.559000',
		price: {
			ps: 'S$0.00',
			original: 214,
			po: 'S$214.00'
		},
		model: 'BSS12CLI-152C',
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		sku: '4ad6c437a8',
		brand: {
			lowerCaseName: 'aeg',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '_fceFZujLWYnG0RblL8tFM.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a421de64d28407c4dd48d24',
				url: 'https://storage.googleapis.com/eezee-brand-images/_fceFZujLWYnG0RblL8tFM.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'aeg',
			name: 'AEG',
			_id: '59b24e3eb38a0b0ad30a39de'
		},
		_id: '59b90311196632786ed8a011'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160121150633LYAUJV5Y5ZOBP_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160121150633LYAUJV5Y5ZOBP_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 155.15,
			po: 'S$155.15'
		},
		includes: [],
		model: 'BD120',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'RYOBI 12V LI-ION COMPACT DRILL DRIVER, BD120C',
		uniqTitle: 'ryobi-12-v-li-ion-compact-drill-driver-bd-120-c',
		bulkDiscount: [],
		sku: 'bd0989654d',
		brand: {
			lowerCaseName: 'ryobi',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'UU84JKK_tk1_qaKb4YaDlI.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a431f61cdf0b93657221346',
				url: 'https://storage.googleapis.com/eezee-brand-images/UU84JKK_tk1_qaKb4YaDlI.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'ryobi',
			name: 'RYOBI',
			_id: '59b24e3eb38a0b0ad30a39e5'
		},
		dateUpdated: '2017-11-21T12:17:44.397000',
		_id: '59b90311196632786ed8a621'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201606281655186HWWFO4ETLFC4_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201606281655186HWWFO4ETLFC4_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201606281655218LSQ7JR2J7FES_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201606281655218LSQ7JR2J7FES_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 510,
			po: 'S$510.00'
		},
		includes: [],
		model: 'M18BIW',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MILWAUKEE 18V 4.0AH LI-ION 1/2"SQ DRIVE IMPACT WRENCH- M18BIW',
		uniqTitle: 'milwaukee-18-v-4-0-ah-li-ion-1-2-sq-drive-impact-wrench-m-18-biw',
		bulkDiscount: [],
		sku: 'e8e66c7f1a',
		brand: {
			lowerCaseName: 'milwaukee tool',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '0BuaOLaW2DexFUZjGufprm.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a434ee6cdf0b936572ca18d',
				url: 'https://storage.googleapis.com/eezee-brand-images/0BuaOLaW2DexFUZjGufprm.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'milwaukee-tool',
			name: 'MILWAUKEE TOOL',
			_id: '59b24e3eb38a0b0ad30a3a13'
		},
		dateUpdated: '2017-11-21T12:17:44.359000',
		_id: '59b90311196632786ed8a37e'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201511031647286OEEVVL4EPKX3_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201511031647286OEEVVL4EPKX3_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 149.8,
			po: 'S$149.80'
		},
		includes: [],
		model: 'DCD700C2',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'DEWALT 10.8V 1.3AH LI-ON 10MM DRILL DRIVER DCD700C2',
		uniqTitle: 'dewalt-10-8-v-1-3-ah-li-on-10-mm-drill-driver-dcd-700-c-2',
		bulkDiscount: [],
		sku: 'b273e52301',
		brand: {
			lowerCaseName: 'dewalt',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'kHDa6GXPfw2zEgRUviGHdg.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a43508fcdf0b936572cc3e3',
				url: 'https://storage.googleapis.com/eezee-brand-images/kHDa6GXPfw2zEgRUviGHdg.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'dewalt',
			name: 'DEWALT',
			_id: '59b24e3eb38a0b0ad30a3a18'
		},
		dateUpdated: '2017-11-21T12:17:44.134000',
		_id: '59b90310196632786ed890bb'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140827161548G3D1L7HHO4BHV_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140827161548G3D1L7HHO4BHV_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59cc8a8635cc384838b44d38',
		includes: [],
		variants: [],
		title: 'DEWALT 10.8V 1.1AH LI-ION DRIVER, DCF610S2',
		uniqTitle: 'dewalt-10-8-v-1-1-ah-li-ion-driver-dcf-610-s-2',
		bulkDiscount: [],
		dateUpdated: '2017-11-21T12:17:44.249000',
		price: {
			ps: 'S$0.00',
			original: 187.25,
			po: 'S$187.25'
		},
		model: 'DCF610S2',
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		sku: '9fab9e3437',
		brand: {
			lowerCaseName: 'dewalt',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'kHDa6GXPfw2zEgRUviGHdg.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a43508fcdf0b936572cc3e3',
				url: 'https://storage.googleapis.com/eezee-brand-images/kHDa6GXPfw2zEgRUviGHdg.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'dewalt',
			name: 'DEWALT',
			_id: '59b24e3eb38a0b0ad30a3a18'
		},
		_id: '59b90311196632786ed898b8'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151211164549QL28TCPXW1N7C_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151211164549QL28TCPXW1N7C_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59cc8a8635cc384838b44d38',
		includes: [],
		variants: [],
		title: 'DEWALT 18V 4.0AH LI-ON BRUSHLESS DRILL DRIVER, DCD790M2',
		uniqTitle: 'dewalt-18-v-4-0-ah-li-on-brushless-drill-driver-dcd-790-m-2',
		bulkDiscount: [],
		dateUpdated: '2017-11-21T12:17:44.391000',
		price: {
			ps: 'S$0.00',
			original: 368.35,
			po: 'S$368.35'
		},
		model: 'DCD790M2',
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		sku: '9e96c0ba7b',
		brand: {
			lowerCaseName: 'dewalt',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'kHDa6GXPfw2zEgRUviGHdg.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a43508fcdf0b936572cc3e3',
				url: 'https://storage.googleapis.com/eezee-brand-images/kHDa6GXPfw2zEgRUviGHdg.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'dewalt',
			name: 'DEWALT',
			_id: '59b24e3eb38a0b0ad30a3a18'
		},
		_id: '59b90311196632786ed8a5a7'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160520114334BA4FLTEDRTY0W_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160520114334BA4FLTEDRTY0W_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 398.85,
			po: 'S$398.85'
		},
		includes: [],
		model: 'DCD796M2',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'DEWALT XR BRUSHLESS HAMMER DRILL DRIVER 18V 4.0AH DCD796M2',
		uniqTitle: 'dewalt-xr-brushless-hammer-drill-driver-18-v-4-0-ah-dcd-796-m-2',
		bulkDiscount: [],
		sku: 'b58a274698',
		brand: {
			lowerCaseName: 'dewalt',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'kHDa6GXPfw2zEgRUviGHdg.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a43508fcdf0b936572cc3e3',
				url: 'https://storage.googleapis.com/eezee-brand-images/kHDa6GXPfw2zEgRUviGHdg.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'dewalt',
			name: 'DEWALT',
			_id: '59b24e3eb38a0b0ad30a3a18'
		},
		dateUpdated: '2017-11-21T12:17:44.420000',
		_id: '59b90312196632786ed8a7d8'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201503251317057KHHJQYWW4FSA_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201503251317057KHHJQYWW4FSA_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 318.86,
			po: 'S$318.86'
		},
		includes: [],
		model: 'DS18DFL',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'HITACHI 18V LI-ION DRILL, DS18DFL',
		uniqTitle: 'hitachi-18-v-li-ion-drill-ds-18-dfl',
		bulkDiscount: [],
		sku: '038320c80e',
		brand: {
			lowerCaseName: 'hitachi power tools',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '8Ggb9WN6SaNoMpyUTB2cUO.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a4358a9cdf0b936572d71d1',
				url: 'https://storage.googleapis.com/eezee-brand-images/8Ggb9WN6SaNoMpyUTB2cUO.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'hitachi-power-tools',
			name: 'HITACHI POWER TOOLS',
			_id: '59b24e3eb38a0b0ad30a3a2a'
		},
		dateUpdated: '2017-11-21T12:17:44.296000',
		_id: '59b90311196632786ed89efa'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150325151627PKI2D5PHARVD9_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150325151627PKI2D5PHARVD9_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 513.6,
			po: 'S$513.60'
		},
		includes: [],
		model: 'WR14DBAL2',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'HITACHI 1/2"DR 14.4V LI-ON IMPACT WRENCH, WR14DBAL2',
		uniqTitle: 'hitachi-1-2-dr-14-4-v-li-on-impact-wrench-wr-14-dbal-2',
		bulkDiscount: [],
		sku: '9e9c2c129c',
		brand: {
			lowerCaseName: 'hitachi power tools',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '8Ggb9WN6SaNoMpyUTB2cUO.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a4358a9cdf0b936572d71d1',
				url: 'https://storage.googleapis.com/eezee-brand-images/8Ggb9WN6SaNoMpyUTB2cUO.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'hitachi-power-tools',
			name: 'HITACHI POWER TOOLS',
			_id: '59b24e3eb38a0b0ad30a3a2a'
		},
		dateUpdated: '2017-11-21T12:17:44.297000',
		_id: '59b90311196632786ed89f01'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130516161223HYUWPPUXXJJKW_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130516161223HYUWPPUXXJJKW_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 422.65,
			po: 'S$422.65'
		},
		includes: [],
		model: 'DDF456RME',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MAKITA 18V 4.0AH LI-ION 13MM DRIVER DRILL, DDF456RME',
		uniqTitle: 'makita-18-v-4-0-ah-li-ion-13-mm-driver-drill-ddf-456-rme',
		bulkDiscount: [],
		sku: '5bf5f02ebe',
		brand: {
			lowerCaseName: 'makita',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '~Z2A3nzi_yxqstZaJyKHa7.jpg',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a57393137f8836a18c6ea31',
				url: 'https://storage.googleapis.com/eezee-brand-images/~Z2A3nzi_yxqstZaJyKHa7.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'makita',
			name: 'MAKITA',
			_id: '59b24e3eb38a0b0ad30a39e4'
		},
		dateUpdated: '2017-11-21T12:17:44.095000',
		_id: '59b90310196632786ed88e3e'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130826100226QT0LGWL4T4FDF_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130826100226QT0LGWL4T4FDF_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 433.35,
			po: 'S$433.35'
		},
		includes: [],
		model: 'DTD146RFE',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MAKITA 18V 3.0AH LI-ION IMPACT DRIVER, DTD146RFE',
		uniqTitle: 'makita-18-v-3-0-ah-li-ion-impact-driver-dtd-146-rfe',
		bulkDiscount: [],
		sku: 'cc19651afc',
		brand: {
			lowerCaseName: 'makita',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '~Z2A3nzi_yxqstZaJyKHa7.jpg',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a57393137f8836a18c6ea31',
				url: 'https://storage.googleapis.com/eezee-brand-images/~Z2A3nzi_yxqstZaJyKHa7.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'makita',
			name: 'MAKITA',
			_id: '59b24e3eb38a0b0ad30a39e4'
		},
		dateUpdated: '2017-11-21T12:17:44.102000',
		_id: '59b90310196632786ed88eab'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201308261011458TTEO4DQOUAO4_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201308261011458TTEO4DQOUAO4_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 545.7,
			po: 'S$545.70'
		},
		includes: [],
		model: 'DTP140RFE',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MAKITA 18V 3.0AH LI-ION 4 MODE IMPACT DRIVER, DTP140RFE',
		uniqTitle: 'makita-18-v-3-0-ah-li-ion-4-mode-impact-driver-dtp-140-rfe',
		bulkDiscount: [],
		sku: '294b547106',
		brand: {
			lowerCaseName: 'makita',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '~Z2A3nzi_yxqstZaJyKHa7.jpg',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a57393137f8836a18c6ea31',
				url: 'https://storage.googleapis.com/eezee-brand-images/~Z2A3nzi_yxqstZaJyKHa7.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'makita',
			name: 'MAKITA',
			_id: '59b24e3eb38a0b0ad30a39e4'
		},
		dateUpdated: '2017-11-21T12:17:44.102000',
		_id: '59b90310196632786ed88eaf'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150611115547SYIPWKXKQOLAJ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150611115547SYIPWKXKQOLAJ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 518.95,
			po: 'S$518.95'
		},
		includes: [],
		model: 'DTW251RME',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MAKITA 18V 4.0AH LI-ION 12.7MM IMPACT WRENCH, DTW251RME',
		uniqTitle: 'makita-18-v-4-0-ah-li-ion-12-7-mm-impact-wrench-dtw-251-rme',
		bulkDiscount: [],
		sku: '17bddc08f6',
		brand: {
			lowerCaseName: 'makita',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '~Z2A3nzi_yxqstZaJyKHa7.jpg',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a57393137f8836a18c6ea31',
				url: 'https://storage.googleapis.com/eezee-brand-images/~Z2A3nzi_yxqstZaJyKHa7.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'makita',
			name: 'MAKITA',
			_id: '59b24e3eb38a0b0ad30a39e4'
		},
		dateUpdated: '2017-11-21T12:17:44.312000',
		_id: '59b90311196632786ed8a04b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160518153946B9AJW7HRCNXXA_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160518153946B9AJW7HRCNXXA_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 559.08,
			po: 'S$559.08'
		},
		includes: [],
		model: 'DHR202RYE',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MAKITA 18V 1.5AH LI-ION ROTARY HAMMER DHR202RYE',
		uniqTitle: 'makita-18-v-1-5-ah-li-ion-rotary-hammer-dhr-202-rye',
		bulkDiscount: [],
		sku: '2fc219db76',
		brand: {
			lowerCaseName: 'makita',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '~Z2A3nzi_yxqstZaJyKHa7.jpg',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a57393137f8836a18c6ea31',
				url: 'https://storage.googleapis.com/eezee-brand-images/~Z2A3nzi_yxqstZaJyKHa7.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'makita',
			name: 'MAKITA',
			_id: '59b24e3eb38a0b0ad30a39e4'
		},
		dateUpdated: '2017-11-21T12:17:44.472000',
		_id: '59b90312196632786ed8abe4'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20161019165010V83FDKNNZ1KXF_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161019165010V83FDKNNZ1KXF_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 363.8,
			po: 'S$363.80'
		},
		includes: [],
		model: 'DTD146RYE',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MAKITA 18V 1.5AH LI-ION IMPACT DRIVER DTD146RYE',
		uniqTitle: 'makita-18-v-1-5-ah-li-ion-impact-driver-dtd-146-rye',
		bulkDiscount: [],
		sku: 'feaa55be84',
		brand: {
			lowerCaseName: 'makita',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '~Z2A3nzi_yxqstZaJyKHa7.jpg',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a57393137f8836a18c6ea31',
				url: 'https://storage.googleapis.com/eezee-brand-images/~Z2A3nzi_yxqstZaJyKHa7.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'makita',
			name: 'MAKITA',
			_id: '59b24e3eb38a0b0ad30a39e4'
		},
		dateUpdated: '2017-11-21T12:17:44.472000',
		_id: '59b90312196632786ed8abe9'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201705051315005IM5JZIRTRUNQ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201705051315005IM5JZIRTRUNQ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 679.45,
			po: 'S$679.45'
		},
		includes: [],
		model: 'DHR242RTE',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MAKITA COMB HAMMER LI-ION ROTARY DHR242RTE - (18V 5.0AH)',
		uniqTitle: 'makita-comb-hammer-li-ion-rotary-dhr-242-rte-18-v-5-0-ah',
		bulkDiscount: [],
		sku: '9f2308c2fd',
		brand: {
			lowerCaseName: 'makita',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '~Z2A3nzi_yxqstZaJyKHa7.jpg',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a57393137f8836a18c6ea31',
				url: 'https://storage.googleapis.com/eezee-brand-images/~Z2A3nzi_yxqstZaJyKHa7.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'makita',
			name: 'MAKITA',
			_id: '59b24e3eb38a0b0ad30a39e4'
		},
		dateUpdated: '2017-11-21T12:17:44.513000',
		_id: '59b90312196632786ed8ae8e'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170505132411PSSCEGH96YUAL_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170505132411PSSCEGH96YUAL_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 535,
			po: 'S$535.00'
		},
		includes: [],
		model: 'DTD170RFE',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MAKITA LI-ION IMPACT DRIVER DTD170RFE - (18V) 3.0AH',
		uniqTitle: 'makita-li-ion-impact-driver-dtd-170-rfe-18-v-3-0-ah',
		bulkDiscount: [],
		sku: 'ef19c9c06b',
		brand: {
			lowerCaseName: 'makita',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '~Z2A3nzi_yxqstZaJyKHa7.jpg',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a57393137f8836a18c6ea31',
				url: 'https://storage.googleapis.com/eezee-brand-images/~Z2A3nzi_yxqstZaJyKHa7.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'makita',
			name: 'MAKITA',
			_id: '59b24e3eb38a0b0ad30a39e4'
		},
		dateUpdated: '2017-11-21T12:17:44.514000',
		_id: '59b90312196632786ed8ae91'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160905094529WSONDHDI0DZVP_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160905094529WSONDHDI0DZVP_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 197.95,
			po: 'S$197.95'
		},
		includes: [],
		model: 'TD110DWAE',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MAKITA LI-ION IMPACT DRIVER TD110DWAE - 12V',
		uniqTitle: 'makita-li-ion-impact-driver-td-110-dwae-12-v',
		bulkDiscount: [],
		sku: 'b7947c071e',
		brand: {
			lowerCaseName: 'makita',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '~Z2A3nzi_yxqstZaJyKHa7.jpg',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a57393137f8836a18c6ea31',
				url: 'https://storage.googleapis.com/eezee-brand-images/~Z2A3nzi_yxqstZaJyKHa7.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'makita',
			name: 'MAKITA',
			_id: '59b24e3eb38a0b0ad30a39e4'
		},
		dateUpdated: '2017-11-21T12:17:44.517000',
		_id: '59b90312196632786ed8ae9f'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201702071359500CEKEFEP8D7IV_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201702071359500CEKEFEP8D7IV_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 444.05,
			po: 'S$444.05'
		},
		includes: [],
		model: 'DTD152RTE',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MAKITA LI-ION IMPACT DRIVER DTD152RTE - (18V) 5.0AH',
		uniqTitle: 'makita-li-ion-impact-driver-dtd-152-rte-18-v-5-0-ah',
		bulkDiscount: [],
		sku: 'f29a73c02b',
		brand: {
			lowerCaseName: 'makita',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '~Z2A3nzi_yxqstZaJyKHa7.jpg',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a57393137f8836a18c6ea31',
				url: 'https://storage.googleapis.com/eezee-brand-images/~Z2A3nzi_yxqstZaJyKHa7.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'makita',
			name: 'MAKITA',
			_id: '59b24e3eb38a0b0ad30a39e4'
		},
		dateUpdated: '2017-11-21T12:17:44.517000',
		_id: '59b90312196632786ed8aea4'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151103140438THZXESCJFRHAY_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151103140438THZXESCJFRHAY_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 321,
			po: 'S$321.00'
		},
		includes: [],
		model: 'DC9933',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'DAWER DC9933 BRUSHLESS 20V LI-ON INTELLIGENT IMPACT WRENCH',
		uniqTitle: 'dawer-dc-9933-brushless-20-v-li-on-intelligent-impact-wrench',
		bulkDiscount: [],
		sku: '4daf1547a3',
		brand: {
			lowerCaseName: 'dawer power tools',
			kebabName: 'dawer-power-tools',
			name: 'DAWER POWER TOOLS',
			_id: '59b24e3eb38a0b0ad30a3b6d'
		},
		dateUpdated: '2017-11-21T12:17:44.389000',
		_id: '59b90311196632786ed8a58a'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130522143411YZ1Q6RNOSMUUH_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130522143411YZ1Q6RNOSMUUH_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20130522143416Q33A0MOQ48F3T_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130522143416Q33A0MOQ48F3T_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20130522143421O27NLO0T7GEH5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130522143421O27NLO0T7GEH5_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20130522143425IYJ7PZD5YQJ49_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130522143425IYJ7PZD5YQJ49_full.jpg',
			fileType: 'image'
		}],
		includes: [],
		variants: [],
		duplicate: false,
		title: 'BOSCH 18MM 36V LI-ION ROTARY HAMMER, GBH36V-EC',
		uniqTitle: 'bosch-18-mm-36-v-li-ion-rotary-hammer-gbh-36-v-ec',
		bulkDiscount: [],
		dateUpdated: '2017-11-29T11:46:28.841000',
		price: {
			ps: 'S$0.00',
			original: 802.5,
			po: 'S$802.50'
		},
		model: 'GBH36VLI',
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		sku: '007325922f',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		_id: '59b90310196632786ed88b1e'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130522144152DOM1EP36EREOM_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130522144152DOM1EP36EREOM_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170113100911ZA40ZG0KU1EQA_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170113100911ZA40ZG0KU1EQA_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 246.1,
			po: 'S$246.10'
		},
		includes: [],
		model: 'GSR1442LI',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'BOSCH 14.4V LI-ION 10MM DRIVER DRILL, GSR14.4-2 LI',
		uniqTitle: 'bosch-14-4-v-li-ion-10-mm-driver-drill-gsr-14-4-2-li',
		bulkDiscount: [],
		sku: 'a38d1d21f4',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		dateUpdated: '2017-11-21T12:17:44.049000',
		_id: '59b90310196632786ed88b4b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130603174644GTSLFISGUBBOR_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130603174644GTSLFISGUBBOR_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170110123524OEJIMEWBZUTTM_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170110123524OEJIMEWBZUTTM_full.jpg',
			fileType: 'image'
		}],
		includes: [],
		duplicate: false,
		variants: [],
		title: 'BOSCH 10.8V LI-ION IMPACT DRIVER, GDR1080-LI',
		uniqTitle: 'bosch-10-8-v-li-ion-impact-driver-gdr-1080-li',
		bulkDiscount: [],
		dateUpdated: '2017-11-29T09:25:03.705000',
		price: {
			ps: 'S$0.00',
			original: 181.9,
			po: 'S$181.90'
		},
		model: 'GDR1080-LI',
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		sku: '60d8d075a9',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		_id: '59b90310196632786ed88b6c'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130603174714ATFKIZS5Y7XZ0_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130603174714ATFKIZS5Y7XZ0_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170110122913BH7R2IDZHORFB_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170110122913BH7R2IDZHORFB_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 203.3,
			po: 'S$203.30'
		},
		includes: [],
		model: 'GDR1440-LI',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'BOSCH 14.4V LI-ION IMPACT DRIVER, GDR1440-LI',
		uniqTitle: 'bosch-14-4-v-li-ion-impact-driver-gdr-1440-li',
		bulkDiscount: [],
		sku: '46c0f2e77d',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		dateUpdated: '2017-11-21T12:17:44.050000',
		_id: '59b90310196632786ed88b6f'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130603174939IFHBMNNFVHEAZ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130603174939IFHBMNNFVHEAZ_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170113110150YWMZGLHTWALYT_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170113110150YWMZGLHTWALYT_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170113110152DQPTTT9ZHMYNR_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170113110152DQPTTT9ZHMYNR_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20170113110154TQVYW6ZSILHYW_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170113110154TQVYW6ZSILHYW_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201701131101558M3STEILXAI3O_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201701131101558M3STEILXAI3O_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 540.35,
			po: 'S$540.35'
		},
		includes: [],
		model: 'GDS18V-LI',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'BOSCH 18V LI-ION IMPACT WRENCH, GDS18V-LI',
		uniqTitle: 'bosch-18-v-li-ion-impact-wrench-gds-18-v-li',
		bulkDiscount: [],
		sku: '78daf5218f',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		dateUpdated: '2017-11-21T12:17:44.050000',
		_id: '59b90310196632786ed88b72'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130603191308FMPXP1TTULOKD_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130603191308FMPXP1TTULOKD_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 203.3,
			po: 'S$203.30'
		},
		includes: [],
		model: 'GSR1800-LI',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'BOSCH 18V LI-ION DRIVER DRILL, GSR1800 - LI',
		uniqTitle: 'bosch-18-v-li-ion-driver-drill-gsr-1800-li',
		bulkDiscount: [],
		sku: 'a99fe3e905',
		brand: {
			lowerCaseName: 'bosch',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'm1GHaSX9R~eFMf9jboQG8f.jpg',
				expire: '2017-12-26T05:19:32.898000',
				__v: 0,
				_id: '5a4220c04d28407c4dd4a4b2',
				url: 'https://storage.googleapis.com/eezee-brand-images/m1GHaSX9R~eFMf9jboQG8f.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'bosch',
			name: 'BOSCH',
			_id: '59b24e3eb38a0b0ad30a39e1'
		},
		dateUpdated: '2017-11-21T12:17:44.051000',
		_id: '59b90310196632786ed88ba1'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130312160345O62ZZOR6FE9WK_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130312160345O62ZZOR6FE9WK_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20130726102923PBMGWS3RWHGXS_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130726102923PBMGWS3RWHGXS_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 181.9,
			po: 'S$181.90'
		},
		includes: [],
		model: 'BID-1228',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'RYOBI 12V NI-CD IMPACT SCREW DRIVER, BID1228',
		uniqTitle: 'ryobi-12-v-ni-cd-impact-screw-driver-bid-1228',
		bulkDiscount: [],
		sku: '270a370f0c',
		brand: {
			lowerCaseName: 'ryobi',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'UU84JKK_tk1_qaKb4YaDlI.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a431f61cdf0b93657221346',
				url: 'https://storage.googleapis.com/eezee-brand-images/UU84JKK_tk1_qaKb4YaDlI.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'ryobi',
			name: 'RYOBI',
			_id: '59b24e3eb38a0b0ad30a39e5'
		},
		dateUpdated: '2017-11-21T12:17:44.070000',
		_id: '59b90310196632786ed88c9c'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160207103816SCKK25E5YNTNG_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160207103816SCKK25E5YNTNG_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20150319163039MKDSRZT7MJBQ1_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150319163039MKDSRZT7MJBQ1_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 149.8,
			po: 'S$149.80'
		},
		includes: [],
		model: 'STDC041LB',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'STANLEY 10.8V LI-ION IMPACT DRIVER, STDC041LB',
		uniqTitle: 'stanley-10-8-v-li-ion-impact-driver-stdc-041-lb',
		bulkDiscount: [],
		sku: '25a161d1d1',
		brand: {
			lowerCaseName: 'stanley',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'dOomX0nAk_j7b203VHBuCs.gif',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a433352cdf0b93657278892',
				url: 'https://storage.googleapis.com/eezee-brand-images/dOomX0nAk_j7b203VHBuCs.gif',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'stanley',
			name: 'STANLEY',
			_id: '59b24e3eb38a0b0ad30a39ec'
		},
		dateUpdated: '2017-11-21T12:17:44.291000',
		_id: '59b90311196632786ed89ea9'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140702164657A7V600XF3RROU_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140702164657A7V600XF3RROU_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628140137AHU0M23QHRRI5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628140137AHU0M23QHRRI5_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628140137YFMBRKYPNP6BZ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628140137YFMBRKYPNP6BZ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 375,
			po: 'S$375.00'
		},
		includes: [],
		model: 'M12CDD',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MILWAUKEE 12V 4.0AH- LI-ION BRUSHLESS DRILL, M12CDD',
		uniqTitle: 'milwaukee-12-v-4-0-ah-li-ion-brushless-drill-m-12-cdd',
		bulkDiscount: [],
		sku: '07b2779dee',
		brand: {
			lowerCaseName: 'milwaukee tool',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '0BuaOLaW2DexFUZjGufprm.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a434ee6cdf0b936572ca18d',
				url: 'https://storage.googleapis.com/eezee-brand-images/0BuaOLaW2DexFUZjGufprm.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'milwaukee-tool',
			name: 'MILWAUKEE TOOL',
			_id: '59b24e3eb38a0b0ad30a3a13'
		},
		dateUpdated: '2017-11-21T12:17:44.226000',
		_id: '59b90311196632786ed8973f'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201407021702481YVWFNU46EE2K_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201407021702481YVWFNU46EE2K_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628174658DVIQUBVEEU4UC_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628174658DVIQUBVEEU4UC_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628174659POG8ESB35JRYD_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628174659POG8ESB35JRYD_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201606281746592B29KUFIKXDN0_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201606281746592B29KUFIKXDN0_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628174700LTDGEGLID0QAC_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628174700LTDGEGLID0QAC_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628174700DG2Y1LZQYDNMO_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628174700DG2Y1LZQYDNMO_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 415,
			po: 'S$415.00'
		},
		includes: [],
		model: 'M12CID',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MILWAUKEE 12V 4.0AH LI-ION BRUSHLESS IMPACT DRIVER, M12CID',
		uniqTitle: 'milwaukee-12-v-4-0-ah-li-ion-brushless-impact-driver-m-12-cid',
		bulkDiscount: [],
		sku: '55259e3147',
		brand: {
			lowerCaseName: 'milwaukee tool',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '0BuaOLaW2DexFUZjGufprm.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a434ee6cdf0b936572ca18d',
				url: 'https://storage.googleapis.com/eezee-brand-images/0BuaOLaW2DexFUZjGufprm.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'milwaukee-tool',
			name: 'MILWAUKEE TOOL',
			_id: '59b24e3eb38a0b0ad30a3a13'
		},
		dateUpdated: '2017-11-21T12:17:44.226000',
		_id: '59b90311196632786ed89744'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160628152655Y6G7RZEIH5T7M_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628152655Y6G7RZEIH5T7M_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628152705RBWMFGMUCEYWU_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628152705RBWMFGMUCEYWU_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '2016062815270544EMC9BVFL278_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2016062815270544EMC9BVFL278_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628152706SLNNZJRMOB6JU_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628152706SLNNZJRMOB6JU_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628152706O9U0BSFLDG8UH_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628152706O9U0BSFLDG8UH_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628152707M3FZT9SYHFHSP_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628152707M3FZT9SYHFHSP_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 199,
			po: 'S$199.00'
		},
		includes: [],
		model: 'M12BDD',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MILWAUKEE 12V 2.0AH LI-ION 3/8" DRILL, M12BDD',
		uniqTitle: 'milwaukee-12-v-2-0-ah-li-ion-3-8-drill-m-12-bdd',
		bulkDiscount: [],
		sku: 'f6fb4157ef',
		brand: {
			lowerCaseName: 'milwaukee tool',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '0BuaOLaW2DexFUZjGufprm.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a434ee6cdf0b936572ca18d',
				url: 'https://storage.googleapis.com/eezee-brand-images/0BuaOLaW2DexFUZjGufprm.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'milwaukee-tool',
			name: 'MILWAUKEE TOOL',
			_id: '59b24e3eb38a0b0ad30a3a13'
		},
		dateUpdated: '2017-11-21T12:17:44.240000',
		_id: '59b90311196632786ed89821'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150814175250XPE4B6MYAIZ5Y_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150814175250XPE4B6MYAIZ5Y_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20140710153227ROCJOLRRPTSWB_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140710153227ROCJOLRRPTSWB_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 329,
			po: 'S$329.00'
		},
		includes: [],
		model: 'M18BDD',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MILWAUKEE 18V 2.0AH LI-ION COMPACT DRILL DRIVER, M18BDD',
		uniqTitle: 'milwaukee-18-v-2-0-ah-li-ion-compact-drill-driver-m-18-bdd',
		bulkDiscount: [],
		sku: '4a43f746e8',
		brand: {
			lowerCaseName: 'milwaukee tool',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '0BuaOLaW2DexFUZjGufprm.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a434ee6cdf0b936572ca18d',
				url: 'https://storage.googleapis.com/eezee-brand-images/0BuaOLaW2DexFUZjGufprm.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'milwaukee-tool',
			name: 'MILWAUKEE TOOL',
			_id: '59b24e3eb38a0b0ad30a3a13'
		},
		dateUpdated: '2017-11-21T12:17:44.240000',
		_id: '59b90311196632786ed89823'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160628163501THH4XJETYDOBM_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628163501THH4XJETYDOBM_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628163506OOUIOQBGERD5X_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628163506OOUIOQBGERD5X_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201606281635065HO6Z3QJK4B7L_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201606281635065HO6Z3QJK4B7L_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628163507NECJ0ONBGJ7LN_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628163507NECJ0ONBGJ7LN_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628163507GECBXN1TVSJPF_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628163507GECBXN1TVSJPF_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628163508EVPI7GOOLYD60_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628163508EVPI7GOOLYD60_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628163509ZAZ5LRSMDMWW8_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628163509ZAZ5LRSMDMWW8_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 365,
			po: 'S$365.00'
		},
		includes: [],
		model: 'M18BPD',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MILWAUKEE 18V 2.0AH LI-ION COMPACT HAMMER DRILL DRIVER, M18BPD',
		uniqTitle: 'milwaukee-18-v-2-0-ah-li-ion-compact-hammer-drill-driver-m-18-bpd',
		bulkDiscount: [],
		sku: 'f24220b68e',
		brand: {
			lowerCaseName: 'milwaukee tool',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '0BuaOLaW2DexFUZjGufprm.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a434ee6cdf0b936572ca18d',
				url: 'https://storage.googleapis.com/eezee-brand-images/0BuaOLaW2DexFUZjGufprm.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'milwaukee-tool',
			name: 'MILWAUKEE TOOL',
			_id: '59b24e3eb38a0b0ad30a3a13'
		},
		dateUpdated: '2017-11-21T12:17:44.240000',
		_id: '59b90311196632786ed89824'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141106114102KOU9XCHMNKUBZ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141106114102KOU9XCHMNKUBZ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 288,
			po: 'S$288.00'
		},
		includes: ['2 x REDLITHIUM\u2122 2.0Ah Extended Capacity battery\r\n\r\n\r\n1x Charger', '2 x REDLITHIUM\u2122 2.0Ah Extended Capacity battery', '1x Charger'],
		model: 'M12BIW12-202C',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MILWAUKEE 2.0AH LI 1/2" DR.IMPACT WRENCH-M12BIW12-202C (12V)',
		uniqTitle: 'milwaukee-2-0-ah-li-1-2-dr-impact-wrench-m-12-biw-12-202-c-12-v',
		bulkDiscount: [],
		sku: '921bafd855',
		brand: {
			lowerCaseName: 'milwaukee tool',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '0BuaOLaW2DexFUZjGufprm.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a434ee6cdf0b936572ca18d',
				url: 'https://storage.googleapis.com/eezee-brand-images/0BuaOLaW2DexFUZjGufprm.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'milwaukee-tool',
			name: 'MILWAUKEE TOOL',
			_id: '59b24e3eb38a0b0ad30a3a13'
		},
		dateUpdated: '2017-11-21T12:17:44.269000',
		_id: '59b90311196632786ed89b5b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160628142303SOKMRVVWVGBUB_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628142303SOKMRVVWVGBUB_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628142234AN8CAEMPPCRAZ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628142234AN8CAEMPPCRAZ_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628142235SXAYPHTDXILT6_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628142235SXAYPHTDXILT6_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 508,
			po: 'S$508.00'
		},
		includes: [],
		model: 'M12CH',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MILWAUKEE 12V 4.0AH LI-ION BRUSHLESS SDS+ HAMMER, M12CH',
		uniqTitle: 'milwaukee-12-v-4-0-ah-li-ion-brushless-sds-hammer-m-12-ch',
		bulkDiscount: [],
		sku: 'e70c1516e2',
		brand: {
			lowerCaseName: 'milwaukee tool',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '0BuaOLaW2DexFUZjGufprm.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a434ee6cdf0b936572ca18d',
				url: 'https://storage.googleapis.com/eezee-brand-images/0BuaOLaW2DexFUZjGufprm.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'milwaukee-tool',
			name: 'MILWAUKEE TOOL',
			_id: '59b24e3eb38a0b0ad30a3a13'
		},
		dateUpdated: '2017-11-21T12:17:44.309000',
		_id: '59b90311196632786ed89ff3'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151118083930NLQ2CIVZTYZRK_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151118083930NLQ2CIVZTYZRK_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628140537Q7IYGY6Y1TWUB_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628140537Q7IYGY6Y1TWUB_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628140538UM6KFM39G6XHS_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628140538UM6KFM39G6XHS_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628140538NKCTKVKLLNWMT_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628140538NKCTKVKLLNWMT_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160628140538GJL56FBE4I1OY_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160628140538GJL56FBE4I1OY_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 540,
			po: 'S$540.00'
		},
		includes: [],
		model: 'M18CDD',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MILWAUKEE 18V 4.0AH LI-ION COMPACT DRILL DRIVER, M18CDD',
		uniqTitle: 'milwaukee-18-v-4-0-ah-li-ion-compact-drill-driver-m-18-cdd',
		bulkDiscount: [],
		sku: '16520c2e1e',
		brand: {
			lowerCaseName: 'milwaukee tool',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '0BuaOLaW2DexFUZjGufprm.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a434ee6cdf0b936572ca18d',
				url: 'https://storage.googleapis.com/eezee-brand-images/0BuaOLaW2DexFUZjGufprm.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'milwaukee-tool',
			name: 'MILWAUKEE TOOL',
			_id: '59b24e3eb38a0b0ad30a3a13'
		},
		dateUpdated: '2017-11-21T12:17:44.438000',
		_id: '59b90312196632786ed8a939'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20161228173554SNFVNWPHJD6W6_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161228173554SNFVNWPHJD6W6_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20161228231857LWXDIJGECVLGW_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161228231857LWXDIJGECVLGW_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20161228231858WSHS54DUTMZ7T_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161228231858WSHS54DUTMZ7T_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201612282318583AP3GIFEAOS4X_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201612282318583AP3GIFEAOS4X_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20161228231859XZH6ULCHHNNSH_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20161228231859XZH6ULCHHNNSH_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 727.6,
			po: 'S$727.60'
		},
		includes: [],
		model: 'M18FIW12',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MILWAUKEE BRUSHLESS 1/2" DR.IMPACT WRENCH M18FIW12 (18V-5.0AH LI)',
		uniqTitle: 'milwaukee-brushless-1-2-dr-impact-wrench-m-18-fiw-12-18-v-5-0-ah-li',
		bulkDiscount: [],
		sku: '8501170e27',
		brand: {
			lowerCaseName: 'milwaukee tool',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '0BuaOLaW2DexFUZjGufprm.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a434ee6cdf0b936572ca18d',
				url: 'https://storage.googleapis.com/eezee-brand-images/0BuaOLaW2DexFUZjGufprm.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'milwaukee-tool',
			name: 'MILWAUKEE TOOL',
			_id: '59b24e3eb38a0b0ad30a3a13'
		},
		dateUpdated: '2017-11-21T12:17:44.483000',
		_id: '59b90312196632786ed8aca7'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140827160612CGSFNTJO3CFEH_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140827160612CGSFNTJO3CFEH_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59cc8a8635cc384838b44d38',
		includes: [],
		variants: [],
		title: 'DEWALT 24V ROTARY HAMMER, DC222KA',
		uniqTitle: 'dewalt-24-v-rotary-hammer-dc-222-ka',
		bulkDiscount: [],
		dateUpdated: '2017-11-21T12:17:44.249000',
		price: {
			ps: 'S$0.00',
			original: 716.9,
			po: 'S$716.90'
		},
		model: 'DC222KA',
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		sku: '1506e763bb',
		brand: {
			lowerCaseName: 'dewalt',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'kHDa6GXPfw2zEgRUviGHdg.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a43508fcdf0b936572cc3e3',
				url: 'https://storage.googleapis.com/eezee-brand-images/kHDa6GXPfw2zEgRUviGHdg.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'dewalt',
			name: 'DEWALT',
			_id: '59b24e3eb38a0b0ad30a3a18'
		},
		_id: '59b90311196632786ed898b6'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20170324131717JNIA4NQQB1LVQ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20170324131717JNIA4NQQB1LVQ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 319.93,
			po: 'S$319.93'
		},
		includes: [],
		model: 'DCF787D2',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'DEWALT BRUSHLESS LI-ION IMPACT DRIVER 18V 2.0AH DCF787D2',
		uniqTitle: 'dewalt-brushless-li-ion-impact-driver-18-v-2-0-ah-dcf-787-d-2',
		bulkDiscount: [],
		sku: '20029bdead',
		brand: {
			lowerCaseName: 'dewalt',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'kHDa6GXPfw2zEgRUviGHdg.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a43508fcdf0b936572cc3e3',
				url: 'https://storage.googleapis.com/eezee-brand-images/kHDa6GXPfw2zEgRUviGHdg.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'dewalt',
			name: 'DEWALT',
			_id: '59b24e3eb38a0b0ad30a3a18'
		},
		dateUpdated: '2017-11-21T12:17:44.505000',
		_id: '59b90312196632786ed8adf6'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160129100546UTKGRLB5PSLC9_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160129100546UTKGRLB5PSLC9_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59cc8a8635cc384838b44d38',
		includes: [],
		variants: [],
		title: 'DEWALT 10.8V DRILL DRIVER + IMPACT DRIVER COMBO KIT DCK211S2',
		uniqTitle: 'dewalt-10-8-v-drill-driver-impact-driver-combo-kit-dck-211-s-2',
		bulkDiscount: [],
		dateUpdated: '2017-11-21T12:17:44.130000',
		price: {
			ps: 'S$0.00',
			original: 256.8,
			po: 'S$256.80'
		},
		model: 'DCK211S2 COMBO',
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		sku: '81a8c72125',
		brand: {
			lowerCaseName: 'dewalt',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'kHDa6GXPfw2zEgRUviGHdg.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a43508fcdf0b936572cc3e3',
				url: 'https://storage.googleapis.com/eezee-brand-images/kHDa6GXPfw2zEgRUviGHdg.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'dewalt',
			name: 'DEWALT',
			_id: '59b24e3eb38a0b0ad30a3a18'
		},
		_id: '59b90310196632786ed8908c'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160128163140RJGM8H4YLK4JI_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160128163140RJGM8H4YLK4JI_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20160330112455QBLGHOKOPTCTY_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160330112455QBLGHOKOPTCTY_full.jpg',
			fileType: 'image'
		}],
		supplierId: '59cc8a8635cc384838b44d38',
		includes: [],
		variants: [],
		title: 'DEWALT 10.8V 2.0AH LI-ION 10MM DRIVER DRILL, DCD710D2',
		uniqTitle: 'dewalt-10-8-v-2-0-ah-li-ion-10-mm-driver-drill-dcd-710-d-2',
		bulkDiscount: [],
		dateUpdated: '2017-11-21T12:17:44.131000',
		price: {
			ps: 'S$0.00',
			original: 160.5,
			po: 'S$160.50'
		},
		model: 'DCD710D2',
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		sku: 'f7cbe93d46',
		brand: {
			lowerCaseName: 'dewalt',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'kHDa6GXPfw2zEgRUviGHdg.jpg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a43508fcdf0b936572cc3e3',
				url: 'https://storage.googleapis.com/eezee-brand-images/kHDa6GXPfw2zEgRUviGHdg.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'dewalt',
			name: 'DEWALT',
			_id: '59b24e3eb38a0b0ad30a3a18'
		},
		_id: '59b90310196632786ed8908f'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160129165543F6MWKTOARNSN3_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160129165543F6MWKTOARNSN3_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 49.85,
			po: 'S$49.85'
		},
		includes: [],
		model: 'KC9039P1-B1',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'BLACK AND DECKER SCREWDRIVER 3.6V KC9039P1-B 3 POSITION',
		uniqTitle: 'black-and-decker-screwdriver-3-6-v-kc-9039-p-1-b-3-position',
		bulkDiscount: [],
		sku: '33c64982a1',
		brand: {
			lowerCaseName: 'black and decker',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'ZXTAafMUbjVKcwdcIn9WeF.svg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a434fdfcdf0b936572cac34',
				url: 'https://storage.googleapis.com/eezee-brand-images/ZXTAafMUbjVKcwdcIn9WeF.svg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'black-and-decker',
			name: 'BLACK AND DECKER',
			_id: '59b24e3eb38a0b0ad30a3a16'
		},
		dateUpdated: '2017-11-21T12:17:44.130000',
		_id: '59b90310196632786ed89089'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160505103402R7K8HKY6ZOWHV_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160505103402R7K8HKY6ZOWHV_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 68.95,
			po: 'S$68.95'
		},
		includes: ['10x Driver bits.', '1x AC Adaptor.'],
		model: 'CP310X',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'BLACK AND DECKER 3.6V COMPACT SCREWDRIVER CP310X',
		uniqTitle: 'black-and-decker-3-6-v-compact-screwdriver-cp-310-x',
		bulkDiscount: [],
		sku: 'a073f06e84',
		brand: {
			lowerCaseName: 'black and decker',
			image: {
				bucket: 'eezee-brand-images',
				fileName: 'ZXTAafMUbjVKcwdcIn9WeF.svg',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a434fdfcdf0b936572cac34',
				url: 'https://storage.googleapis.com/eezee-brand-images/ZXTAafMUbjVKcwdcIn9WeF.svg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'black-and-decker',
			name: 'BLACK AND DECKER',
			_id: '59b24e3eb38a0b0ad30a3a16'
		},
		dateUpdated: '2017-11-21T12:17:44.244000',
		_id: '59b90311196632786ed8987b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141119212751HP5REW4NHZ1JM_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141119212751HP5REW4NHZ1JM_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 192.6,
			po: 'S$192.60'
		},
		includes: [],
		model: 'DS10DFL',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'HITACHI 10.8V LI-ION DRILL, DS10DFL',
		uniqTitle: 'hitachi-10-8-v-li-ion-drill-ds-10-dfl',
		bulkDiscount: [],
		sku: '4d99806712',
		brand: {
			lowerCaseName: 'hitachi power tools',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '8Ggb9WN6SaNoMpyUTB2cUO.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a4358a9cdf0b936572d71d1',
				url: 'https://storage.googleapis.com/eezee-brand-images/8Ggb9WN6SaNoMpyUTB2cUO.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'hitachi-power-tools',
			name: 'HITACHI POWER TOOLS',
			_id: '59b24e3eb38a0b0ad30a3a2a'
		},
		dateUpdated: '2017-11-21T12:17:44.296000',
		_id: '59b90311196632786ed89ef8'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201502271440361LOW775DGCKJB_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201502271440361LOW775DGCKJB_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 200,
			po: 'S$200.00'
		},
		includes: [],
		model: 'DS14DFL',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'HITACHI 10MM LI-ION DRILL, DS14DFL',
		uniqTitle: 'hitachi-10-mm-li-ion-drill-ds-14-dfl',
		bulkDiscount: [],
		sku: 'c5298e0a3d',
		brand: {
			lowerCaseName: 'hitachi power tools',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '8Ggb9WN6SaNoMpyUTB2cUO.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a4358a9cdf0b936572d71d1',
				url: 'https://storage.googleapis.com/eezee-brand-images/8Ggb9WN6SaNoMpyUTB2cUO.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'hitachi-power-tools',
			name: 'HITACHI POWER TOOLS',
			_id: '59b24e3eb38a0b0ad30a3a2a'
		},
		dateUpdated: '2017-11-21T12:17:44.296000',
		_id: '59b90311196632786ed89ef9'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201411192130273GZBWDJT3L8AN_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201411192130273GZBWDJT3L8AN_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 433.35,
			po: 'S$433.35'
		},
		includes: [],
		model: 'DH14DL',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'HITACHI 14.4V LI-ION ROTARY DRILL, DH14DL',
		uniqTitle: 'hitachi-14-4-v-li-ion-rotary-drill-dh-14-dl',
		bulkDiscount: [],
		sku: '2e6e2aa6cb',
		brand: {
			lowerCaseName: 'hitachi power tools',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '8Ggb9WN6SaNoMpyUTB2cUO.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a4358a9cdf0b936572d71d1',
				url: 'https://storage.googleapis.com/eezee-brand-images/8Ggb9WN6SaNoMpyUTB2cUO.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'hitachi-power-tools',
			name: 'HITACHI POWER TOOLS',
			_id: '59b24e3eb38a0b0ad30a3a2a'
		},
		dateUpdated: '2017-11-21T12:17:44.296000',
		_id: '59b90311196632786ed89efb'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160222163844GBWWTHBSPO0FJ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160222163844GBWWTHBSPO0FJ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 909.5,
			po: 'S$909.50'
		},
		includes: [],
		model: 'DH36DAL',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'HITACHI 36V LI-ION ROTARY DRILL, DH36DAL',
		uniqTitle: 'hitachi-36-v-li-ion-rotary-drill-dh-36-dal',
		bulkDiscount: [],
		sku: '2fc39dd6d6',
		brand: {
			lowerCaseName: 'hitachi power tools',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '8Ggb9WN6SaNoMpyUTB2cUO.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a4358a9cdf0b936572d71d1',
				url: 'https://storage.googleapis.com/eezee-brand-images/8Ggb9WN6SaNoMpyUTB2cUO.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'hitachi-power-tools',
			name: 'HITACHI POWER TOOLS',
			_id: '59b24e3eb38a0b0ad30a3a2a'
		},
		dateUpdated: '2017-11-21T12:17:44.296000',
		_id: '59b90311196632786ed89efd'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20150325152012DQLRPSDKEDWTH_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20150325152012DQLRPSDKEDWTH_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 535,
			po: 'S$535.00'
		},
		includes: [],
		model: 'WR18DBAL2',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'HITACHI 1/2"DR 18V LI-ION IMPACT WRENCH, WR18DBAL2',
		uniqTitle: 'hitachi-1-2-dr-18-v-li-ion-impact-wrench-wr-18-dbal-2',
		bulkDiscount: [],
		sku: '9cc5025bb8',
		brand: {
			lowerCaseName: 'hitachi power tools',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '8Ggb9WN6SaNoMpyUTB2cUO.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a4358a9cdf0b936572d71d1',
				url: 'https://storage.googleapis.com/eezee-brand-images/8Ggb9WN6SaNoMpyUTB2cUO.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'hitachi-power-tools',
			name: 'HITACHI POWER TOOLS',
			_id: '59b24e3eb38a0b0ad30a3a2a'
		},
		dateUpdated: '2017-11-21T12:17:44.297000',
		_id: '59b90311196632786ed89f02'
	}, {
		buyPrice: 374,
		images: [{
			bucket: 'eezee-product-images',
			fileName: '5h0u9yj.jpeg',
			expire: '2017-10-31T05:18:23.411Z',
			__v: 0,
			_id: '59f82e8562af544889dd1578',
			url: 'https://storage.googleapis.com/eezee-product-images/5h0u9yj.jpeg',
			fileType: 'image'
		}],
		supplierId: '59f82ec062af544889dd1594',
		includes: [],
		variants: [],
		title: 'Hitachi 18V Cordless Impact Wrench WR18DSDL',
		bulkDiscount: [],
		uniqTitle: 'hitachi-18-v-cordless-impact-wrench-wr-18-dsdl',
		dateUpdated: '2017-11-21T12:17:44.586000',
		price: {
			ps: 'S$0.00',
			original: 448.8,
			po: 'S$448.80'
		},
		model: 'WR18DSDL',
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		sku: '3ce61185f4',
		brand: {
			lowerCaseName: 'hitachi power tools',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '8Ggb9WN6SaNoMpyUTB2cUO.png',
				expire: '2017-12-27T04:52:02.735000',
				__v: 0,
				_id: '5a4358a9cdf0b936572d71d1',
				url: 'https://storage.googleapis.com/eezee-brand-images/8Ggb9WN6SaNoMpyUTB2cUO.png',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'hitachi-power-tools',
			name: 'HITACHI POWER TOOLS',
			_id: '59b24e3eb38a0b0ad30a3a2a'
		},
		_id: '59f82e8f62af544889dd1579'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130516161202A9YFYU8R5XAJH_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130516161202A9YFYU8R5XAJH_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 358.45,
			po: 'S$358.45'
		},
		includes: [],
		model: 'DDF456RYE',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MAKITA 18V 1.5AH LI-ION 13MM DRIVER DRILL, DDF456RYE',
		uniqTitle: 'makita-18-v-1-5-ah-li-ion-13-mm-driver-drill-ddf-456-rye',
		bulkDiscount: [],
		sku: '540bca0401',
		brand: {
			lowerCaseName: 'makita',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '~Z2A3nzi_yxqstZaJyKHa7.jpg',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a57393137f8836a18c6ea31',
				url: 'https://storage.googleapis.com/eezee-brand-images/~Z2A3nzi_yxqstZaJyKHa7.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'makita',
			name: 'MAKITA',
			_id: '59b24e3eb38a0b0ad30a39e4'
		},
		dateUpdated: '2017-11-21T12:17:44.096000',
		_id: '59b90310196632786ed88e3f'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20130821142649QUDYR7ZMTDU1S_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20130821142649QUDYR7ZMTDU1S_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 347.75,
			po: 'S$347.75'
		},
		includes: [],
		model: 'DHP452RHE',
		variants: [],
		categories: {
			sub: 'Cordless Drills, Impact Drivers & Wrenches',
			mainKebabCase: 'power-tools-cordless',
			subKebabCase: 'cordless-drills-impact-drivers-wrenches',
			main: 'Power Tools - Cordless'
		},
		title: 'MAKITA 18V 1.3AH LI-ION 13MM HAMMER DRIVER DRILL, DHP452RHE',
		uniqTitle: 'makita-18-v-1-3-ah-li-ion-13-mm-hammer-driver-drill-dhp-452-rhe',
		bulkDiscount: [],
		sku: '49151a04e9',
		brand: {
			lowerCaseName: 'makita',
			image: {
				bucket: 'eezee-brand-images',
				fileName: '~Z2A3nzi_yxqstZaJyKHa7.jpg',
				expire: '2018-01-11T05:53:14.713000',
				__v: 0,
				_id: '5a57393137f8836a18c6ea31',
				url: 'https://storage.googleapis.com/eezee-brand-images/~Z2A3nzi_yxqstZaJyKHa7.jpg',
				fileType: 'image'
			},
			featured: false,
			kebabName: 'makita',
			name: 'MAKITA',
			_id: '59b24e3eb38a0b0ad30a39e4'
		},
		dateUpdated: '2017-11-21T12:17:44.096000',
		_id: '59b90310196632786ed88e4c'
	}]
};
var brandResults = {
	size: 24,
	products: [{
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151029200331W9BI33HXOYEZR_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151029200331W9BI33HXOYEZR_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 11.77,
			po: 'S$11.77'
		},
		includes: [],
		model: 'ID3902',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO CRATE ID3902',
		uniqTitle: 'toyogo-crate-id-3902',
		bulkDiscount: [],
		sku: '97ead77f20',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a442'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201510292021166CPG8RJIETM4H_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201510292021166CPG8RJIETM4H_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 8.03,
			po: 'S$8.03'
		},
		includes: [],
		model: '2181',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX 2181',
		uniqTitle: 'toyogo-storage-box-2181',
		bulkDiscount: [],
		sku: 'b66bd7b136',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a446'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '2017052211051215V4HHXSPKZAA_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2017052211051215V4HHXSPKZAA_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 9.1,
			po: 'S$9.10'
		},
		includes: [],
		model: '9703',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9703',
		uniqTitle: 'toyogo-storage-box-with-cover-9703',
		bulkDiscount: [],
		sku: '624f9956a3',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.522000',
		_id: '59b90312196632786ed8af07'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151007131054SJXP5QROZL7AV_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151007131054SJXP5QROZL7AV_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 37.45,
			po: 'S$37.45'
		},
		includes: [],
		model: '9809',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9809',
		uniqTitle: 'toyogo-storage-box-with-cover-9809',
		bulkDiscount: [],
		sku: 'c102fb9c38',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.255000',
		_id: '59b90311196632786ed8994d'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '2015082510142228O65ELJCCC3P_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2015082510142228O65ELJCCC3P_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 9.63,
			po: 'S$9.63'
		},
		includes: [],
		model: '9507',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9507',
		uniqTitle: 'toyogo-storage-box-with-cover-9507',
		bulkDiscount: [],
		sku: 'a4768f842c',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a445'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141029115825TTZFIC10CNBRK_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141029115825TTZFIC10CNBRK_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 16.59,
			po: 'S$16.59'
		},
		includes: [],
		model: '9906',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9906',
		uniqTitle: 'toyogo-storage-box-with-cover-9906',
		bulkDiscount: [],
		sku: 'f30123aaa2',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a448'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201510292105543RIEBF6MAGSBF_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201510292105543RIEBF6MAGSBF_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 21.4,
			po: 'S$21.40'
		},
		includes: [],
		model: '407-4',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO 4 TIER COLLEGE A4 DRAWER 407-4',
		uniqTitle: 'toyogo-4-tier-college-a-4-drawer-407-4',
		bulkDiscount: [],
		sku: 'b4d3cb1afd',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a44d'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20141117085848L8JXJONH09DJ5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20141117085848L8JXJONH09DJ5_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 8.56,
			po: 'S$8.56'
		},
		includes: [],
		model: '9506',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9506',
		uniqTitle: 'toyogo-storage-box-with-cover-9506',
		bulkDiscount: [],
		sku: '6a2145d113',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.255000',
		_id: '59b90311196632786ed8994e'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140326124408WMZLJQNJFJVQV_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140326124408WMZLJQNJFJVQV_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20140326124413OHU5KQUHPGWOS_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140326124413OHU5KQUHPGWOS_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 19.26,
			po: 'S$19.26'
		},
		includes: [],
		model: '9508',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9508',
		uniqTitle: 'toyogo-storage-box-with-cover-9508',
		bulkDiscount: [],
		sku: '3d1e403647',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.196000',
		_id: '59b90311196632786ed894fb'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140210153708EBNIAOD5JK3XL_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140210153708EBNIAOD5JK3XL_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 44.94,
			po: 'S$44.94'
		},
		includes: [],
		model: '9810',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9810',
		uniqTitle: 'toyogo-storage-box-with-cover-9810',
		bulkDiscount: [],
		sku: 'a166a0760c',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a444'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151029203957YJFJ2UNOBWIC7_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151029203957YJFJ2UNOBWIC7_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 35.31,
			po: 'S$35.31'
		},
		includes: [],
		model: '9808',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9808',
		uniqTitle: 'toyogo-storage-box-with-cover-9808',
		bulkDiscount: [],
		sku: 'ddd09d77dd',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a449'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'g9iJ~~aXADOzOk5hBgILvs.png',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14fde0d0e0fa3ebd9715c3',
			url: 'https://storage.googleapis.com/eezee-product-images/g9iJ~~aXADOzOk5hBgILvs.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'PkyHZOVARaOE5Gm_TCM8ij.png',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14fde5d0e0fa3ebd9715c4',
			url: 'https://storage.googleapis.com/eezee-product-images/PkyHZOVARaOE5Gm_TCM8ij.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'nXYoMwIJHkZ~nCLZe7_O8D.png',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14fdead0e0fa3ebd9715c5',
			url: 'https://storage.googleapis.com/eezee-product-images/nXYoMwIJHkZ~nCLZe7_O8D.png',
			fileType: 'image'
		}],
		supplierId: '59c261ffd6cfd23e4425a049',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'Colour',
			_id: '5a1502a0d0e0fa3ebd971cba',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Grey',
				_id: '5a1502a0d0e0fa3ebd971cbd',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Blue',
				_id: '5a1502a0d0e0fa3ebd971cbc',
				order: 1
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Green',
				_id: '5a1502a0d0e0fa3ebd971cbb',
				order: 2
			}]
		}],
		title: 'TOYOGO SECURITY CRATE CONTAINER 4631',
		bulkDiscount: [],
		uniqTitle: 'toyogo-security-crate-container-4631',
		dateUpdated: '2017-11-22T04:52:48.249000',
		price: {
			ps: 'S$0.00',
			original: 49.05,
			po: 'S$49.05'
		},
		model: '4631',
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		sku: '87ec8b4305',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		_id: '5a14fd6fd0e0fa3ebd971515'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20140326115621HEIOS8N4NZ22B_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140326115621HEIOS8N4NZ22B_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '20140326115629A97MVPRMC3FSJ_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20140326115629A97MVPRMC3FSJ_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 16.05,
			po: 'S$16.05'
		},
		includes: [],
		model: '1090',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-1090',
		uniqTitle: 'toyogo-storage-box-with-cover-1090',
		bulkDiscount: [],
		sku: 'ae9117116a',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.196000',
		_id: '59b90311196632786ed894fa'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151029200748NMDNXX2APVZQ5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151029200748NMDNXX2APVZQ5_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 19.26,
			po: 'S$19.26'
		},
		includes: [],
		model: 'ID4713',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO INDUSTRIAL CRATE ID4713',
		uniqTitle: 'toyogo-industrial-crate-id-4713',
		bulkDiscount: [],
		sku: '018397fcba',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a443'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151029210131UJCB4JKPVOBWI_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151029210131UJCB4JKPVOBWI_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 7.49,
			po: 'S$7.49'
		},
		includes: [],
		model: '9904',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9904',
		uniqTitle: 'toyogo-storage-box-with-cover-9904',
		bulkDiscount: [],
		sku: 'e720ce0490',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a44c'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'PdxEi1BtfMTFLajLiIOjHY.png',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14e33ad0e0fa3ebd96eb8b',
			url: 'https://storage.googleapis.com/eezee-product-images/PdxEi1BtfMTFLajLiIOjHY.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'HfMcf3IfTEDvI~6t~EZvM7.png',
			expire: '2017-11-21T10:03:48.977Z',
			__v: 0,
			_id: '5a14f62bd0e0fa3ebd970a77',
			url: 'https://storage.googleapis.com/eezee-product-images/HfMcf3IfTEDvI~6t~EZvM7.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '0RzUX7r_yWPUgofk96iDsu.jpg',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14fa3fd0e0fa3ebd97104f',
			url: 'https://storage.googleapis.com/eezee-product-images/0RzUX7r_yWPUgofk96iDsu.jpg',
			fileType: 'image'
		}],
		supplierId: '59c261ffd6cfd23e4425a049',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'Colour',
			_id: '5a14feb1d0e0fa3ebd971752',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Grey',
				_id: '5a14feb1d0e0fa3ebd971754',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Blue',
				_id: '5a14feb1d0e0fa3ebd971753',
				order: 1
			}]
		}],
		title: 'TOYOGO SECURITY CRATE CONTAINER 4629',
		bulkDiscount: [],
		uniqTitle: 'toyogo-security-crate-container-4629',
		dateUpdated: '2017-11-22T04:36:01.424000',
		price: {
			ps: 'S$0.00',
			original: 33.1,
			po: 'S$33.10'
		},
		model: '4629',
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		sku: 'bbfdccb579',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		_id: '5a14ed22d0e0fa3ebd96fbfd'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'FVAH18~dN5cIf8~v6br4DL.png',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14f7a6d0e0fa3ebd970d08',
			url: 'https://storage.googleapis.com/eezee-product-images/FVAH18~dN5cIf8~v6br4DL.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'J~K~w6lF9O~t1YLvnw~I1H.png',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14f8a5d0e0fa3ebd970e58',
			url: 'https://storage.googleapis.com/eezee-product-images/J~K~w6lF9O~t1YLvnw~I1H.png',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'cpePhXiTJ1hdZ71owFEMCr.jpg',
			__v: 0,
			expire: '2017-11-21T10:03:48.977Z',
			_id: '5a14f9e6d0e0fa3ebd970fa2',
			url: 'https://storage.googleapis.com/eezee-product-images/cpePhXiTJ1hdZ71owFEMCr.jpg',
			fileType: 'image'
		}],
		supplierId: '59c261ffd6cfd23e4425a049',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'Colour',
			_id: '5a14fe97d0e0fa3ebd9716dd',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Grey',
				_id: '5a14fe97d0e0fa3ebd9716df',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Blue',
				_id: '5a14fe97d0e0fa3ebd9716de',
				order: 1
			}]
		}],
		title: 'TOYOGO SECURITY CRATE CONTAINER 4630',
		bulkDiscount: [],
		uniqTitle: 'toyogo-security-crate-container-4630',
		dateUpdated: '2017-11-22T04:35:35.063000',
		price: {
			ps: 'S$0.00',
			original: 42.9,
			po: 'S$42.90'
		},
		model: '4630',
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		sku: '394d12f070',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		_id: '5a14f6ead0e0fa3ebd970bfb'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'UhJ0MIm9CjaOc1uS5HqkRW.jpg',
			expire: '2017-11-22T06:35:22.658Z',
			__v: 0,
			_id: '5a154f21918693670dc24a28',
			url: 'https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'O24EoqiMcC10foNWdsXNdN.jpg',
			expire: '2017-11-22T06:35:22.658Z',
			__v: 0,
			_id: '5a15501e918693670dc24b88',
			url: 'https://storage.googleapis.com/eezee-product-images/O24EoqiMcC10foNWdsXNdN.jpg',
			fileType: 'image'
		}],
		supplierId: '59c261ffd6cfd23e4425a049',
		includes: [],
		duplicate: false,
		variants: [],
		title: 'TOYOGO HEAVY DUTY PALLET P-1411H',
		bulkDiscount: [],
		uniqTitle: 'toyogo-heavy-duty-pallet-p-1411-h',
		dateUpdated: '2017-11-26T09:50:23.146000',
		price: {
			ps: 'S$0.00',
			original: 115,
			po: 'S$115.00'
		},
		model: 'P-1411H',
		categories: {
			sub: 'Packaging & Shipping Supplies',
			mainKebabCase: 'industrial-consumable-goods',
			subKebabCase: 'packaging-shipping-supplies',
			main: 'Industrial Consumable Goods'
		},
		sku: '00e66e3885',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		_id: '5a1553ef918693670dc25007'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201408071740032PUWZWGK4BUWD_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201408071740032PUWZWGK4BUWD_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 16.05,
			po: 'S$16.05'
		},
		includes: [],
		model: '1070',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-1070',
		uniqTitle: 'toyogo-storage-box-with-cover-1070',
		bulkDiscount: [],
		sku: '0f0c406c2a',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.240000',
		_id: '59b90311196632786ed89825'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151029202815IFNQN1W6F7H1S_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151029202815IFNQN1W6F7H1S_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 25.68,
			po: 'S$25.68'
		},
		includes: [],
		model: '9807',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO STORAGE BOX WITH COVER-9807',
		uniqTitle: 'toyogo-storage-box-with-cover-9807',
		bulkDiscount: [],
		sku: 'a5f65c8e8b',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a447'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '201409191215342XDXM8TJ9NPA5_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201409191215342XDXM8TJ9NPA5_full.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: '201409191215577ENR7JQCEJVXW_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/201409191215577ENR7JQCEJVXW_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 24.93,
			po: 'S$24.93'
		},
		includes: [],
		model: '9709',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO FANCY CLIPS BOX-9709',
		uniqTitle: 'toyogo-fancy-clips-box-9709',
		bulkDiscount: [],
		sku: '161cfdea71',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a44a'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20151029205551NEVT4ZDBKJ2S1_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20151029205551NEVT4ZDBKJ2S1_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 19.26,
			po: 'S$19.26'
		},
		includes: [],
		model: '4218-4',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO TRAY 4218-4',
		uniqTitle: 'toyogo-tray-4218-4',
		bulkDiscount: [],
		sku: 'f64f58f3a6',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.372000',
		_id: '59b90311196632786ed8a44b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: '20160526224432GJ6FOZ5NFU9V4_full.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/20160526224432GJ6FOZ5NFU9V4_full.jpg',
			fileType: 'image'
		}],
		price: {
			ps: 'S$0.00',
			original: 3.42,
			po: 'S$3.42'
		},
		includes: [],
		model: '4313',
		variants: [],
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		title: 'TOYOGO PLASTIC BASKET 4313',
		uniqTitle: 'toyogo-plastic-basket-4313',
		bulkDiscount: [],
		sku: 'edc6e76dec',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		dateUpdated: '2017-11-21T12:17:44.422000',
		_id: '59b90312196632786ed8a80b'
	}, {
		images: [{
			bucket: 'eezee-product-images',
			fileName: 'PPTtfzJE9xtKKOe2XBMHKU.jpg',
			expire: '2017-11-22T06:35:22.658Z',
			__v: 0,
			_id: '5a156d78918693670dc274ee',
			url: 'https://storage.googleapis.com/eezee-product-images/PPTtfzJE9xtKKOe2XBMHKU.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'UhJ0MIm9CjaOc1uS5HqkRW.jpg',
			expire: '2017-11-22T06:35:22.658Z',
			__v: 0,
			_id: '5a154f21918693670dc24a28',
			url: 'https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg',
			fileType: 'image'
		}, {
			bucket: 'eezee-product-images',
			fileName: 'zfNdxdzB~UO~aZ5sQ4TCnU.jpg',
			expire: '2017-11-22T06:35:22.658Z',
			__v: 0,
			_id: '5a156ea8918693670dc2764c',
			url: 'https://storage.googleapis.com/eezee-product-images/zfNdxdzB~UO~aZ5sQ4TCnU.jpg',
			fileType: 'image'
		}],
		supplierId: '59c261ffd6cfd23e4425a049',
		includes: [],
		duplicate: false,
		variants: [{
			name: 'Colour',
			_id: '5a3c6498f5ad5a4e7ccd1e82',
			_set: [{
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Blue',
				_id: '5a3c6498f5ad5a4e7ccd1e84',
				order: 0
			}, {
				price: {
					sale: 0,
					ps: 'S$0.00',
					original: 0,
					po: 'S$0.00'
				},
				name: 'Black',
				_id: '5a3c6498f5ad5a4e7ccd1e83',
				order: 1
			}]
		}],
		title: 'TOYOGO INDUSTRIAL PALLET P-1114G',
		bulkDiscount: [],
		uniqTitle: 'toyogo-industrial-pallet-p-1114-g',
		dateUpdated: '2017-12-22T01:49:12.949000',
		price: {
			ps: 'S$0.00',
			original: 103.5,
			po: 'S$103.50'
		},
		model: 'P-1114G',
		categories: {
			sub: 'Storage Boxes & Shelving',
			mainKebabCase: 'material-handling',
			subKebabCase: 'storage-boxes-shelving',
			main: 'Material Handling'
		},
		sku: 'f6070e246a',
		brand: {
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			name: 'TOYOGO',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		_id: '5a156c4c918693670dc27302'
	}]
};
var emptyResults = {
	size: 0,
	products: []
};
var mockProduct = [{
	_id: '5a139ce317369256188bab9e',
	supplier: null,
	supplierId: '59c24cdf0302410b73a5b7bd',
	uniqTitle: 'oring-as-568-as-457-id-354-97-x-cs-6-99-silicone-70-shore',
	descriptionHtml: '<p class="md-block-unstyled">ORING AS568 AS457</p><p class="md-block-unstyled"> ID 354.97 X CS 6.99</p><p class="md-block-unstyled">Material : Silicone  70 Shore    </p><p class="md-block-unstyled">  </p><p class="md-block-unstyled"><strong class="md-inline-bold"><u class="md-inline-underline">Additional Information</u></strong></p><p class="md-block-unstyled">Silicone O-Rings are sometimes referred to VMQ O-Rings.</p><p class="md-block-unstyled">Silicone elastomers are an excellent material due to its outstanding resistance to extreme range of temperature ranging from (-59&#x60;C to 232&#x60;C) and it has good retention of compression and flexibility. </p><p class="md-block-unstyled">In addition Silicone perform excellent resistance to ozone, oxygen, moisture and water swell. Last of all, Silicone has and produces very low odour and taste elastomer therefore making it the right material to be used in food and beverage, and medical industry.</p><p class="md-block-unstyled"><strong class="md-inline-bold"><u class="md-inline-underline">Temperature Range (Dry Heat)</u></strong></p><p class="md-block-unstyled">Low: -75&#x60;F / -59&#x60;C High: 450&#x60;F / 232&#x60;C</p><p class="md-block-unstyled"><strong class="md-inline-bold"><u class="md-inline-underline">Overview on Application Rating for Material Silicone </u></strong></p><p class="md-block-unstyled">Properties (Rating)</p><p class="md-block-unstyled">Oils &amp; Grease - Fair</p><p class="md-block-unstyled">Tear Strength \u2013 Poor</p><p class="md-block-unstyled">Fuel Resistance - Poor</p><p class="md-block-unstyled">Heat Ozone &amp; Aging Resistance - Excellent</p><p class="md-block-unstyled">Water Swell Resistance - Excellent</p><p class="md-block-unstyled">Abrasion Resistance - Poor</p><p class="md-block-unstyled">Other than the size and material type, there is one final option that you need to take in consideration. And that is the Durometer. Durometer are being classified as an industry standard to measure the elastomer hardness. Durometer is measured and listed in accordance with \u201CShore A\u201D scale. Typical standard hardness for the elastomer are 70 shore, 75 shore and 90 shore to choose from depending on the material that you are using. The higher the value of the shore indicates that the material you are using is harder. Durometer is also generally stated and accepted with a \u201C+/- 5\u201D tolerance. Silicone O-Rings the standard nominal durometer is 70 Shore.</p><p class="md-block-unstyled"><strong class="md-inline-bold"><u class="md-inline-underline">Primary Usage</u></strong></p><p class="md-block-unstyled">O-Rings and rubber seals are generally used for:</p><p class="md-block-unstyled">\xB7 Applications that require resistance to OIL</p><p class="md-block-unstyled">\xB7 Applications that are required to work in low temperatures (-0\xB0C)</p><p class="md-block-unstyled">\xB7 High performance Fuel systems that requires strictly no leakage</p><ul class="md-block-unordered-list-item"><li>Aircrafts</li><li>Marine Ships</li><li>F1 Cars</li></ul><p class="md-block-unstyled">\xB7 General Industrial Use </p><p class="md-block-unstyled"><strong class="md-inline-bold"><u class="md-inline-underline">Tips for installation of an O-ring</u></strong></p><p class="md-block-unstyled">O-rings need to be installed properly for a perfect fit and sealing. It is important that you install the O-ring in a prescribed manner to ensure your application continues to function properly. You will also ensure you increase the life of the application.</p><p class="md-block-unstyled"><strong class="md-inline-bold"><u class="md-inline-underline">So how do you install an O-ring?</u></strong></p><p class="md-block-unstyled">The process of installing an O-ring into a male gland is an intricate affair that should be carefully undertaken. Glide it along the shaft so as it reaches the gland. At that point, it should easily snap into place. Simple as it might sound, a number of steps will ensure that the O-ring doesn\u2019t get damaged.</p><p class="md-block-unstyled">If you want to install an O-ring correctly and within a short time, here are steps to follow:</p><p class="md-block-unstyled">\xB7 Covering and lubricating the threading of the shaft</p><p class="md-block-unstyled">The threading of the shaft has the potential of tearing the rubber seal. Cover the threads using a masking tape and then lubricate them to allow for easy passage of the O-ring. The aim is to have the O-ring slide through without getting torn.</p><p class="md-block-unstyled">\xB7 Don\u2019t force it over sharp corners</p><p class="md-block-unstyled">That\u2019s a tip that will save you the stress of a torn O-ring. In fact, running the O-ring over jagged or sharp objects could get it torn. You may not be able to notice some of these tears. That\u2019s why you should ensure you prevent them from occurring in the first place.</p><p class="md-block-unstyled">\xB7 Even stretching</p><p class="md-block-unstyled">You will have to stretch the O-ring over the shaft. Ensure you do it evenly. Pulling from one side is a no-no. If anything, you should stretch the O-ring as little as possible. You will not just get a tighter grip but added security too.</p><p class="md-block-unstyled">\xB7 Don\u2019t roll it down the shaft</p><p class="md-block-unstyled">Instead of rolling the O-ring down the shaft, slide it. If you spiral wind or roll an O-ring, it cannot be properly installed. It will also not function optimally and can even end up being damaged. If you have a lubricant, apply it on the O-ring and you will keep it rolling.</p><p class="md-block-unstyled">\xB7 Finishing it off</p><p class="md-block-unstyled">Place the female component in a manner that allows its radius to go around the corner. This should be done when you are finalizing the installation process. Ensure the lead of this component is inside the chamfer. This is how you will be able to guarantee the safety of the O-ring.</p><p class="md-block-unstyled"><em class="md-inline-italic">For O-rings to perform optimally, they have to be properly installed. It doesn\u2019t just provide secure sealing but also increases the service life of the component together with the application. Don\u2019t compromise on this process.</em></p><p class="md-block-unstyled"><strong class="md-inline-bold"><u class="md-inline-underline">Installation Guide</u></strong></p><figure class="md-block-image"><img src="https://storage.googleapis.com/eezee-product-images/aJevGRVmv9HExN7pOdJQ6n.png" alt="" /><figcaption className="md-block-image-caption"></figcaption></figure>',
	description: '{"entityMap":{},"blocks":[{"key":"fn0jl","text":"ORING AS568 AS457","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ab126","text":" ID 354.97 X CS 6.99","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"490hn","text":"Material : Silicone  70 Shore    ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"91cpk","text":"  ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"abgdh","text":"Additional Information","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":22,"style":"BOLD"},{"offset":0,"length":22,"style":"UNDERLINE"}],"entityRanges":[],"data":{}},{"key":"6nl08","text":"Silicone O-Rings are sometimes referred to VMQ O-Rings.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2bh62","text":"Silicone elastomers are an excellent material due to its outstanding resistance to extreme range of temperature ranging from (-59`C to 232`C) and it has good retention of compression and flexibility. ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"d0asl","text":"In addition Silicone perform excellent resistance to ozone, oxygen, moisture and water swell. Last of all, Silicone has and produces very low odour and taste elastomer therefore making it the right material to be used in food and beverage, and medical industry.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1d0l4","text":"Temperature Range (Dry Heat)","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":28,"style":"BOLD"},{"offset":0,"length":28,"style":"UNDERLINE"}],"entityRanges":[],"data":{}},{"key":"598d2","text":"Low: -75`F / -59`C High: 450`F / 232`C","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a3ho4","text":"Overview on Application Rating for Material Silicone ","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":53,"style":"BOLD"},{"offset":0,"length":53,"style":"UNDERLINE"}],"entityRanges":[],"data":{}},{"key":"6div6","text":"Properties (Rating)","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2vvf8","text":"Oils & Grease - Fair","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a81ak","text":"Tear Strength \u2013 Poor","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"16n5","text":"Fuel Resistance - Poor","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5hbj5","text":"Heat Ozone & Aging Resistance - Excellent","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8e3ru","text":"Water Swell Resistance - Excellent","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"18ra0","text":"Abrasion Resistance - Poor","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8ubmv","text":"Other than the size and material type, there is one final option that you need to take in consideration. And that is the Durometer. Durometer are being classified as an industry standard to measure the elastomer hardness. Durometer is measured and listed in accordance with \u201CShore A\u201D scale. Typical standard hardness for the elastomer are 70 shore, 75 shore and 90 shore to choose from depending on the material that you are using. The higher the value of the shore indicates that the material you are using is harder. Durometer is also generally stated and accepted with a \u201C+/- 5\u201D tolerance. Silicone O-Rings the standard nominal durometer is 70 Shore.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"15k59","text":"Primary Usage","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":13,"style":"BOLD"},{"offset":0,"length":13,"style":"UNDERLINE"}],"entityRanges":[],"data":{}},{"key":"11j56","text":"O-Rings and rubber seals are generally used for:","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8t11h","text":"\xB7 Applications that require resistance to OIL","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6lu0g","text":"\xB7 Applications that are required to work in low temperatures (-0\xB0C)","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"99opc","text":"\xB7 High performance Fuel systems that requires strictly no leakage","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4dbnc","text":"Aircrafts","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"evrj8","text":"Marine Ships","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2nkeb","text":"F1 Cars","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aqmfm","text":"\xB7 General Industrial Use ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3oa4r","text":"Tips for installation of an O-ring","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":34,"style":"BOLD"},{"offset":0,"length":34,"style":"UNDERLINE"}],"entityRanges":[],"data":{}},{"key":"cnh1n","text":"O-rings need to be installed properly for a perfect fit and sealing. It is important that you install the O-ring in a prescribed manner to ensure your application continues to function properly. You will also ensure you increase the life of the application.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2e8ro","text":"So how do you install an O-ring?","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":32,"style":"BOLD"},{"offset":0,"length":32,"style":"UNDERLINE"}],"entityRanges":[],"data":{}},{"key":"650jm","text":"The process of installing an O-ring into a male gland is an intricate affair that should be carefully undertaken. Glide it along the shaft so as it reaches the gland. At that point, it should easily snap into place. Simple as it might sound, a number of steps will ensure that the O-ring doesn\u2019t get damaged.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"abapc","text":"If you want to install an O-ring correctly and within a short time, here are steps to follow:","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b4b6r","text":"\xB7 Covering and lubricating the threading of the shaft","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5oiv9","text":"The threading of the shaft has the potential of tearing the rubber seal. Cover the threads using a masking tape and then lubricate them to allow for easy passage of the O-ring. The aim is to have the O-ring slide through without getting torn.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"293rc","text":"\xB7 Don\u2019t force it over sharp corners","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"47vni","text":"That\u2019s a tip that will save you the stress of a torn O-ring. In fact, running the O-ring over jagged or sharp objects could get it torn. You may not be able to notice some of these tears. That\u2019s why you should ensure you prevent them from occurring in the first place.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6eho4","text":"\xB7 Even stretching","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e4kp6","text":"You will have to stretch the O-ring over the shaft. Ensure you do it evenly. Pulling from one side is a no-no. If anything, you should stretch the O-ring as little as possible. You will not just get a tighter grip but added security too.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"el7uv","text":"\xB7 Don\u2019t roll it down the shaft","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a8iu1","text":"Instead of rolling the O-ring down the shaft, slide it. If you spiral wind or roll an O-ring, it cannot be properly installed. It will also not function optimally and can even end up being damaged. If you have a lubricant, apply it on the O-ring and you will keep it rolling.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8cu0q","text":"\xB7 Finishing it off","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6tpf1","text":"Place the female component in a manner that allows its radius to go around the corner. This should be done when you are finalizing the installation process. Ensure the lead of this component is inside the chamfer. This is how you will be able to guarantee the safety of the O-ring.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2mnva","text":"For O-rings to perform optimally, they have to be properly installed. It doesn\u2019t just provide secure sealing but also increases the service life of the component together with the application. Don\u2019t compromise on this process.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":226,"style":"ITALIC"}],"entityRanges":[],"data":{}},{"key":"4o3b8","text":"Installation Guide","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":18,"style":"BOLD"},{"offset":0,"length":18,"style":"UNDERLINE"}],"entityRanges":[],"data":{}},{"key":"6fd09","text":"","type":"atomic:image","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{"src":"https://storage.googleapis.com/eezee-product-images/aJevGRVmv9HExN7pOdJQ6n.png"}}]}',
	model: 'ORING AS568 AS457 ID 354.97 X CS 6.99Silicone 70 Shore',
	brand: {
		name: 'Eriks',
		kebabName: 'eriks',
		lowerCaseName: 'eriks',
		_id: '59df4b94728c0a0deed8a6d6'
	},
	title: 'ORING AS568 AS457 ID 354.97 X CS 6.99 Silicone 70 Shore',
	__v: 6,
	duplicate: false,
	sku: '373505da93',
	includes: [],
	specs: [],
	shipping: {
		weight: 0.1,
		length: 0.1,
		width: 0.1,
		height: 0.1
	},
	bulkDiscount: [{
		discount: 20,
		quantity: 8,
		_id: '5a30a4e7801ac66366808017'
	}, {
		discount: 26,
		quantity: 10,
		_id: '5a30a4e7801ac66366808017'
	}, {
		discount: 5,
		quantity: 4,
		_id: '5a30a4e7801ac66366808017'
	}],
	variants: [],
	specSheets: [],
	price: {
		original: 26,
		sale: 0,
		po: 'S$26.00',
		ps: 'S$0.00'
	},
	images: [{
		__v: 0,
		fileType: 'image',
		bucket: 'eezee-product-images',
		fileName: 'tjewl6d.jpeg',
		url: 'https://storage.googleapis.com/eezee-product-images/tjewl6d.jpeg',
		_id: '59f7599b9518e2289998f329',
		expire: '2017-10-30T08:41:28.939Z'
	}, {
		__v: 0,
		fileType: 'image',
		bucket: 'eezee-product-images',
		fileName: '6646v7l.jpeg',
		url: 'https://storage.googleapis.com/eezee-product-images/6646v7l.jpeg',
		_id: '59f759a29518e2289998f32a',
		expire: '2017-10-30T08:41:28.939Z'
	}],
	dateUpdated: '2017-12-13T03:56:23.550Z',
	dateCreated: '2017-11-21T03:26:27.671Z',
	active: true,
	categories: {
		main: 'Mechanical Parts',
		sub: 'O Ring',
		mainKebabCase: 'mechanical-parts',
		subKebabCase: 'o-ring'
	}
}, {
	supplier: null,
	_id: '59b90312196632786ed8a8f1',
	title: 'CLABER RAIN SENSOR',
	brand: {
		name: 'CLABER',
		lowerCaseName: 'claber',
		kebabName: 'claber',
		_id: '59b24e3eb38a0b0ad30a3b4f'
	},
	model: '90915',
	description: '{"entityMap":{},"blocks":[{"key":"9m96e","text":"Suitable for all watering systems, the rain sensor avoids unnecessary wastage of water by turning the sprinklers off when it is raining.","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"cpep6","text":"The sensor is connected to the common solenoid valve (24 V) or to the Aquauno timers.","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3av2l","text":"When the internal flow reaches a level of 5 mm of rain per square metre, the system shuts down.","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ff852","text":"Programmed watering automatically resumes when the water in the sensor evaporates.","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3h0ao","text":"The rain sensor should be installed in an outdoor area exposed to rain using the stainless steel bracket provided.","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
	descriptionHtml: '<ul><li>Suitable for all watering systems, the rain sensor avoids unnecessary wastage of water by turning the sprinklers off when it is raining.</li><li>The sensor is connected to the common solenoid valve (24 V) or to the Aquauno timers.</li><li>When the internal flow reaches a level of 5 mm of rain per square metre, the system shuts down.</li><li>Programmed watering automatically resumes when the water in the sensor evaporates.</li><li>The rain sensor should be installed in an outdoor area exposed to rain using the stainless steel bracket provided.</li></ul>',
	uniqTitle: 'claber-rain-sensor-90915',
	__v: 1,
	sku: '4592dbb01e',
	includes: [],
	specs: [{
		name: 'Fixing',
		value: 'supplied with pivoting wall bracket'
	}],
	bulkDiscount: [],
	variants: [],
	specSheets: [],
	price: {
		original: 79.9,
		sale: 0,
		po: 'S$79.90',
		ps: 'S$0.00'
	},
	images: [{
		url: 'https://storage.googleapis.com/eezee-product-images/20160622133420NTDBSYUKP9MSA_full.jpg',
		fileName: '20160622133420NTDBSYUKP9MSA_full.jpg',
		bucket: 'eezee-product-images',
		fileType: 'image'
	}, {
		url: 'https://storage.googleapis.com/eezee-product-images/201606221334541ZUISXEFJJDZ4_full.jpg',
		fileName: '201606221334541ZUISXEFJJDZ4_full.jpg',
		bucket: 'eezee-product-images',
		fileType: 'image'
	}, {
		url: 'https://storage.googleapis.com/eezee-product-images/20160622133454HBW7E4DG0V5O7_full.jpg',
		fileName: '20160622133454HBW7E4DG0V5O7_full.jpg',
		bucket: 'eezee-product-images',
		fileType: 'image'
	}, {
		url: 'https://storage.googleapis.com/eezee-product-images/20160622133454TSRQKQUACUXG0_full.jpg',
		fileName: '20160622133454TSRQKQUACUXG0_full.jpg',
		bucket: 'eezee-product-images',
		fileType: 'image'
	}],
	dateUpdated: '2017-11-21T12:17:44.435Z',
	dateCreated: '2017-09-30T09:16:59.930Z',
	active: true,
	categories: {
		main: 'Outdoor & Gardening',
		sub: 'Garden Watering System',
		mainKebabCase: 'outdoor-gardening',
		subKebabCase: 'garden-watering-system'
	}
}];
var storeResults = {
	size: 746,
	products: [{
		_id: '5a1553ef918693670dc25007',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'toyogo-heavy-duty-pallet-p-1411-h',
		descriptionHtml: '<p class="md-block-unstyled">TOYOGO HEAVY DUTY PALLET P-1411H is a heavy-duty industrial pallet made from plastic. It is lightweight, low-cost and very strong and durable. Injection moulded into one piece, this recyclable 4-way entry plastic pallet is an alternative to wood, weighing 50% to 70% less than wooden pallets. Besides providing ease of handling, they do not absorb moisture and are suitable for transporting most products. ideal for airfreight and export as no fumigation is required meeting ISPM 15 standards, saving you time and money.</p><p class="md-block-unstyled">Plastic pallets are helpful, even when it comes to being green. Plastic pallets can hold heavy cargo during shipping and be easily moved around by hand truck or forklift or stacked up one on top of another just like timber pallets. It also has anti-slip rubber grommets to stabilise the unit load and guard against load shifting by providing a non-skid surface.</p><p class="md-block-unstyled">Mainly used as an alternative to wooden pallets, plastic pallets also have the ability to be customised for individualised shipping. The major bonus of plastic pallets is their hygiene compared to timber. They can be easily and thoroughly cleaned in between usage which is not true of timber pallets. This makes them perfect for transporting sensitive goods such as medicines and food.</p><p class="md-block-unstyled">Usability is the major reason so many companies are going with plastic pallets and many manufacturers have capitalised on this by creating new designs specifically for each industry. There are many low cost options available on the market now to compare quite favourably with their wooden counterparts. Low cost is achieved by the use of resin that has been recycled and scrap regrind.</p><p class="md-block-unstyled">Plastic is long lasting and durable. This is especially important in the case of used plastic pallets as these must support lots of items of various weights many times. They must also hold up when being lifted by a forklift or moved over many miles in trucks over many years, being left out in the elements time and time again between transports.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Dimensions</strong></p><p class="md-block-unstyled">1400 x 110 x 150 mm</p><p class="md-block-unstyled"><strong class="md-inline-bold">Key Features</strong></p><ul class="md-block-unordered-list-item"><li>One-piece moulded pallet</li><li>Reversible Four-way Entry for Forklift &amp; Reach truck handling</li><li>Anti-slip rubber grommets</li></ul><p class="md-block-unstyled"><strong class="md-inline-bold">Other Features</strong></p><ul class="md-block-unordered-list-item"><li>Washable</li><li>Hygienic and non toxic</li><li>Resistant to chemical</li><li>Odourless</li><li>No splints and chipping</li><li>Safe to handle, free from nails and screws</li><li>Recyclable</li><li>Consistent weight and size</li><li>Nestable results in space saving</li></ul><p class="md-block-unstyled"><br/></p><p class="md-block-unstyled"><strong class="md-inline-bold">Plastic vs Wood Pallet</strong></p><p class="md-block-unstyled">Plastic pallet is becoming the most feasible alternative to wood pallet. Plastic pallet is durable and lightweight, and about the same price as wood pallet. Plastic pallet does not require fumigation for export, is half the weight of wood and it satisfies good storage practice for food and pharmaceutical customers. There is no risk of injuries to workers as plastic lightweight pallets have no protruding nails or splinters like wood pallets. </p><p class="md-block-unstyled">It is pest free and able to handle wet environment. </p><p class="md-block-unstyled">The dynamic load capacity ranges from 500 kg to 1.5 tons, depending on the design and raw materials used. </p><p class="md-block-unstyled"><br/></p><p class="md-block-unstyled"><br/></p>',
		description: '{"entityMap":{},"blocks":[{"key":"4g5t5","text":"TOYOGO HEAVY DUTY PALLET P-1411H is a heavy-duty industrial pallet made from plastic. It is lightweight, low-cost and very strong and durable. Injection moulded into one piece, this recyclable 4-way entry plastic pallet is an alternative to wood, weighing 50% to 70% less than wooden pallets. Besides providing ease of handling, they do not absorb moisture and are suitable for transporting most products. ideal for airfreight and export as no fumigation is required meeting ISPM 15 standards, saving you time and money.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5upiv","text":"Plastic pallets are helpful, even when it comes to being green. Plastic pallets can hold heavy cargo during shipping and be easily moved around by hand truck or forklift or stacked up one on top of another just like timber pallets. It also has anti-slip rubber grommets to stabilise the unit load and guard against load shifting by providing a non-skid surface.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fn4gr","text":"Mainly used as an alternative to wooden pallets, plastic pallets also have the ability to be customised for individualised shipping. The major bonus of plastic pallets is their hygiene compared to timber. They can be easily and thoroughly cleaned in between usage which is not true of timber pallets. This makes them perfect for transporting sensitive goods such as medicines and food.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b0349","text":"Usability is the major reason so many companies are going with plastic pallets and many manufacturers have capitalised on this by creating new designs specifically for each industry. There are many low cost options available on the market now to compare quite favourably with their wooden counterparts. Low cost is achieved by the use of resin that has been recycled and scrap regrind.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"15t52","text":"Plastic is long lasting and durable. This is especially important in the case of used plastic pallets as these must support lots of items of various weights many times. They must also hold up when being lifted by a forklift or moved over many miles in trucks over many years, being left out in the elements time and time again between transports.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3sp5e","text":"Dimensions","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":10,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"cv2d3","text":"1400 x 110 x 150 mm","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"34b2p","text":"Key Features","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":12,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"3jksf","text":"One-piece moulded pallet","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9995s","text":"Reversible Four-way Entry for Forklift & Reach truck handling","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b63d1","text":"Anti-slip rubber grommets","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"as55f","text":"Other Features","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":14,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"d3ig7","text":"Washable","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4qne2","text":"Hygienic and non toxic","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"cgqai","text":"Resistant to chemical","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"de7nl","text":"Odourless","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4cv5i","text":"No splints and chipping","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"em1pp","text":"Safe to handle, free from nails and screws","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4mnd3","text":"Recyclable","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"c5mo8","text":"Consistent weight and size","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"cpeha","text":"Nestable results in space saving","type":"unordered-list-item","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f71ht","text":"","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"10kn2","text":"Plastic vs Wood Pallet","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":22,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"21o5b","text":"Plastic pallet is becoming the most feasible alternative to wood pallet. Plastic pallet is durable and lightweight, and about the same price as wood pallet. Plastic pallet does not require fumigation for export, is half the weight of wood and it satisfies good storage practice for food and pharmaceutical customers. There is no risk of injuries to workers as plastic lightweight pallets have no protruding nails or splinters like wood pallets. ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8qi9i","text":"It is pest free and able to handle wet environment. ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ac2vl","text":"The dynamic load capacity ranges from 500 kg to 1.5 tons, depending on the design and raw materials used. ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"82da7","text":"","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"973m9","text":"","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: 'P-1411H',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'cHNCWaE8jvHgb69~nduD12.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/cHNCWaE8jvHgb69~nduD12.jpg',
				_id: '5a6be0ce4e9c6a0c689a242e',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: false,
			name: 'TOYOGO',
			lowerCaseName: 'toyogo',
			kebabName: 'toyogo',
			_id: '59b24e3eb38a0b0ad30a3a9b'
		},
		title: 'TOYOGO HEAVY DUTY PALLET P-1411H',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '00e66e3885',
		includes: [],
		specs: [],
		shipping: {
			weight: 1,
			length: 140,
			width: 110,
			height: 15
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 115,
			sale: 0,
			po: 'S$115.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'UhJ0MIm9CjaOc1uS5HqkRW.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg',
			_id: '5a154f21918693670dc24a28',
			expire: '2017-11-22T06:35:22.658Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'O24EoqiMcC10foNWdsXNdN.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/O24EoqiMcC10foNWdsXNdN.jpg',
			_id: '5a15501e918693670dc24b88',
			expire: '2017-11-22T06:35:22.658Z'
		}],
		dateUpdated: '2017-11-26T09:50:23.146Z',
		dateCreated: '2017-11-22T10:39:43.569Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Industrial Consumable Goods',
			sub: 'Packaging & Shipping Supplies',
			mainKebabCase: 'industrial-consumable-goods',
			subKebabCase: 'packaging-shipping-supplies'
		}
	}, {
		_id: '5a582d7337f8836a18c9e637',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'etape-\u2076-5-m-16-ft-digital-measuring-tape',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Large Digital Display.</p><p class="md-block-unstyled">\u2022 Bluetooth Option.</p><p class="md-block-unstyled">\u2022 Centerline Calculation.</p><p class="md-block-unstyled">\u2022 2 Long Term Memories.</p><p class="md-block-unstyled">\u2022 Rezero Function.</p><p class="md-block-unstyled">\u2022 Short Term Measurement Hold.</p><p class="md-block-unstyled">\u2022 Inside/Outside Measurement.</p><p class="md-block-unstyled">\u2022 Inches/Metric Conversion.</p><p class="md-block-unstyled">https://youtu.be/diejcdz7Kso</p>',
		description: '{"entityMap":{},"blocks":[{"key":"9do8m","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"51kji","text":"\u2022 Large Digital Display.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"abe5m","text":"\u2022 Bluetooth Option.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3bhgf","text":"\u2022 Centerline Calculation.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"cd51q","text":"\u2022 2 Long Term Memories.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6ikl8","text":"\u2022 Rezero Function.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2fdka","text":"\u2022 Short Term Measurement Hold.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3asne","text":"\u2022 Inside/Outside Measurement.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9366h","text":"\u2022 Inches/Metric Conversion.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"34rid","text":"https://youtu.be/diejcdz7Kso","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: 'eTAPE16',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: '2g6uxbqoHPH9r_sA2kbE52.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/2g6uxbqoHPH9r_sA2kbE52.jpg',
				_id: '5a6c3d9b4e9c6a0c68a10690',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'eTape16',
			lowerCaseName: 'etape16',
			kebabName: 'etape-16',
			_id: '5a541e62806c690331c19b6e'
		},
		title: 'eTAPE\xB9\u2076 5m16ft Digital Measuring Tape',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '591b929277',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.27,
			length: 18,
			width: 12,
			height: 55
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 43,
			sale: 0,
			po: 'S$43.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'BG3VrUBIpfnK5WgDp3H3H~.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/BG3VrUBIpfnK5WgDp3H3H~.jpg',
			_id: '5a582b0a37f8836a18c9df10',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'lxwEUb0GhyOk~ZoYWPNYw3.png',
			url: 'https://storage.googleapis.com/eezee-product-images/lxwEUb0GhyOk~ZoYWPNYw3.png',
			_id: '5a582d2937f8836a18c9e583',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'vSLLCG8yvrzrbMJaqX7B2D.png',
			url: 'https://storage.googleapis.com/eezee-product-images/vSLLCG8yvrzrbMJaqX7B2D.png',
			_id: '5a582d4237f8836a18c9e584',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-12T05:50:56.774Z',
		dateCreated: '2018-01-12T03:37:23.636Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrical Measuring Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrical-measuring-tools'
		}
	}, {
		_id: '5a582d7a37f8836a18c9e640',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'etape-\u2076-5-m-16-ft-digital-measuring-tape',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Large Digital Display.</p><p class="md-block-unstyled">\u2022 Bluetooth Option.</p><p class="md-block-unstyled">\u2022 Centerline Calculation.</p><p class="md-block-unstyled">\u2022 2 Long Term Memories.</p><p class="md-block-unstyled">\u2022 Rezero Function.</p><p class="md-block-unstyled">\u2022 Short Term Measurement Hold.</p><p class="md-block-unstyled">\u2022 Inside/Outside Measurement.</p><p class="md-block-unstyled">\u2022 Inches/Metric Conversion.</p><p class="md-block-unstyled">https://youtu.be/diejcdz7Kso</p>',
		description: '{"entityMap":{},"blocks":[{"key":"9do8m","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"51kji","text":"\u2022 Large Digital Display.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"abe5m","text":"\u2022 Bluetooth Option.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3bhgf","text":"\u2022 Centerline Calculation.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"cd51q","text":"\u2022 2 Long Term Memories.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6ikl8","text":"\u2022 Rezero Function.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2fdka","text":"\u2022 Short Term Measurement Hold.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3asne","text":"\u2022 Inside/Outside Measurement.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9366h","text":"\u2022 Inches/Metric Conversion.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"34rid","text":"https://youtu.be/diejcdz7Kso","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: 'eTAPE16',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: '2g6uxbqoHPH9r_sA2kbE52.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/2g6uxbqoHPH9r_sA2kbE52.jpg',
				_id: '5a6c3d9b4e9c6a0c68a10690',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'eTape16',
			lowerCaseName: 'etape16',
			kebabName: 'etape-16',
			_id: '5a541e62806c690331c19b6e'
		},
		title: 'eTAPE\xB9\u2076 5m16ft Digital Measuring Tape',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '4fb29fd47b',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.27,
			length: 18,
			width: 12,
			height: 55
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 43,
			sale: 0,
			po: 'S$43.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'BG3VrUBIpfnK5WgDp3H3H~.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/BG3VrUBIpfnK5WgDp3H3H~.jpg',
			_id: '5a582b0a37f8836a18c9df10',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'lxwEUb0GhyOk~ZoYWPNYw3.png',
			url: 'https://storage.googleapis.com/eezee-product-images/lxwEUb0GhyOk~ZoYWPNYw3.png',
			_id: '5a582d2937f8836a18c9e583',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'vSLLCG8yvrzrbMJaqX7B2D.png',
			url: 'https://storage.googleapis.com/eezee-product-images/vSLLCG8yvrzrbMJaqX7B2D.png',
			_id: '5a582d4237f8836a18c9e584',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-12T05:50:17.228Z',
		dateCreated: '2018-01-12T03:37:30.696Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a582d9d37f8836a18c9e708',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'etape-\u2076-5-m-16-ft-digital-measuring-tape',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Large Digital Display.</p><p class="md-block-unstyled">\u2022 Bluetooth Option.</p><p class="md-block-unstyled">\u2022 Centerline Calculation.</p><p class="md-block-unstyled">\u2022 2 Long Term Memories.</p><p class="md-block-unstyled">\u2022 Rezero Function.</p><p class="md-block-unstyled">\u2022 Short Term Measurement Hold.</p><p class="md-block-unstyled">\u2022 Inside/Outside Measurement.</p><p class="md-block-unstyled">\u2022 Inches/Metric Conversion.</p><p class="md-block-unstyled">https://youtu.be/diejcdz7Kso</p>',
		description: '{"entityMap":{},"blocks":[{"key":"9do8m","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"51kji","text":"\u2022 Large Digital Display.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"abe5m","text":"\u2022 Bluetooth Option.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3bhgf","text":"\u2022 Centerline Calculation.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"cd51q","text":"\u2022 2 Long Term Memories.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6ikl8","text":"\u2022 Rezero Function.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2fdka","text":"\u2022 Short Term Measurement Hold.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3asne","text":"\u2022 Inside/Outside Measurement.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9366h","text":"\u2022 Inches/Metric Conversion.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"34rid","text":"https://youtu.be/diejcdz7Kso","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: 'eTAPE16',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: '2g6uxbqoHPH9r_sA2kbE52.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/2g6uxbqoHPH9r_sA2kbE52.jpg',
				_id: '5a6c3d9b4e9c6a0c68a10690',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'eTape16',
			lowerCaseName: 'etape16',
			kebabName: 'etape-16',
			_id: '5a541e62806c690331c19b6e'
		},
		title: 'eTAPE\xB9\u2076 5m16ft Digital Measuring Tape',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'c9b27be954',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.27,
			length: 18,
			width: 12,
			height: 55
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 43,
			sale: 0,
			po: 'S$43.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'BG3VrUBIpfnK5WgDp3H3H~.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/BG3VrUBIpfnK5WgDp3H3H~.jpg',
			_id: '5a582b0a37f8836a18c9df10',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'lxwEUb0GhyOk~ZoYWPNYw3.png',
			url: 'https://storage.googleapis.com/eezee-product-images/lxwEUb0GhyOk~ZoYWPNYw3.png',
			_id: '5a582d2937f8836a18c9e583',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'vSLLCG8yvrzrbMJaqX7B2D.png',
			url: 'https://storage.googleapis.com/eezee-product-images/vSLLCG8yvrzrbMJaqX7B2D.png',
			_id: '5a582d4237f8836a18c9e584',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-12T05:49:39.940Z',
		dateCreated: '2018-01-12T03:38:05.579Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Measuring & Layout Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'measuring-layout-tools'
		}
	}, {
		_id: '5a5830ea37f8836a18c9f1ee',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'boxo-5-m-measuring-tape',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 With ABS/TPR Case, Tape Lock And Belt Clip.</p><p class="md-block-unstyled">\u2022 Power Return Tape.</p><p class="md-block-unstyled">\u2022 Aligning Hook For Internal / External Measurement.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"75bec","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7d4fm","text":"\u2022 With ABS/TPR Case, Tape Lock And Belt Clip.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fich7","text":"\u2022 Power Return Tape.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"djh9l","text":"\u2022 Aligning Hook For Internal / External Measurement.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: 'MT50019',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'HKzOIr3qkWVui2gKkaTik6.png',
				url: 'https://storage.googleapis.com/eezee-brand-images/HKzOIr3qkWVui2gKkaTik6.png',
				_id: '5a6c3dc34e9c6a0c68a10938',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'BOXO',
			lowerCaseName: 'boxo',
			kebabName: 'boxo',
			featured: true,
			_id: '5a53346d806c690331bfacce'
		},
		title: 'BOXO 5m Measuring Tape',
		__v: 0,
		shopNumber: '0563306553',
		sku: '77c5be5477',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.2,
			length: 7.2,
			width: 1.9,
			height: 3.8
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 4.8,
			sale: 0,
			po: 'S$4.80',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: '1hNZb85lw8~AGhuKuuThmU.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/1hNZb85lw8~AGhuKuuThmU.jpg',
			_id: '5a582f7337f8836a18c9ecd1',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-02-26T09:52:49.425Z',
		dateCreated: '2018-01-12T03:52:10.513Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a5830ee37f8836a18c9f1fd',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'boxo-5-m-measuring-tape',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 With ABS/TPR Case, Tape Lock And Belt Clip.</p><p class="md-block-unstyled">\u2022 Power Return Tape.</p><p class="md-block-unstyled">\u2022 Aligning Hook For Internal / External Measurement.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"75bec","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7d4fm","text":"\u2022 With ABS/TPR Case, Tape Lock And Belt Clip.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fich7","text":"\u2022 Power Return Tape.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"djh9l","text":"\u2022 Aligning Hook For Internal / External Measurement.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: 'MT50019',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'HKzOIr3qkWVui2gKkaTik6.png',
				url: 'https://storage.googleapis.com/eezee-brand-images/HKzOIr3qkWVui2gKkaTik6.png',
				_id: '5a6c3dc34e9c6a0c68a10938',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'BOXO',
			lowerCaseName: 'boxo',
			kebabName: 'boxo',
			featured: true,
			_id: '5a53346d806c690331bfacce'
		},
		title: 'BOXO 5m Measuring Tape',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'a5c597d005',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.2,
			length: 7.2,
			width: 1.9,
			height: 3.8
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 4.8,
			sale: 0,
			po: 'S$4.80',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: '1hNZb85lw8~AGhuKuuThmU.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/1hNZb85lw8~AGhuKuuThmU.jpg',
			_id: '5a582f7337f8836a18c9ecd1',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-12T03:52:35.752Z',
		dateCreated: '2018-01-12T03:52:14.882Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Measuring & Layout Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'measuring-layout-tools'
		}
	}, {
		_id: '5a584bbc37f8836a18ca8aa4',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'neji-saurus-6-screw-removal-pliers-gt',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled"> </p><p class="md-block-unstyled"><strong class="md-inline-bold">Made in Japan</strong></p><p class="md-block-unstyled">\u2022 Length : 160mm.</p><p class="md-block-unstyled">\u2022 Multi-Purpose Screw Removing Tool.</p><p class="md-block-unstyled">\u2022 Material : Carbon Steel.</p><p class="md-block-unstyled">\u2022 Hardness : HRC58\xB12.</p><p class="md-block-unstyled">\u2022 Cutting Capacity : 1.2mm (copper Wire).</p><p class="md-block-unstyled">\u2022 Elaborately-Designed Serration Fit the Profile of Screw Head at the Best Angle, Also Good For Truss Head Screw.</p><p class="md-block-unstyled">\u2022 Truss : Lower-Profile dome Head.</p><p class="md-block-unstyled">https://youtu.be/W_QLVBZKegg</p><p class="md-block-unstyled">https://youtu.be/EOSoxf1jsXw</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"auehm","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4tq3n","text":"Made in Japan","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":13,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"2pobh","text":"\u2022 Length : 160mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3b9o","text":"\u2022 Multi-Purpose Screw Removing Tool.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"np2v","text":"\u2022 Material : Carbon Steel.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"euvv1","text":"\u2022 Hardness : HRC58\xB12.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"839qi","text":"\u2022 Cutting Capacity : 1.2mm (copper Wire).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"eq3rr","text":"\u2022 Elaborately-Designed Serration Fit the Profile of Screw Head at the Best Angle, Also Good For Truss Head Screw.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2rluh","text":"\u2022 Truss : Lower-Profile dome Head.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"32l5q","text":"https://youtu.be/W_QLVBZKegg","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fpf9k","text":"https://youtu.be/EOSoxf1jsXw","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: 'PZ-58',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: '77aLqzklSwREMFt8fram8I.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/77aLqzklSwREMFt8fram8I.jpg',
				_id: '5a6c3e924e9c6a0c68a10f0b',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'Neji-Saurus',
			lowerCaseName: 'neji-saurus',
			kebabName: 'neji-saurus',
			_id: '5a541e4b806c690331c19ac5'
		},
		title: 'Neji-Saurus 6\xBC\u201D Screw Removal Pliers GT',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '2c517eb18f',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.15,
			length: 21,
			width: 9,
			height: 2
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 35,
			sale: 0,
			po: 'S$35.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'h9BAg4CHPeleY80Qzw3sGc.png',
			url: 'https://storage.googleapis.com/eezee-product-images/h9BAg4CHPeleY80Qzw3sGc.png',
			_id: '5a584a2037f8836a18ca849c',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'm6u6fvnSei3gUVkyHnlviM.png',
			url: 'https://storage.googleapis.com/eezee-product-images/m6u6fvnSei3gUVkyHnlviM.png',
			_id: '5a584a2937f8836a18ca849d',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'Rszchlyeojdo5HkOMobJzr.png',
			url: 'https://storage.googleapis.com/eezee-product-images/Rszchlyeojdo5HkOMobJzr.png',
			_id: '5a584a2e37f8836a18ca849e',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'nrXXQ~bl14dDLzr7Q8K5EV.png',
			url: 'https://storage.googleapis.com/eezee-product-images/nrXXQ~bl14dDLzr7Q8K5EV.png',
			_id: '5a584a3337f8836a18ca8563',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'r21SyjdsjOZWYjZiWCEmeO.png',
			url: 'https://storage.googleapis.com/eezee-product-images/r21SyjdsjOZWYjZiWCEmeO.png',
			_id: '5a584a3937f8836a18ca8564',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'sY71geLI0t1uqT1RpADlmm.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/sY71geLI0t1uqT1RpADlmm.jpg',
			_id: '5a584a3c37f8836a18ca8565',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-17T04:12:10.291Z',
		dateCreated: '2018-01-12T05:46:36.641Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a584d0537f8836a18ca9650',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'neji-saurus-6-screw-removal-pliers-gt',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled"> </p><p class="md-block-unstyled"><strong class="md-inline-bold">Made in Japan</strong></p><p class="md-block-unstyled">\u2022 Length : 160mm.</p><p class="md-block-unstyled">\u2022 Multi-Purpose Screw Removing Tool.</p><p class="md-block-unstyled">\u2022 Material : Carbon Steel.</p><p class="md-block-unstyled">\u2022 Hardness : HRC58\xB12.</p><p class="md-block-unstyled">\u2022 Cutting Capacity : 1.2mm (copper Wire).</p><p class="md-block-unstyled">\u2022 Elaborately-Designed Serration Fit the Profile of Screw Head at the Best Angle, Also Good For Truss Head Screw.</p><p class="md-block-unstyled">\u2022 Truss : Lower-Profile dome Head.</p><p class="md-block-unstyled">http://youtu.be/W_QLVBZKegg</p><p class="md-block-unstyled">https://youtu.be/EOSoxf1jsXw</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7rh9s","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dt4da","text":"Made in Japan","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":13,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"2m6kk","text":"\u2022 Length : 160mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9qmof","text":"\u2022 Multi-Purpose Screw Removing Tool.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6qmgp","text":"\u2022 Material : Carbon Steel.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8ap20","text":"\u2022 Hardness : HRC58\xB12.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"d9ulo","text":"\u2022 Cutting Capacity : 1.2mm (copper Wire).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3q2d1","text":"\u2022 Elaborately-Designed Serration Fit the Profile of Screw Head at the Best Angle, Also Good For Truss Head Screw.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"34t9n","text":"\u2022 Truss : Lower-Profile dome Head.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dnfpa","text":"http://youtu.be/W_QLVBZKegg","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"drkgl","text":"https://youtu.be/EOSoxf1jsXw","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: 'PZ-58',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: '77aLqzklSwREMFt8fram8I.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/77aLqzklSwREMFt8fram8I.jpg',
				_id: '5a6c3e924e9c6a0c68a10f0b',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'Neji-Saurus',
			lowerCaseName: 'neji-saurus',
			kebabName: 'neji-saurus',
			_id: '5a541e4b806c690331c19ac5'
		},
		title: 'Neji-Saurus 6\xBC\u201D Screw Removal Pliers GT',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '4d4f7d2735',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.15,
			length: 21,
			width: 9,
			height: 2
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 35,
			sale: 0,
			po: 'S$35.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'h9BAg4CHPeleY80Qzw3sGc.png',
			url: 'https://storage.googleapis.com/eezee-product-images/h9BAg4CHPeleY80Qzw3sGc.png',
			_id: '5a584a2037f8836a18ca849c',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'm6u6fvnSei3gUVkyHnlviM.png',
			url: 'https://storage.googleapis.com/eezee-product-images/m6u6fvnSei3gUVkyHnlviM.png',
			_id: '5a584a2937f8836a18ca849d',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'Rszchlyeojdo5HkOMobJzr.png',
			url: 'https://storage.googleapis.com/eezee-product-images/Rszchlyeojdo5HkOMobJzr.png',
			_id: '5a584a2e37f8836a18ca849e',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'nrXXQ~bl14dDLzr7Q8K5EV.png',
			url: 'https://storage.googleapis.com/eezee-product-images/nrXXQ~bl14dDLzr7Q8K5EV.png',
			_id: '5a584a3337f8836a18ca8563',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'r21SyjdsjOZWYjZiWCEmeO.png',
			url: 'https://storage.googleapis.com/eezee-product-images/r21SyjdsjOZWYjZiWCEmeO.png',
			_id: '5a584a3937f8836a18ca8564',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'sY71geLI0t1uqT1RpADlmm.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/sY71geLI0t1uqT1RpADlmm.jpg',
			_id: '5a584a3c37f8836a18ca8565',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-17T04:11:37.539Z',
		dateCreated: '2018-01-12T05:52:05.429Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a584d2937f8836a18ca9d5c',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'neji-saurus-6-screw-removal-pliers-gt',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled"> </p><p class="md-block-unstyled"><strong class="md-inline-bold">Made in Japan</strong></p><p class="md-block-unstyled">\u2022 Length : 160mm.</p><p class="md-block-unstyled">\u2022 Multi-Purpose Screw Removing Tool.</p><p class="md-block-unstyled">\u2022 Material : Carbon Steel.</p><p class="md-block-unstyled">\u2022 Hardness : HRC58\xB12.</p><p class="md-block-unstyled">\u2022 Cutting Capacity : 1.2mm (copper Wire).</p><p class="md-block-unstyled">\u2022 Elaborately-Designed Serration Fit the Profile of Screw Head at the Best Angle, Also Good For Truss Head Screw.</p><p class="md-block-unstyled">\u2022 Truss : Lower-Profile dome Head.</p><p class="md-block-unstyled">https://youtu.be/W_QLVBZKegg</p><p class="md-block-unstyled">https://youtu.be/EOSoxf1jsXw</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dmb9j","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"acaev","text":"Made in Japan","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":13,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"7rorr","text":"\u2022 Length : 160mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a9886","text":"\u2022 Multi-Purpose Screw Removing Tool.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2hph3","text":"\u2022 Material : Carbon Steel.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9tl30","text":"\u2022 Hardness : HRC58\xB12.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2cl6n","text":"\u2022 Cutting Capacity : 1.2mm (copper Wire).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fa5gd","text":"\u2022 Elaborately-Designed Serration Fit the Profile of Screw Head at the Best Angle, Also Good For Truss Head Screw.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6v3uf","text":"\u2022 Truss : Lower-Profile dome Head.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"909f4","text":"https://youtu.be/W_QLVBZKegg","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"878ad","text":"https://youtu.be/EOSoxf1jsXw","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: 'PZ-58',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: '77aLqzklSwREMFt8fram8I.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/77aLqzklSwREMFt8fram8I.jpg',
				_id: '5a6c3e924e9c6a0c68a10f0b',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'Neji-Saurus',
			lowerCaseName: 'neji-saurus',
			kebabName: 'neji-saurus',
			_id: '5a541e4b806c690331c19ac5'
		},
		title: 'Neji-Saurus 6\xBC\u201D Screw Removal Pliers GT',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'e51490640c',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.15,
			length: 21,
			width: 9,
			height: 2
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 35,
			sale: 0,
			po: 'S$35.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'h9BAg4CHPeleY80Qzw3sGc.png',
			url: 'https://storage.googleapis.com/eezee-product-images/h9BAg4CHPeleY80Qzw3sGc.png',
			_id: '5a584a2037f8836a18ca849c',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'm6u6fvnSei3gUVkyHnlviM.png',
			url: 'https://storage.googleapis.com/eezee-product-images/m6u6fvnSei3gUVkyHnlviM.png',
			_id: '5a584a2937f8836a18ca849d',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'Rszchlyeojdo5HkOMobJzr.png',
			url: 'https://storage.googleapis.com/eezee-product-images/Rszchlyeojdo5HkOMobJzr.png',
			_id: '5a584a2e37f8836a18ca849e',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'nrXXQ~bl14dDLzr7Q8K5EV.png',
			url: 'https://storage.googleapis.com/eezee-product-images/nrXXQ~bl14dDLzr7Q8K5EV.png',
			_id: '5a584a3337f8836a18ca8563',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'r21SyjdsjOZWYjZiWCEmeO.png',
			url: 'https://storage.googleapis.com/eezee-product-images/r21SyjdsjOZWYjZiWCEmeO.png',
			_id: '5a584a3937f8836a18ca8564',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'sY71geLI0t1uqT1RpADlmm.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/sY71geLI0t1uqT1RpADlmm.jpg',
			_id: '5a584a3c37f8836a18ca8565',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-17T04:11:11.634Z',
		dateCreated: '2018-01-12T05:52:41.829Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a584d4737f8836a18ca9e5f',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'neji-saurus-6-screw-removal-pliers-gt',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled"> </p><p class="md-block-unstyled"><strong class="md-inline-bold">Made in Japan</strong></p><p class="md-block-unstyled">\u2022 Length : 160mm.</p><p class="md-block-unstyled">\u2022 Multi-Purpose Screw Removing Tool.</p><p class="md-block-unstyled">\u2022 Material : Carbon Steel.</p><p class="md-block-unstyled">\u2022 Hardness : HRC58\xB12.</p><p class="md-block-unstyled">\u2022 Cutting Capacity : 1.2mm (copper Wire).</p><p class="md-block-unstyled">\u2022 Elaborately-Designed Serration Fit the Profile of Screw Head at the Best Angle, Also Good For Truss Head Screw.</p><p class="md-block-unstyled">\u2022 Truss : Lower-Profile dome Head.</p><p class="md-block-unstyled">https://youtu.be/W_QLVBZKegg</p><p class="md-block-unstyled">https://youtu.be/EOSoxf1jsXw</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9bf7m","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"epk8u","text":"Made in Japan","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":13,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"2i4mj","text":"\u2022 Length : 160mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6k0ui","text":"\u2022 Multi-Purpose Screw Removing Tool.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"31cot","text":"\u2022 Material : Carbon Steel.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dqvhs","text":"\u2022 Hardness : HRC58\xB12.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7hh91","text":"\u2022 Cutting Capacity : 1.2mm (copper Wire).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ers13","text":"\u2022 Elaborately-Designed Serration Fit the Profile of Screw Head at the Best Angle, Also Good For Truss Head Screw.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6ujk1","text":"\u2022 Truss : Lower-Profile dome Head.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"cbgrd","text":"https://youtu.be/W_QLVBZKegg","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a5fn6","text":"https://youtu.be/EOSoxf1jsXw","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: 'PZ-58',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: '77aLqzklSwREMFt8fram8I.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/77aLqzklSwREMFt8fram8I.jpg',
				_id: '5a6c3e924e9c6a0c68a10f0b',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'Neji-Saurus',
			lowerCaseName: 'neji-saurus',
			kebabName: 'neji-saurus',
			_id: '5a541e4b806c690331c19ac5'
		},
		title: 'Neji-Saurus 6\xBC\u201D Screw Removal Pliers GT',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '15538165a6',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.15,
			length: 21,
			width: 9,
			height: 2
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 35,
			sale: 0,
			po: 'S$35.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'h9BAg4CHPeleY80Qzw3sGc.png',
			url: 'https://storage.googleapis.com/eezee-product-images/h9BAg4CHPeleY80Qzw3sGc.png',
			_id: '5a584a2037f8836a18ca849c',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'm6u6fvnSei3gUVkyHnlviM.png',
			url: 'https://storage.googleapis.com/eezee-product-images/m6u6fvnSei3gUVkyHnlviM.png',
			_id: '5a584a2937f8836a18ca849d',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'Rszchlyeojdo5HkOMobJzr.png',
			url: 'https://storage.googleapis.com/eezee-product-images/Rszchlyeojdo5HkOMobJzr.png',
			_id: '5a584a2e37f8836a18ca849e',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'nrXXQ~bl14dDLzr7Q8K5EV.png',
			url: 'https://storage.googleapis.com/eezee-product-images/nrXXQ~bl14dDLzr7Q8K5EV.png',
			_id: '5a584a3337f8836a18ca8563',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'r21SyjdsjOZWYjZiWCEmeO.png',
			url: 'https://storage.googleapis.com/eezee-product-images/r21SyjdsjOZWYjZiWCEmeO.png',
			_id: '5a584a3937f8836a18ca8564',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'sY71geLI0t1uqT1RpADlmm.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/sY71geLI0t1uqT1RpADlmm.jpg',
			_id: '5a584a3c37f8836a18ca8565',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-17T04:10:08.795Z',
		dateCreated: '2018-01-12T05:53:11.878Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a584d6037f8836a18ca9e9f',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'neji-saurus-6-screw-removal-pliers-gt',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled"><strong class="md-inline-bold">Made in Japan</strong></p><p class="md-block-unstyled">\u2022 Length : 160mm.</p><p class="md-block-unstyled">\u2022 Multi-Purpose Screw Removing Tool.</p><p class="md-block-unstyled">\u2022 Material : Carbon Steel.</p><p class="md-block-unstyled">\u2022 Hardness : HRC58\xB12.</p><p class="md-block-unstyled">\u2022 Cutting Capacity : 1.2mm (copper Wire).</p><p class="md-block-unstyled">\u2022 Elaborately-Designed Serration Fit the Profile of Screw Head at the Best Angle, Also Good For Truss Head Screw.</p><p class="md-block-unstyled">\u2022 Truss : Lower-Profile dome Head.</p><p class="md-block-unstyled">https://youtu.be/W_QLVBZKegg</p><p class="md-block-unstyled">https://youtu.be/EOSoxf1jsXw</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"21up1","text":"Made in Japan","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":13,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"9ob8a","text":"\u2022 Length : 160mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f78p4","text":"\u2022 Multi-Purpose Screw Removing Tool.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"cq0m4","text":"\u2022 Material : Carbon Steel.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2f16k","text":"\u2022 Hardness : HRC58\xB12.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7b8sl","text":"\u2022 Cutting Capacity : 1.2mm (copper Wire).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"cf24u","text":"\u2022 Elaborately-Designed Serration Fit the Profile of Screw Head at the Best Angle, Also Good For Truss Head Screw.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bl4i7","text":"\u2022 Truss : Lower-Profile dome Head.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6h9au","text":"https://youtu.be/W_QLVBZKegg","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5lmcl","text":"https://youtu.be/EOSoxf1jsXw","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: 'PZ-58',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: '77aLqzklSwREMFt8fram8I.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/77aLqzklSwREMFt8fram8I.jpg',
				_id: '5a6c3e924e9c6a0c68a10f0b',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'Neji-Saurus',
			lowerCaseName: 'neji-saurus',
			kebabName: 'neji-saurus',
			_id: '5a541e4b806c690331c19ac5'
		},
		title: 'Neji-Saurus 6\xBC\u201D Screw Removal Pliers GT',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '95fdbe4604',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.15,
			length: 21,
			width: 9,
			height: 2
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 35,
			sale: 0,
			po: 'S$35.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'h9BAg4CHPeleY80Qzw3sGc.png',
			url: 'https://storage.googleapis.com/eezee-product-images/h9BAg4CHPeleY80Qzw3sGc.png',
			_id: '5a584a2037f8836a18ca849c',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'm6u6fvnSei3gUVkyHnlviM.png',
			url: 'https://storage.googleapis.com/eezee-product-images/m6u6fvnSei3gUVkyHnlviM.png',
			_id: '5a584a2937f8836a18ca849d',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'Rszchlyeojdo5HkOMobJzr.png',
			url: 'https://storage.googleapis.com/eezee-product-images/Rszchlyeojdo5HkOMobJzr.png',
			_id: '5a584a2e37f8836a18ca849e',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'nrXXQ~bl14dDLzr7Q8K5EV.png',
			url: 'https://storage.googleapis.com/eezee-product-images/nrXXQ~bl14dDLzr7Q8K5EV.png',
			_id: '5a584a3337f8836a18ca8563',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'r21SyjdsjOZWYjZiWCEmeO.png',
			url: 'https://storage.googleapis.com/eezee-product-images/r21SyjdsjOZWYjZiWCEmeO.png',
			_id: '5a584a3937f8836a18ca8564',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'sY71geLI0t1uqT1RpADlmm.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/sY71geLI0t1uqT1RpADlmm.jpg',
			_id: '5a584a3c37f8836a18ca8565',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-17T04:08:50.751Z',
		dateCreated: '2018-01-12T05:53:36.638Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Fasteners',
			sub: 'Screws',
			mainKebabCase: 'fasteners',
			subKebabCase: 'screws'
		}
	}, {
		_id: '5a58517b37f8836a18caad37',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-6-hd-diagonal-cutter-x-plus',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 6\xBC (160mm).</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5749.</p><p class="md-block-unstyled">\u2022 For Soft And Piano Wire.</p><p class="md-block-unstyled">\u2022 Retrotit With ClickSpring (Insert Spring).</p><p class="md-block-unstyled">\u2022 Slim Shape Of Waist For Better Access.</p><p class="md-block-unstyled">\u2022 Optimized Power Joint Save Cutting Force By 20%.</p><p class="md-block-unstyled">\u2022 And Precision Cutting Edges For Hardest And Enduring Use.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3qvqs","text":"\u2022 6\xBC (160mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1d00j","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ap1pf","text":"\u2022 Quality : DIN ISO 5749.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b9t8","text":"\u2022 For Soft And Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a3kff","text":"\u2022 Retrotit With ClickSpring (Insert Spring).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"71q1s","text":"\u2022 Slim Shape Of Waist For Better Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bcqt3","text":"\u2022 Optimized Power Joint Save Cutting Force By 20%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4h331","text":"\u2022 And Precision Cutting Edges For Hardest And Enduring Use.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6hpl3","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"em28s","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"49iqs","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f4dn3","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '133-160-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 6\xBC\u201D HD Diagonal Cutter X \u2013 Plus',
		__v: 0,
		shopNumber: '0563306553',
		sku: '96114c227e',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.19,
			length: 16,
			width: 11,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 43,
			sale: 0,
			po: 'S$43.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'X2SHCU0rYkPWXvIeoWjINQ.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/X2SHCU0rYkPWXvIeoWjINQ.jpg',
			_id: '5a58504837f8836a18caa8d7',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'nCNjH~gVZY9xW0BQRchsEt.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/nCNjH~gVZY9xW0BQRchsEt.jpg',
			_id: '5a58507b37f8836a18caa998',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'gzmO6KIfyNYfsvfv~Qu8zi.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/gzmO6KIfyNYfsvfv~Qu8zi.jpg',
			_id: '5a5850a537f8836a18caaa4b',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-02-26T09:52:49.428Z',
		dateCreated: '2018-01-12T06:11:07.087Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a58518437f8836a18caad5c',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-6-hd-diagonal-cutter-x-plus',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 6\xBC (160mm).</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5749.</p><p class="md-block-unstyled">\u2022 For Soft And Piano Wire.</p><p class="md-block-unstyled">\u2022 Retrotit With ClickSpring (Insert Spring).</p><p class="md-block-unstyled">\u2022 Slim Shape Of Waist For Better Access.</p><p class="md-block-unstyled">\u2022 Optimized Power Joint Save Cutting Force By 20%.</p><p class="md-block-unstyled">\u2022 And Precision Cutting Edges For Hardest And Enduring Use.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3qvqs","text":"\u2022 6\xBC (160mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1d00j","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ap1pf","text":"\u2022 Quality : DIN ISO 5749.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b9t8","text":"\u2022 For Soft And Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a3kff","text":"\u2022 Retrotit With ClickSpring (Insert Spring).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"71q1s","text":"\u2022 Slim Shape Of Waist For Better Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bcqt3","text":"\u2022 Optimized Power Joint Save Cutting Force By 20%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4h331","text":"\u2022 And Precision Cutting Edges For Hardest And Enduring Use.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6hpl3","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"em28s","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"49iqs","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f4dn3","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '133-160-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 6\xBC\u201D HD Diagonal Cutter X \u2013 Plus',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '177c21dbd1',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.19,
			length: 16,
			width: 11,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 43,
			sale: 0,
			po: 'S$43.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'X2SHCU0rYkPWXvIeoWjINQ.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/X2SHCU0rYkPWXvIeoWjINQ.jpg',
			_id: '5a58504837f8836a18caa8d7',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'nCNjH~gVZY9xW0BQRchsEt.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/nCNjH~gVZY9xW0BQRchsEt.jpg',
			_id: '5a58507b37f8836a18caa998',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'gzmO6KIfyNYfsvfv~Qu8zi.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/gzmO6KIfyNYfsvfv~Qu8zi.jpg',
			_id: '5a5850a537f8836a18caaa4b',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-12T06:11:34.124Z',
		dateCreated: '2018-01-12T06:11:16.918Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a58519f37f8836a18caadc6',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-6-hd-diagonal-cutter-x-plus',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 6\xBC (160mm).</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5749.</p><p class="md-block-unstyled">\u2022 For Soft And Piano Wire.</p><p class="md-block-unstyled">\u2022 Retrotit With ClickSpring (Insert Spring).</p><p class="md-block-unstyled">\u2022 Slim Shape Of Waist For Better Access.</p><p class="md-block-unstyled">\u2022 Optimized Power Joint Save Cutting Force By 20%.</p><p class="md-block-unstyled">\u2022 And Precision Cutting Edges For Hardest And Enduring Use.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3qvqs","text":"\u2022 6\xBC (160mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1d00j","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ap1pf","text":"\u2022 Quality : DIN ISO 5749.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b9t8","text":"\u2022 For Soft And Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a3kff","text":"\u2022 Retrotit With ClickSpring (Insert Spring).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"71q1s","text":"\u2022 Slim Shape Of Waist For Better Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bcqt3","text":"\u2022 Optimized Power Joint Save Cutting Force By 20%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4h331","text":"\u2022 And Precision Cutting Edges For Hardest And Enduring Use.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6hpl3","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"em28s","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"49iqs","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f4dn3","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '133-160-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 6\xBC\u201D HD Diagonal Cutter X \u2013 Plus',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '8e4430aa57',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.19,
			length: 16,
			width: 11,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 43,
			sale: 0,
			po: 'S$43.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'X2SHCU0rYkPWXvIeoWjINQ.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/X2SHCU0rYkPWXvIeoWjINQ.jpg',
			_id: '5a58504837f8836a18caa8d7',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'nCNjH~gVZY9xW0BQRchsEt.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/nCNjH~gVZY9xW0BQRchsEt.jpg',
			_id: '5a58507b37f8836a18caa998',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'gzmO6KIfyNYfsvfv~Qu8zi.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/gzmO6KIfyNYfsvfv~Qu8zi.jpg',
			_id: '5a5850a537f8836a18caaa4b',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-12T06:12:03.123Z',
		dateCreated: '2018-01-12T06:11:43.078Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a5851bd37f8836a18caaf04',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-6-hd-diagonal-cutter-x-plus',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 6\xBC (160mm).</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5749.</p><p class="md-block-unstyled">\u2022 For Soft And Piano Wire.</p><p class="md-block-unstyled">\u2022 Retrotit With ClickSpring (Insert Spring).</p><p class="md-block-unstyled">\u2022 Slim Shape Of Waist For Better Access.</p><p class="md-block-unstyled">\u2022 Optimized Power Joint Save Cutting Force By 20%.</p><p class="md-block-unstyled">\u2022 And Precision Cutting Edges For Hardest And Enduring Use.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3qvqs","text":"\u2022 6\xBC (160mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1d00j","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ap1pf","text":"\u2022 Quality : DIN ISO 5749.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b9t8","text":"\u2022 For Soft And Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a3kff","text":"\u2022 Retrotit With ClickSpring (Insert Spring).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"71q1s","text":"\u2022 Slim Shape Of Waist For Better Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bcqt3","text":"\u2022 Optimized Power Joint Save Cutting Force By 20%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4h331","text":"\u2022 And Precision Cutting Edges For Hardest And Enduring Use.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6hpl3","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"em28s","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"49iqs","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f4dn3","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '133-160-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 6\xBC\u201D HD Diagonal Cutter X \u2013 Plus',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '1e6b4d1545',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.19,
			length: 16,
			width: 11,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 43,
			sale: 0,
			po: 'S$43.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'X2SHCU0rYkPWXvIeoWjINQ.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/X2SHCU0rYkPWXvIeoWjINQ.jpg',
			_id: '5a58504837f8836a18caa8d7',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'nCNjH~gVZY9xW0BQRchsEt.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/nCNjH~gVZY9xW0BQRchsEt.jpg',
			_id: '5a58507b37f8836a18caa998',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'gzmO6KIfyNYfsvfv~Qu8zi.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/gzmO6KIfyNYfsvfv~Qu8zi.jpg',
			_id: '5a5850a537f8836a18caaa4b',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-12T06:12:29.292Z',
		dateCreated: '2018-01-12T06:12:13.055Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a58535b37f8836a18cab48e',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-1000-volt-vde-multifunctional-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 7\u201D (180mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Quality : DIN ISO 5743.</strong></p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.</p><p class="md-block-unstyled">\u2022 Save Cutting Force By 25%.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/n_HyQ0V0nPE</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fv6lh","text":"\u2022 7\u201D (180mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7vbsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"2m7mo","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b5m95","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1ug02","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dsa33","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6t8lb","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3vblm","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":25,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"52ff6","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9qhhv","text":"\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b7356","text":"\u2022 Save Cutting Force By 25%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3idis","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"5ku34","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"337ok","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fc8h0","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ejnlt","text":"https://youtu.be/n_HyQ0V0nPE","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '21-185-VDE',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 1000 Volt VDE Multifunctional Diagonal Cutter',
		__v: 0,
		shopNumber: '0563306553',
		sku: '196b145e91',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.27,
			length: 18,
			width: 5.4,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 78,
			sale: 0,
			po: 'S$78.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'pNn4rYz6M_lInuA8590RHw.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/pNn4rYz6M_lInuA8590RHw.jpg',
			_id: '5a58524537f8836a18cab0ef',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: '2aSIzVmJnYgOx4nIY_1gQl.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2aSIzVmJnYgOx4nIY_1gQl.jpg',
			_id: '5a58525737f8836a18cab0f0',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'XqEnt8O3F6CofOF9~lnIG4.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/XqEnt8O3F6CofOF9~lnIG4.jpg',
			_id: '5a58525b37f8836a18cab0f1',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-02-26T09:52:49.429Z',
		dateCreated: '2018-01-12T06:19:07.411Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a58536037f8836a18cab4bb',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-1000-volt-vde-multifunctional-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 7\u201D (180mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Quality : DIN ISO 5743.</strong></p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.</p><p class="md-block-unstyled">\u2022 Save Cutting Force By 25%.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/n_HyQ0V0nPE</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fv6lh","text":"\u2022 7\u201D (180mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7vbsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"2m7mo","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b5m95","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1ug02","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dsa33","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6t8lb","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3vblm","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":25,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"52ff6","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9qhhv","text":"\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b7356","text":"\u2022 Save Cutting Force By 25%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3idis","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"5ku34","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"337ok","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fc8h0","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ejnlt","text":"https://youtu.be/n_HyQ0V0nPE","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '21-185-VDE',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 1000 Volt VDE Multifunctional Diagonal Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '7c589b09a5',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.27,
			length: 18,
			width: 5.4,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 78,
			sale: 0,
			po: 'S$78.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'pNn4rYz6M_lInuA8590RHw.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/pNn4rYz6M_lInuA8590RHw.jpg',
			_id: '5a58524537f8836a18cab0ef',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: '2aSIzVmJnYgOx4nIY_1gQl.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2aSIzVmJnYgOx4nIY_1gQl.jpg',
			_id: '5a58525737f8836a18cab0f0',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'XqEnt8O3F6CofOF9~lnIG4.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/XqEnt8O3F6CofOF9~lnIG4.jpg',
			_id: '5a58525b37f8836a18cab0f1',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-12T06:19:34.931Z',
		dateCreated: '2018-01-12T06:19:12.964Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a58537f37f8836a18cab53d',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-1000-volt-vde-multifunctional-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 7\u201D (180mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Quality : DIN ISO 5743.</strong></p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.</p><p class="md-block-unstyled">\u2022 Save Cutting Force By 25%.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/n_HyQ0V0nPE</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fv6lh","text":"\u2022 7\u201D (180mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7vbsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"2m7mo","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b5m95","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1ug02","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dsa33","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6t8lb","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3vblm","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":25,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"52ff6","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9qhhv","text":"\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b7356","text":"\u2022 Save Cutting Force By 25%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3idis","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"5ku34","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"337ok","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fc8h0","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ejnlt","text":"https://youtu.be/n_HyQ0V0nPE","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '21-185-VDE',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 1000 Volt VDE Multifunctional Diagonal Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'eeac1da7f4',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.27,
			length: 18,
			width: 5.4,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 78,
			sale: 0,
			po: 'S$78.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'pNn4rYz6M_lInuA8590RHw.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/pNn4rYz6M_lInuA8590RHw.jpg',
			_id: '5a58524537f8836a18cab0ef',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: '2aSIzVmJnYgOx4nIY_1gQl.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2aSIzVmJnYgOx4nIY_1gQl.jpg',
			_id: '5a58525737f8836a18cab0f0',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'XqEnt8O3F6CofOF9~lnIG4.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/XqEnt8O3F6CofOF9~lnIG4.jpg',
			_id: '5a58525b37f8836a18cab0f1',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-12T06:19:59.773Z',
		dateCreated: '2018-01-12T06:19:43.157Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a58539837f8836a18cab689',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-1000-volt-vde-multifunctional-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 7\u201D (180mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Quality : DIN ISO 5743.</strong></p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.</p><p class="md-block-unstyled">\u2022 Save Cutting Force By 25%.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/n_HyQ0V0nPE</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fv6lh","text":"\u2022 7\u201D (180mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7vbsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"2m7mo","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b5m95","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1ug02","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dsa33","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6t8lb","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3vblm","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":25,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"52ff6","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9qhhv","text":"\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b7356","text":"\u2022 Save Cutting Force By 25%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3idis","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"5ku34","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"337ok","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fc8h0","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ejnlt","text":"https://youtu.be/n_HyQ0V0nPE","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '21-185-VDE',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 1000 Volt VDE Multifunctional Diagonal Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '5b539ce812',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.27,
			length: 18,
			width: 5.4,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 78,
			sale: 0,
			po: 'S$78.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'pNn4rYz6M_lInuA8590RHw.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/pNn4rYz6M_lInuA8590RHw.jpg',
			_id: '5a58524537f8836a18cab0ef',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: '2aSIzVmJnYgOx4nIY_1gQl.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/2aSIzVmJnYgOx4nIY_1gQl.jpg',
			_id: '5a58525737f8836a18cab0f0',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'XqEnt8O3F6CofOF9~lnIG4.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/XqEnt8O3F6CofOF9~lnIG4.jpg',
			_id: '5a58525b37f8836a18cab0f1',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-12T06:20:26.850Z',
		dateCreated: '2018-01-12T06:20:08.816Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a5853b437f8836a18cab717',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-multifunctional-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 7\u201D (180mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Quality : DIN ISO 5743.</strong></p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.</p><p class="md-block-unstyled">\u2022 Save Cutting Force By 25%.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/n_HyQ0V0nPE</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fv6lh","text":"\u2022 7\u201D (180mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7vbsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"2m7mo","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b5m95","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1ug02","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dsa33","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6t8lb","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3vblm","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":25,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"52ff6","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9qhhv","text":"\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b7356","text":"\u2022 Save Cutting Force By 25%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3idis","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"5ku34","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"337ok","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fc8h0","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ejnlt","text":"https://youtu.be/n_HyQ0V0nPE","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '21-185-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 Multifunctional Diagonal Cutter',
		__v: 1,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '4fd12b44d7',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.27,
			length: 18,
			width: 5.4,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 69,
			sale: 0,
			po: 'S$69.00',
			ps: 'S$0.00'
		},
		images: [{
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a58540037f8836a18cab82d',
			url: 'https://storage.googleapis.com/eezee-product-images/_dgovCuTEWTpbR2SGvYZJ8.jpg',
			fileName: '_dgovCuTEWTpbR2SGvYZJ8.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a58540437f8836a18cab82e',
			url: 'https://storage.googleapis.com/eezee-product-images/EMxf0OQsPD9w3m71CTdXWf.jpg',
			fileName: 'EMxf0OQsPD9w3m71CTdXWf.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a58540c37f8836a18cab8e1',
			url: 'https://storage.googleapis.com/eezee-product-images/dK~T_G8wb7fDq3bBJOrVeO.jpg',
			fileName: 'dK~T_G8wb7fDq3bBJOrVeO.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}],
		dateUpdated: '2018-01-12T06:23:19.118Z',
		dateCreated: '2018-01-12T06:20:36.137Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a58545f37f8836a18cab9c6',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-multifunctional-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 7\u201D (180mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Quality : DIN ISO 5743.</strong></p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.</p><p class="md-block-unstyled">\u2022 Save Cutting Force By 25%.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/n_HyQ0V0nPE</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fv6lh","text":"\u2022 7\u201D (180mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7vbsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"2m7mo","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b5m95","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1ug02","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dsa33","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6t8lb","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3vblm","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":25,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"52ff6","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9qhhv","text":"\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b7356","text":"\u2022 Save Cutting Force By 25%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3idis","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"5ku34","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"337ok","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fc8h0","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ejnlt","text":"https://youtu.be/n_HyQ0V0nPE","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '21-185-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 Multifunctional Diagonal Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'a24b8448f8',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.27,
			length: 18,
			width: 5.4,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 69,
			sale: 0,
			po: 'S$69.00',
			ps: 'S$0.00'
		},
		images: [{
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a58540037f8836a18cab82d',
			url: 'https://storage.googleapis.com/eezee-product-images/_dgovCuTEWTpbR2SGvYZJ8.jpg',
			fileName: '_dgovCuTEWTpbR2SGvYZJ8.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a58540437f8836a18cab82e',
			url: 'https://storage.googleapis.com/eezee-product-images/EMxf0OQsPD9w3m71CTdXWf.jpg',
			fileName: 'EMxf0OQsPD9w3m71CTdXWf.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a58540c37f8836a18cab8e1',
			url: 'https://storage.googleapis.com/eezee-product-images/dK~T_G8wb7fDq3bBJOrVeO.jpg',
			fileName: 'dK~T_G8wb7fDq3bBJOrVeO.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}],
		dateUpdated: '2018-01-12T06:23:49.181Z',
		dateCreated: '2018-01-12T06:23:27.500Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a58547c37f8836a18caba60',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-multifunctional-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 7\u201D (180mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Quality : DIN ISO 5743.</strong></p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.</p><p class="md-block-unstyled">\u2022 Save Cutting Force By 25%.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/n_HyQ0V0nPE</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fv6lh","text":"\u2022 7\u201D (180mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7vbsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"2m7mo","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b5m95","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1ug02","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dsa33","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6t8lb","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3vblm","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":25,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"52ff6","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9qhhv","text":"\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b7356","text":"\u2022 Save Cutting Force By 25%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3idis","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"5ku34","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"337ok","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fc8h0","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ejnlt","text":"https://youtu.be/n_HyQ0V0nPE","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '21-185-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 Multifunctional Diagonal Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'ddf3e5338b',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.27,
			length: 18,
			width: 5.4,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 69,
			sale: 0,
			po: 'S$69.00',
			ps: 'S$0.00'
		},
		images: [{
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a58540037f8836a18cab82d',
			url: 'https://storage.googleapis.com/eezee-product-images/_dgovCuTEWTpbR2SGvYZJ8.jpg',
			fileName: '_dgovCuTEWTpbR2SGvYZJ8.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a58540437f8836a18cab82e',
			url: 'https://storage.googleapis.com/eezee-product-images/EMxf0OQsPD9w3m71CTdXWf.jpg',
			fileName: 'EMxf0OQsPD9w3m71CTdXWf.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a58540c37f8836a18cab8e1',
			url: 'https://storage.googleapis.com/eezee-product-images/dK~T_G8wb7fDq3bBJOrVeO.jpg',
			fileName: 'dK~T_G8wb7fDq3bBJOrVeO.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}],
		dateUpdated: '2018-01-12T06:24:09.481Z',
		dateCreated: '2018-01-12T06:23:56.478Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a58549337f8836a18cabbb2',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-multifunctional-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 7\u201D (180mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Quality : DIN ISO 5743.</strong></p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.</p><p class="md-block-unstyled">\u2022 Save Cutting Force By 25%.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/n_HyQ0V0nPE</p>',
		description: '{"entityMap":{},"blocks":[{"key":"bu52i","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fv6lh","text":"\u2022 7\u201D (180mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7vbsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"2m7mo","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b5m95","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1ug02","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dsa33","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6t8lb","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3vblm","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":25,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"52ff6","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9qhhv","text":"\u2022 Universal Tool For Electrical Wiring : Cutting, Stripping, Shearing, Crimping And Bending of Loops.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b7356","text":"\u2022 Save Cutting Force By 25%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3idis","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"5ku34","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"337ok","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fc8h0","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ejnlt","text":"https://youtu.be/n_HyQ0V0nPE","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '21-185-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 Multifunctional Diagonal Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '4c0c19ec53',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.27,
			length: 18,
			width: 5.4,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 69,
			sale: 0,
			po: 'S$69.00',
			ps: 'S$0.00'
		},
		images: [{
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a58540037f8836a18cab82d',
			url: 'https://storage.googleapis.com/eezee-product-images/_dgovCuTEWTpbR2SGvYZJ8.jpg',
			fileName: '_dgovCuTEWTpbR2SGvYZJ8.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a58540437f8836a18cab82e',
			url: 'https://storage.googleapis.com/eezee-product-images/EMxf0OQsPD9w3m71CTdXWf.jpg',
			fileName: 'EMxf0OQsPD9w3m71CTdXWf.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a58540c37f8836a18cab8e1',
			url: 'https://storage.googleapis.com/eezee-product-images/dK~T_G8wb7fDq3bBJOrVeO.jpg',
			fileName: 'dK~T_G8wb7fDq3bBJOrVeO.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}],
		dateUpdated: '2018-01-12T06:24:35.730Z',
		dateCreated: '2018-01-12T06:24:19.767Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a5c1e0337f8836a18d56f19',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-cable-shear',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 180mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Fine Cutting Edge For Clean And Smooth Cutting of Copper And Aluminium Cables.</p><p class="md-block-unstyled">\u2022 Not For Hard Drawn Copper Conductors or Steel Wire.</p><p class="md-block-unstyled">\u2022 Ground, Bolted Precison Joint, Re-Adjustable.</p><p class="md-block-unstyled">\u2022 One Hand Operation With Integrated Spring And Catch.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 \xD8 18mm/50mm\xB2.</p><p class="md-block-unstyled">https://youtu.be/0iQr6WLVM7E</p>',
		description: '{"entityMap":{},"blocks":[{"key":"ebmfd","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"im62","text":"\u2022 Length : 180mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1ncdf","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8c7ak","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a3i8n","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aitq8","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3uo36","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bqooi","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8slak","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bhegh","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"314gm","text":"\u2022 Fine Cutting Edge For Clean And Smooth Cutting of Copper And Aluminium Cables.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7n9g","text":"\u2022 Not For Hard Drawn Copper Conductors or Steel Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"66lhi","text":"\u2022 Ground, Bolted Precison Joint, Re-Adjustable.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"32r2q","text":"\u2022 One Hand Operation With Integrated Spring And Catch.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6i89j","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"d72nk","text":"\u2022 \xD8 18mm/50mm\xB2.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2scs2","text":"https://youtu.be/0iQr6WLVM7E","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '47-180-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 Cable Shear',
		__v: 0,
		shopNumber: '0563306553',
		sku: '02518ee58d',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.305,
			length: 18,
			width: 6.4,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 69,
			sale: 0,
			po: 'S$69.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'TzIckeC~lV~uqI4BZbxbMP.png',
			url: 'https://storage.googleapis.com/eezee-product-images/TzIckeC~lV~uqI4BZbxbMP.png',
			_id: '5a5c1c9837f8836a18d5510d',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'LP0aJ22Ifm4wnO3Dpxz5sG.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/LP0aJ22Ifm4wnO3Dpxz5sG.jpg',
			_id: '5a5c1cae37f8836a18d55110',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'esTckGHv5ixpBouXBZm62j.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/esTckGHv5ixpBouXBZm62j.jpg',
			_id: '5a5c1cb537f8836a18d551da',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-02-26T09:52:49.441Z',
		dateCreated: '2018-01-15T03:20:35.413Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a5c1e0a37f8836a18d56f57',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-cable-shear',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 180mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Fine Cutting Edge For Clean And Smooth Cutting of Copper And Aluminium Cables.</p><p class="md-block-unstyled">\u2022 Not For Hard Drawn Copper Conductors or Steel Wire.</p><p class="md-block-unstyled">\u2022 Ground, Bolted Precison Joint, Re-Adjustable.</p><p class="md-block-unstyled">\u2022 One Hand Operation With Integrated Spring And Catch.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 \xD8 18mm/50mm\xB2.</p><p class="md-block-unstyled">https://youtu.be/0iQr6WLVM7E</p>',
		description: '{"entityMap":{},"blocks":[{"key":"ebmfd","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"im62","text":"\u2022 Length : 180mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1ncdf","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8c7ak","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a3i8n","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aitq8","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3uo36","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bqooi","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8slak","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bhegh","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"314gm","text":"\u2022 Fine Cutting Edge For Clean And Smooth Cutting of Copper And Aluminium Cables.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7n9g","text":"\u2022 Not For Hard Drawn Copper Conductors or Steel Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"66lhi","text":"\u2022 Ground, Bolted Precison Joint, Re-Adjustable.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"32r2q","text":"\u2022 One Hand Operation With Integrated Spring And Catch.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6i89j","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"d72nk","text":"\u2022 \xD8 18mm/50mm\xB2.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2scs2","text":"https://youtu.be/0iQr6WLVM7E","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '47-180-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 Cable Shear',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'fc7203efe3',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.305,
			length: 18,
			width: 6.4,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 69,
			sale: 0,
			po: 'S$69.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'TzIckeC~lV~uqI4BZbxbMP.png',
			url: 'https://storage.googleapis.com/eezee-product-images/TzIckeC~lV~uqI4BZbxbMP.png',
			_id: '5a5c1c9837f8836a18d5510d',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'LP0aJ22Ifm4wnO3Dpxz5sG.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/LP0aJ22Ifm4wnO3Dpxz5sG.jpg',
			_id: '5a5c1cae37f8836a18d55110',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'esTckGHv5ixpBouXBZm62j.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/esTckGHv5ixpBouXBZm62j.jpg',
			_id: '5a5c1cb537f8836a18d551da',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:21:00.637Z',
		dateCreated: '2018-01-15T03:20:42.329Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a5c1e2637f8836a18d570bd',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-cable-shear',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 180mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Fine Cutting Edge For Clean And Smooth Cutting of Copper And Aluminium Cables.</p><p class="md-block-unstyled">\u2022 Not For Hard Drawn Copper Conductors or Steel Wire.</p><p class="md-block-unstyled">\u2022 Ground, Bolted Precison Joint, Re-Adjustable.</p><p class="md-block-unstyled">\u2022 One Hand Operation With Integrated Spring And Catch.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 \xD8 18mm/50mm\xB2.</p><p class="md-block-unstyled">https://youtu.be/0iQr6WLVM7E</p>',
		description: '{"entityMap":{},"blocks":[{"key":"ebmfd","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"im62","text":"\u2022 Length : 180mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1ncdf","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8c7ak","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a3i8n","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aitq8","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3uo36","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bqooi","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8slak","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bhegh","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"314gm","text":"\u2022 Fine Cutting Edge For Clean And Smooth Cutting of Copper And Aluminium Cables.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7n9g","text":"\u2022 Not For Hard Drawn Copper Conductors or Steel Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"66lhi","text":"\u2022 Ground, Bolted Precison Joint, Re-Adjustable.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"32r2q","text":"\u2022 One Hand Operation With Integrated Spring And Catch.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6i89j","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"d72nk","text":"\u2022 \xD8 18mm/50mm\xB2.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2scs2","text":"https://youtu.be/0iQr6WLVM7E","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '47-180-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 Cable Shear',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'a910914e74',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.305,
			length: 18,
			width: 6.4,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 69,
			sale: 0,
			po: 'S$69.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'TzIckeC~lV~uqI4BZbxbMP.png',
			url: 'https://storage.googleapis.com/eezee-product-images/TzIckeC~lV~uqI4BZbxbMP.png',
			_id: '5a5c1c9837f8836a18d5510d',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'LP0aJ22Ifm4wnO3Dpxz5sG.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/LP0aJ22Ifm4wnO3Dpxz5sG.jpg',
			_id: '5a5c1cae37f8836a18d55110',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'esTckGHv5ixpBouXBZm62j.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/esTckGHv5ixpBouXBZm62j.jpg',
			_id: '5a5c1cb537f8836a18d551da',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:21:24.804Z',
		dateCreated: '2018-01-15T03:21:10.417Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a5c1e3b37f8836a18d57175',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-cable-shear',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 180mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Fine Cutting Edge For Clean And Smooth Cutting of Copper And Aluminium Cables.</p><p class="md-block-unstyled">\u2022 Not For Hard Drawn Copper Conductors or Steel Wire.</p><p class="md-block-unstyled">\u2022 Ground, Bolted Precison Joint, Re-Adjustable.</p><p class="md-block-unstyled">\u2022 One Hand Operation With Integrated Spring And Catch.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 \xD8 18mm/50mm\xB2.</p><p class="md-block-unstyled">https://youtu.be/0iQr6WLVM7E</p>',
		description: '{"entityMap":{},"blocks":[{"key":"ebmfd","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"im62","text":"\u2022 Length : 180mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1ncdf","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8c7ak","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a3i8n","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aitq8","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"3uo36","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bqooi","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8slak","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bhegh","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"314gm","text":"\u2022 Fine Cutting Edge For Clean And Smooth Cutting of Copper And Aluminium Cables.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7n9g","text":"\u2022 Not For Hard Drawn Copper Conductors or Steel Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"66lhi","text":"\u2022 Ground, Bolted Precison Joint, Re-Adjustable.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"32r2q","text":"\u2022 One Hand Operation With Integrated Spring And Catch.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6i89j","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"d72nk","text":"\u2022 \xD8 18mm/50mm\xB2.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2scs2","text":"https://youtu.be/0iQr6WLVM7E","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '47-180-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 Cable Shear',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '74ae6a4307',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.305,
			length: 18,
			width: 6.4,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 69,
			sale: 0,
			po: 'S$69.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'TzIckeC~lV~uqI4BZbxbMP.png',
			url: 'https://storage.googleapis.com/eezee-product-images/TzIckeC~lV~uqI4BZbxbMP.png',
			_id: '5a5c1c9837f8836a18d5510d',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'LP0aJ22Ifm4wnO3Dpxz5sG.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/LP0aJ22Ifm4wnO3Dpxz5sG.jpg',
			_id: '5a5c1cae37f8836a18d55110',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'esTckGHv5ixpBouXBZm62j.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/esTckGHv5ixpBouXBZm62j.jpg',
			_id: '5a5c1cb537f8836a18d551da',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:21:46.699Z',
		dateCreated: '2018-01-15T03:21:31.315Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a5c20c437f8836a18d57bb0',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-hd-diagonal-cutter-piano',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 180mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5749.</p><p class="md-block-unstyled">\u2022 For Soft And Piano Wire.</p><p class="md-block-unstyled">\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"5oin8","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"35kef","text":"\u2022 Length : 180mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aqbgg","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2tber","text":"\u2022 Quality : DIN ISO 5749.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4q3mn","text":"\u2022 For Soft And Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"75ilo","text":"\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5ddg1","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"1kg25","text":"\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8ofgq","text":"\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"egl70","text":"\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '33-180-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 HD Diagonal Cutter \u2013 Piano',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'e9888bc3d1',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.26,
			length: 18,
			width: 5.6,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 43,
			sale: 0,
			po: 'S$43.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'iJu5G3GWgCApExV6SDic_V.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/iJu5G3GWgCApExV6SDic_V.jpg',
			_id: '5a5c1fe437f8836a18d578af',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'fzwVWj~8VaBTqQ80wTVOeH.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/fzwVWj~8VaBTqQ80wTVOeH.jpg',
			_id: '5a5c1ff137f8836a18d578b0',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'PrRXwZQOW~1smJJyA8ZvRI.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/PrRXwZQOW~1smJJyA8ZvRI.jpg',
			_id: '5a5c201137f8836a18d57987',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:42:35.044Z',
		dateCreated: '2018-01-15T03:32:20.946Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a5c20cb37f8836a18d57bf5',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-hd-diagonal-cutter-piano',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 180mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5749.</p><p class="md-block-unstyled">\u2022 For Soft And Piano Wire.</p><p class="md-block-unstyled">\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"5oin8","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"35kef","text":"\u2022 Length : 180mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aqbgg","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2tber","text":"\u2022 Quality : DIN ISO 5749.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4q3mn","text":"\u2022 For Soft And Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"75ilo","text":"\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5ddg1","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"1kg25","text":"\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8ofgq","text":"\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"egl70","text":"\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '33-180-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 HD Diagonal Cutter \u2013 Piano',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'c9735ee7d4',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.26,
			length: 18,
			width: 5.6,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 43,
			sale: 0,
			po: 'S$43.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'iJu5G3GWgCApExV6SDic_V.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/iJu5G3GWgCApExV6SDic_V.jpg',
			_id: '5a5c1fe437f8836a18d578af',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'fzwVWj~8VaBTqQ80wTVOeH.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/fzwVWj~8VaBTqQ80wTVOeH.jpg',
			_id: '5a5c1ff137f8836a18d578b0',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'PrRXwZQOW~1smJJyA8ZvRI.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/PrRXwZQOW~1smJJyA8ZvRI.jpg',
			_id: '5a5c201137f8836a18d57987',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:42:13.401Z',
		dateCreated: '2018-01-15T03:32:27.481Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a5c20e437f8836a18d57cbf',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-hd-diagonal-cutter-piano',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 180mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5749.</p><p class="md-block-unstyled">\u2022 For Soft And Piano Wire.</p><p class="md-block-unstyled">\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"5oin8","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"35kef","text":"\u2022 Length : 180mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aqbgg","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2tber","text":"\u2022 Quality : DIN ISO 5749.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4q3mn","text":"\u2022 For Soft And Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"75ilo","text":"\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5ddg1","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"1kg25","text":"\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8ofgq","text":"\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"egl70","text":"\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '33-180-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 HD Diagonal Cutter \u2013 Piano',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '6cdcd1a295',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.26,
			length: 18,
			width: 5.6,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 43,
			sale: 0,
			po: 'S$43.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'iJu5G3GWgCApExV6SDic_V.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/iJu5G3GWgCApExV6SDic_V.jpg',
			_id: '5a5c1fe437f8836a18d578af',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'fzwVWj~8VaBTqQ80wTVOeH.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/fzwVWj~8VaBTqQ80wTVOeH.jpg',
			_id: '5a5c1ff137f8836a18d578b0',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'PrRXwZQOW~1smJJyA8ZvRI.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/PrRXwZQOW~1smJJyA8ZvRI.jpg',
			_id: '5a5c201137f8836a18d57987',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:41:51.424Z',
		dateCreated: '2018-01-15T03:32:52.118Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a5c210337f8836a18d57e63',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-hd-diagonal-cutter-piano',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 180mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5749.</p><p class="md-block-unstyled">\u2022 For Soft And Piano Wire.</p><p class="md-block-unstyled">\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"5oin8","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"35kef","text":"\u2022 Length : 180mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aqbgg","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2tber","text":"\u2022 Quality : DIN ISO 5749.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4q3mn","text":"\u2022 For Soft And Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"75ilo","text":"\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5ddg1","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"1kg25","text":"\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8ofgq","text":"\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"egl70","text":"\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '33-180-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\u2033 HD Diagonal Cutter \u2013 Piano',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'f6adea7559',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.26,
			length: 18,
			width: 5.6,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 43,
			sale: 0,
			po: 'S$43.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'iJu5G3GWgCApExV6SDic_V.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/iJu5G3GWgCApExV6SDic_V.jpg',
			_id: '5a5c1fe437f8836a18d578af',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'fzwVWj~8VaBTqQ80wTVOeH.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/fzwVWj~8VaBTqQ80wTVOeH.jpg',
			_id: '5a5c1ff137f8836a18d578b0',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'PrRXwZQOW~1smJJyA8ZvRI.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/PrRXwZQOW~1smJJyA8ZvRI.jpg',
			_id: '5a5c201137f8836a18d57987',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:41:26.540Z',
		dateCreated: '2018-01-15T03:33:23.022Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a5c226537f8836a18d58389',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-hd-combination-pliers',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 7\xBD\u201D (190mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Knurled Jaws With Extra Long Cutting Edge And 4-Point Vice-Grip Pipe Hole.</p><p class="md-block-unstyled">\u2022 Rounded Back For Easy Access And Levering.</p><p class="md-block-unstyled">\u2022 Saves Cutting Force By 40%</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/BPL2bvDgz78</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2016/04/tool3.jpg" target="_blank" rel="noopener noreferrer"> </a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2016/04/tool3.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2016/04/tool3.jpg"}}},"blocks":[{"key":"5oin8","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4geuh","text":"\u2022 7\xBD\u201D (190mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"48c0a","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"5gm54","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8jfl6","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7dljp","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"17b0r","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"20q6o","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8fcp4","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"c71bv","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"c5022","text":"\u2022 Knurled Jaws With Extra Long Cutting Edge And 4-Point Vice-Grip Pipe Hole.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fkdub","text":"\u2022 Rounded Back For Easy Access And Levering.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b856g","text":"\u2022 Saves Cutting Force By 40%","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"57dlb","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"4hiop","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"75vgn","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"44n5e","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a7j78","text":"https://youtu.be/BPL2bvDgz78","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"72e4e","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":1,"key":0}],"data":{}}]}',
		model: '21-410-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\xBD\u201D HD Combination Pliers',
		__v: 0,
		shopNumber: '0563306553',
		sku: '95031944dd',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.295,
			length: 19,
			width: 6,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 56,
			sale: 0,
			po: 'S$56.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'G52TMxvD_w2ax4Opbk_37X.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/G52TMxvD_w2ax4Opbk_37X.jpg',
			_id: '5a5c21de37f8836a18d58223',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'sgLAYxlQ6x58FV3xRr~Vcd.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/sgLAYxlQ6x58FV3xRr~Vcd.jpg',
			_id: '5a5c21e937f8836a18d58224',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-02-26T09:52:49.443Z',
		dateCreated: '2018-01-15T03:39:17.462Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a5c226b37f8836a18d583d6',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-hd-combination-pliers',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 7\xBD\u201D (190mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Knurled Jaws With Extra Long Cutting Edge And 4-Point Vice-Grip Pipe Hole.</p><p class="md-block-unstyled">\u2022 Rounded Back For Easy Access And Levering.</p><p class="md-block-unstyled">\u2022 Saves Cutting Force By 40%</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/BPL2bvDgz78</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2016/04/tool3.jpg" target="_blank" rel="noopener noreferrer"> </a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2016/04/tool3.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2016/04/tool3.jpg"}}},"blocks":[{"key":"5oin8","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4geuh","text":"\u2022 7\xBD\u201D (190mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"48c0a","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"5gm54","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8jfl6","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7dljp","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"17b0r","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"20q6o","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8fcp4","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"c71bv","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"c5022","text":"\u2022 Knurled Jaws With Extra Long Cutting Edge And 4-Point Vice-Grip Pipe Hole.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fkdub","text":"\u2022 Rounded Back For Easy Access And Levering.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b856g","text":"\u2022 Saves Cutting Force By 40%","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"57dlb","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"4hiop","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"75vgn","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"44n5e","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a7j78","text":"https://youtu.be/BPL2bvDgz78","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"72e4e","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":1,"key":0}],"data":{}}]}',
		model: '21-410-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\xBD\u201D HD Combination Pliers',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '5931cd4a4c',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.295,
			length: 19,
			width: 6,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 56,
			sale: 0,
			po: 'S$56.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'G52TMxvD_w2ax4Opbk_37X.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/G52TMxvD_w2ax4Opbk_37X.jpg',
			_id: '5a5c21de37f8836a18d58223',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'sgLAYxlQ6x58FV3xRr~Vcd.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/sgLAYxlQ6x58FV3xRr~Vcd.jpg',
			_id: '5a5c21e937f8836a18d58224',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:39:38.543Z',
		dateCreated: '2018-01-15T03:39:23.354Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a5c228137f8836a18d584b8',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-hd-combination-pliers',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 7\xBD\u201D (190mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Knurled Jaws With Extra Long Cutting Edge And 4-Point Vice-Grip Pipe Hole.</p><p class="md-block-unstyled">\u2022 Rounded Back For Easy Access And Levering.</p><p class="md-block-unstyled">\u2022 Saves Cutting Force By 40%</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/BPL2bvDgz78</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2016/04/tool3.jpg" target="_blank" rel="noopener noreferrer"> </a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2016/04/tool3.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2016/04/tool3.jpg"}}},"blocks":[{"key":"5oin8","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4geuh","text":"\u2022 7\xBD\u201D (190mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"48c0a","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"5gm54","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8jfl6","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7dljp","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"17b0r","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"20q6o","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8fcp4","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"c71bv","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"c5022","text":"\u2022 Knurled Jaws With Extra Long Cutting Edge And 4-Point Vice-Grip Pipe Hole.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fkdub","text":"\u2022 Rounded Back For Easy Access And Levering.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b856g","text":"\u2022 Saves Cutting Force By 40%","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"57dlb","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"4hiop","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"75vgn","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"44n5e","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a7j78","text":"https://youtu.be/BPL2bvDgz78","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"72e4e","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":1,"key":0}],"data":{}}]}',
		model: '21-410-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\xBD\u201D HD Combination Pliers',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '41c9019822',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.295,
			length: 19,
			width: 6,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 56,
			sale: 0,
			po: 'S$56.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'G52TMxvD_w2ax4Opbk_37X.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/G52TMxvD_w2ax4Opbk_37X.jpg',
			_id: '5a5c21de37f8836a18d58223',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'sgLAYxlQ6x58FV3xRr~Vcd.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/sgLAYxlQ6x58FV3xRr~Vcd.jpg',
			_id: '5a5c21e937f8836a18d58224',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:39:59.215Z',
		dateCreated: '2018-01-15T03:39:45.296Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a5c229937f8836a18d58664',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-hd-combination-pliers',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 7\xBD\u201D (190mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Knurled Jaws With Extra Long Cutting Edge And 4-Point Vice-Grip Pipe Hole.</p><p class="md-block-unstyled">\u2022 Rounded Back For Easy Access And Levering.</p><p class="md-block-unstyled">\u2022 Saves Cutting Force By 40%</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/BPL2bvDgz78</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2016/04/tool3.jpg" target="_blank" rel="noopener noreferrer"> </a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2016/04/tool3.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2016/04/tool3.jpg"}}},"blocks":[{"key":"5oin8","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4geuh","text":"\u2022 7\xBD\u201D (190mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"48c0a","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"5gm54","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8jfl6","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7dljp","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"17b0r","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"20q6o","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8fcp4","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"c71bv","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"c5022","text":"\u2022 Knurled Jaws With Extra Long Cutting Edge And 4-Point Vice-Grip Pipe Hole.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fkdub","text":"\u2022 Rounded Back For Easy Access And Levering.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"b856g","text":"\u2022 Saves Cutting Force By 40%","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"57dlb","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"4hiop","text":"\u2022 3.5mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"75vgn","text":"\u2022 2.5mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"44n5e","text":"\u2022 2.0mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a7j78","text":"https://youtu.be/BPL2bvDgz78","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"72e4e","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":1,"key":0}],"data":{}}]}',
		model: '21-410-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\xBD\u201D HD Combination Pliers',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '78d63c1488',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.295,
			length: 19,
			width: 6,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 56,
			sale: 0,
			po: 'S$56.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'G52TMxvD_w2ax4Opbk_37X.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/G52TMxvD_w2ax4Opbk_37X.jpg',
			_id: '5a5c21de37f8836a18d58223',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'sgLAYxlQ6x58FV3xRr~Vcd.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/sgLAYxlQ6x58FV3xRr~Vcd.jpg',
			_id: '5a5c21e937f8836a18d58224',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:40:24.067Z',
		dateCreated: '2018-01-15T03:40:09.635Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a5c24e937f8836a18d59332',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-wire-rope-shear',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 190mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Extra Durable Cutting Edge For Clean And Smooth Cutting Hard Wire Rope And Wire.</p><p class="md-block-unstyled">\u2022 Grinded, Bolted Precison Joint, Re-Adjustable.</p><p class="md-block-unstyled">\u2022 One Hand Operation With Integrated Spring And Catch.</p><p class="md-block-unstyled">\u2022 The Blades Clasp Around The Wire Rope In a Vshape And Shear It With a Clear Cut.</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/222.jpg" target="_blank" rel="noopener noreferrer"> https://youtu.be/dvjKT1iPJko</a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/222.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/222.jpg"}}},"blocks":[{"key":"5oin8","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1hia8","text":"\u2022 Length : 190mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2npqt","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7o4ig","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"jivm","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4l1oe","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"95qvk","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e2qd4","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1dubs","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aa446","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"59qa9","text":"\u2022 Extra Durable Cutting Edge For Clean And Smooth Cutting Hard Wire Rope And Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2q6nq","text":"\u2022 Grinded, Bolted Precison Joint, Re-Adjustable.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5i6gr","text":"\u2022 One Hand Operation With Integrated Spring And Catch.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a5uui","text":"\u2022 The Blades Clasp Around The Wire Rope In a Vshape And Shear It With a Clear Cut.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ahruv","text":" https://youtu.be/dvjKT1iPJko","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":29,"key":0}],"data":{}}]}',
		model: '97-519-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\xBD\u201D Wire Rope Shear',
		__v: 0,
		shopNumber: '0563306553',
		sku: '3fcfc40848',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.36,
			length: 19,
			width: 7,
			height: 3.1
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 76,
			sale: 0,
			po: 'S$76.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'Psu~E85W7P6yoxqRw1rpS_.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/Psu~E85W7P6yoxqRw1rpS_.jpg',
			_id: '5a5c23f937f8836a18d59044',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'awjyjaCco6gqLPG6dwvOuy.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/awjyjaCco6gqLPG6dwvOuy.jpg',
			_id: '5a5c240437f8836a18d59045',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'FHvKkSyjyaxkQVVTp2itiz.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/FHvKkSyjyaxkQVVTp2itiz.jpg',
			_id: '5a5c240937f8836a18d59046',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-02-26T09:52:49.444Z',
		dateCreated: '2018-01-15T03:50:01.949Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a5c24f037f8836a18d59387',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-wire-rope-shear',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 190mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Extra Durable Cutting Edge For Clean And Smooth Cutting Hard Wire Rope And Wire.</p><p class="md-block-unstyled">\u2022 Grinded, Bolted Precison Joint, Re-Adjustable.</p><p class="md-block-unstyled">\u2022 One Hand Operation With Integrated Spring And Catch.</p><p class="md-block-unstyled">\u2022 The Blades Clasp Around The Wire Rope In a Vshape And Shear It With a Clear Cut.</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/222.jpg" target="_blank" rel="noopener noreferrer"> https://youtu.be/dvjKT1iPJko</a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/222.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/222.jpg"}}},"blocks":[{"key":"5oin8","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1hia8","text":"\u2022 Length : 190mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2npqt","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7o4ig","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"jivm","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4l1oe","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"95qvk","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e2qd4","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1dubs","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aa446","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"59qa9","text":"\u2022 Extra Durable Cutting Edge For Clean And Smooth Cutting Hard Wire Rope And Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2q6nq","text":"\u2022 Grinded, Bolted Precison Joint, Re-Adjustable.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5i6gr","text":"\u2022 One Hand Operation With Integrated Spring And Catch.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a5uui","text":"\u2022 The Blades Clasp Around The Wire Rope In a Vshape And Shear It With a Clear Cut.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ahruv","text":" https://youtu.be/dvjKT1iPJko","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":29,"key":0}],"data":{}}]}',
		model: '97-519-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\xBD\u201D Wire Rope Shear',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'ba16728099',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.36,
			length: 19,
			width: 7,
			height: 3.1
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 76,
			sale: 0,
			po: 'S$76.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'Psu~E85W7P6yoxqRw1rpS_.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/Psu~E85W7P6yoxqRw1rpS_.jpg',
			_id: '5a5c23f937f8836a18d59044',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'awjyjaCco6gqLPG6dwvOuy.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/awjyjaCco6gqLPG6dwvOuy.jpg',
			_id: '5a5c240437f8836a18d59045',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'FHvKkSyjyaxkQVVTp2itiz.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/FHvKkSyjyaxkQVVTp2itiz.jpg',
			_id: '5a5c240937f8836a18d59046',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:50:24.451Z',
		dateCreated: '2018-01-15T03:50:08.886Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a5c250637f8836a18d59481',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-wire-rope-shear',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 190mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Extra Durable Cutting Edge For Clean And Smooth Cutting Hard Wire Rope And Wire.</p><p class="md-block-unstyled">\u2022 Grinded, Bolted Precison Joint, Re-Adjustable.</p><p class="md-block-unstyled">\u2022 One Hand Operation With Integrated Spring And Catch.</p><p class="md-block-unstyled">\u2022 The Blades Clasp Around The Wire Rope In a Vshape And Shear It With a Clear Cut.</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/222.jpg" target="_blank" rel="noopener noreferrer"> https://youtu.be/dvjKT1iPJko</a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/222.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/222.jpg"}}},"blocks":[{"key":"5oin8","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1hia8","text":"\u2022 Length : 190mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2npqt","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7o4ig","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"jivm","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4l1oe","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"95qvk","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e2qd4","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1dubs","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aa446","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"59qa9","text":"\u2022 Extra Durable Cutting Edge For Clean And Smooth Cutting Hard Wire Rope And Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2q6nq","text":"\u2022 Grinded, Bolted Precison Joint, Re-Adjustable.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5i6gr","text":"\u2022 One Hand Operation With Integrated Spring And Catch.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a5uui","text":"\u2022 The Blades Clasp Around The Wire Rope In a Vshape And Shear It With a Clear Cut.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ahruv","text":" https://youtu.be/dvjKT1iPJko","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":29,"key":0}],"data":{}}]}',
		model: '97-519-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\xBD\u201D Wire Rope Shear',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '81b181731e',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.36,
			length: 19,
			width: 7,
			height: 3.1
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 76,
			sale: 0,
			po: 'S$76.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'Psu~E85W7P6yoxqRw1rpS_.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/Psu~E85W7P6yoxqRw1rpS_.jpg',
			_id: '5a5c23f937f8836a18d59044',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'awjyjaCco6gqLPG6dwvOuy.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/awjyjaCco6gqLPG6dwvOuy.jpg',
			_id: '5a5c240437f8836a18d59045',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'FHvKkSyjyaxkQVVTp2itiz.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/FHvKkSyjyaxkQVVTp2itiz.jpg',
			_id: '5a5c240937f8836a18d59046',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:50:47.285Z',
		dateCreated: '2018-01-15T03:50:30.654Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a5c251e37f8836a18d59581',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-7-wire-rope-shear',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 190mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Extra Durable Cutting Edge For Clean And Smooth Cutting Hard Wire Rope And Wire.</p><p class="md-block-unstyled">\u2022 Grinded, Bolted Precison Joint, Re-Adjustable.</p><p class="md-block-unstyled">\u2022 One Hand Operation With Integrated Spring And Catch.</p><p class="md-block-unstyled">\u2022 The Blades Clasp Around The Wire Rope In a Vshape And Shear It With a Clear Cut.</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/222.jpg" target="_blank" rel="noopener noreferrer">https://youtu.be/dvjKT1iPJko</a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/222.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/222.jpg"}}},"blocks":[{"key":"5oin8","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1hia8","text":"\u2022 Length : 190mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2npqt","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7o4ig","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"jivm","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4l1oe","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"95qvk","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e2qd4","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1dubs","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aa446","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"59qa9","text":"\u2022 Extra Durable Cutting Edge For Clean And Smooth Cutting Hard Wire Rope And Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2q6nq","text":"\u2022 Grinded, Bolted Precison Joint, Re-Adjustable.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5i6gr","text":"\u2022 One Hand Operation With Integrated Spring And Catch.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a5uui","text":"\u2022 The Blades Clasp Around The Wire Rope In a Vshape And Shear It With a Clear Cut.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ahruv","text":"https://youtu.be/dvjKT1iPJko","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":28,"key":0}],"data":{}}]}',
		model: '97-519-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 7\xBD\u201D Wire Rope Shear',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '3ad93f3a20',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.36,
			length: 19,
			width: 7,
			height: 3.1
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 76,
			sale: 0,
			po: 'S$76.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'Psu~E85W7P6yoxqRw1rpS_.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/Psu~E85W7P6yoxqRw1rpS_.jpg',
			_id: '5a5c23f937f8836a18d59044',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'awjyjaCco6gqLPG6dwvOuy.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/awjyjaCco6gqLPG6dwvOuy.jpg',
			_id: '5a5c240437f8836a18d59045',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'FHvKkSyjyaxkQVVTp2itiz.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/FHvKkSyjyaxkQVVTp2itiz.jpg',
			_id: '5a5c240937f8836a18d59046',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-15T03:58:51.689Z',
		dateCreated: '2018-01-15T03:50:54.494Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a5d80aa37f8836a18da4d56',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-8-radio-telephone-pliers-40-\u2070',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 200mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5749.</p><p class="md-block-unstyled">\u2022 For Soft And Piano Wire.</p><p class="md-block-unstyled">\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dpth9","text":"\u2022 Length : 200mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"25jts","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ehrlb","text":"\u2022 Quality : DIN ISO 5749.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"eld4h","text":"\u2022 For Soft And Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7t9ne","text":"\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8su9g","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"3kf3h","text":"\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"189o1","text":"\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4l7k2","text":"\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: ' 17-200-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 8\u2033 Radio \u2013 / Telephone Pliers 40\u2070',
		__v: 0,
		shopNumber: '0563306553',
		sku: '0552c9567d',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.19,
			length: 20,
			width: 5.3,
			height: 2.8
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 40,
			sale: 0,
			po: 'S$40.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'wJQkbRAwlhJuyrgDKzszt4.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/wJQkbRAwlhJuyrgDKzszt4.jpg',
			_id: '5a5d7ff737f8836a18da499a',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'k_Om15ZI4GsFhTCyps8u1u.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/k_Om15ZI4GsFhTCyps8u1u.jpg',
			_id: '5a5d800237f8836a18da49de',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-02-26T09:52:49.446Z',
		dateCreated: '2018-01-16T04:33:46.874Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a5d80b437f8836a18da4db3',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-8-radio-telephone-pliers-40-\u2070',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 200mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5749.</p><p class="md-block-unstyled">\u2022 For Soft And Piano Wire.</p><p class="md-block-unstyled">\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dpth9","text":"\u2022 Length : 200mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"25jts","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ehrlb","text":"\u2022 Quality : DIN ISO 5749.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"eld4h","text":"\u2022 For Soft And Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7t9ne","text":"\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8su9g","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"3kf3h","text":"\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"189o1","text":"\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4l7k2","text":"\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: ' 17-200-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 8\u2033 Radio \u2013 / Telephone Pliers 40\u2070',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '2f2270fd46',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.19,
			length: 20,
			width: 5.3,
			height: 2.8
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 40,
			sale: 0,
			po: 'S$40.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'wJQkbRAwlhJuyrgDKzszt4.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/wJQkbRAwlhJuyrgDKzszt4.jpg',
			_id: '5a5d7ff737f8836a18da499a',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'k_Om15ZI4GsFhTCyps8u1u.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/k_Om15ZI4GsFhTCyps8u1u.jpg',
			_id: '5a5d800237f8836a18da49de',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T04:34:11.477Z',
		dateCreated: '2018-01-16T04:33:56.048Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a5d80cf37f8836a18da4f77',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-8-radio-telephone-pliers-40-\u2070',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 200mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5749.</p><p class="md-block-unstyled">\u2022 For Soft And Piano Wire.</p><p class="md-block-unstyled">\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dpth9","text":"\u2022 Length : 200mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"25jts","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ehrlb","text":"\u2022 Quality : DIN ISO 5749.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"eld4h","text":"\u2022 For Soft And Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7t9ne","text":"\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8su9g","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"3kf3h","text":"\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"189o1","text":"\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4l7k2","text":"\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: ' 17-200-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 8\u2033 Radio \u2013 / Telephone Pliers 40\u2070',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '276181c2dc',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.19,
			length: 20,
			width: 5.3,
			height: 2.8
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 40,
			sale: 0,
			po: 'S$40.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'wJQkbRAwlhJuyrgDKzszt4.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/wJQkbRAwlhJuyrgDKzszt4.jpg',
			_id: '5a5d7ff737f8836a18da499a',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'k_Om15ZI4GsFhTCyps8u1u.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/k_Om15ZI4GsFhTCyps8u1u.jpg',
			_id: '5a5d800237f8836a18da49de',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T04:34:45.044Z',
		dateCreated: '2018-01-16T04:34:23.122Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a5d80f037f8836a18da511e',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-8-radio-telephone-pliers-40-\u2070',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 200mm.</p><p class="md-block-unstyled">\u2022 Forged, Made in Germany.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5749.</p><p class="md-block-unstyled">\u2022 For Soft And Piano Wire.</p><p class="md-block-unstyled">\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.</p>',
		description: '{"entityMap":{},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"dpth9","text":"\u2022 Length : 200mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"25jts","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"ehrlb","text":"\u2022 Quality : DIN ISO 5749.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"eld4h","text":"\u2022 For Soft And Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7t9ne","text":"\u2022 Power Joint And Precision Cutting Edges For Hardest And Enduring.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8su9g","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"3kf3h","text":"\u2022 3.8mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"189o1","text":"\u2022 2.7mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"4l7k2","text":"\u2022 2.3mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: ' 17-200-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 8\u2033 Radio \u2013 / Telephone Pliers 40\u2070',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '6b1410e0ab',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.19,
			length: 20,
			width: 5.3,
			height: 2.8
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 40,
			sale: 0,
			po: 'S$40.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'wJQkbRAwlhJuyrgDKzszt4.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/wJQkbRAwlhJuyrgDKzszt4.jpg',
			_id: '5a5d7ff737f8836a18da499a',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'k_Om15ZI4GsFhTCyps8u1u.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/k_Om15ZI4GsFhTCyps8u1u.jpg',
			_id: '5a5d800237f8836a18da49de',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T04:35:14.057Z',
		dateCreated: '2018-01-16T04:34:56.069Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a5d823437f8836a18da57f2',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-8-power-cutter',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 210mm.</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Innovative, Durable and lever Assisted Precision Power Joint.</p><p class="md-block-unstyled">\u2022 Powerful Extra Durable Middle Cutter For Safe And Easy Cutting of Soft, Hard And Piano Wires.</p><p class="md-block-unstyled">\u2022 One Hand Operation With Integrated Spring And Catch.</p><p class="md-block-unstyled">\u2022 Save Cutting Force By 50%.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 5.2mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 4.0mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 3.6mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/wwYUKpyw8I8</p>',
		description: '{"entityMap":{},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aavd0","text":"\u2022 Length : 210mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f37b6","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"b954h","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a1ml2","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7afcj","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6kknc","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fgk5","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"68scf","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7m6mb","text":"\u2022 Approved EvoLine\xAE Ergonomics With Innovative, Durable and lever Assisted Precision Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7mjbk","text":"\u2022 Powerful Extra Durable Middle Cutter For Safe And Easy Cutting of Soft, Hard And Piano Wires.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bsvii","text":"\u2022 One Hand Operation With Integrated Spring And Catch.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fk607","text":"\u2022 Save Cutting Force By 50%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9iuj9","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"82che","text":"\u2022 5.2mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1009l","text":"\u2022 4.0mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"287u5","text":"\u2022 3.6mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2acnt","text":"https://youtu.be/wwYUKpyw8I8","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '24-210-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 8\xBD\u201D Power Cutter',
		__v: 0,
		shopNumber: '0563306553',
		sku: '433f96790e',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.39,
			length: 21,
			width: 76,
			height: 3.1
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 85,
			sale: 0,
			po: 'S$85.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'u9nLxqKL_pIALjRA18vaPs.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/u9nLxqKL_pIALjRA18vaPs.jpg',
			_id: '5a5d81ba37f8836a18da5662',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'o4EL2SGl8evIU78Pq6JNzU.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/o4EL2SGl8evIU78Pq6JNzU.jpg',
			_id: '5a5d81ca37f8836a18da5664',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-02-26T09:52:49.447Z',
		dateCreated: '2018-01-16T04:40:20.764Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a5d823d37f8836a18da5857',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-8-power-cutter',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 210mm.</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Innovative, Durable and lever Assisted Precision Power Joint.</p><p class="md-block-unstyled">\u2022 Powerful Extra Durable Middle Cutter For Safe And Easy Cutting of Soft, Hard And Piano Wires.</p><p class="md-block-unstyled">\u2022 One Hand Operation With Integrated Spring And Catch.</p><p class="md-block-unstyled">\u2022 Save Cutting Force By 50%.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 5.2mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 4.0mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 3.6mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/wwYUKpyw8I8</p>',
		description: '{"entityMap":{},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aavd0","text":"\u2022 Length : 210mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f37b6","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"b954h","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a1ml2","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7afcj","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6kknc","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fgk5","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"68scf","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7m6mb","text":"\u2022 Approved EvoLine\xAE Ergonomics With Innovative, Durable and lever Assisted Precision Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7mjbk","text":"\u2022 Powerful Extra Durable Middle Cutter For Safe And Easy Cutting of Soft, Hard And Piano Wires.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bsvii","text":"\u2022 One Hand Operation With Integrated Spring And Catch.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fk607","text":"\u2022 Save Cutting Force By 50%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9iuj9","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"82che","text":"\u2022 5.2mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1009l","text":"\u2022 4.0mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"287u5","text":"\u2022 3.6mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2acnt","text":"https://youtu.be/wwYUKpyw8I8","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '24-210-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 8\xBD\u201D Power Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '56f079361a',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.39,
			length: 21,
			width: 76,
			height: 3.1
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 85,
			sale: 0,
			po: 'S$85.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'u9nLxqKL_pIALjRA18vaPs.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/u9nLxqKL_pIALjRA18vaPs.jpg',
			_id: '5a5d81ba37f8836a18da5662',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'o4EL2SGl8evIU78Pq6JNzU.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/o4EL2SGl8evIU78Pq6JNzU.jpg',
			_id: '5a5d81ca37f8836a18da5664',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T04:40:46.582Z',
		dateCreated: '2018-01-16T04:40:29.325Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a5d825537f8836a18da5981',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-8-power-cutter',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 210mm.</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Innovative, Durable and lever Assisted Precision Power Joint.</p><p class="md-block-unstyled">\u2022 Powerful Extra Durable Middle Cutter For Safe And Easy Cutting of Soft, Hard And Piano Wires.</p><p class="md-block-unstyled">\u2022 One Hand Operation With Integrated Spring And Catch.</p><p class="md-block-unstyled">\u2022 Save Cutting Force By 50%.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 5.2mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 4.0mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 3.6mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/wwYUKpyw8I8</p>',
		description: '{"entityMap":{},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aavd0","text":"\u2022 Length : 210mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f37b6","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"b954h","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a1ml2","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7afcj","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6kknc","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fgk5","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"68scf","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7m6mb","text":"\u2022 Approved EvoLine\xAE Ergonomics With Innovative, Durable and lever Assisted Precision Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7mjbk","text":"\u2022 Powerful Extra Durable Middle Cutter For Safe And Easy Cutting of Soft, Hard And Piano Wires.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bsvii","text":"\u2022 One Hand Operation With Integrated Spring And Catch.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fk607","text":"\u2022 Save Cutting Force By 50%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9iuj9","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"82che","text":"\u2022 5.2mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1009l","text":"\u2022 4.0mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"287u5","text":"\u2022 3.6mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2acnt","text":"https://youtu.be/wwYUKpyw8I8","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '24-210-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 8\xBD\u201D Power Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '629a820a32',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.39,
			length: 21,
			width: 76,
			height: 3.1
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 85,
			sale: 0,
			po: 'S$85.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'u9nLxqKL_pIALjRA18vaPs.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/u9nLxqKL_pIALjRA18vaPs.jpg',
			_id: '5a5d81ba37f8836a18da5662',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'o4EL2SGl8evIU78Pq6JNzU.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/o4EL2SGl8evIU78Pq6JNzU.jpg',
			_id: '5a5d81ca37f8836a18da5664',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T04:41:07.893Z',
		dateCreated: '2018-01-16T04:40:53.063Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a5d826a37f8836a18da5b7c',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-8-power-cutter',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 Length : 210mm.</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Innovative, Durable and lever Assisted Precision Power Joint.</p><p class="md-block-unstyled">\u2022 Powerful Extra Durable Middle Cutter For Safe And Easy Cutting of Soft, Hard And Piano Wires.</p><p class="md-block-unstyled">\u2022 One Hand Operation With Integrated Spring And Catch.</p><p class="md-block-unstyled">\u2022 Save Cutting Force By 50%.</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 5.2mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 4.0mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 3.6mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled">https://youtu.be/wwYUKpyw8I8</p>',
		description: '{"entityMap":{},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"aavd0","text":"\u2022 Length : 210mm.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f37b6","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"b954h","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"a1ml2","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7afcj","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6kknc","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fgk5","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"68scf","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7m6mb","text":"\u2022 Approved EvoLine\xAE Ergonomics With Innovative, Durable and lever Assisted Precision Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7mjbk","text":"\u2022 Powerful Extra Durable Middle Cutter For Safe And Easy Cutting of Soft, Hard And Piano Wires.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"bsvii","text":"\u2022 One Hand Operation With Integrated Spring And Catch.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"fk607","text":"\u2022 Save Cutting Force By 50%.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"9iuj9","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"82che","text":"\u2022 5.2mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"1009l","text":"\u2022 4.0mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"287u5","text":"\u2022 3.6mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2acnt","text":"https://youtu.be/wwYUKpyw8I8","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '24-210-2K',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 8\xBD\u201D Power Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '54b7dd5f4e',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.39,
			length: 21,
			width: 76,
			height: 3.1
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 85,
			sale: 0,
			po: 'S$85.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'u9nLxqKL_pIALjRA18vaPs.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/u9nLxqKL_pIALjRA18vaPs.jpg',
			_id: '5a5d81ba37f8836a18da5662',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'o4EL2SGl8evIU78Pq6JNzU.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/o4EL2SGl8evIU78Pq6JNzU.jpg',
			_id: '5a5d81ca37f8836a18da5664',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T04:41:33.223Z',
		dateCreated: '2018-01-16T04:41:14.711Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a5d83c837f8836a18da6f8c',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-9-1000-volt-vde-hd-long-nose-pliers',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 9\u201D (220mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.</p><p class="md-block-unstyled">\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.</p><p class="md-block-unstyled">\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg" target="_blank" rel="noopener noreferrer"> </a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg"}}},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"be77g","text":"\u2022 9\u201D (220mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"20fsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"fsj56","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6oj9o","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5ksb0","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"35blu","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8bip4","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5qdjb","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8s62l","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"678if","text":"\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2s2h8","text":"\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7uvks","text":"\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"42tsk","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"886t4","text":"\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f64o5","text":"\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"beprr","text":"\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e7058","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":1,"key":0}],"data":{}}]}',
		model: '21-150-VDE',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 9\u2033 1000 Volt VDE HD Long Nose Pliers',
		__v: 0,
		shopNumber: '0563306553',
		sku: 'a276fd0d68',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.295,
			length: 22,
			width: 55,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 69,
			sale: 0,
			po: 'S$69.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'yJB8tW40L5qbC_yPMUlTWf.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/yJB8tW40L5qbC_yPMUlTWf.jpg',
			_id: '5a5d82ea37f8836a18da5e3f',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'e1YtQL4JDa5H_NX4r4v3Lz.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/e1YtQL4JDa5H_NX4r4v3Lz.jpg',
			_id: '5a5d82f237f8836a18da5e40',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'vz2WHWunPKWmYF7z61naYE.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/vz2WHWunPKWmYF7z61naYE.jpg',
			_id: '5a5d82f937f8836a18da5e41',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'YwCHhdCElzK3GlkslZ1lQl.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/YwCHhdCElzK3GlkslZ1lQl.jpg',
			_id: '5a5d831337f8836a18da66a8',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-02-26T09:52:49.448Z',
		dateCreated: '2018-01-16T04:47:04.860Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a5d83d137f8836a18da6ff9',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-9-1000-volt-vde-hd-long-nose-pliers',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 9\u201D (220mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.</p><p class="md-block-unstyled">\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.</p><p class="md-block-unstyled">\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg" target="_blank" rel="noopener noreferrer"> </a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg"}}},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"be77g","text":"\u2022 9\u201D (220mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"20fsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"fsj56","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6oj9o","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5ksb0","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"35blu","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8bip4","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5qdjb","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8s62l","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"678if","text":"\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2s2h8","text":"\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7uvks","text":"\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"42tsk","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"886t4","text":"\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f64o5","text":"\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"beprr","text":"\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e7058","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":1,"key":0}],"data":{}}]}',
		model: '21-150-VDE',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 9\u2033 1000 Volt VDE HD Long Nose Pliers',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '16f25afb6b',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.295,
			length: 22,
			width: 55,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 69,
			sale: 0,
			po: 'S$69.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'yJB8tW40L5qbC_yPMUlTWf.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/yJB8tW40L5qbC_yPMUlTWf.jpg',
			_id: '5a5d82ea37f8836a18da5e3f',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'e1YtQL4JDa5H_NX4r4v3Lz.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/e1YtQL4JDa5H_NX4r4v3Lz.jpg',
			_id: '5a5d82f237f8836a18da5e40',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'vz2WHWunPKWmYF7z61naYE.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/vz2WHWunPKWmYF7z61naYE.jpg',
			_id: '5a5d82f937f8836a18da5e41',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'YwCHhdCElzK3GlkslZ1lQl.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/YwCHhdCElzK3GlkslZ1lQl.jpg',
			_id: '5a5d831337f8836a18da66a8',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T04:51:29.316Z',
		dateCreated: '2018-01-16T04:47:13.145Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a5d83ea37f8836a18da77db',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-9-1000-volt-vde-hd-long-nose-pliers',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 9\u201D (220mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.</p><p class="md-block-unstyled">\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.</p><p class="md-block-unstyled">\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg" target="_blank" rel="noopener noreferrer"> </a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg"}}},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"be77g","text":"\u2022 9\u201D (220mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"20fsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"fsj56","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6oj9o","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5ksb0","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"35blu","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8bip4","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5qdjb","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8s62l","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"678if","text":"\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2s2h8","text":"\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7uvks","text":"\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"42tsk","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"886t4","text":"\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f64o5","text":"\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"beprr","text":"\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e7058","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":1,"key":0}],"data":{}}]}',
		model: '21-150-VDE',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 9\u2033 1000 Volt VDE HD Long Nose Pliers',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '8d986390a0',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.295,
			length: 22,
			width: 55,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 69,
			sale: 0,
			po: 'S$69.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'yJB8tW40L5qbC_yPMUlTWf.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/yJB8tW40L5qbC_yPMUlTWf.jpg',
			_id: '5a5d82ea37f8836a18da5e3f',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'e1YtQL4JDa5H_NX4r4v3Lz.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/e1YtQL4JDa5H_NX4r4v3Lz.jpg',
			_id: '5a5d82f237f8836a18da5e40',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'vz2WHWunPKWmYF7z61naYE.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/vz2WHWunPKWmYF7z61naYE.jpg',
			_id: '5a5d82f937f8836a18da5e41',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'YwCHhdCElzK3GlkslZ1lQl.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/YwCHhdCElzK3GlkslZ1lQl.jpg',
			_id: '5a5d831337f8836a18da66a8',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T04:47:51.096Z',
		dateCreated: '2018-01-16T04:47:38.037Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a5d83fd37f8836a18da7923',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-9-1000-volt-vde-hd-long-nose-pliers',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 9\u201D (220mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.</p><p class="md-block-unstyled">\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.</p><p class="md-block-unstyled">\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg" target="_blank" rel="noopener noreferrer"> </a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg"}}},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"be77g","text":"\u2022 9\u201D (220mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"20fsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"fsj56","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6oj9o","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5ksb0","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"35blu","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8bip4","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5qdjb","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8s62l","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"678if","text":"\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2s2h8","text":"\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7uvks","text":"\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"42tsk","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"886t4","text":"\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f64o5","text":"\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"beprr","text":"\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e7058","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":1,"key":0}],"data":{}}]}',
		model: '21-150-VDE',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 9\u2033 1000 Volt VDE HD Long Nose Pliers',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '8f3a2db9a7',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.295,
			length: 22,
			width: 55,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 69,
			sale: 0,
			po: 'S$69.00',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'yJB8tW40L5qbC_yPMUlTWf.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/yJB8tW40L5qbC_yPMUlTWf.jpg',
			_id: '5a5d82ea37f8836a18da5e3f',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'e1YtQL4JDa5H_NX4r4v3Lz.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/e1YtQL4JDa5H_NX4r4v3Lz.jpg',
			_id: '5a5d82f237f8836a18da5e40',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'vz2WHWunPKWmYF7z61naYE.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/vz2WHWunPKWmYF7z61naYE.jpg',
			_id: '5a5d82f937f8836a18da5e41',
			expire: '2018-01-11T05:53:14.713Z'
		}, {
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'YwCHhdCElzK3GlkslZ1lQl.jpg',
			url: 'https://storage.googleapis.com/eezee-product-images/YwCHhdCElzK3GlkslZ1lQl.jpg',
			_id: '5a5d831337f8836a18da66a8',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T04:48:20.225Z',
		dateCreated: '2018-01-16T04:47:57.479Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a5d853037f8836a18da83e7',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-9-1000-volt-vde-hd-long-nose-pliers',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 9\u201D (220mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.</p><p class="md-block-unstyled">\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.</p><p class="md-block-unstyled">\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg" target="_blank" rel="noopener noreferrer"> </a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg"}}},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"be77g","text":"\u2022 9\u201D (220mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"20fsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"fsj56","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6oj9o","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5ksb0","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"35blu","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8bip4","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5qdjb","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8s62l","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"678if","text":"\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2s2h8","text":"\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7uvks","text":"\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"42tsk","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"886t4","text":"\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f64o5","text":"\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"beprr","text":"\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e7058","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":1,"key":0}],"data":{}}]}',
		model: '21-150-VDE',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 9\u2033 1000 Volt VDE HD Long Nose Pliers',
		__v: 1,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'f53dbb87e1',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.295,
			length: 22,
			width: 55,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 60,
			sale: 0,
			po: 'S$60.00',
			ps: 'S$0.00'
		},
		images: [{
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d854e37f8836a18da84c9',
			url: 'https://storage.googleapis.com/eezee-product-images/wIE2TCoBA4GhMFbqcAqYQ9.jpg',
			fileName: 'wIE2TCoBA4GhMFbqcAqYQ9.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d855637f8836a18da84ca',
			url: 'https://storage.googleapis.com/eezee-product-images/dQdTSOzDkWZ7hPoxu4Uelx.jpg',
			fileName: 'dQdTSOzDkWZ7hPoxu4Uelx.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d855c37f8836a18da84cb',
			url: 'https://storage.googleapis.com/eezee-product-images/SShAKEsT2epjWma6XtlOOI.jpg',
			fileName: 'SShAKEsT2epjWma6XtlOOI.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d856037f8836a18da84cc',
			url: 'https://storage.googleapis.com/eezee-product-images/Rl5VpvEp~AHQaP~WjCrGSo.jpg',
			fileName: 'Rl5VpvEp~AHQaP~WjCrGSo.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}],
		dateUpdated: '2018-01-16T04:54:58.000Z',
		dateCreated: '2018-01-16T04:53:04.129Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a5d85a837f8836a18da86b0',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-9-1000-volt-vde-hd-long-nose-pliers',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 9\u201D (220mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.</p><p class="md-block-unstyled">\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.</p><p class="md-block-unstyled">\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg" target="_blank" rel="noopener noreferrer"> </a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg"}}},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"be77g","text":"\u2022 9\u201D (220mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"20fsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"fsj56","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6oj9o","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5ksb0","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"35blu","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8bip4","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5qdjb","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8s62l","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"678if","text":"\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2s2h8","text":"\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7uvks","text":"\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"42tsk","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"886t4","text":"\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f64o5","text":"\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"beprr","text":"\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e7058","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":1,"key":0}],"data":{}}]}',
		model: '21-150-VDE',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 9\u2033 1000 Volt VDE HD Long Nose Pliers',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '347e4424ff',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.295,
			length: 22,
			width: 55,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 60,
			sale: 0,
			po: 'S$60.00',
			ps: 'S$0.00'
		},
		images: [{
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d854e37f8836a18da84c9',
			url: 'https://storage.googleapis.com/eezee-product-images/wIE2TCoBA4GhMFbqcAqYQ9.jpg',
			fileName: 'wIE2TCoBA4GhMFbqcAqYQ9.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d855637f8836a18da84ca',
			url: 'https://storage.googleapis.com/eezee-product-images/dQdTSOzDkWZ7hPoxu4Uelx.jpg',
			fileName: 'dQdTSOzDkWZ7hPoxu4Uelx.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d855c37f8836a18da84cb',
			url: 'https://storage.googleapis.com/eezee-product-images/SShAKEsT2epjWma6XtlOOI.jpg',
			fileName: 'SShAKEsT2epjWma6XtlOOI.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d856037f8836a18da84cc',
			url: 'https://storage.googleapis.com/eezee-product-images/Rl5VpvEp~AHQaP~WjCrGSo.jpg',
			fileName: 'Rl5VpvEp~AHQaP~WjCrGSo.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}],
		dateUpdated: '2018-01-16T04:55:20.304Z',
		dateCreated: '2018-01-16T04:55:04.682Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a5d85e137f8836a18da899f',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-9-1000-volt-vde-hd-long-nose-pliers',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 9\u201D (220mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.</p><p class="md-block-unstyled">\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.</p><p class="md-block-unstyled">\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg" target="_blank" rel="noopener noreferrer"> </a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg"}}},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"be77g","text":"\u2022 9\u201D (220mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"20fsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"fsj56","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6oj9o","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5ksb0","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"35blu","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8bip4","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5qdjb","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8s62l","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"678if","text":"\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2s2h8","text":"\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7uvks","text":"\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"42tsk","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"886t4","text":"\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f64o5","text":"\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"beprr","text":"\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e7058","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":1,"key":0}],"data":{}}]}',
		model: '21-150-VDE',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 9\u2033 1000 Volt VDE HD Long Nose Pliers',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '06c030709c',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.295,
			length: 22,
			width: 55,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 60,
			sale: 0,
			po: 'S$60.00',
			ps: 'S$0.00'
		},
		images: [{
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d854e37f8836a18da84c9',
			url: 'https://storage.googleapis.com/eezee-product-images/wIE2TCoBA4GhMFbqcAqYQ9.jpg',
			fileName: 'wIE2TCoBA4GhMFbqcAqYQ9.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d855637f8836a18da84ca',
			url: 'https://storage.googleapis.com/eezee-product-images/dQdTSOzDkWZ7hPoxu4Uelx.jpg',
			fileName: 'dQdTSOzDkWZ7hPoxu4Uelx.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d855c37f8836a18da84cb',
			url: 'https://storage.googleapis.com/eezee-product-images/SShAKEsT2epjWma6XtlOOI.jpg',
			fileName: 'SShAKEsT2epjWma6XtlOOI.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d856037f8836a18da84cc',
			url: 'https://storage.googleapis.com/eezee-product-images/Rl5VpvEp~AHQaP~WjCrGSo.jpg',
			fileName: 'Rl5VpvEp~AHQaP~WjCrGSo.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}],
		dateUpdated: '2018-01-16T04:56:16.768Z',
		dateCreated: '2018-01-16T04:56:01.972Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a5d85f737f8836a18da8a8d',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'orbis-9-1000-volt-vde-hd-long-nose-pliers',
		descriptionHtml: '<p class="md-block-unstyled"> </p><p class="md-block-unstyled">\u2022 9\u201D (220mm).</p><p class="md-block-unstyled"><strong class="md-inline-bold">\u2022 Forged, Made in Germany.</strong></p><p class="md-block-unstyled">\u2022 Ergonomische Head 25\u2070 Bent.</p><p class="md-block-unstyled">\u2022 Advantageous In Use In All Positions.</p><p class="md-block-unstyled">\u2022 Slim Head For Easy Access.</p><p class="md-block-unstyled">\u2022 Induction Hardened Precision Cutter.</p><p class="md-block-unstyled">\u2022 Lever Optimised Power Joint.</p><p class="md-block-unstyled">\u2022 Quality : DIN ISO 5743.</p><p class="md-block-unstyled">\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.</p><p class="md-block-unstyled">\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.</p><p class="md-block-unstyled">\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.</p><p class="md-block-unstyled">\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).</p><p class="md-block-unstyled"><strong class="md-inline-bold">Cutting Capacity</strong></p><p class="md-block-unstyled">\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.</p><p class="md-block-unstyled">\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.</p><p class="md-block-unstyled">\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.</p><p class="md-block-unstyled"><a class="md-inline-link" href="http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg" target="_blank" rel="noopener noreferrer"> </a></p>',
		description: '{"entityMap":{"0":{"type":"LINK","mutability":"MUTABLE","data":{"href":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg","url":"http://www.tigerhandtools.com.sg/wp-content/uploads/2015/05/113.jpg"}}},"blocks":[{"key":"8na66","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"be77g","text":"\u2022 9\u201D (220mm).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"20fsn","text":"\u2022 Forged, Made in Germany.","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":26,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"fsj56","text":"\u2022 Ergonomische Head 25\u2070 Bent.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"6oj9o","text":"\u2022 Advantageous In Use In All Positions.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5ksb0","text":"\u2022 Slim Head For Easy Access.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"35blu","text":"\u2022 Induction Hardened Precision Cutter.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8bip4","text":"\u2022 Lever Optimised Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"5qdjb","text":"\u2022 Quality : DIN ISO 5743.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"8s62l","text":"\u2022 Approved EvoLine\xAE Ergonomics With Power Joint.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"678if","text":"\u2022 Half-Round, Straight Long And Slim Knurled Jaws Specially Profiled.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"2s2h8","text":"\u2022 Smooth Wave Profile And 4 Point Vice-Grip Pipe Hole.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"7uvks","text":"\u2022 Added Value : Pulling of Round Pieces And Manipulating of Sensitive Pieces (Copper Tubes, Thread, Cables).","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"42tsk","text":"Cutting Capacity","type":"unstyled","depth":0,"inlineStyleRanges":[{"offset":0,"length":16,"style":"BOLD"}],"entityRanges":[],"data":{}},{"key":"886t4","text":"\u2022 3.0mm For 800N/mm Tensile Strength For Medium Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"f64o5","text":"\u2022 2.0mm For 1600N/mm Tensile Strength For Hard Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"beprr","text":"\u2022 1.4mm For 2000N/mm Tensile Strength For Piano Wire.","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}},{"key":"e7058","text":" ","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[{"offset":0,"length":1,"key":0}],"data":{}}]}',
		model: '21-150-VDE',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'UlKtmn96mc9cxdZPsnr6yU.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/UlKtmn96mc9cxdZPsnr6yU.jpg',
				_id: '5a6c3d8c4e9c6a0c68a10684',
				expire: '2018-01-26T04:20:26.637Z'
			},
			name: 'ORBIS',
			lowerCaseName: 'orbis',
			kebabName: 'orbis',
			featured: true,
			_id: '5a5334c6806c690331bfae3c'
		},
		title: 'ORBIS 9\u2033 1000 Volt VDE HD Long Nose Pliers',
		__v: 0,
		duplicate: true,
		shopNumber: '0563306553',
		sku: '58d2e277e8',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.295,
			length: 22,
			width: 55,
			height: 3
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 60,
			sale: 0,
			po: 'S$60.00',
			ps: 'S$0.00'
		},
		images: [{
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d854e37f8836a18da84c9',
			url: 'https://storage.googleapis.com/eezee-product-images/wIE2TCoBA4GhMFbqcAqYQ9.jpg',
			fileName: 'wIE2TCoBA4GhMFbqcAqYQ9.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d855637f8836a18da84ca',
			url: 'https://storage.googleapis.com/eezee-product-images/dQdTSOzDkWZ7hPoxu4Uelx.jpg',
			fileName: 'dQdTSOzDkWZ7hPoxu4Uelx.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d855c37f8836a18da84cb',
			url: 'https://storage.googleapis.com/eezee-product-images/SShAKEsT2epjWma6XtlOOI.jpg',
			fileName: 'SShAKEsT2epjWma6XtlOOI.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}, {
			expire: '2018-01-11T05:53:14.713Z',
			_id: '5a5d856037f8836a18da84cc',
			url: 'https://storage.googleapis.com/eezee-product-images/Rl5VpvEp~AHQaP~WjCrGSo.jpg',
			fileName: 'Rl5VpvEp~AHQaP~WjCrGSo.jpg',
			bucket: 'eezee-product-images',
			fileType: 'image',
			__v: 0
		}],
		dateUpdated: '2018-01-16T04:56:16.768Z',
		dateCreated: '2018-01-16T04:56:23.958Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a5d9aed37f8836a18dafae3',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'pard-6-3-1000-v-insulated-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"><br/></p>',
		description: '{"entityMap":{},"blocks":[{"key":"evosk","text":"","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '612160N',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'PWNj_OvDYoIsDmM~LvRMLj.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/PWNj_OvDYoIsDmM~LvRMLj.jpg',
				_id: '5a6c3d834e9c6a0c68a1067d',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'PARD',
			lowerCaseName: 'pard',
			kebabName: 'pard',
			_id: '5a5334a1806c690331bfad9a'
		},
		title: 'PARD 6.3\u2033 1000V Insulated Diagonal Cutter',
		__v: 0,
		shopNumber: '0563306553',
		sku: '2ff1fe9548',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.25,
			length: 23.5,
			width: 8.5,
			height: 3.5
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 18.2,
			sale: 0,
			po: 'S$18.20',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'WpE9SJMxszvxFFRoCSUGSe.png',
			url: 'https://storage.googleapis.com/eezee-product-images/WpE9SJMxszvxFFRoCSUGSe.png',
			_id: '5a5d99ee37f8836a18daf80c',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-02-26T09:52:49.450Z',
		dateCreated: '2018-01-16T06:25:49.818Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}, {
		_id: '5a5d9af837f8836a18dafb60',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'pard-6-3-1000-v-insulated-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"><br/></p>',
		description: '{"entityMap":{},"blocks":[{"key":"evosk","text":"","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '612160N',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'PWNj_OvDYoIsDmM~LvRMLj.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/PWNj_OvDYoIsDmM~LvRMLj.jpg',
				_id: '5a6c3d834e9c6a0c68a1067d',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'PARD',
			lowerCaseName: 'pard',
			kebabName: 'pard',
			_id: '5a5334a1806c690331bfad9a'
		},
		title: 'PARD 6.3\u2033 1000V Insulated Diagonal Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '21a08b1f66',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.25,
			length: 23.5,
			width: 8.5,
			height: 3.5
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 18.2,
			sale: 0,
			po: 'S$18.20',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'WpE9SJMxszvxFFRoCSUGSe.png',
			url: 'https://storage.googleapis.com/eezee-product-images/WpE9SJMxszvxFFRoCSUGSe.png',
			_id: '5a5d99ee37f8836a18daf80c',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T06:26:16.617Z',
		dateCreated: '2018-01-16T06:26:00.106Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Cutting & Sawing Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'cutting-sawing-tools'
		}
	}, {
		_id: '5a5d9b1037f8836a18dafd84',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'pard-6-3-1000-v-insulated-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"><br/></p>',
		description: '{"entityMap":{},"blocks":[{"key":"evosk","text":"","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '612160N',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'PWNj_OvDYoIsDmM~LvRMLj.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/PWNj_OvDYoIsDmM~LvRMLj.jpg',
				_id: '5a6c3d834e9c6a0c68a1067d',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'PARD',
			lowerCaseName: 'pard',
			kebabName: 'pard',
			_id: '5a5334a1806c690331bfad9a'
		},
		title: 'PARD 6.3\u2033 1000V Insulated Diagonal Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'a475d886fc',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.25,
			length: 23.5,
			width: 8.5,
			height: 3.5
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 18.2,
			sale: 0,
			po: 'S$18.20',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'WpE9SJMxszvxFFRoCSUGSe.png',
			url: 'https://storage.googleapis.com/eezee-product-images/WpE9SJMxszvxFFRoCSUGSe.png',
			_id: '5a5d99ee37f8836a18daf80c',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T06:26:42.136Z',
		dateCreated: '2018-01-16T06:26:24.227Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Fastening Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'fastening-tools'
		}
	}, {
		_id: '5a5d9b2a37f8836a18dafefc',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'pard-6-3-1000-v-insulated-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"><br/></p>',
		description: '{"entityMap":{},"blocks":[{"key":"evosk","text":"","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: '612160N',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'PWNj_OvDYoIsDmM~LvRMLj.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/PWNj_OvDYoIsDmM~LvRMLj.jpg',
				_id: '5a6c3d834e9c6a0c68a1067d',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'PARD',
			lowerCaseName: 'pard',
			kebabName: 'pard',
			_id: '5a5334a1806c690331bfad9a'
		},
		title: 'PARD 6.3\u2033 1000V Insulated Diagonal Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: '4d5b1a59ad',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.25,
			length: 23.5,
			width: 8.5,
			height: 3.5
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 18.2,
			sale: 0,
			po: 'S$18.20',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'WpE9SJMxszvxFFRoCSUGSe.png',
			url: 'https://storage.googleapis.com/eezee-product-images/WpE9SJMxszvxFFRoCSUGSe.png',
			_id: '5a5d99ee37f8836a18daf80c',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T06:27:05.839Z',
		dateCreated: '2018-01-16T06:26:50.146Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Hand Tools',
			sub: 'Mechanical Tools',
			mainKebabCase: 'hand-tools',
			subKebabCase: 'mechanical-tools'
		}
	}, {
		_id: '5a5d9c8937f8836a18db04cf',
		supplierId: '5a4c74cd806c6903314b38c3',
		uniqTitle: 'pard-7-1000-v-insulated-heavy-duty-diagonal-cutter',
		descriptionHtml: '<p class="md-block-unstyled"><br/></p>',
		description: '{"entityMap":{},"blocks":[{"key":"evosk","text":"","type":"unstyled","depth":0,"inlineStyleRanges":[],"entityRanges":[],"data":{}}]}',
		model: ' 612180N',
		brand: {
			image: {
				__v: 0,
				fileType: 'image',
				bucket: 'eezee-brand-images',
				fileName: 'PWNj_OvDYoIsDmM~LvRMLj.jpg',
				url: 'https://storage.googleapis.com/eezee-brand-images/PWNj_OvDYoIsDmM~LvRMLj.jpg',
				_id: '5a6c3d834e9c6a0c68a1067d',
				expire: '2018-01-26T04:20:26.637Z'
			},
			featured: true,
			name: 'PARD',
			lowerCaseName: 'pard',
			kebabName: 'pard',
			_id: '5a5334a1806c690331bfad9a'
		},
		title: 'PARD 7\u201D 1000V Insulated Heavy Duty Diagonal Cutter',
		__v: 0,
		duplicate: false,
		shopNumber: '0563306553',
		sku: 'ffbfbc9d12',
		includes: [],
		specs: [],
		shipping: {
			weight: 0.26,
			length: 28,
			width: 8.5,
			height: 3.5
		},
		bulkDiscount: [],
		variants: [],
		specSheets: [],
		price: {
			original: 20.6,
			sale: 0,
			po: 'S$20.60',
			ps: 'S$0.00'
		},
		images: [{
			__v: 0,
			fileType: 'image',
			bucket: 'eezee-product-images',
			fileName: 'bmjhYc4TpB8tgzVI9leEwu.png',
			url: 'https://storage.googleapis.com/eezee-product-images/bmjhYc4TpB8tgzVI9leEwu.png',
			_id: '5a5d9bab37f8836a18db01ea',
			expire: '2018-01-11T05:53:14.713Z'
		}],
		dateUpdated: '2018-01-16T06:43:06.915Z',
		dateCreated: '2018-01-16T06:32:41.467Z',
		discontinued: false,
		active: true,
		categories: {
			main: 'Electrical Components',
			sub: 'Electrician Tools',
			mainKebabCase: 'electrical-components',
			subKebabCase: 'electrician-tools'
		}
	}],
	categoryNiche: [{
		name: 'Mechanical Tools',
		_id: '5a97c088be21be1fe1c0db7a'
	}, {
		name: 'Fastening Tools',
		_id: '5a97c088be21be1fe1c0db79'
	}, {
		name: 'Air Tools',
		_id: '5a97c088be21be1fe1c0db78'
	}],
	c: 'Tiger Hand Tools'
};


var redisCache = void 0;

// it("Redis can connect, get obj and return falsey", function() {
// 	// expect(true).toBeFalsy();
// 	expect.assertions(1);

// 	let redisCache = new RedisCache({
// 		host: ['localhost'],
// 		port: 6379
// 	})

// 	redisCache.getObj('obj:falseyBitch')
// 		.then( data => expect(data).toBeFalsy() )

// 		// 	{
// 		// 	console.log(data && 1 === 1);
// 		// 	expect(true).toBeFalsy()
// 		// })

// });

// test('Redis can connect, get obj and return falsey', async  () => {

// 	expect.assertions(1);

// 	let redisCache = new RedisCache({
// 		host: ['localhost'],
// 		port: 6379
// 	})

// 	return redisCache.getObj('obj:falseyBitch')
// 		.then( data => expect(data).toBeFalsy());
// })

// test('Redis can connect, get and set', async () => {

// 	let redisCache = new RedisCache({
// 		host: ['localhost'],
// 		port: 6379
// 	})

// 	return redisCache.set('redis-test-jasper', 'hello world')
// 		.then( () => redisCache.get('redis-test-jasper'))
// 		.then( data => expect(data).toBe('hello world'))
// })

// test('Redis can connect, set expiry and get falsy', async () => {

// 	let redisCache = new RedisCache({
// 		host: ['localhost'],
// 		port: 6379
// 	})

// 	return redisCache.set('redis-test-jasper-ex', 'hello world', 1)
// 		.then( () => {
// 			return new Promise( ( resolve, reject ) => {
// 				setTimeout(
// 					() => {

// 						redisCache.get('redis-test-jasper-ex')
// 							// .then( data => {
// 							// 	console.log(data);
// 							// 	return expect(data).toBe('hello world')
// 							// })
// 							.then( data => resolve(data) )
// 							.catch( err => reject(err) )

// 					}, 3000
// 				)
// 			})
// 		})
// 		.then( data => {
// 			return expect(data).toBeFalsy()
// 		})

// })

// test('Redis can connect, set expiry and get value', async () => {

// 	let redisCache = new RedisCache({
// 		host: ['localhost'],
// 		port: 6379
// 	})

// 	return redisCache.set('redis-test-jasper-ex', 'hello world', 5)
// 		.then( () => {
// 			return new Promise( ( resolve, reject ) => {
// 				setTimeout(
// 					() => {

// 						redisCache.get('redis-test-jasper-ex')
// 							// .then( data => {
// 							// 	console.log(data);
// 							// 	return expect(data).toBe('hello world')
// 							// })
// 							.then( data => resolve(data) )
// 							.catch( err => reject(err) )

// 					}, 3000
// 				)
// 			})
// 		})
// 		.then( data => {
// 			return expect(data).toBe('hello world')
// 		})

// })

// test('Redis can connect, get and set obj', async () => {

// 	let redisCache = new RedisCache({
// 		host: ['localhost'],
// 		port: 6379
// 	})

// 	return redisCache.setObj('obj:test', { msg: 'hello world' })
// 		.then( () => redisCache.getObj('obj:test'))
// 		.then( data => expect(data.msg).toBe('hello world'))
// })

// test('Redis can connect to a cluster, get and set obj', async () => {

// 	let redisCache = new RedisCache({
// 		host: ["10.148.0.11", "10.148.0.13", "10.148.0.12"],
// 		port: ['6379', '6379', '6379']
// 	})

// 	return redisCache.setObj('obj:test', { msg: 'hello world' })
// 		.then( () => redisCache.getObj('obj:test'))
// 		.then( data => expect(data.msg).toBe('hello world'))
// })

test('Search page info is correct', function () {

	var inputs = {
		productList: searchResults.products,
		searchParam: 'a',
		size: searchResults.size
	};

	var _getSearchPageInfo = (0, _seo.getSearchPageInfo)(inputs),
	    title = _getSearchPageInfo.title,
	    description = _getSearchPageInfo.description,
	    searchParam = _getSearchPageInfo.searchParam,
	    image = _getSearchPageInfo.image,
	    aggregatePriceJSON = _getSearchPageInfo.aggregatePriceJSON;

	console.log(aggregatePriceJSON);

	expect(title).toBe("Find A In Singapore - Eezee");
	expect(description).toBe("Compare prices from different suppliers, wholesalers and distributors for A on Eezee.");
	expect(searchParam).toBe("a");
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/20140730114812KXWPANWWL3ZTC_full.jpg");
	expect(aggregatePriceJSON).toBe('{"@context":"http://schema.org/","@type":"Product","name":"Anchors & Rivets","image":["https://storage.googleapis.com/eezee-product-images/20140730114812KXWPANWWL3ZTC_full.jpg","https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg","https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg"],"offers":{"@type":"AggregateOffer","lowPrice":0.59,"highPrice":1300,"priceCurrency":"SGD","offerCount":8142},"brand":{"@type":"Thing","name":"HIT TOOLS"}}');
});

test('Search page 2 info is correct', function () {

	var inputs = {
		productList: searchResults.products,
		searchParam: 'a',
		size: searchResults.size,
		page: 2
	};

	var _getSearchPageInfo2 = (0, _seo.getSearchPageInfo)(inputs),
	    title = _getSearchPageInfo2.title,
	    description = _getSearchPageInfo2.description,
	    searchParam = _getSearchPageInfo2.searchParam,
	    image = _getSearchPageInfo2.image,
	    aggregatePriceJSON = _getSearchPageInfo2.aggregatePriceJSON;

	console.log(aggregatePriceJSON);

	expect(title).toBe("Find A In Singapore - Eezee - Page 2");
	expect(description).toBe("Page 2 - Compare prices from different suppliers, wholesalers and distributors for A on Eezee.");
	expect(searchParam).toBe("a");
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/20140730114812KXWPANWWL3ZTC_full.jpg");
	expect(aggregatePriceJSON).toBe('{"@context":"http://schema.org/","@type":"Product","name":"Anchors & Rivets","image":["https://storage.googleapis.com/eezee-product-images/20140730114812KXWPANWWL3ZTC_full.jpg","https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg","https://storage.googleapis.com/eezee-product-images/5khs8ue.jpeg"],"offers":{"@type":"AggregateOffer","lowPrice":0.59,"highPrice":1300,"priceCurrency":"SGD","offerCount":8142},"brand":{"@type":"Thing","name":"HIT TOOLS"}}');
});

test('Search "safety" page info is correct', function () {

	var inputs = {
		productList: safetySearchResults.products,
		searchParam: 'safety',
		size: safetySearchResults.size
	};

	var _getSearchPageInfo3 = (0, _seo.getSearchPageInfo)(inputs),
	    title = _getSearchPageInfo3.title,
	    description = _getSearchPageInfo3.description,
	    searchParam = _getSearchPageInfo3.searchParam,
	    image = _getSearchPageInfo3.image,
	    aggregatePriceJSON = _getSearchPageInfo3.aggregatePriceJSON;

	// Safety search results on Eezee Singapore


	expect(title).toBe("Find Safety In Singapore - Eezee");
	expect(description).toBe("Compare prices from different suppliers, wholesalers and distributors for Safety on Eezee.");
	expect(searchParam).toBe("safety");
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/20131227150417AWXS0Z0LWLL9A_full.jpg");
	expect(aggregatePriceJSON).toBe('{"@context":"http://schema.org/","@type":"Product","name":"Body & Fall Protection","image":["https://storage.googleapis.com/eezee-product-images/20131227150417AWXS0Z0LWLL9A_full.jpg","https://storage.googleapis.com/eezee-product-images/20131227150421DWJ4AQ6P0HXHZ_full.jpg","https://storage.googleapis.com/eezee-product-images/20131227150425HAJX9RANLTUU9_full.jpg","https://storage.googleapis.com/eezee-product-images/201312271504293PVVJCKDESOKK_full.jpg","https://storage.googleapis.com/eezee-product-images/x47x2vn.jpeg","https://storage.googleapis.com/eezee-product-images/rbi3jap.png","https://storage.googleapis.com/eezee-product-images/20141210174413DEXBJ1XWZAOF8_full.jpg","https://storage.googleapis.com/eezee-product-images/20141210174417XXDVZX6HA5C9G_full.jpg"],"offers":{"@type":"AggregateOffer","lowPrice":0.65,"highPrice":644,"priceCurrency":"SGD","offerCount":3749},"brand":{"@type":"Thing","name":"NO BRAND"}}');
});

// test('Search "toyogo" page info is correct', () => {

// 	const inputs = {
// 		productList: toyogoSearchResults.products, 
// 		searchParam: 'toyogo',
// 		size: toyogoSearchResults.size
// 	};

// 	let {
// 		title,
// 		description,
// 		searchParam,
// 		image,
// 		aggregatePriceJSON
// 	} = getSearchPageInfo( inputs );

// 		console.log(title)
// 		console.log(description)
// 		console.log(searchParam)
// 		console.log(image)
// 		console.log(aggregatePriceJSON)

// 	// Safety search results on Eezee Singapore
// 	expect(title).toBe("Toyogo search results on Eezee Singapore");
// 	expect(description).toBe("Find and compare prices for Safety on Eezee.")
// 	expect(searchParam).toBe("safety")
// 	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/20131227150417AWXS0Z0LWLL9A_full.jpg")
// 	expect(aggregatePriceJSON).toBe(`{"@context":"http://schema.org/","@type":"Product","name":"Body &amp; Fall Protection","image":["https://storage.googleapis.com/eezee-product-images/20131227150417AWXS0Z0LWLL9A_full.jpg","https://storage.googleapis.com/eezee-product-images/20131227150421DWJ4AQ6P0HXHZ_full.jpg","https://storage.googleapis.com/eezee-product-images/20131227150425HAJX9RANLTUU9_full.jpg","https://storage.googleapis.com/eezee-product-images/201312271504293PVVJCKDESOKK_full.jpg","https://storage.googleapis.com/eezee-product-images/x47x2vn.jpeg","https://storage.googleapis.com/eezee-product-images/rbi3jap.png","https://storage.googleapis.com/eezee-product-images/20141210174413DEXBJ1XWZAOF8_full.jpg","https://storage.googleapis.com/eezee-product-images/20141210174417XXDVZX6HA5C9G_full.jpg"],"offers":{"@type":"AggregateOffer","lowPrice":0.65,"highPrice":644,"priceCurrency":"SGD","offerCount":3749},"brand":{"@type":"Thing","name":"NO BRAND"}}`);


// });

test('Search "acc safe", empty page info is correct', function () {

	var inputs = {
		productList: emptyResults.products,
		searchParam: 'acc safe',
		size: emptyResults.size
	};

	var _getSearchPageInfo4 = (0, _seo.getSearchPageInfo)(inputs),
	    title = _getSearchPageInfo4.title,
	    description = _getSearchPageInfo4.description,
	    searchParam = _getSearchPageInfo4.searchParam,
	    image = _getSearchPageInfo4.image,
	    aggregatePriceJSON = _getSearchPageInfo4.aggregatePriceJSON;

	// Safety search results on Eezee Singapore


	expect(title).toBe("Find Acc Safe In Singapore - Eezee");
	expect(description).toBe("Compare prices from different suppliers, wholesalers and distributors for Acc Safe on Eezee.");
	expect(searchParam).toBe("acc safe");
	expect(image).toBe("https://eezee.sg/static/eezee-product.svg");
	expect(aggregatePriceJSON).toBe('');
});

test('Category page info is correct', function () {

	var inputs = {
		productList: categoryResults.products,
		size: categoryResults.size
	};

	var _getSubCategoryInfo = (0, _seo.getSubCategoryInfo)(inputs),
	    title = _getSubCategoryInfo.title,
	    description = _getSubCategoryInfo.description,
	    searchParam = _getSubCategoryInfo.searchParam,
	    image = _getSubCategoryInfo.image,
	    aggregatePriceJSON = _getSubCategoryInfo.aggregatePriceJSON;

	expect(title).toBe('Find\u3010Cordless Drills, Impact Drivers & Wrenches\u3011in Singapore - Best Price on Eezee');
	expect(description).toBe('Source and compare Cordless Drills, Impact Drivers & Wrenches directly from authorised distributors on Eezee.\u3010Bulk Discount\u3011\u3010Wholesale Price\u3011');
	expect(searchParam).toBe('Cordless Drills, Impact Drivers & Wrenches');
	expect(image).toBe('https://storage.googleapis.com/eezee-product-images/201511031408597GPLBC5ASWEJE_full.jpg');
	expect(aggregatePriceJSON).toBe('{"@context":"http://schema.org/","@type":"Product","name":"Cordless Drills, Impact Drivers & Wrenches","image":["https://storage.googleapis.com/eezee-product-images/201511031408597GPLBC5ASWEJE_full.jpg","https://storage.googleapis.com/eezee-product-images/20130603174555ZJQKB4FMA4CJD_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123231OMG6X6OVRWL10_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123230O7J4SX3OEHDGF_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123232SLX076H1GYXEH_full.jpg","https://storage.googleapis.com/eezee-product-images/20130603190247E4E7K02ODMWSV_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123656C2IN7ZZXC6GFV_full.jpg","https://storage.googleapis.com/eezee-product-images/20170207131217OFP8J4MSOWUQR_full.jpg","https://storage.googleapis.com/eezee-product-images/20170207131218EPJL3XEUNSX1T_full.jpg"],"offers":{"@type":"AggregateOffer","lowPrice":49.85,"highPrice":909.5,"priceCurrency":"SGD","offerCount":399},"brand":{"@type":"Thing","name":"DAWER POWER TOOLS"}}');
});

test('Category page 2 info is correct', function () {

	var inputs = {
		productList: categoryResults.products,
		size: categoryResults.size,
		page: 2
	};

	var _getSubCategoryInfo2 = (0, _seo.getSubCategoryInfo)(inputs),
	    title = _getSubCategoryInfo2.title,
	    description = _getSubCategoryInfo2.description,
	    searchParam = _getSubCategoryInfo2.searchParam,
	    image = _getSubCategoryInfo2.image,
	    aggregatePriceJSON = _getSubCategoryInfo2.aggregatePriceJSON;

	expect(title).toBe('Find\u3010Cordless Drills, Impact Drivers & Wrenches\u3011in Singapore - Best Price on Eezee - Page 2');
	expect(description).toBe('Page 2 - Source and compare Cordless Drills, Impact Drivers & Wrenches directly from authorised distributors on Eezee.\u3010Bulk Discount\u3011\u3010Wholesale Price\u3011');
	expect(searchParam).toBe('Cordless Drills, Impact Drivers & Wrenches');
	expect(image).toBe('https://storage.googleapis.com/eezee-product-images/201511031408597GPLBC5ASWEJE_full.jpg');
	expect(aggregatePriceJSON).toBe('{"@context":"http://schema.org/","@type":"Product","name":"Cordless Drills, Impact Drivers & Wrenches","image":["https://storage.googleapis.com/eezee-product-images/201511031408597GPLBC5ASWEJE_full.jpg","https://storage.googleapis.com/eezee-product-images/20130603174555ZJQKB4FMA4CJD_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123231OMG6X6OVRWL10_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123230O7J4SX3OEHDGF_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123232SLX076H1GYXEH_full.jpg","https://storage.googleapis.com/eezee-product-images/20130603190247E4E7K02ODMWSV_full.jpg","https://storage.googleapis.com/eezee-product-images/20170110123656C2IN7ZZXC6GFV_full.jpg","https://storage.googleapis.com/eezee-product-images/20170207131217OFP8J4MSOWUQR_full.jpg","https://storage.googleapis.com/eezee-product-images/20170207131218EPJL3XEUNSX1T_full.jpg"],"offers":{"@type":"AggregateOffer","lowPrice":49.85,"highPrice":909.5,"priceCurrency":"SGD","offerCount":399},"brand":{"@type":"Thing","name":"DAWER POWER TOOLS"}}');
});

test('Brand page info is correct', function () {

	var inputs = {
		productList: brandResults.products,
		size: brandResults.size
	};

	var _getBrandPageInfo = (0, _seo.getBrandPageInfo)(inputs),
	    title = _getBrandPageInfo.title,
	    description = _getBrandPageInfo.description,
	    searchParam = _getBrandPageInfo.searchParam,
	    image = _getBrandPageInfo.image,
	    aggregatePriceJSON = _getBrandPageInfo.aggregatePriceJSON;

	expect(title).toBe('Toyogo Singapore - Best Price');
	expect(description).toBe('Source and compare Toyogo products directly from Toyogo on Eezee Singapore.\u3010Bulk Discount\u3011\u3010Wholesale Price\u3011');
	expect(searchParam).toBe('Toyogo');
	expect(image).toBe('https://storage.googleapis.com/eezee-product-images/20151029200331W9BI33HXOYEZR_full.jpg');
	expect(aggregatePriceJSON).toBe('{"@context":"http://schema.org/","@type":"Product","name":"Storage Boxes & Shelving","image":["https://storage.googleapis.com/eezee-product-images/20151029200331W9BI33HXOYEZR_full.jpg","https://storage.googleapis.com/eezee-product-images/201510292021166CPG8RJIETM4H_full.jpg","https://storage.googleapis.com/eezee-product-images/2017052211051215V4HHXSPKZAA_full.jpg"],"offers":{"@type":"AggregateOffer","lowPrice":3.42,"highPrice":115,"priceCurrency":"SGD","offerCount":24},"brand":{"@type":"Thing","name":"TOYOGO"}}');
});

test('Brand page 2 info is correct', function () {

	var inputs = {
		productList: brandResults.products,
		size: brandResults.size,
		page: 2
	};

	var _getBrandPageInfo2 = (0, _seo.getBrandPageInfo)(inputs),
	    title = _getBrandPageInfo2.title,
	    description = _getBrandPageInfo2.description,
	    searchParam = _getBrandPageInfo2.searchParam,
	    image = _getBrandPageInfo2.image,
	    aggregatePriceJSON = _getBrandPageInfo2.aggregatePriceJSON;

	expect(title).toBe('Toyogo Singapore Page 2 - Best Price');
	expect(description).toBe('Page 2 - Source and compare Toyogo products directly from Toyogo on Eezee Singapore.\u3010Bulk Discount\u3011\u3010Wholesale Price\u3011');
	expect(searchParam).toBe('Toyogo');
	expect(image).toBe('https://storage.googleapis.com/eezee-product-images/20151029200331W9BI33HXOYEZR_full.jpg');
	expect(aggregatePriceJSON).toBe('{"@context":"http://schema.org/","@type":"Product","name":"Storage Boxes & Shelving","image":["https://storage.googleapis.com/eezee-product-images/20151029200331W9BI33HXOYEZR_full.jpg","https://storage.googleapis.com/eezee-product-images/201510292021166CPG8RJIETM4H_full.jpg","https://storage.googleapis.com/eezee-product-images/2017052211051215V4HHXSPKZAA_full.jpg"],"offers":{"@type":"AggregateOffer","lowPrice":3.42,"highPrice":115,"priceCurrency":"SGD","offerCount":24},"brand":{"@type":"Thing","name":"TOYOGO"}}');
});

test('Brand Page still shows proper seo when no products are returned', function () {

	var inputs = {
		productList: [],
		size: 0,
		searchParam: 'boxco'
	};

	var _getBrandPageInfo3 = (0, _seo.getBrandPageInfo)(inputs),
	    title = _getBrandPageInfo3.title,
	    image = _getBrandPageInfo3.image,
	    searchParam = _getBrandPageInfo3.searchParam,
	    description = _getBrandPageInfo3.description,
	    aggregatePriceJSON = _getBrandPageInfo3.aggregatePriceJSON;

	expect(title).toBe("Boxco Singapore - Best Price");
	expect(description).toBe("Source and compare Boxco products directly from Boxco on Eezee Singapore.【Bulk Discount】【Wholesale Price】");
	expect(searchParam).toBe('Boxco');
	expect(image).toBe("https://eezee.sg/static/eezee-product.svg");
	expect(aggregatePriceJSON).toBe('');
});

test('Product Page Info does not include model number if length > 15', function () {

	var inputs = mockProduct[0];

	var _getProductDetailsPag = (0, _seo.getProductDetailsPageInfo)(inputs),
	    title = _getProductDetailsPag.title,
	    image = _getProductDetailsPag.image,
	    description = _getProductDetailsPag.description,
	    productSchema = _getProductDetailsPag.productSchema;

	expect(title).toBe("ORING AS568 AS457 ID 354.97 X CS 6.99 Silicone 70 Shore Singapore - Eezee");
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/tjewl6d.jpeg");
	expect(description).toBe("Up to 26% Off - Buy ORING AS568 AS457 ID 354.97 X CS 6.99 Silicone 70 Shore directly from authorised distributors, suppliers and wholesalers on Eezee Singapore.");
	expect(productSchema).toBe('{"@context":"http://schema.org/","@type":"Product","name":"ORING AS568 AS457 ID 354.97 X CS 6.99 Silicone 70 Shore","image":["https://storage.googleapis.com/eezee-product-images/tjewl6d.jpeg","https://storage.googleapis.com/eezee-product-images/6646v7l.jpeg"],"mpn":"ORING AS568 AS457 ID 354.97 X CS 6.99Silicone 70 Shore","brand":{"@type":"Thing","name":"Eriks"},"offers":{"@type":"Offer","priceCurrency":"SGD","price":26,"itemCondition":"https://schema.org/NewCondition","availability":"http://schema.org/InStock"}}');
});

test('Product Page Info should include model number if length < 15 and not in product title', function () {

	var inputs = mockProduct[1];

	var _getProductDetailsPag2 = (0, _seo.getProductDetailsPageInfo)(inputs),
	    title = _getProductDetailsPag2.title,
	    image = _getProductDetailsPag2.image,
	    description = _getProductDetailsPag2.description,
	    productSchema = _getProductDetailsPag2.productSchema,
	    breadCrumbSchema = _getProductDetailsPag2.breadCrumbSchema;

	// console.log( JSON.stringify(breadCrumbSchema) );

	expect(title).toBe("CLABER RAIN SENSOR Singapore - Eezee");
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/20160622133420NTDBSYUKP9MSA_full.jpg");
	expect(description).toBe("Buy CLABER RAIN SENSOR 90915 directly from authorised distributors, suppliers and wholesalers on Eezee Singapore.");
	expect(productSchema).toBe('{"@context":"http://schema.org/","@type":"Product","name":"CLABER RAIN SENSOR","image":["https://storage.googleapis.com/eezee-product-images/20160622133420NTDBSYUKP9MSA_full.jpg","https://storage.googleapis.com/eezee-product-images/201606221334541ZUISXEFJJDZ4_full.jpg","https://storage.googleapis.com/eezee-product-images/20160622133454HBW7E4DG0V5O7_full.jpg","https://storage.googleapis.com/eezee-product-images/20160622133454TSRQKQUACUXG0_full.jpg"],"mpn":"90915","brand":{"@type":"Thing","name":"CLABER"},"offers":{"@type":"Offer","priceCurrency":"SGD","price":79.9,"itemCondition":"https://schema.org/NewCondition","availability":"http://schema.org/InStock"}}');
});

test('Store Page Info should render properly', function () {
	// getStorePageInfo();

	var inputs = {
		searchParam: "0563306553",
		productList: storeResults.products,
		size: storeResults.size,
		page: false,
		categoryNiche: storeResults.categoryNiche,
		companyName: storeResults.c
	};

	var _getStorePageInfo = (0, _seo.getStorePageInfo)(inputs),
	    title = _getStorePageInfo.title,
	    image = _getStorePageInfo.image,
	    searchParam = _getStorePageInfo.searchParam,
	    description = _getStorePageInfo.description,
	    aggregatePriceJSON = _getStorePageInfo.aggregatePriceJSON;

	expect(title).toBe("Eezee Store 0563306553 | Tiger Hand Tools");
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg");
	expect(description).toBe("Tiger Hand Tools stocks reputable brands for Mechanical Tools, Fastening Tools & Air Tools in Singapore. Shop with us now!");
	expect(aggregatePriceJSON).toBe('{"@context":"http://schema.org/","@type":"Product","name":"Packaging & Shipping Supplies","image":["https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg","https://storage.googleapis.com/eezee-product-images/O24EoqiMcC10foNWdsXNdN.jpg","https://storage.googleapis.com/eezee-product-images/BG3VrUBIpfnK5WgDp3H3H~.jpg","https://storage.googleapis.com/eezee-product-images/lxwEUb0GhyOk~ZoYWPNYw3.png","https://storage.googleapis.com/eezee-product-images/vSLLCG8yvrzrbMJaqX7B2D.png","https://storage.googleapis.com/eezee-product-images/BG3VrUBIpfnK5WgDp3H3H~.jpg","https://storage.googleapis.com/eezee-product-images/lxwEUb0GhyOk~ZoYWPNYw3.png","https://storage.googleapis.com/eezee-product-images/vSLLCG8yvrzrbMJaqX7B2D.png"],"offers":{"@type":"AggregateOffer","lowPrice":4.8,"highPrice":115,"priceCurrency":"SGD","offerCount":746},"brand":{"@type":"Thing","name":"TOYOGO"}}');
});

test('Store Page 2 Info should render properly', function () {
	// getStorePageInfo();

	var inputs = {
		searchParam: "0563306553",
		productList: storeResults.products,
		size: storeResults.size,
		page: 2,
		categoryNiche: storeResults.categoryNiche,
		companyName: storeResults.c
	};

	var _getStorePageInfo2 = (0, _seo.getStorePageInfo)(inputs),
	    title = _getStorePageInfo2.title,
	    image = _getStorePageInfo2.image,
	    searchParam = _getStorePageInfo2.searchParam,
	    description = _getStorePageInfo2.description,
	    aggregatePriceJSON = _getStorePageInfo2.aggregatePriceJSON;

	expect(title).toBe("Eezee Store 0563306553 | Tiger Hand Tools - Page 2");
	expect(image).toBe("https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg");
	expect(description).toBe("Page 2 - Tiger Hand Tools stocks reputable brands for Mechanical Tools, Fastening Tools & Air Tools in Singapore. Shop with us now!");
	expect(aggregatePriceJSON).toBe('{"@context":"http://schema.org/","@type":"Product","name":"Packaging & Shipping Supplies","image":["https://storage.googleapis.com/eezee-product-images/UhJ0MIm9CjaOc1uS5HqkRW.jpg","https://storage.googleapis.com/eezee-product-images/O24EoqiMcC10foNWdsXNdN.jpg","https://storage.googleapis.com/eezee-product-images/BG3VrUBIpfnK5WgDp3H3H~.jpg","https://storage.googleapis.com/eezee-product-images/lxwEUb0GhyOk~ZoYWPNYw3.png","https://storage.googleapis.com/eezee-product-images/vSLLCG8yvrzrbMJaqX7B2D.png","https://storage.googleapis.com/eezee-product-images/BG3VrUBIpfnK5WgDp3H3H~.jpg","https://storage.googleapis.com/eezee-product-images/lxwEUb0GhyOk~ZoYWPNYw3.png","https://storage.googleapis.com/eezee-product-images/vSLLCG8yvrzrbMJaqX7B2D.png"],"offers":{"@type":"AggregateOffer","lowPrice":4.8,"highPrice":115,"priceCurrency":"SGD","offerCount":746},"brand":{"@type":"Thing","name":"TOYOGO"}}');
});

// test('Validator works as expected', () => {

// 	const schema = {
// 		name: {
// 			conditions: [
// 				{ 
// 					required: true,
// 					msg: 'Name is required lei...'
// 				}
// 			]
// 		},

// 		hp: {
// 			conditions: [
// 				{
// 					required: true,
// 					msg: 'HP is required!'
// 				},

// 				{ 
// 					field: 'hp',
// 					comparator: 'length',
// 					length:{
// 						condition: '$gte',
// 						value: 9
// 					},
// 					msg: 'HP NEED TO BE GTE 9 LA'
// 				}
// 			]
// 		}
// 	}

// 	const obj = {
// 		name:'',
// 		hp:'92718779'
// 	};

// 	const errors = validate({ obj, schema });

// 	console.log(errors);

// 	expect( errors.name ).toBe('Name is required lei...');
// 	expect( errors.hp ).toBe('HP NEED TO BE GTE 9 LA');

// })